# #!/usr/bin/tclsh
#proc r {} {
#    
#    while { 1 } {
#        puts [ construct [ gets stdin] ]
#    }
#}
#

proc clipped { str } {
    regsub -all " *$" $str "" str
    regsub -all "\n" $str "" str
    return $str
}

proc allspaces { str } {
    regsub -all " " $str "" str
    regsub -all "\n" $str "" str
    return $str
}

proc construct { str } {
    set str [clipped $str]
    if { [regexp \[\*\?\] $str] == 1} {
        set str "matches '$str'"
        return $str
    }
    if { [string first ":" $str] != -1 } {
        scan $str "%\[^:]%*c%\[^:]" s1 s2
        set str "between '$s1' and '$s2'"
        return $str
    }
    if { [string first "|" $str] != -1 } {
        set sn "${str}"
        set str "in ("
        set ln [string length $sn]
        set i 1
        while { $ln > 0 } {
            scan $sn "%\[^|]%*c%s" s1 s2
            if { $i > 1 } {
                set str "$str,"
            }
            set str "$str'$s1'"
            set sn $s2
            set ln [expr $ln - [string length $s1] - 1]
            set i [incr i]
        }
        set str "${str})"
        return $str
    }
    if { [regexp \[><=\] $str] == 1 } {
        regsub ">=|<=|>|<|=" $str "&'" str2
        return ${str2}'
    }
    if { $str == "null" || $str == "NULL" } {
        return "is null"
    }
    if { $str == "not null" || $str == "NOT NULL" } {
        return "is not null"
    }
    return "='$str'"
}
#r
