proc docopl:summa {} {
    global DOCOPL DOCOPL_DATA SCHETTOV NAKLPTOV
    
    set w $DOCOPL(inwin).docopl
    set i 0
    set DOCOPL(sopl1) 0
    set DOCOPL(sdolg1) 0
    set DOCOPL(sopl2) 0
    set DOCOPL(sdolg2) 0
    set wk 1
    if { $DOCOPL(tip) == "n" } { set wk 0 }
    while { [info exists DOCOPL_DATA($i,$wk)] } {
        catch [set DOCOPL(sopl1) [expr $DOCOPL(sopl1) + $DOCOPL_DATA($i,1)]]
        catch [set DOCOPL(sopl2) [expr $DOCOPL(sopl2) + $DOCOPL_DATA($i,2)]]
        incr i
    }
    if { $DOCOPL(tip) == "s" } { set sdoc2 $SCHETTOV(scena) }
    if { $DOCOPL(tip) == "n" } { 
        set sdoc1 $NAKLPTOV(scena1)
        set sdoc2 $NAKLPTOV(scena2)
    }
    catch [set DOCOPL(sdolg1) [expr $sdoc1 - $DOCOPL(sopl1)]]
    catch [set DOCOPL(sdolg2) [expr $sdoc2 - $DOCOPL(sopl2)]]
    if { $DOCOPL(sdolg1) == 0 } { set color1 green }
    if { $DOCOPL(sdolg1) > 0 } { set color1 red }
    if { $DOCOPL(sdolg1) < 0 } { set color1 magenta }
    if { $DOCOPL(sdolg2) == 0 } { set color2 green }
    if { $DOCOPL(sdolg2) > 0 } { set color2 red }
    if { $DOCOPL(sdolg2) < 0 } { set color2 magenta }
    catch [$w.itogod.sdolg1 configure -bg $color1]
    catch [$w.itogod.sdolg2 configure -bg $color2]
}

proc docopl:browsecommand { rowcol } {
    global DOCOPL DOCOPL_DATA
    
    set w $DOCOPL(inwin).docopl.dat.tbl
    if { [info exists DOCOPL(ActiveRow)] && \
         $DOCOPL(ActiveRow) >= 0 } {
        $w tag row UnSelectRow $DOCOPL(ActiveRow)
    }
    set DOCOPL(ActiveRowCol) $rowcol 
    scan $DOCOPL(ActiveRowCol) "%\[^,]%*c%s" DOCOPL(ActiveRow) DOCOPL(ActiveCol)
    docopl:summa
    if { $DOCOPL(ActiveRow) >= 0 } {
        $w tag row SelectRow $DOCOPL(ActiveRow)
    }
}

proc docopl { inwin tip cod } {
    # tip = s -   
    # tip = n -   

    if { $cod > 0 } { docopl2 $inwin $tip $cod }
}

proc docopl2 { inwin tip cod } {
    global VS DOCOPL DOCOPL_DATA
    
    set DOCOPL(rows) 11
    set DOCOPL(sopl) 0
    set DOCOPL(sdolg) 0
    set DOCOPL(tip) $tip
    set DOCOPL(cod) $cod
    set DOCOPL(inwin) $inwin
    set w $DOCOPL(inwin).docopl
    set w1 ${w}.menu
    
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +250+70
    wm geometry $w =0x0
    #wm overrideredirect $w 1
    switch $DOCOPL(tip) {
        s   { set titstr "" }
        n   { set titstr " " }
    }
    wm title $w "  $titstr"
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<Ins>" -command docopl:addrow
    $w1.1 add command -label "" -command docopl:print
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command docopl:delete
    $w1.1 add separator
    if { $DOCOPL(tip) == "s" } {
        $w1.1 add command -label " " -command docopl:nnakl
        $w1.1 add separator
    }
    $w1.1 add command -label ""  -accelerator "<Esc>"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command docopl:ok
    button $w.buttons.clear -text "" -command docopl:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
        
    
    set forbut "insert  print  delete  exit "
    if { $DOCOPL(tip) == "s" } {
        set forbut "insert  print  delete  nalnakl \" \" exit "
    }
    foreach {i j} [subst { $forbut }] {
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { 
            $w.butimg.$i configure -command "destroy .balloon; $w.buttons.exit invoke"
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        $DOCOPL(inwin).docopl.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $DOCOPL(inwin).docopl <Button-3> { 
        set win $DOCOPL(inwin).docopl.dat.tbl
        $DOCOPL(inwin).docopl.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    
    entry $w.curfldval -width 32 -textvar DOCOPL_DATA(active) -fg red -bg #fffff0
    label $w.tut -font $VS(fontn) -text "   $titstr " -relief raised -bd 1
    pack $w.tut 
    pack $w.curfldval
    foreach i { dat itogoo itogod } {
        frame $w.$i
        pack $w.$i
    }
    scrollbar $w.dat.sby -takefocus 0 -command " $w.dat.tbl yview "
    table $w.dat.tbl -width 3 -height 11 -cols 3 -rows $DOCOPL(rows) \
        -yscrollcommand " $w.dat.sby set " \
        -cursor arrow \
        -variable DOCOPL_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { docopl:browsecommand %S } \
        -wrap on
        
    $w.dat.tbl tag config title -fg yellow
    $w.dat.tbl tag config sel -bg grey85
    $w.dat.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.dat.tbl
    $w.dat.tbl tag col AnchorCenter 2 
    if { $DOCOPL(tip) == "s" } {
        $w.dat.tbl tag col Disabled 0
    }
    $w.dat.tbl tag col AnchorE 1 2
    $w.dat.tbl tag row AnchorCenter -1
    $w.dat.tbl width 0 11 1 11 2 11
    
    pack $w.dat.tbl -side left
    pack $w.dat.sby -side right -fill y
    
    if { $DOCOPL(tip) == "s" } {
        set l1txt "           "
        set l2txt "               "
        set widlst "itogoo.l1 itogoo.sopl2 itogod.l2 itogod.sdolg2"
    } else {
        set l1txt ""
        set l2txt "    "
        set widlst "itogoo.l1 itogoo.sopl1 itogoo.sopl2 itogod.l2 itogod.sdolg1 itogod.sdolg2"
    }
    label $w.itogoo.l1 -text $l1txt
    label $w.itogoo.sopl1 -textvar DOCOPL(sopl1) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    label $w.itogoo.sopl2 -textvar DOCOPL(sopl2) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    label $w.itogod.l2 -text $l2txt
    label $w.itogod.sdolg1 -textvar DOCOPL(sdolg1) -bd 1 -relief sunken -anchor e -width 11
    label $w.itogod.sdolg2 -textvar DOCOPL(sdolg2) -bd 1 -relief sunken -anchor e -width 11
    foreach i [subst { $widlst }] {
        pack $w.$i -side left -padx 1
    }
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.dat.tbl <KeyPress-F2> {
        set kol 0
        if { $DOCOPL(tip) == "s" } { set kol 1 }
        if { $DOCOPL(ActiveRow) >= 0 && $DOCOPL(ActiveCol) == 1 } {
            set DOCOPL_DATA($DOCOPL(ActiveRow),1) $DOCOPL(sdolg1)
        }
        if { $DOCOPL(ActiveRow) >= 0 && $DOCOPL(ActiveCol) == 2 } {
            set DOCOPL_DATA($DOCOPL(ActiveRow),2) $DOCOPL(sdolg2)
        }
        if { $DOCOPL(ActiveRow) >= 0 && $DOCOPL(ActiveCol) == $kol } {
            set DOCOPL_DATA($DOCOPL(ActiveRow),$kol) "$VS(day).$VS(month).$VS(year)"
        }
    }
    bind $w <Key-Escape> {
        $DOCOPL(inwin).docopl.buttons.exit invoke
    }
    bind $w.dat.tbl <Key-Insert> { %W configure -rows [incr DOCOPL(rows)] }
    wm geometry $w [centerwindow $w]
    docopl:read
    focus $w.dat.tbl
}

proc docopl:ok {} {
    global DOCOPL DOCOPL_DATA VS

    #     
    set i 0
    while 1 {
        if [info exists DOCOPL_DATA($i,1)] {
            if ![info exists DOCOPL_DATA($i,cod)] {
                docopl:insert $i
            } else { 
                if { $DOCOPL_DATA($i,cod) <= 0 } {
                    docopl:insert $i
                }
                if { $DOCOPL_DATA($i,cod) > 0 } {
                    if { $DOCOPL(tip) == "n" } {
                        if ![info exists DOCOPL_DATA($i,1)] { set DOCOPL_DATA($i,1) 0 }
                        if ![info exists DOCOPL_DATA($i,2)] { set DOCOPL_DATA($i,2) 0 }
                    }
                    set ifvar { $DOCOPL_DATA($i,old_0) != $DOCOPL_DATA($i,0) || $DOCOPL_DATA($i,old_1) != $DOCOPL_DATA($i,1) || $DOCOPL_DATA($i,old_2) != $DOCOPL_DATA($i,2) }
                    if { $DOCOPL(tip) == "s" } {
                        set ifvar { $DOCOPL_DATA($i,old_1) != $DOCOPL_DATA($i,1) || $DOCOPL_DATA($i,old_2) != $DOCOPL_DATA($i,2) }
                    }
                    if [subst { $ifvar }] {
                        docopl:update $i
                    }
                }
            }
        } else break
        incr i
    }
    set VS($DOCOPL(inwin).docopl_update) 0
}

proc docopl:addrow {} {
    global DOCOPL

    $DOCOPL(inwin).docopl.dat.tbl configure -rows [incr DOCOPL(rows)]
}

proc docopl:nnakl {} {
    global DOCOPL DOCOPL_DATA
    
    if { $DOCOPL(tip) == "s" } {
        if [info exists DOCOPL_DATA($DOCOPL(ActiveRow),cod)] {
            nnakl:ident schetopl
            docopl:read
        }
    }
}
