proc schetfnr:fnr {} {
    global VS FINNAKLR STT

    set w .schetfnr.top.head.fnr
    set FINNAKLR(hebutton) 0
    
    label $w.tut -bg gray70 -wraplength 1 -width 2 -height 5 -font $VS(fontn) \
        -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    foreach { i } { num dov dovwho } {
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
        if { $i == "num" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
    }
    foreach { i j } { num    "  " \
                      dov    ": " \
                      dovwho "             " \
                  } {
        label $w.$i.l -text $j
        pack $w.$i.l -side left
    }
    foreach { i j k } {num.num              num         5 \
                       num.dat              dat         10 \
                       num.skladnam         skladnam    30 \
                       dov.dovnum           dovnum      10 \
                       dov.dovdat           dovdat      10 \
                       dovwho.e             dovwho      52 \
                       } {
        entry $w.$i -textvariable FINNAKLR($j) -width $k
    }
    foreach { i j } { num.l1      " " \
                      num.l2      " " \
                      dov.l1      "  " \
                  } {
        label $w.$i -text $j
    }
    button $w.num.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set FINNAKLR(hebutton) 1; finnaklr:heskladnam r .schetfnr.top.head.fnr"
    
    foreach i {num.num num.l1 num.dat num.l2 num.skladnam num.b \
               dov.dovnum dov.l1 dov.dovdat \
               dovwho.e \
              } {
        pack $w.$i -side left
    }
    bind $w.num.skladnam <FocusOut> {
        if { "$FINNAKLR(old_skladnam)" != "$FINNAKLR(skladnam)" } {
            regsub -all " " "$FINNAKLR(skladnam)" "" lng
            if { $FINNAKLR(hebutton) == 0 } {
                if { [string length $lng] > 0 } {
                    finnaklr:heskladnam u .schetfnr.top.head.fnr
                    set FINNAKLR(old_skladnam) $FINNAKLR(skladnam)
                } else { set FINNAKLR(skladnam) "" }
            }
        }
    }
    bind $w.num.skladnam <FocusIn> {
        if { [clipped $FINNAKLR(skladnam)] == "" } {
            set FINNAKLR(skladcod) $STT(sgpcod)
            set FINNAKLR(skladnam) $STT(sgpnam)
        }
    }
    bind $w.num.skladnam <Button-1> {
        catch [destroy .schetfnr.top.head.fnr.he]
    }
    bind $w.num.dat <FocusIn> {
        if { $FINNAKLR(dat) == "" } {
            set FINNAKLR(dat) $VS(day).$VS(month).$VS(year)
        }
    }
    bind $w.num.num <FocusIn> {
        if { $FINNAKLR(num) == "" } {
            %W configure -state disabled
        }
    }
    bind $w.num.num <KeyRelease-Return> {
        focus -force .schetfnr.tov.tbl
    }
}

