proc finnaklr:clear {} {
    global FINNAKLR
    
    set FINNAKLR(num) ""
    set FINNAKLR(dat) ""
    set FINNAKLR(skladcod) ""
    set FINNAKLR(skladnam) ""
    set FINNAKLR(dovnum) ""
    set FINNAKLR(dovdat) ""
    set FINNAKLR(dovwho) ""
    finnaklr:old
}

proc finnaklr:old {} {
    global FINNAKLR
    
    set FINNAKLR(old_num)         $FINNAKLR(num)
    set FINNAKLR(old_dat)         $FINNAKLR(dat)
    set FINNAKLR(old_skladcod)    $FINNAKLR(skladcod)
    set FINNAKLR(old_skladnam)    $FINNAKLR(skladnam)
    set FINNAKLR(old_dovnum)      $FINNAKLR(dovnum)
    set FINNAKLR(old_dovdat)      $FINNAKLR(dovdat)
    set FINNAKLR(old_dovwho)      $FINNAKLR(dovwho)
}

proc finnaklr:delete {} {
    global VS FINNAKLR SCHET
    
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        puts $socks "finnaklr_del $SCHET(cod)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } { }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        } else {
            finnaklr:clear
            finnaklr:old
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc finnaklr:update {} {
    global VS FINNAKLR SCHET

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ... " green
        puts $socks "finnaklr_upd $SCHET(cod) \
                               \"$FINNAKLR(num)\" \
                               \"$FINNAKLR(dat)\" \
                               \"$FINNAKLR(skladcod)\" \
                               \"$FINNAKLR(dovnum)\" \
                               \"$FINNAKLR(dovdat)\" \
                               \"$FINNAKLR(dovwho)\" "
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        } else {
            finnaklr:old
        }

        close $socks
        waiting "" ""
        finnaklr:read
    } else {
        errormsg nosocks "  !"
    }
}

proc finnaklr:read {} {
    global VS FINNAKLR SCHET
    
    waiting "  ..." blue
    finnaklr:clear
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "finnaklrone_sel $SCHET(cod)"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      FINNAKLR(num) \
                      FINNAKLR(dat) \
                      FINNAKLR(skladcod) \
                      FINNAKLR(skladnam) \
                      FINNAKLR(dovnum) \
                      FINNAKLR(dovdat) \
                      FINNAKLR(dovwho)
        }
        set FINNAKLR(num)      [clipped $FINNAKLR(num)]
        set FINNAKLR(dat)      [clipped $FINNAKLR(dat)]
        set FINNAKLR(skladnam) [clipped $FINNAKLR(skladnam)]
        set FINNAKLR(dovnum)   [clipped $FINNAKLR(dovnum)]
        set FINNAKLR(dovdat)   [clipped $FINNAKLR(dovdat)]
        set FINNAKLR(dovwho)   [clipped $FINNAKLR(dovwho)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    finnaklr:old
    waiting "" ""
}

proc finnaklr:insert {} {
    global VS FINNAKLR SCHET
    
    if { $SCHET(cod) > 0 && \
         $FINNAKLR(skladcod) > 0 && \
         [string length [clipped $FINNAKLR(dat)]] > 0 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "finnaklr_ins \"$SCHET(cod)\" \"$FINNAKLR(dat)\" \"$FINNAKLR(skladcod)\" \"$FINNAKLR(dovnum)\" \"$FINNAKLR(dovdat)\" \"$FINNAKLR(dovwho)\""
            flush $socks
    
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set FINNAKLR(num) $str
            }
       
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
        } else {
            errormsg nosocks "  !"
        }
        finnaklr:old
        finnaklr:read
    }
}

proc finnaklr:print {} {
    global VS SCHET SCHETTOV

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "finnaklr_rep \"$SCHET(cod)\" \"$SCHETTOV(sortstr) $SCHETTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc finnaklr:heskladnam { tip win } {
    global FINNAKLR HE
    
    set w .schetfnr.top.head.fnr.num.skladnam
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$FINNAKLR(skladnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $namstr $tip $win
    set FINNAKLR(skladcod) $HE(cod)
    set FINNAKLR(skladnam) [clipped $HE(nam)]
    set FINNAKLR(old_skladnam) $FINNAKLR(skladnam)
    set FINNAKLR(hebutton) 0
}

