proc globalperenos { tbl sizetbl } {
    global GLOBALPERENOS VS GLOBALPERENOS_DATA

    set w .globalperenos
    catch [unset GLOBALPERENOS]
    set GLOBALPERENOS(lfrom,cod) 0
    set GLOBALPERENOS(lfrom,nam) ""
    set GLOBALPERENOS(lto,cod) 0
    set GLOBALPERENOS(lto,nam) ""
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    switch $tbl {
        postpol { set str "" }
        tovar   { set str "" }
    }
    set tit "   $str"
    wm title $w $tit
    
    frame $w.tit -bd 2 -relief sunken
    frame $w.from
    frame $w.to
    frame $w.but -bd 2 -relief groove
    pack $w.tit -side top
    pack $w.but -side bottom
    pack $w.from -side left
    pack $w.to -side right
    

    label $w.tit.l1 -font $VS(fontn) -text $tit
    label $w.tit.l2 -font $VS(fontn) -text ""
    entry $w.tit.from -textvar GLOBALPERENOS(lfrom,nam) -width $sizetbl -bd 2 -relief sunken -state disabled -bg seashell2 -fg blue4
    label $w.tit.l3 -font $VS(fontn) -text " "
    entry $w.tit.to -textvar GLOBALPERENOS(lto,nam) -width $sizetbl -bd 2 -relief sunken -state disabled -bg seashell2 -fg blue4
    pack $w.tit.l1
    foreach i { l2 from l3 to } { pack $w.tit.$i -side left }

    foreach i { from to } {
        scrollbar $w.$i.sb -takefocus 0 -command "$w.$i.lb yview"
        listbox $w.$i.lb -yscroll "globalperenos:llb $w $i" -height 20 -width $sizetbl
        pack $w.$i.lb $w.$i.sb -side left -fill y
        bind $w.$i.lb <Double-Button-1> "globalperenos:bbind %W $i"
        bind $w.$i.lb <KeyPress-Return> "globalperenos:bbind %W $i"
    }
    
    button $w.but.ok -text "" -command "globalperenos:run $tbl"
    button $w.but.exit -text "" -command "destroy $w"
    pack $w.but.ok $w.but.exit -side left -padx 15 -pady 3
    
    
    
    focus $w.from.lb
    wm geometry $w [centerwindow $w]
    globalperenos:read $tbl
    
}

proc globalperenos:llb { w i args } {
    eval $w.$i.sb set $args
    if { $i == "from" } {
        eval $w.to.lb yview moveto [lindex $args 0]
    }
}

proc globalperenos:bbind { win i } {
    global GLOBALPERENOS GLOBALPERENOS_DATA

    set GLOBALPERENOS(l$i,nam) "$GLOBALPERENOS_DATA($i,nam,[$win curselection])"
    set GLOBALPERENOS(l$i,cod) "$GLOBALPERENOS_DATA($i,cod,[$win curselection])"
}
