proc he { x y fieldcount fieldwidth tbl hematch tip win } {
    global VS HE
    
    set HE(flg) ""
    set HE(inwin) $win
    set HE(cod) " "
    set HE(nam) " "
    set hematch [clipped $hematch]
    set w $win.he.lb.listbox
    switch $tip {
        r   { waiting "  ..." blue }
        u   { waiting "   ..." magenta }
    }
    update
    
    if { $x != 0 || $y != 0 || $fieldcount != 0 || $fieldwidth != 0 } {
        if [ regexp \003 $hematch ] {
            regsub \[^\003]\[\ -]*$ $hematch "*&*" hematch
            scan $hematch "%\[^*]%\[^\n]" hematchcod hematchnam
        } else {
            set hematch "*$hematch*"
            set hematchcod {}
            set hematchnam $hematch
        }
    }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "he \"$tbl\" \"$hematch\""
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set HE(cod,$i) {}; set HE(nam,$i) {}; set HE(flg) {}
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" HE(cod,$i) HE(nam,$i) HE(flg)
            incr i
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    - !    ."
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    set HE(i) $i

    if { "$HE(flg)" != "3" } { 
        he:display $x $y $fieldcount $fieldwidth $tbl $hematchcod $hematchnam $tip $win
        catch [set HE(cod) $HE(cod,$HE(curselection))]
        catch [set HE(nam) $HE(nam,$HE(curselection))]
    } else {
        catch [set HE(cod) $HE(cod,0)]
        catch [set HE(nam) $HE(nam,0)]
    }
    waiting "" ""
    update
}

proc he:display { x y fieldcount fieldwidth tbl hematchcod hematchnam tip win } {
    global VS HE

    set HE(cod) {}
    set HE(nam) {}
    set HE(curselection) {}
    set HE(find) $hematchnam
    
    set w $win.he
    catch [destroy $w]
    toplevel $w -cursor arrow -highlightcolor cyan4 -highlightthickness 2 -bd 3 -relief sunken -bg #cfffcf
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    
    frame $w.lb -bd 2 -relief ridge
    frame $w.lb.find -bd 2 -relief ridge
    label $w.lb.find.l -text ":" -fg yellow -bg grey60 -relief raised
    entry $w.lb.find.e -textvar HE(find) -fg yellow -bg grey60
    entry $w.lb.tit -state disabled -textvar HE(tit) -bg grey40 -fg green \
            -xscroll "$w.lb.sbx set"
    scrollbar $w.lb.sby -command "$w.lb.listbox yview" -takefocus 0
    scrollbar $w.lb.sbx -orient horiz -command { he:display:scrolls } -takefocus 0
    listbox $w.lb.listbox -yscroll "$w.lb.sby set" -bg #cfffcf \
            -xscroll { he:display:scrolll } -height $fieldcount -width $fieldwidth
    frame $w.exit -bd 2 -relief ridge
    #button $w.exit.b -text "" -command "set HE(curselection) -99"
    label $w.exit.b -text "  " -relief raised -takefocus 1
        
    $w.lb.listbox delete 0 end
    
    for { set i 0 } { $i < $HE(i) } { incr i } {
        regsub -all \003 $HE(nam,$i) " " dispnam
        $w.lb.listbox insert end $dispnam
    }
    
    pack $w.lb
    pack $w.lb.find -fill x
    pack $w.lb.tit -anchor w -fill x
    pack $w.lb.find.l -side left
    pack $w.lb.find.e -side left -fill x -expand 1
    pack $w.lb.sbx -fill x -side bottom
    pack $w.lb.sby -side right -fill y -anchor n
    pack $w.lb.listbox -side left -expand 1 -fill both
    pack $w.exit $w.exit.b
    
    waiting "" ""
    update
    bind $w.lb.listbox <KeyPress-Insert> [list he:int:ins $win $tbl]
    bind $w.lb.listbox <Double-ButtonRelease-1> {
        set HE(curselection) [%W curselection]
    }
    bind $w.lb.listbox <ButtonPress-1> {
        focus -force %W
    }
    bind $w.lb.listbox <Key-Return> {
       set HE(curselection) [%W curselection]
    }
    bind $w.lb.listbox <Key-F5> {
        regsub "\.listbox" %W ".find.e" fun
        focus -force $fun
    }
    bind $w.lb.listbox <Key-Escape> {
        set HE(curselection) -99
    }
    bind $w.lb.find.l <ButtonPress-1> {
        %W configure -relief sunken
    }
    bind $w.exit.b <ButtonPress-1> {
        %W configure -relief sunken
    }
    bind $w.exit.b <ButtonRelease-1> {
        set HE(curselection) -99
    }
    bind $w.exit.b <Enter> {
        %W configure -bg #00c0c0
    }
    bind $w.exit.b <Leave> {
        %W configure -bg #d9d9d9
    }
    bind $w.lb.find.e <Key-Return> {
        set HE(curselection) -100
    }
    bind $w.lb.find.e <Key-Escape> {
        regsub "\.find\.e" %W ".listbox" fun
        focus -force $fun
    }
    bind $w.lb.find.l <ButtonRelease-1> {
        %W configure -relief raised
        set HE(curselection) -100
    }
    bind $w.lb.find.l <Enter> {
        %W configure -bg #00c0c0
    }
    bind $w.lb.find.l <Leave> {
        %W configure -bg grey60
    }
    
    $w.lb.listbox selection set 0 0
    $w.lb.listbox activate 0
    focus -force $w.lb.listbox
    grab $w
    tkwait variable HE(curselection)
    destroy $w
    if { $HE(curselection) == "-100" } {
        he:replay $x $y $fieldcount $fieldwidth $tbl "$hematchcod$HE(find)" $tip $win
    }
    set HE(tit) ""
    focus -force [focus -lastfor $win]
}

proc he:display:scrolls {args} {
    global HE

    eval "$HE(inwin).he.lb.tit xview $args"
    eval "$HE(inwin).he.lb.listbox xview $args"
}

proc he:display:scrolll {args} {
    global HE
    
    eval "$HE(inwin).he.lb.sbx set $args"
    eval "$HE(inwin).he.lb.tit xview [list moveto [lindex $args 0]]"
}

proc he:replay { x y fieldcount fieldwidth tbl hematch tip win } {
    he $x $y $fieldcount $fieldwidth $tbl $hematch $tip $win
}

proc he:int:ins { win tbl } {
    global HE POSTPOL TOVAR
    
    set sep \003
    switch -regexp $tbl {
        klient {
            set HE(tit) ""
            destroy $win.he
            postpol:insert he {}
            set HE(curselection) -1
            set HE(cod,-1) $POSTPOL(entry,cod)
            set HE(nam,-1) $POSTPOL(entry,nam)
            focus -force [focus -lastfor $win]
        }
    }
    switch $tbl {
        tovar {
            set HE(tit) ""
            destroy $win.he
            tovar:insert he {}
            set HE(curselection) -1
            set HE(cod,-1) $TOVAR(entry,cod)$sep$TOVAR(entry,eicod)
            set HE(nam,-1) $TOVAR(entry,nam)$sep$TOVAR(entry,einam)$sep$TOVAR(entry,cena)$sep$TOVAR(entry,issernum)
            focus -force [focus -lastfor $win]
        }
    }
    switch $tbl {
        tovarp {
            set HE(tit) ""
            destroy $win.he
            tovar:insert he {}
            set HE(curselection) -1
            set HE(cod,-1) $TOVAR(entry,cod)$sep$TOVAR(entry,eicod)
            set HE(nam,-1) $TOVAR(entry,nam)$sep$TOVAR(entry,einam)$sep$TOVAR(entry,cena)$sep$TOVAR(entry,issernum)
            focus -force [focus -lastfor $win]
        }
    }
}
