proc jurnal { } {
    global VS JURNAL SCHETTOV JURNAL_DATA

    catch [unset JURNAL_DATA]
    set JURNAL(listbox,curselection) 0
    if ![info exists JURNAL(entry,clockdatbegin)] {
        set JURNAL(entry,datbegin) "$VS(day).$VS(month).$VS(year)"
        set JURNAL(entry,datend)   "$VS(day).$VS(month).$VS(year)"
        set JURNAL(entry,clockdatbegin) $VS(clock)
        set JURNAL(entry,clockdatend) $VS(clock)
    }
    set w .jurnal
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +5+55
    wm geometry $w =0x0
    set titstr "    "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "jurnal:entry"
    $w1.1 add command -label "" -command "jurnal:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable JURNAL(sortstr) -value "3" -command jurnal:read
        $w1.1.sort add radio -label "  " -variable JURNAL(sortstr) -value "4, 3" -command jurnal:read
        $w1.1.sort add radio -label "  " -variable JURNAL(sortstr) -value "7" -command jurnal:read
        $w1.1.sort add radio -label "  " -variable JURNAL(sortstr) -value "5, 4, 3" -command jurnal:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable JURNAL(sortdesc) -value " " -command jurnal:read
        $w1.1.sort add radio -label " " -variable JURNAL(sortdesc) -value "desc" -command jurnal:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -command jurnal:schet
    $w1.1 add command -label "" -accelerator "<Enter>" -command jurnal:nnakl
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable JURNAL(statusline) -relief sunken -anchor w -padx 3 -width 50
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find  print  sort  schet  nalnakl  exit } {
        if { $i == "print" } { findbox jurnal 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == "" || $j == "" }  { $w.butimg.$i configure -state disabled }
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    foreach i { p0 p1 p2 p3 p4 } {
        frame $w.namefield.$i
    }
    $w.namefield.p0 configure -relief raised -bd 1
    $w.namefield.p2 configure -relief raised -bd 1
    $w.namefield.p3 configure -relief raised -bd 1
    $w.namefield.p4 configure -relief raised -bd 1
    label $w.namefield.p0.1 -text "N /" -anchor center -bd 1 -height 2 -width 4 -wraplength 30
    label $w.namefield.p1.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p2.1 -text " " -anchor center -bd 1 -height 2 -width 46
    label $w.namefield.p3.1 -text " " -anchor center -bd 1 -height 2 -width 13 -wraplength 80
    label $w.namefield.p4.1 -text "" -anchor center -bd 1 -height 2 -width 13
    
    label $w.namefield.p1.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p1.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p0 p1 p2 p3 p4 } {
        pack $w.namefield.$i -anchor w -side left -fill both
    }
    foreach i { p0.1 p1.1 p2.1 p3.1 p4.1 } {
        pack $w.namefield.$i -fill both
    }
    foreach i { p1.2 p1.3 } {
        pack $w.namefield.$i -side left
    }
    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 94
    
    pack $w.lb -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    jurnal:entry
    
    bind $w.butimg.sort <Button-1> {
        .jurnal.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .jurnal.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        %W selection set $id $id
        set JURNAL(statusline) [ %W get $id ]
        set JURNAL(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .jurnal.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { schet  nalnakl  } {
            .jurnal.menu.1 entryconfigure [.jurnal.menu.1 index $j] -state disabled
            .jurnal.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { schet  nalnakl  } {
            .jurnal.menu.1 entryconfigure [.jurnal.menu.1 index $j] -state normal
            .jurnal.butimg.$i configure -state normal
        }
    }
    bind $w <Key-Escape> { .jurnal.buttons.exit invoke }
    bind $w <Key-F5>     { jurnal:entry }
    bind $w <Key-Return> { jurnal:nnakl }
    bind $w.lb.listbox <KeyRelease-Down> { 
        event generate %W <B1-ButtonRelease>
    }
    bind $w.lb.listbox <KeyRelease-Up> { 
        event generate %W <B1-ButtonRelease>
    }
    focus $w.lb.listbox
}

proc jurnal:entry:createvar {} {
    global JURNAL
    
    foreach i { datbegin datend } {
        if ![info exists JURNAL(entry,$i)] {
            set JURNAL(entry,$i) ""
        }
    }
}

proc jurnal:entry {} {
    global VS JURNAL
    
    set w .jurnal.entry
    jurnal:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +200+78
    wm geometry $w =0x0
    frame $w.msg
    wm title $w "  "
    label $w.msg.l -font $VS(fontn) -text "   "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tit datbegin datend } {
        frame $w.inf.$i
        pack $w.inf.$i -padx 3 -pady 3
        if { $i == "tit" || $i == "datend" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tit        "    :"
                      datbegin   "  " \
                      datend     " " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {datbegin   datbegin      10 \
                       datend     datend        10 \
                       } {
        entry $w.inf.$i.e -textvariable JURNAL(entry,$j) -width $k
    }
    
    foreach { i j } { ControlUp datbegin.bu ControlDown datbegin.bd ControlUp datend.bu ControlDown datend.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.datbegin.bd configure -command "jurnal:incrdate - datbegin"
    $w.inf.datbegin.bu configure -command "jurnal:incrdate + datbegin"
    $w.inf.datend.bd configure -command "jurnal:incrdate - datend"
    $w.inf.datend.bu configure -command "jurnal:incrdate + datend"
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "destroy $w; jurnal:read"
    button $w.buttons.exit -text "" -command "destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { datbegin.e datend.e } {
        pack $w.inf.$i -side left
    }
    foreach i { datbegin.bu datbegin.bd datend.bu datend.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.datbegin.e
    
    bind $w <Key-Escape>     { .jurnal.entry.buttons.exit invoke }
    bind $w <Control-Return> { .jurnal.entry.buttons.ok invoke }
    bind $w.inf.datbegin.e <KeyPress-Next>  { jurnal:incrdate - datbegin }
    bind $w.inf.datbegin.e <KeyPress-Prior> { jurnal:incrdate + datbegin }
    bind $w.inf.datend.e   <KeyPress-Next>  { jurnal:incrdate - datend }
    bind $w.inf.datend.e   <KeyPress-Prior> { jurnal:incrdate + datend }
    wm geometry $w [centerwindow $w]
    tkwait window $w
    jurnal:createfind
    if ![info exists JURNAL(find,listbox)] { set JURNAL(find,listbox) "" }
    if { [lsearch -exact $JURNAL(find,listbox) $JURNAL(find)] == -1} {
        lappend JURNAL(find,listbox) $JURNAL(find)
    }
}

proc jurnal:incrdate { k d } {
    global JURNAL
    
    set JURNAL(entry,clock$d) [expr $JURNAL(entry,clock$d) $k 86400 ]
    set JURNAL(entry,$d) [clock format $JURNAL(entry,clock$d) -format %d.%m.%Y]
}

proc jurnal:createfind {} {
    global JURNAL
    
    catch [set JURNAL(find) ":  $JURNAL(entry,datbegin)  $JURNAL(entry,datend)"]
}

proc jurnal:schet {} {
    global JURNAL_DATA JURNAL

    schetfnr 1 $JURNAL_DATA(schetcod,$JURNAL(listbox,curselection))    
}

proc jurnal:nnakl {} {
    global JURNAL_DATA JURNAL SCHET
    
    set SCHET(cod) $JURNAL_DATA(schetcod,$JURNAL(listbox,curselection))
    nnakl 0 $JURNAL_DATA(nnaklcod,$JURNAL(listbox,curselection)) .jurnal
}
