proc jurnal:read {} {
    global VS JURNAL JURNAL_DATA JURNAL_DATA2
    
    set w .jurnal.lb.listbox
    event generate .jurnal.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset JURNAL_DATA]
    if { $JURNAL(sortstr) == "" }    { set JURNAL(sortstr) "3" } 
    if { $JURNAL(sortdesc) == "" }   { set JURNAL(sortdesc) " "  }
    if { $JURNAL(find) == "" } {
        jurnal:createfind
        lappend JURNAL(find,listbox) $JURNAL(find)
    } 
    
    $w delete 0 end
    
    set nnaklcodold ""
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "jurnal_sel \"$JURNAL(entry,datbegin)\" \"$JURNAL(entry,datend)\" \"$JURNAL(sortstr) $JURNAL(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { schetcod nnaklcod nnaklnum nnakldat klientnam klientinn sall } {
                set JURNAL_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                JURNAL_DATA(schetcod,$i) \
                JURNAL_DATA(nnaklcod,$i) \
                JURNAL_DATA(nnaklnum,$i) \
                JURNAL_DATA(nnakldat,$i) \
                JURNAL_DATA(klientnam,$i) \
                JURNAL_DATA(klientinn,$i) \
                JURNAL_DATA(sall,$i)
            $w insert end [format "%4d %6d %10s %46.46s %12.12s %11.2f" \
                [expr $i + 1] \
                $JURNAL_DATA(nnaklnum,$i) \
                $JURNAL_DATA(nnakldat,$i) \
                $JURNAL_DATA(klientnam,$i) \
                $JURNAL_DATA(klientinn,$i) \
                $JURNAL_DATA(sall,$i)]
            
            set nnaklcodold $JURNAL_DATA(nnaklcod,$i)
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set JURNAL(statusline) " $i ."
        }
        set JURNAL(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc jurnal:print {} {
    global VS JURNAL    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "jurnal_rep \"$JURNAL(entry,datbegin)\" \"$JURNAL(entry,datend)\" \"$JURNAL(sortstr) $JURNAL(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
