proc myorg:entry:clearvar {} {
    global MYORG
    
    set MYORG(nam) ""
    set MYORG(gorodnam) ""
    set MYORG(phonecod) ""
    set MYORG(index) ""
    set MYORG(ulica) ""
    set MYORG(bossfio) ""
    set MYORG(bossphone) ""
    set MYORG(glbuhfio) ""
    set MYORG(glbuhphone) ""
    set MYORG(banknam) ""
    set MYORG(bankmfo) ""
    set MYORG(bankschet1) ""
    set MYORG(bankschet2) ""
    set MYORG(zkpo) ""
    set MYORG(inn) ""
    set MYORG(ns) ""
    set MYORG(phoneo) ""
    set MYORG(fax) ""
    set MYORG(email) ""
    set MYORG(www) ""
}

proc myorg {} {
    global MYORG VS
    
    set w .allcfg.dat
    catch [destroy $w]
    frame $w
    pack $w
    frame $w.title -bd 5
    label $w.title.l -font $VS(fontn) -text "  " -relief raised -anchor center -bd 1 -padx 3 -width 26
    frame $w.inf -bd 2 -relief raised
    pack $w.title $w.title.l -fill x
    pack $w.inf
    
    foreach { i } {nam gorod phonecod ulica boss glbuh bank schet zkpo phone email } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "nam" || $i == "ulica" || $i == "boss" || $i == "glbuh" || $i == "schet" || $i == "zkpo" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { nam       "        " \
                      gorod     "        : " \
                      phonecod  "                " \
                      ulica     "               " \
                      boss      ":" \
                      glbuh     ".:" \
                      bank      "         " \
                      schet     "          " \
                      zkpo      "      " \
                      phone     " " \
                      email     "       E-mail" \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    
    foreach { i j k } {nam.nam              nam            50 \
                       gorod.gorodnam       gorodnam       50 \
                       phonecod.phonecod    phonecod       6 \
                       phonecod.index       index          6 \
                       ulica.ulica          ulica          50 \
                       boss.bossfio         bossfio        50 \
                       boss.bossphone       bossphone      9 \
                       glbuh.glbuhfio       glbuhfio       50 \
                       glbuh.glbuhphone     glbuhphone     9 \
                       bank.banknam         banknam        50 \
                       bank.bankmfo         bankmfo        6 \
                       schet.bankschet1     bankschet1     14 \
                       schet.bankschet2     bankschet2     14 \
                       zkpo.zkpo            zkpo           8 \
                       zkpo.inn             inn            12 \
                       zkpo.ns              ns             8 \
                       phone.phoneo         phoneo         9 \
                       phone.fax            fax            9 \
                       email.email          email          30 \
                       email.www            www            30 \
                      } {
        entry $w.inf.$i -textvariable MYORG($j) -width $k
    }
    
    foreach { i j } { phonecod.l1   "  " \
                      boss.l1       " " \
                      glbuh.l1      " " \
                      bank.l1       " " \
                      schet.l1      "  " \
                      zkpo.l1       "  " \
                      zkpo.l2       "  " \
                      phone.l1      " " \
                      email.l1      " WWW" } {
        label $w.inf.$i -text $j
    }
    
    frame $w.buttons -relief sunken -bd 1
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "myorg:insert"
    button $w.buttons.clear -text "" -command "myorg:entry:clearvar"
    button $w.buttons.exit -text "" -command "destroy .allcfg"
        
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.inf
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 10
  
    foreach i { nam.nam gorod.gorodnam phonecod.phonecod
                phonecod.l1 phonecod.index ulica.ulica 
                boss.bossfio boss.l1 boss.bossphone
                glbuh.glbuhfio glbuh.l1 glbuh.glbuhphone 
                bank.banknam bank.l1 bank.bankmfo
                schet.bankschet1 schet.l1 schet.bankschet2
                zkpo.zkpo zkpo.l1 zkpo.inn zkpo.l2 zkpo.ns
                phone.phoneo phone.l1 phone.fax
                email.email email.l1 email.www 
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.nam.nam
    myorg:read
    tkwait window $w
}
