proc naklphead {} {
    global VS NAKLP

    set w $NAKLP(inwin).naklp.head
    set NAKLP(hebutton) 0
    
    label $w.tut -bg gray70 -wraplength 1 -width 2 -height 6 -font $VS(fontn) -text "" -relief sunken -bd 1
    frame $w.other -bd 1 -relief ridge
    pack $w.tut -side left -fill y
    if { $NAKLP(pr) == "r" } {
        pack $w.other -side right -fill y
    }
    foreach { i } { num sklad klient lgota prim1 } {
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
        if { $i == "num" || $i == "lgota" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
    }
    foreach { i j } { num       "   N" \
                      sklad     "     " \
                      klient    " " \
                      lgota     "    " \
                      prim1     "" \
                  } {
        if { $NAKLP(pr) == "r" && $i == "klient" } {
            set j "    "
        }
        label $w.$i.l1 -text $j
    }
    foreach { i j k } {num.num              num         10 \
                       num.dat              dat         10 \
                       num.operacianam      operacianam 30 \
                       sklad.skladnam       skladnam    30 \
                       sklad.datdolga       datdolga    10 \
                       klient.klientnam     klientnam   50 \
                       klient.kurs          kurs        6 \
                       lgota.lgotanam       lgotanam    30 \
                       lgota.proc           proc        6 \
                       lgota.lgotaproc      lgotaproc   6 \
                       prim1.e              prim1       60 \
                       } {
        if { $NAKLP(tip) == "f" || $NAKLP(pr) == "r" } {
            if { $i != "klient.kurs" } {
                entry $w.$i -textvar NAKLP($j) -width $k
            }
        } else {
            entry $w.$i -textvar NAKLP($j) -width $k
        }
    }
    $w.lgota.proc configure -state disabled
    $w.lgota.lgotanam configure -state disabled
    if [winfo exists $w.sklad.datdolga] {
        $w.sklad.datdolga configure -takefocus 0
    }
    if { $NAKLP(pr) == "r" } {
        $w.num.num configure -width 5
        if { $NAKLP(cod) <= 0 || $NAKLP(cod) == "" } {
            $w.num.num configure -state disabled
        }
    }
    foreach { i j } { num.l2    " " \
                      num.l3    " " \
                      sklad.l2    "  " \
                      klient.l2 " " \
                      lgota.l2  "% " \
                      lgota.l3  "%" \
                  } {
        if { $NAKLP(tip) == "f" || $NAKLP(pr) == "r" } {
            if { $i != "klient.l2" } {
                label $w.$i -text $j
            }
        } else {
            label $w.$i -text $j
        }
    }
    
    button $w.sklad.b1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set NAKLP(hebutton) 1; naklphead:heskladnam r $NAKLP(inwin).naklp.head"
    button $w.num.b2 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set NAKLP(hebutton) 1; naklphead:heoperacianam r $NAKLP(inwin).naklp.head"
    button $w.klient.b1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set NAKLP(hebutton) 1; naklphead:heklientnam r $NAKLP(inwin).naklp.head"
    
    foreach i { num.l1 num.num num.l2 num.dat num.l3 num.operacianam num.b2 \
                sklad.l1 sklad.skladnam sklad.b1 \
                klient.l1 klient.klientnam klient.b1 klient.l2 klient.kurs \
                prim1.l1 prim1.e
              } {
        if { $NAKLP(tip) == "f" || $NAKLP(pr) == "r" } {
            if { $i != "klient.l2" && $i != "klient.kurs" } {
                pack $w.$i -side left
            }
        } else {
            pack $w.$i -side left
        }
    }
    
    if { $NAKLP(pr) == "r" } {
        foreach i { sklad.l2 sklad.datdolga lgota.l1 lgota.lgotanam  lgota.proc lgota.l2 lgota.lgotaproc lgota.l3 } {
            pack $w.$i -side left
        }
    }
    
    naklphead:other $w.other

    foreach { i } { sklad.skladnam num.operacianam klient.klientnam } {
        bind $w.$i <FocusOut> {
            scan %W "%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%\[^.]" wn
            if { "$NAKLP(old_$wn)" != "$NAKLP($wn)" } {
                regsub -all " " "$NAKLP($wn)" "" lng
                if { $NAKLP(hebutton) == 0 } {
                    if { [string length $lng] > 0 } {
                        #set wn2 $wn
                        naklphead:he$wn u $NAKLP(inwin).naklp.head
                        #set NAKLP(old_$wn2) $NAKLP($wn2)
                    } else { set NAKLP($wn) "" }
                }
            }
        }
    }
    foreach { i } { sklad.skladnam num.operacianam klient.klientnam } {
        bind $w.$i <Button-1> {
            catch [ destroy $NAKLP(inwin).naklp.head.he ]
        }
    }
    bind $w.num.dat <FocusIn> {
        if { $NAKLP(dat) == "" } {
            set NAKLP(dat) $VS(day).$VS(month).$VS(year)
        }
    }
    if [winfo exists $w.sklad.datdolga] {
        bind $w.sklad.datdolga <FocusIn> {
            if { [clipped $NAKLP(datdolga)] == "" } {
                set NAKLP(datdolga) $VS(day).$VS(month).$VS(year)
            }
        }
    }
    bind $w.lgota.lgotaproc <FocusOut> {
        naklp:lgotaproc
    }
    
    if { $NAKLP(tip) != "f" && $NAKLP(pr) != "r" } {
        bind $w.klient.kurs <FocusOut> {
            if { $NAKLP(kurs) > 0 } {
                set NAKLP(kurs) [format "%%.2f" $NAKLP(kurs)]
            }
            if { $NAKLP(old_kurs) != $NAKLP(kurs) && $NAKLP(kurs) > 0 } {
                naklphead:kurs
            }
        }
    }
    if { $NAKLP(cod) == 0 } {
        focus $w.num.num
    }
}

proc naklphead:other { win } {
    foreach { i j } { opl " <F9>" rez " <F4>" otg " <F6>" } {
        button $win.$i -text $j -width 7 -takefocus 0 -wraplength 75 -bg grey80 -command naklp:naklr$i
        pack $win.$i -padx 2 -pady 0
    }
}

proc naklphead:trace:operaciacod { name1 name2 op } {
    global NAKLP
    
    runzaim $NAKLP(inwin).naklp $NAKLP(cod)
}