proc nnakl { st nnaklcod inwin } {
    global VS NNAKL SCHETTOV SCHETNNAKL SCHETNNAKL_DATA NNAKLTOV NNAKLTOV_DATA

    catch [unset NNAKL NNAKLTOV NNAKLTOV_DATA]
    nnaklhead:clear
    nnakltov:clear
    set NNAKL(cod) $nnaklcod
    set NNAKL(inwin) $inwin
    set NNAKL(st) $st
    set w $NNAKL(inwin).nnakl
    set w1 ${w}.menu

    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+73
    wm geometry $w =0x0
    wm title $w " "
    
    trace vdelete NNAKL(window) w nnakl:trace:window
    trace variable NNAKL(window) w nnakl:trace:window
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -state disabled -command nnakl:print
    $w1.1 add cascade -label "" -menu $w1.1.sort -state disabled
        $w1.1.sort add radio -label "  " -variable NNAKLTOV(sortstr) -value "tnam" -command nnakltov:read
        $w1.1.sort add radio -label "  " -variable NNAKLTOV(sortstr) -value "koll" -command nnakltov:read
        $w1.1.sort add radio -label "  " -variable NNAKLTOV(sortstr) -value "enam" -command nnakltov:read
        $w1.1.sort add radio -label " " -variable NNAKLTOV(sortstr) -value "cenaa" -command nnakltov:read
        $w1.1.sort add radio -label "  " -variable NNAKLTOV(sortstr) -value "pnam" -command nnakltov:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable NNAKLTOV(sortdesc) -value " " -command nnakltov:read
        $w1.1.sort add radio -label " " -variable NNAKLTOV(sortdesc) -value "desc" -command nnakltov:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete -state disabled
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command nnakl:delete
    $w1.1 add separator
    $w1.1 add command -label ""
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command nnakl:ok
    button $w.buttons.clear -text "" -command nnakl:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    frame $w.head -bd 1 -relief raised
    frame $w.tov -bd 1 -relief raised
    pack $w.head $w.tov -padx 5 -fill x
        
    foreach {i j} { print  sort  delete  exit } {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -state disabled -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; $w.buttons.exit invoke"}
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        $NNAKL(inwin).nnakl.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        $NNAKL(inwin).nnakl.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Button-1> { 
        if [regexp \.nnakl\.head|\.nnakl\.tov %W] {
            set NNAKL(window) %W 
        }
    }
    bind $w <Button-3> { 
        event generate %W <Button-1>
        if [regexp \.nnakl\.head|\.nnakl\.tov %W] {
            switch -regexp %W {
                \.nnakl\.head { set win $NNAKL(inwin).nnakl.head }
                \.nnakl\.tov  { set win $NNAKL(inwin).nnakl.tov }
            }
            $NNAKL(inwin).nnakl.menu.1 post [winfo pointerx %W] [winfo pointery %W]
        }
    }
    bind $w <Key-Escape> { $NNAKL(inwin).nnakl.buttons.exit invoke }
    bind $w <Control-p>          { postpol:update $NNAKL(inwin).nnakl }
    bind $w <Control-P>          { postpol:update $NNAKL(inwin).nnakl }
    bind $w <Control-ccedilla>   { postpol:update $NNAKL(inwin).nnakl }
    bind $w <Control-Ccedilla>   { postpol:update $NNAKL(inwin).nnakl }
    bind $w <Control-u>          { nnakl:controlu }
    bind $w <Control-U>          { nnakl:controlu }
    bind $w <Control-atilde>     { nnakl:controlu }
    bind $w <Control-Atilde>     { nnakl:controlu }
    
    nnaklhead
    nnakltov
    if { $NNAKL(st) == 0 } nnakl:alldisabled
    wm geometry $w [centerwindow $w]
    nnaklhead:read
    nnakltov:read
}

proc nnakl:iconmenu:state {s l} {
    global NNAKL
    
    set w $NNAKL(inwin).nnakl
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        catch [$w.butimg.$statei configure -state $s]
    }
}

proc nnakl:trace:window { name1 name2 op } {
    global NNAKL NNAKLTOV
    
    set w $NNAKL(inwin).nnakl
    foreach i { head tov } {
        $w.$i.tut configure -fg black -bg gray70 -relief sunken
    }
    nnakl:iconmenu:state disabled "print  sort  delete  "
    switch -regexp $NNAKL(window) {
        \.nnakl\.head {
            nnakl:iconmenu:state normal "print "
            $w.head.tut configure -fg blue -bg gray90 -relief raised
        }
        \.nnakl\.tov {
            if { $NNAKL(cod) > 0 } { 
                nnakl:iconmenu:state normal "sort  delete "
            }
            $w.tov.tut configure -fg blue -bg gray90 -relief raised
        }
    }
}

proc nnakl:print {} {
    global NNAKLTOV NNAKL
    
    switch -regexp $NNAKL(window) {
        \.nnakl\.head {
            nnaklhead:print
        }
    }        
}

proc nnakl:delete {} {
    global NNAKL
    
    switch -regexp $NNAKL(window) {
        \.nnakl\.tov {
            nnakltov:delete
        }
    }        
}

proc nnakl:clear {} {
    global NNAKL
    
    switch -regexp $NNAKL(window) {
        \.nnakl\.head {
            nnaklhead:clear
        }
    }        
}

proc nnakl:ok {} {
    global VS NNAKL NNAKLTOV NNAKLTOV_DATA SCHETNNAKL SCHETNNAKL_DATA

    #  
    if { $NNAKL(num) != $NNAKL(old_num) \
         || $NNAKL(dat) != $NNAKL(old_dat) \
         || $NNAKL(umova) != $NNAKL(old_umova) \
         || $NNAKL(forma) != $NNAKL(old_forma) \
         || $NNAKL(prim1) != $NNAKL(old_prim1) } {
        nnaklhead:update
    }
    #     
    set i 0
    while 1 {
        if [info exists NNAKLTOV_DATA($i,schfnrtovcod)] {
            if { ![info exists NNAKLTOV_DATA($i,cod)] } {
                if { [info exists NNAKLTOV_DATA($i,6)] } {
                    if { $NNAKLTOV_DATA($i,6) >= 0 } { nnakltov:insert $i }
                }
            } else { 
                if { $NNAKLTOV_DATA($i,cod) <= 0 } {
                    if { [info exists NNAKLTOV_DATA($i,6)] } {
                        if { $NNAKLTOV_DATA($i,6) >= 0 } { nnakltov:insert $i }
                    }
                }
                if { $NNAKLTOV_DATA($i,cod) > 0 } {
                    if { [info exists NNAKLTOV_DATA($i,6)] } {
                        if { $NNAKLTOV_DATA($i,old_6) != $NNAKLTOV_DATA($i,6) } {
                            nnakltov:update $i
                        }
                    }
                }
            }
        } else break
        incr i
    }
    if { $NNAKL(inwin) == ".schetfnr.schetnnakl" } schetnnakl:cor
    nnakltov:summa
    set VS($NNAKL(inwin).nnakl_update) 0
}

proc nnakl:alldisabled {} {
    global NNAKL
    
    set w $NNAKL(inwin).nnakl.buttons
    foreach i { ok clear } { $w.$i configure -state disabled }
}

proc nnakl:ident { st } {
    global VS SCHET DOCOPL DOCOPL_DATA
    
    if { $st == "finnaklr" } { 
        set sofnrcod $SCHET(cod)
        set win .schetfnr.top.head.fnr
        set ststr ""
    }
    if { $st == "schetopl" } { 
        set sofnrcod $DOCOPL_DATA($DOCOPL(ActiveRow),cod)
        if [winfo exists .schetfnr.docopl] {
            set win .schetfnr.docopl
        } else {
            set win .snnno.docopl
        }
        set ststr " "
    }
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "   ..." blue
        puts $socks "issofnrnnakl $sofnrcod"
        flush $socks
    
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set nnaklcod $str
        }
       
        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }

    if { $nnaklcod == 0 } {
        if [whatdoing "    $ststr" $win] {
            nnakl:generate $st $sofnrcod
        }
    } else {
        nnakl 0 $nnaklcod $win
    }
}

proc nnakl:controlu {} {
    global NNAKL NNAKLTOV NNAKLTOV_DATA

    switch -regexp [focus] {
        \.nnakl\.head {
            if [info exists NNAKL(cod)] { 
                controlu $NNAKL(cod) nnakl 
            }
        }
        \.nnakl\.tov {
            if [info exists NNAKLTOV_DATA($NNAKLTOV(ActiveRow),cod)] { 
                controlu $NNAKLTOV_DATA($NNAKLTOV(ActiveRow),cod) nnakltov
            }
        }
    }
}