proc nnakllist:summa {} {
    global NNAKLLIST NNAKLLIST_DATA
    
    set i 0
    set NNAKLLIST(snnakl1) 0
    set NNAKLLIST(snnakl2) 0
    while { $i <= $NNAKLLIST(listbox,count) } {
        catch [set NNAKLLIST(snnakl1) [expr $NNAKLLIST(snnakl1) + $NNAKLLIST_DATA(summa,$i)]]
        catch [set NNAKLLIST(snnakl2) [expr $NNAKLLIST(snnakl2) + $NNAKLLIST_DATA(summands,$i)]]
        incr i
    }
}

proc nnakllist:read { } {
    global VS NNAKLLIST NNAKLLIST_DATA
    
    set w .nnakllist.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset NNAKLLIST_DATA]    
    # 1  
    set dat1 [clock format [expr $VS(clock) - 604800 ] -format %d/%m/%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 86400 ] -format %d/%m/%Y]
    if { $NNAKLLIST(sortstr) == "" }    { set NNAKLLIST(sortstr) "dat" } 
    if { $NNAKLLIST(sortdesc) == "" }   { set NNAKLLIST(sortdesc) " "  }
    if { $NNAKLLIST(find) == "" } {
        set NNAKLLIST(find) "dat >= '$dat1' and dat <= '$dat2'"
        if [info exists NNAKLLIST(find,listbox)] {
            if { [lsearch -exact $NNAKLLIST(find,listbox) $NNAKLLIST(find)] == -1} {
                lappend NNAKLLIST(find,listbox) $NNAKLLIST(find)
            }
        } else {
            lappend NNAKLLIST(find,listbox) $NNAKLLIST(find)
        }
    } 
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "nnakllist_sel \"$NNAKLLIST(find)\" \"$NNAKLLIST(sortstr) $NNAKLLIST(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { cod schetcod num dat klientnam summa summands } {
                set NNAKLLIST_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                NNAKLLIST_DATA(cod,$i) \
                NNAKLLIST_DATA(schetcod,$i) \
                NNAKLLIST_DATA(num,$i) \
                NNAKLLIST_DATA(dat,$i) \
                NNAKLLIST_DATA(klientnam,$i) \
                NNAKLLIST_DATA(summa,$i) \
                NNAKLLIST_DATA(summands,$i)
                $w insert end [format "%-6s %-10s %-50.50s %10.2f %10.2f" \
                    $NNAKLLIST_DATA(num,$i) \
                    $NNAKLLIST_DATA(dat,$i) \
                    $NNAKLLIST_DATA(klientnam,$i) \
                    $NNAKLLIST_DATA(summa,$i) \
                    $NNAKLLIST_DATA(summands,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set NNAKLLIST(statusline) " $i ."
        }
        set NNAKLLIST(listbox,count) [expr $i - 1]
        nnakllist:summa
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    update
}

proc nnakllist:delete {} {
    global VS NNAKLLIST NNAKLLIST_DATA
    
    set w .nnakllist.lb.listbox
    if { $NNAKLLIST(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $NNAKLLIST(listbox,curselection)
            puts $socks "nnakl_del $NNAKLLIST_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {}
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            nnakllist:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $NNAKLLIST(listbox,count)} {
            set id $NNAKLLIST(listbox,count)
            set NNAKLLIST(listbox,curselection) $NNAKLLIST(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set NNAKLLIST(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set NNAKLLIST(deletestatus) 0
}

proc nnakllist:print {} {
    global VS NNAKLLIST

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "nnakllist_rep \"$NNAKLLIST(find)\" \"$NNAKLLIST(sortstr) $NNAKLLIST(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc nnakllist:find {} {
    global VS NNAKLLIST
    
    nnakllist:entry
    if { $NNAKLLIST(entrystatus) == 1 } {
        set NNAKLLIST(find) "1=1"
        foreach {i j} " \"$NNAKLLIST(entry,num)\" num \
                        \"$NNAKLLIST(entry,dat)\" dat \
                        \"$NNAKLLIST(entry,klientnam)\" c.nam \
                        \"$NNAKLLIST(entry,summa)\" summa \
                       " {
            if { $i != "" } {
                set NNAKLLIST(find) "$NNAKLLIST(find) and $j [construct $i]"
            }    
        }
        if { [string length [clipped $NNAKLLIST(entry,tovarnam)]] > 0 || \
             [string length [clipped $NNAKLLIST(entry,cena)]] > 0 } {
            nnakllist:find:podzapros
        }
        if { [lsearch -exact $NNAKLLIST(find,listbox) $NNAKLLIST(find)] == -1} {
            lappend NNAKLLIST(find,listbox) $NNAKLLIST(find)
        }
        nnakllist:read
    }
    set NNAKLLIST(entrystatus) 0
}

proc nnakllist:find:podzapros {} {
    global NNAKLLIST
    
    set str_sel "select x1.cod from nnakltov x1, schfnrtov x2, tovar x3 where x1.schfnrtov_cod = x2.cod and x2.tovar_cod = x3.cod and x1.nnakl_cod = a.cod"
    foreach {i j} " \"$NNAKLLIST(entry,tovarnam)\"  x3.nam \
                    \"$NNAKLLIST(entry,cena)\"      x1.summa \
                   " {
        if { $i != "" } {
            set str_sel "$str_sel and $j [construct $i]"
        }    
    }
    set NNAKLLIST(find) "$NNAKLLIST(find) and exists ($str_sel)"
}

proc nnakllist:heklient { tip win } {
    global VS NNAKLLIST HE
    
    set w .nnakllist.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 postpol $NNAKLLIST(entry,klientnam) $tip $win
    set NNAKLLIST(entry,klientcod) $HE(cod)
    set NNAKLLIST(entry,klientnam) [clipped $HE(nam)]
}

proc nnakllist:hetovar { tip win } {
    global VS NNAKLLIST HE
    
    set w .nnakllist.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $NNAKLLIST(entry,tovarnam) $tip $win
    set NNAKLLIST(entry,tovarcod) $HE(cod)
    set NNAKLLIST(entry,tovarnam) [clipped $HE(nam)]
}

