proc operacia { p_r } {
    global VS OPERACIA OPERACIA_DATA

    catch [unset OPERACIA_DATA]
    set OPERACIA(entry,nam) {}
    set OPERACIA(p_r) $p_r
    set OPERACIA(listbox,curselection) 0
    
    set w .operacia
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +176+70
    wm geometry $w =0x0
    if { $OPERACIA(p_r) == 1 }  { wm title $w "  " }
    if { $OPERACIA(p_r) == -1 } { wm title $w "  " }
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "operacia:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "operacia:insert"
    $w1.1 add command -label "" -command "operacia:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable OPERACIA(sortdesc) -value " " -command "operacia:read"
        $w1.1.sort add radio -label " " -variable OPERACIA(sortdesc) -value "desc" -command "operacia:read"
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command "operacia:view"
    $w1.1 add command -state disabled -label "" -command "operacia:update"
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set OPERACIA(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set OPERACIA(deletestatus) 1; operacia:delete" -activebackground red -activeforeground yellow
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable OPERACIA(statusline) -relief sunken -anchor w -padx 3 -width 30
    button $w.buttons.help -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view "" update "" delete "" exit ""} {
        if { $i == "insert" } { findbox operacia 30 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    if { $OPERACIA(p_r) == 1 }  { label $w.namefield.l -font $VS(fontn) -text "   " -relief raised -anchor center -bd 1 -padx 3 -width 26 }
    if { $OPERACIA(p_r) == -1 } { label $w.namefield.l -font $VS(fontn) -text "   " -relief raised -anchor center -bd 1 -padx 3 -width 26 }

    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 31
    pack $w.namefield $w.namefield.l -side top
    pack $w.namefield.p1 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -yscroll "$w.lb.scrollbar set" -height 20 -width 32
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    operacia:read
    
    bind $w.butimg.sort <Button-1> {
        .operacia.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.delete <Button-1> {
        .operacia.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .operacia.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
	    set OPERACIA(statusline) [ %W get $id ]
        set OPERACIA(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .operacia.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  } {
            .operacia.menu.1 entryconfigure [.operacia.menu.1 index $j] -state disabled
            .operacia.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { view  update  delete  } {
            .operacia.menu.1 entryconfigure [.operacia.menu.1 index $j] -state normal
            .operacia.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists OPERACIA_DATA(nam,$OPERACIA(listbox,curselection))] {
            operacia:update
        }
    }
    focus $w.lb.listbox
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists OPERACIA_DATA(cod,$OPERACIA(listbox,curselection))] {
            operacia:update
        }
    }
    bind $w <Key-Escape> { .operacia.buttons.exit invoke }
    bind $w <Key-F5>     { operacia:find }
    bind $w <Key-Insert> { operacia:insert }
}

proc operacia:entry {status} {
    global VS OPERACIA

    set OPERACIA(entrystatus) {}    
    set w .operacia.operaciaentry
    if { $status != "view" && $status != "update"} {
        set OPERACIA(entry,nam) {}
        set OPERACIA(entry,phone_cod) {}
    }
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +186+220
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.l
    label $w.inf.l.name -text " " -anchor e
    
    frame $w.inf.e
    entry $w.inf.e.name -textvariable OPERACIA(entry,nam) -width 30
    if { $status == "view" } {
        $w.inf.e.name configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set OPERACIA(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "set OPERACIA(entry,nam) {}; set OPERACIA(entry,phone_cod) {}"
    button $w.buttons.exit -text "" -command "set OPERACIA(entrystatus) 0; destroy $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.inf.l -side left
    pack $w.inf.e -side right
    pack $w.msg.l -padx 5 -pady 5
    pack $w.inf.l.name -padx 5 -pady 5 -anchor e
    pack $w.inf.e.name -padx 5 -pady 5 -anchor w
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.e.name
    } else {
        focus $w.buttons.exit
    }
    bind $w <Key-Escape> {
        .operacia.operaciaentry.buttons.exit invoke
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
