proc operacia:read {} {
    global VS OPERACIA OPERACIA_DATA
    
    set w .operacia.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset OPERACIA_DATA]
    if { $OPERACIA(sortdesc) == "" }   { set OPERACIA(sortdesc) " "  }
    if { $OPERACIA(find) == "" } {
        set OPERACIA(find) "1=1"
        lappend OPERACIA(find,listbox) $OPERACIA(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "operacia_sel $OPERACIA(p_r) \"$OPERACIA(find)\" \"nam $OPERACIA(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set OPERACIA_DATA(cod,$i) {}; set OPERACIA_DATA(nam,$i) {};
            scan $str "%\[^\t]%*c%\[^\n]" OPERACIA_DATA(cod,$i) OPERACIA_DATA(nam,$i)
            if { [clipped $OPERACIA(entry,nam)] == [clipped $OPERACIA_DATA(nam,$i)] } {
                set OPERACIA(listbox,curselection) $i
            }
            
            $w insert end " $OPERACIA_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set OPERACIA(statusline) " $i ."
        }
        set OPERACIA(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc operacia:find {} {
    global VS OPERACIA
    
    operacia:entry find
    if { $OPERACIA(entrystatus) == 1 } {
        set OPERACIA(find) "1=1"
        foreach {i j} "\"$OPERACIA(entry,nam)\" nam" {
            if { $i != "" } {
                set OPERACIA(find) "$OPERACIA(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $OPERACIA(find,listbox) $OPERACIA(find)] == -1} {
            lappend OPERACIA(find,listbox) $OPERACIA(find)
        }
        operacia:read
    }
    set OPERACIA(entrystatus) 0
}

proc operacia:delete {} {
    global VS OPERACIA OPERACIA_DATA
    
    set w .operacia.lb.listbox
    if { $OPERACIA(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $OPERACIA(listbox,curselection)
            puts $socks "operacia_del $OPERACIA_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            operacia:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $OPERACIA(listbox,count)} {
            set id $OPERACIA(listbox,count)
            set OPERACIA(listbox,curselection) $OPERACIA(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set OPERACIA(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set OPERACIA(deletestatus) 0
}

proc operacia:insert {} {
    global VS OPERACIA
    
    set w .operacia.lb.listbox
    operacia:entry insert
    if { $OPERACIA(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "operacia_ins $OPERACIA(p_r) \"$OPERACIA(entry,nam)\""
            flush $socks
    
            while { [ set operaciacod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            operacia:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $OPERACIA(listbox,curselection)]
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set OPERACIA(entrystatus) 0
}

proc operacia:update {} {
    global VS OPERACIA OPERACIA_DATA

    set w .operacia.lb.listbox
    set OPERACIA(entry,nam) [clipped $OPERACIA_DATA(nam,$OPERACIA(listbox,curselection))]
    operacia:entry update
    if { $OPERACIA(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "operacia_upd $OPERACIA_DATA(cod,$OPERACIA(listbox,curselection)) \"$OPERACIA(entry,nam)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            operacia:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $OPERACIA(listbox,curselection)]
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set OPERACIA(entrystatus) 0
}

proc operacia:view {} {
    global VS OPERACIA OPERACIA_DATA
    
    set OPERACIA(entry,nam) $OPERACIA_DATA(nam,$OPERACIA(listbox,curselection))
    operacia:entry view
    catch [event generate .operacia.lb.listbox <<iconmenu-enabled>>]
}

proc operacia:print {} {
    global VS OPERACIA    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "operacia_rep $OPERACIA(p_r) \"$OPERACIA(find)\" \"nam $OPERACIA(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
