proc oplnototg:read {} {
    global VS OPLNOTOTG OPLNOTOTG_DATA OPLNOTOTG_DATA2
    
    set w .oplnototg.lb.listbox
    event generate .oplnototg.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset OPLNOTOTG_DATA]
    if { $OPLNOTOTG(sortstr) == "" }    { set OPLNOTOTG(sortstr) "3, 8, 9" } 
    if { $OPLNOTOTG(sortdesc) == "" }   { set OPLNOTOTG(sortdesc) " "  }
    if { $OPLNOTOTG(find) == "" } {
        oplnototg:createfind
        lappend OPLNOTOTG(find,listbox) $OPLNOTOTG(find)
    } 
    
    $w delete 0 end
    
    set schetcodold ""
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "oplnototg_sel \"$OPLNOTOTG(entry,datbegin)\" \"$OPLNOTOTG(entry,datend)\" \"$OPLNOTOTG(sortstr) $OPLNOTOTG(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        set ii 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { schetcod schfnrtovcod naklnum nakldat opldat schetnum \
                        klientnam tovarnam cena kol prim1 cenawpdv pdv } {
                set OPLNOTOTG_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                OPLNOTOTG_DATA(schetcod,$i) \
                OPLNOTOTG_DATA(schfnrtovcod,$i) \
                OPLNOTOTG_DATA(naklnum,$i) \
                OPLNOTOTG_DATA(nakldat,$i) \
                OPLNOTOTG_DATA(opldat,$i) \
                OPLNOTOTG_DATA(schetnum,$i) \
                OPLNOTOTG_DATA(klientnam,$i) \
                OPLNOTOTG_DATA(tovarnam,$i) \
                OPLNOTOTG_DATA(cena,$i) \
                OPLNOTOTG_DATA(kol,$i) \
                OPLNOTOTG_DATA(prim1,$i) \
                OPLNOTOTG_DATA(cenawpdv,$i) \
                OPLNOTOTG_DATA(pdv,$i)
            if { $schetcodold != $OPLNOTOTG_DATA(schetcod,$i) } {
                $w insert end [format "%6s %6s %6s %6d %40.40s %50s" \
                    $OPLNOTOTG_DATA(naklnum,$i) \
                    $OPLNOTOTG_DATA(nakldat,$i) \
                    $OPLNOTOTG_DATA(opldat,$i) \
                    $OPLNOTOTG_DATA(schetnum,$i) \
                    $OPLNOTOTG_DATA(klientnam,$i) \
                    $OPLNOTOTG_DATA(prim1,$i)]
                set OPLNOTOTG_DATA2(schetcod,$ii) $OPLNOTOTG_DATA(schetcod,$i)
                incr ii
            }
            $w insert end [format "          %46.46s %9.2f %7.2f %9.2f %9.2f" \
                $OPLNOTOTG_DATA(tovarnam,$i) \
                $OPLNOTOTG_DATA(cena,$i) \
                $OPLNOTOTG_DATA(kol,$i) \
                $OPLNOTOTG_DATA(cenawpdv,$i) \
                $OPLNOTOTG_DATA(pdv,$i)]
            set OPLNOTOTG_DATA2(schetcod,$ii) $OPLNOTOTG_DATA(schetcod,$i)
            incr ii
            set schetcodold $OPLNOTOTG_DATA(schetcod,$i)
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set OPLNOTOTG(statusline) " $i ."
        }
        set OPLNOTOTG(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc oplnototg:print {} {
    global VS OPLNOTOTG    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "oplnototg_rep \"$OPLNOTOTG(entry,datbegin)\" \"$OPLNOTOTG(entry,datend)\" \"$OPLNOTOTG(sortstr) $OPLNOTOTG(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
