proc pricepost { we w } {
    global VS PRICEPOST PRICEPOST_DATA

    catch [unset PRICEPOST]
    frame $w.buttons -relief sunken -bd 1
    button $w.buttons.ok -bd 3 -relief groove -text "" -command pricepost:write
    button $w.buttons.exit -text "" -command "destroy $we"
    pack $w.buttons -side bottom -pady 2
    pack $w.buttons.ok $w.buttons.exit -side left -padx 5
    if { $VS(login) != "julia" && $VS(login) != "slon2" && $VS(login) != "vlad" && $VS(login) != "olga" } {
        $w.buttons.ok configure -state disabled
    }
    bind $w <Key-Escape> [list $w.buttons.exit invoke ]
    
    #    ###################################################################
    
    set PRICEPOST(rows) 20
    frame $w.tov
    pack $w.tov
    entry $w.tov.curfldval -textvar PRICEPOST_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.tov.sby -takefocus 0 -command " $w.tov.tbl yview "
    scrollbar $w.tov.sbx -takefocus 0 -command " $w.tov.tbl xview " -orient horizontal
    table $w.tov.tbl -width 2 -height 20 -cols 2 -rows $PRICEPOST(rows) \
        -yscrollcommand " $w.tov.sby set " \
        -xscrollcommand " $w.tov.sbx set " \
        -cursor arrow \
        -variable PRICEPOST_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -drawmode fast \
        -browsecommand { pricepost:browsecommand %W %S } \
        -wrap on
        
    $w.tov.tbl tag config title -fg yellow
    $w.tov.tbl tag config sel -bg grey85
    $w.tov.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tov.tbl
    $w.tov.tbl tag row AnchorCenter -2 -1
    $w.tov.tbl tag col AnchorE 1
    $w.tov.tbl tag col Disabled 0
    $w.tov.tbl width 0 50  1 9
    pack $w.tov.curfldval -anchor w
    pack $w.tov.sbx -side bottom -fill x
    pack $w.tov.tbl -side left
    pack $w.tov.sby -side right -fill y
            
    bind $w.tov.curfldval <Return> [list tkTableMoveCell $w.tov.tbl 0 1]
    focus $w.tov.tbl
    pricepost:read $w
}

proc pricepost:browsecommand { w rowcol } {
    global PRICEPOST PRICEPOST_DATA
    
    if { [info exists PRICEPOST(ActiveRow)] && $PRICEPOST(ActiveRow) >= 0 && \
         $PRICEPOST_DATA($PRICEPOST(ActiveRow),cod) != -1 } {
        $w tag row UnSelectRow $PRICEPOST(ActiveRow)
    }
    set PRICEPOST(ActiveRowCol) $rowcol 
    scan $PRICEPOST(ActiveRowCol) "%\[^,]%*c%s" PRICEPOST(ActiveRow) PRICEPOST(ActiveCol)
    if { $PRICEPOST(ActiveRow) >= 0 && $PRICEPOST_DATA($PRICEPOST(ActiveRow),cod) != -1 } {
        $w tag row SelectRow $PRICEPOST(ActiveRow)
    }
}
