proc prodaga { } {
    global VS PRODAGA SCHETTOV PRODAGA_DATA

    catch [unset PRODAGA_DATA]
    set PRODAGA(listbox,curselection) 0
    if ![info exists PRODAGA(entry,clockdatbegin)] {
        set PRODAGA(entry,datbegin) "$VS(day).$VS(month).$VS(year)"
        set PRODAGA(entry,datend)   "$VS(day).$VS(month).$VS(year)"
        set PRODAGA(entry,clockdatbegin) $VS(clock)
        set PRODAGA(entry,clockdatend) $VS(clock)
    }
    set w .prodaga
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +5+55
    wm geometry $w =0x0
    set titstr "  "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "prodaga:entry"
    $w1.1 add command -label "" -command "prodaga:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable PRODAGA(sortstr) -value "6, 2, 12" -command prodaga:read
        $w1.1.sort add radio -label "  " -variable PRODAGA(sortstr) -value "3, 9, 2, 12" -command prodaga:read
        $w1.1.sort add radio -label "  " -variable PRODAGA(sortstr) -value "4, 9, 2, 12" -command prodaga:read
        $w1.1.sort add radio -label "  " -variable PRODAGA(sortstr) -value "8, 3, 9, 2, 12" -command prodaga:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable PRODAGA(sortdesc) -value " " -command prodaga:read
        $w1.1.sort add radio -label " " -variable PRODAGA(sortdesc) -value "desc" -command prodaga:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -accelerator "<Enter>" -command prodaga:schet
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable PRODAGA(statusline) -relief sunken -anchor w -padx 3 -width 60
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find  print  sort  schet  exit } {
        if { $i == "print" } { findbox prodaga 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""}  { $w.butimg.$i configure -state disabled }
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    foreach i { p1 p2 p3 p4 } {
        frame $w.namefield.$i
    }
    label $w.namefield.p1.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p2.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p3.1 -text "N" -relief raised -anchor center -bd 1
    label $w.namefield.p4.1 -text "      " -relief raised -anchor w -bd 1
    
    label $w.namefield.p1.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p1.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p2.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p3.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p4.2 -text " " -relief raised -anchor center -bd 1 -padx 1
    label $w.namefield.p4.3 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p4.4 -text ". " -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p4.5 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p4.6 -text ". " -relief raised -anchor center -bd 1 -padx 1 -width 8
    label $w.namefield.p4.7 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p1 p2 p3 p4 } {
        pack $w.namefield.$i -anchor w -side left
    }
    foreach i { p1.1 p2.1 p3.1 p4.1 } {
        pack $w.namefield.$i -fill x
    }
    foreach i { p1.2 p1.3 p2.2 p3.2 p4.2 p4.3 p4.4 p4.5 p4.6 p4.7 } {
        pack $w.namefield.$i -side left
    }
    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 94
    
    pack $w.lb -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    prodaga:entry
    
    bind $w.butimg.sort <Button-1> {
        .prodaga.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .prodaga.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set PRODAGA(statusline) [ %W get $id ]
        set PRODAGA(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .prodaga.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { schet  } {
            .prodaga.menu.1 entryconfigure [.prodaga.menu.1 index $j] -state disabled
            .prodaga.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { schet  } {
            .prodaga.menu.1 entryconfigure [.prodaga.menu.1 index $j] -state normal
            .prodaga.butimg.$i configure -state normal
        }
    }
    bind $w <Key-Escape> { .prodaga.buttons.exit invoke }
    bind $w <Key-F5>     { prodaga:entry }
    bind $w <Key-Return> { 
        event generate %W <B1-ButtonRelease>
        prodaga:schet 
    }
    focus $w.lb.listbox
}

proc prodaga:entry:createvar {} {
    global PRODAGA
    
    foreach i { datbegin datend } {
        if ![info exists PRODAGA(entry,$i)] {
            set PRODAGA(entry,$i) ""
        }
    }
}

proc prodaga:entry {} {
    global VS PRODAGA
    
    set w .prodaga.entry
    prodaga:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +200+78
    wm geometry $w =0x0
    frame $w.msg
    wm title $w "  "
    label $w.msg.l -font $VS(fontn) -text "   "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tit datbegin datend } {
        frame $w.inf.$i
        pack $w.inf.$i -padx 3 -pady 3
        if { $i == "tit" || $i == "datend" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tit        ",   :"
                      datbegin   "  " \
                      datend     " " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {datbegin   datbegin      10 \
                       datend     datend        10 \
                       } {
        entry $w.inf.$i.e -textvariable PRODAGA(entry,$j) -width $k
    }
    
    foreach { i j } { ControlUp datbegin.bu ControlDown datbegin.bd ControlUp datend.bu ControlDown datend.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.datbegin.bd configure -command "prodaga:incrdate - datbegin"
    $w.inf.datbegin.bu configure -command "prodaga:incrdate + datbegin"
    $w.inf.datend.bd configure -command "prodaga:incrdate - datend"
    $w.inf.datend.bu configure -command "prodaga:incrdate + datend"
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "destroy $w; prodaga:read"
    button $w.buttons.exit -text "" -command "destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { datbegin.e datend.e } {
        pack $w.inf.$i -side left
    }
    foreach i { datbegin.bu datbegin.bd datend.bu datend.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.datbegin.e
    bind $w <Key-Escape>     { .prodaga.entry.buttons.exit invoke }
    bind $w <Control-Return> { .prodaga.entry.buttons.ok invoke }
    bind $w.inf.datbegin.e <KeyPress-Next>  { prodaga:incrdate - datbegin }
    bind $w.inf.datbegin.e <KeyPress-Prior> { prodaga:incrdate + datbegin }
    bind $w.inf.datend.e   <KeyPress-Next>  { prodaga:incrdate - datend }
    bind $w.inf.datend.e   <KeyPress-Prior> { prodaga:incrdate + datend }
    wm geometry $w [centerwindow $w]
    tkwait window $w
    prodaga:createfind
    if ![info exists PRODAGA(find,listbox)] { set PRODAGA(find,listbox) "" }
    if { [lsearch -exact $PRODAGA(find,listbox) $PRODAGA(find)] == -1} {
        lappend PRODAGA(find,listbox) $PRODAGA(find)
    }
}

proc prodaga:incrdate { k d } {
    global PRODAGA
    
    set PRODAGA(entry,clock$d) [expr $PRODAGA(entry,clock$d) $k 86400 ]
    set PRODAGA(entry,$d) [clock format $PRODAGA(entry,clock$d) -format %d.%m.%Y]
}

proc prodaga:createfind {} {
    global PRODAGA
    
    catch [set PRODAGA(find) ":  $PRODAGA(entry,datbegin)  $PRODAGA(entry,datend)"]
}

proc prodaga:schet {} {
    global PRODAGA_DATA2 PRODAGA
    
    schetfnr 1 $PRODAGA_DATA2(schetcod,$PRODAGA(listbox,curselection))
}
