proc prodaga:read {} {
    global VS PRODAGA PRODAGA_DATA PRODAGA_DATA2
    
    set w .prodaga.lb.listbox
    event generate .prodaga.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset PRODAGA_DATA]
    if { $PRODAGA(sortstr) == "" }    { set PRODAGA(sortstr) "3, 9, 2, 12" } 
    if { $PRODAGA(sortdesc) == "" }   { set PRODAGA(sortdesc) " "  }
    if { $PRODAGA(find) == "" } {
        prodaga:createfind
        lappend PRODAGA(find,listbox) $PRODAGA(find)
    } 
    
    $w delete 0 end
    
    set schetcodold ""
    set schfnrtovcodold ""
    set oldkolprod 0
    set oldkolspiss 0
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "prodaga_sel \"$PRODAGA(entry,datbegin)\" \"$PRODAGA(entry,datend)\" \"$PRODAGA(sortstr) $PRODAGA(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        set ii 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { schetcod schfnrtovcod naklnum nakldat opldat schetnum \
                        zkpo klientnam tovarnam cenaprod cenaprodwpdv kolprod \
                        cenapost kolspis nacenka } {
                set PRODAGA_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                PRODAGA_DATA(schetcod,$i) \
                PRODAGA_DATA(schfnrtovcod,$i) \
                PRODAGA_DATA(naklnum,$i) \
                PRODAGA_DATA(nakldat,$i) \
                PRODAGA_DATA(opldat,$i) \
                PRODAGA_DATA(schetnum,$i) \
                PRODAGA_DATA(zkpo,$i) \
                PRODAGA_DATA(klientnam,$i) \
                PRODAGA_DATA(tovarnam,$i) \
                PRODAGA_DATA(cenaprod,$i) \
                PRODAGA_DATA(cenaprodwpdv,$i) \
                PRODAGA_DATA(kolprod,$i) \
                PRODAGA_DATA(cenapost,$i) \
                PRODAGA_DATA(kolspis,$i) \
                PRODAGA_DATA(kolspiss,$i) \
                PRODAGA_DATA(nacenka,$i)
            if { $schfnrtovcodold != $PRODAGA_DATA(schfnrtovcod,$i) && \
                 $schfnrtovcodold != "" } {
                set nedospisan [expr $oldkolprod - $oldkolspiss]
                if { $nedospisan != 0 } {
                    $w insert end [format "       : %37.37s    %7.2f" \
                        $oldtovarnam \
                        $nedospisan]
                    set PRODAGA_DATA2(schetcod,$ii) $PRODAGA_DATA(schetcod,$i)
                    incr ii
                }
            }
            if { $schetcodold != $PRODAGA_DATA(schetcod,$i) } {
                set schfnrtovcodold ""
                $w insert end [format "%6d %6s %6s %6d %8.8s %50.50s" \
                    $PRODAGA_DATA(naklnum,$i) \
                    $PRODAGA_DATA(nakldat,$i) \
                    $PRODAGA_DATA(opldat,$i) \
                    $PRODAGA_DATA(schetnum,$i) \
                    $PRODAGA_DATA(zkpo,$i) \
                    $PRODAGA_DATA(klientnam,$i)]
                set PRODAGA_DATA2(schetcod,$ii) $PRODAGA_DATA(schetcod,$i)
                incr ii
            }
            if { $schfnrtovcodold != $PRODAGA_DATA(schfnrtovcod,$i) } {
                $w insert end [format "       %40.40s %9.2f %7.2f %9.2f %7.2f %9.2f" \
                    $PRODAGA_DATA(tovarnam,$i) \
                    $PRODAGA_DATA(cenaprodwpdv,$i) \
                    $PRODAGA_DATA(kolprod,$i) \
                    $PRODAGA_DATA(cenapost,$i) \
                    $PRODAGA_DATA(kolspis,$i) \
                    $PRODAGA_DATA(nacenka,$i)]
                set PRODAGA_DATA2(schetcod,$ii) $PRODAGA_DATA(schetcod,$i)
                incr ii
            } else {
                $w insert end [format "                                                                  %9.2f %7.2f %9.2f" \
                    $PRODAGA_DATA(cenapost,$i) \
                    $PRODAGA_DATA(kolspis,$i) \
                    $PRODAGA_DATA(nacenka,$i)]
                set PRODAGA_DATA2(schetcod,$ii) $PRODAGA_DATA(schetcod,$i)
                incr ii
            }
            set schetcodold     $PRODAGA_DATA(schetcod,$i)
            set schfnrtovcodold $PRODAGA_DATA(schfnrtovcod,$i)
            set oldtovarnam     $PRODAGA_DATA(tovarnam,$i)
            set oldkolprod      $PRODAGA_DATA(kolprod,$i)
            set oldkolspiss     $PRODAGA_DATA(kolspiss,$i)
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set PRODAGA(statusline) " $i ."
        }
        set i [expr $i - 1]
        set PRODAGA(listbox,count) $i
        set nedospisan [expr $oldkolprod - $oldkolspiss]
                if { $nedospisan != 0 } {
                    $w insert end [format "       : %37.37s    %7.2f" \
                        $oldtovarnam \
                        $nedospisan]
                    set PRODAGA_DATA2(schetcod,$ii) $PRODAGA_DATA(schetcod,$i)
                    incr ii
                }
        set PRODAGA(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc prodaga:print {} {
    global VS PRODAGA    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "prodaga_rep \"$PRODAGA(entry,datbegin)\" \"$PRODAGA(entry,datend)\" \"$PRODAGA(sortstr) $PRODAGA(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
