proc prodagamat:read {} {
    global VS PRODAGAMAT PRODAGAMAT_DATA
    
    set w .prodagamat.lb.listbox
    event generate .prodagamat.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset PRODAGAMAT_DATA]
    if { $PRODAGAMAT(sortstr) == "" }    { set PRODAGAMAT(sortstr) "2" } 
    if { $PRODAGAMAT(sortdesc) == "" }   { set PRODAGAMAT(sortdesc) " "  }
    if { $PRODAGAMAT(find) == "" } {
        set PRODAGAMAT(find) "1=1"
        lappend PRODAGAMAT(find,listbox) $PRODAGAMAT(find)
    } 
    
    $w delete 0 end
    
    foreach i { sprods sprodsd spoks spoksd snacenkas snacenkasd } {
        set PRODAGAMAT($i) 0
    }
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "prodagamat_sel $PRODAGAMAT(tip) \"$PRODAGAMAT(find)\" \"$PRODAGAMAT(sortstr) $PRODAGAMAT(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { cod num dat klientnam prods prodsd poks poksd nacenkas nacenkasd } {
                set PRODAGAMAT_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                PRODAGAMAT_DATA(cod,$i) \
                PRODAGAMAT_DATA(num,$i) \
                PRODAGAMAT_DATA(dat,$i) \
                PRODAGAMAT_DATA(klientnam,$i) \
                PRODAGAMAT_DATA(prods,$i) \
                PRODAGAMAT_DATA(prodsd,$i) \
                PRODAGAMAT_DATA(poks,$i) \
                PRODAGAMAT_DATA(poksd,$i) \
                PRODAGAMAT_DATA(nacenkas,$i) \
                PRODAGAMAT_DATA(nacenkasd,$i)
            
            $w insert end [format "%5d %6s %23.23s %9.2f %9.2f %9.2f %9.2f %9.2f %9.2f" \
                $PRODAGAMAT_DATA(num,$i) \
                $PRODAGAMAT_DATA(dat,$i) \
                $PRODAGAMAT_DATA(klientnam,$i) \
                $PRODAGAMAT_DATA(prods,$i) \
                $PRODAGAMAT_DATA(prodsd,$i) \
                $PRODAGAMAT_DATA(poks,$i) \
                $PRODAGAMAT_DATA(poksd,$i) \
                $PRODAGAMAT_DATA(nacenkas,$i) \
                $PRODAGAMAT_DATA(nacenkasd,$i)]
            
            foreach j { prods prodsd poks poksd nacenkas nacenkasd } {
                catch [set PRODAGAMAT(s$j) [expr $PRODAGAMAT(s$j) + $PRODAGAMAT_DATA($j,$i)]]
            }
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set PRODAGAMAT(statusline) " $i ."
        }
        set PRODAGAMAT(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc prodagamat:find {} {
    global VS PRODAGAMAT
    
    prodagamat:entry
    if { $PRODAGAMAT(entrystatus) == 1 } {
        set PRODAGAMAT(find) "1=1"
        if { $PRODAGAMAT(tip) != "S" } {
            foreach {i j} "\"$PRODAGAMAT(entry,num)\"         a.num \ 
                           \"$PRODAGAMAT(entry,dat)\"         a.dat \
                           \"$PRODAGAMAT(entry,klientnam)\"   b.nam \
                           \"$PRODAGAMAT(entry,operacianam)\" e.nam \
                           \"$PRODAGAMAT(entry,datotg)\"      c.datotg" {
                if { $i != "" } {
                    set PRODAGAMAT(find) "$PRODAGAMAT(find) and $j [construct $i]"
                }    
            }
        } else {
            foreach {i j} "\"$PRODAGAMAT(entry,num)\"         a.num \ 
                           \"$PRODAGAMAT(entry,dat)\"         a.dat \
                           \"$PRODAGAMAT(entry,klientnam)\"   b.nam \
                           \"$PRODAGAMAT(entry,operacianam)\" e.nam" {
                if { $i != "" } {
                    set PRODAGAMAT(find) "$PRODAGAMAT(find) and $j [construct $i]"
                }    
            }
            if { [string length $PRODAGAMAT(entry,datotg)] > 0 } {
                set PRODAGAMAT(find) "$PRODAGAMAT(find) and exists (select x0.cod from matoperr x0 where x0.schetfnr_cod = a.cod and x0.datotg [construct $PRODAGAMAT(entry,datotg)])"
            }
        }
        if { [lsearch -exact $PRODAGAMAT(find,listbox) $PRODAGAMAT(find)] == -1} {
            lappend PRODAGAMAT(find,listbox) $PRODAGAMAT(find)
        }
        prodagamat:read
    }
    set PRODAGAMAT(entrystatus) 0
}


proc prodagamat:print {} {
    global VS PRODAGAMAT    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "prodagamat_rep \"$PRODAGAMAT(entry,datbegin)\" \"$PRODAGAMAT(entry,datend)\" \"$PRODAGAMAT(sortstr) $PRODAGAMAT(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc prodagamat:heklient { tip win } {
    global VS PRODAGAMAT HE
    
    set w .prodagamat.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 postpol $PRODAGAMAT(entry,klientnam) $tip $win
    set PRODAGAMAT(entry,klientcod) $HE(cod)
    set PRODAGAMAT(entry,klientnam) [clipped $HE(nam)]
}

proc prodagamat:heoperacia { tip win } {
    global VS PRODAGAMAT HE
    
    set w .prodagamat.entry.inf.operacia.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 operaciar $PRODAGAMAT(entry,operacianam) $tip $win
    set PRODAGAMAT(entry,operaciacod) $HE(cod)
    set PRODAGAMAT(entry,operacianam) [clipped $HE(nam)]
}
