proc schettov:summa {} {
    global SCHETTOV SCHETTOV_DATA
    
    set w .schetfnr.tov.itogo
    set i 0
    set SCHETTOV(skol) 0
    set SCHETTOV(scena) 0
    while { [info exists SCHETTOV_DATA($i,1)] && [info exists SCHETTOV_DATA($i,3)]} {
        catch [set SCHETTOV(skol) [expr $SCHETTOV(skol) + $SCHETTOV_DATA($i,1)]]
        catch [set SCHETTOV(scena) [expr $SCHETTOV(scena) + $SCHETTOV_DATA($i,1) * $SCHETTOV_DATA($i,3)]]
        incr i
    }
}

proc schettov:browsecommand { rowcol } {
    global SCHETTOV SCHETTOV_DATA
    
    set w .schetfnr.tov
    if { [info exists SCHETTOV(ActiveRow)] && \
         $SCHETTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $SCHETTOV(ActiveRow)
    }
    #after tovarnam
    if { [ info exists SCHETTOV(ActiveRow) ] && $SCHETTOV(ActiveRow) >= 0 } {
        if { [ info exists SCHETTOV(ActiveCol) ] && $SCHETTOV(ActiveCol) == 0 } {
            if ![ info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),old_0)] { 
                set SCHETTOV_DATA($SCHETTOV(ActiveRow),old_0) "" 
            }
            if ![ info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),0) ] { 
                set SCHETTOV_DATA($SCHETTOV(ActiveRow),0) "" 
            }
            if { $SCHETTOV_DATA($SCHETTOV(ActiveRow),old_0) != $SCHETTOV_DATA($SCHETTOV(ActiveRow),0) && \
                 $SCHETTOV_DATA($SCHETTOV(ActiveRow),0) != "" } {
                schettov:hetovarnam u .schetfnr.tov.tbl
            }
            if { ![ info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),1) ] && 
                [string length $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)] > 0 } { 
                set SCHETTOV_DATA($SCHETTOV(ActiveRow),1) 1 
            }
        }
    }
    set SCHETTOV(ActiveRowCol) $rowcol 
    scan $SCHETTOV(ActiveRowCol) "%\[^,]%*c%s" SCHETTOV(ActiveRow) SCHETTOV(ActiveCol)
    
    # before tovarnam
    if { $SCHETTOV(ActiveCol) == 0 } {
        if [info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),0)] {
            set SCHETTOV_DATA($SCHETTOV(ActiveRow),old_0) $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)
        } 
    }
    schettov:summa
    if { $SCHETTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $SCHETTOV(ActiveRow)
    }
}

proc schetfnr:tov {} {
    global VS SCHETTOV SCHETTOV_DATA SCHETFNR SCHET
    
    set SCHETTOV(rows) 8
    set SCHETTOV(skol) 0
    set SCHETTOV(scena) 0
    set SCHETTOV(sortstr) "tnam"
    set SCHETTOV(sortdesc) ""
    
    set w .schetfnr.tov
    
    frame $w.itogo
    entry $w.curfldval -width 90 -textvar SCHETTOV_DATA(active) -fg red \
        -bg #fffff0 -takefocus 0
    label $w.tut -bg gray70 -wraplength 1 -font $VS(fontn) -width 2 -height 5 -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    pack $w.curfldval -anchor nw
    pack $w.itogo -side bottom -fill x
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 5 -height 8 -cols 5 -rows $SCHETTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable SCHETTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -rowheight $SCHETFNR(widthtbl) \
        -selectmode browse \
        -browsecommand { schettov:browsecommand %S } \
        -wrap on
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    $w.tbl tag col AnchorCenter 2 
    $w.tbl tag col Disabled 2
    $w.tbl tag col AnchorE 1 3
    $w.tbl tag row AnchorCenter -1
    $w.tbl width 0 27 1 8 2 10 3 10 4 34
    
    label $w.itogo.l1 -text "                    :"
    label $w.itogo.skol -textvar SCHETTOV(skol) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.l2 -text "        "
    label $w.itogo.scena -textvar SCHETTOV(scena) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    foreach i { l1 skol l2 scena } {
        pack $w.itogo.$i -side left
    }
    
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    if { $SCHET(cod) != 0 } { focus $w.tbl }
    bind $w.tbl <Key-Insert> { %W configure -rows [incr SCHETTOV(rows)] }
}

