proc schettovt:summa {} {
    global SCHETTOVT SCHETTOVT_DATA SCHETTOV SCHETTOV_DATA
    
    set w .schetfnr.schettovt
    set i 0
    set SCHETTOVT(skol) 0
    set SCHETTOVT(scena) 0
    while { [info exists SCHETTOVT_DATA($i,1)] && [info exists SCHETTOVT_DATA($i,3)]} {
        catch [set SCHETTOVT(skol) [expr $SCHETTOVT(skol) + $SCHETTOVT_DATA($i,1)]]
        catch [set SCHETTOVT(scena) [expr $SCHETTOVT(scena) + $SCHETTOVT_DATA($i,1) * $SCHETTOVT_DATA($i,3)]]
        incr i
    }
    set SCHETTOVT(delta) [expr $SCHETTOV_DATA($SCHETTOV(ActiveRow),1) * $SCHETTOV_DATA($SCHETTOV(ActiveRow),3) - $SCHETTOVT(scena)]
    if { $SCHETTOVT(delta) == 0 } { set color #009000 }
    if { $SCHETTOVT(delta) > 0 } { set color red }
    if { $SCHETTOVT(delta) < 0 } { set color magenta }
    $w.inptov.delta configure -fg $color
}

proc schettovt:browsecommand { rowcol } {
    global SCHETTOVT SCHETTOVT_DATA
    
    set w .schetfnr.schettovt.dat
    if { [info exists SCHETTOVT(ActiveRow)] && \
         $SCHETTOVT(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $SCHETTOVT(ActiveRow)
    }
    #after tovarnam
    if { [ info exists SCHETTOVT(ActiveRow) ] && $SCHETTOVT(ActiveRow) >= 0 } {
        if { [ info exists SCHETTOVT(ActiveCol) ] && $SCHETTOVT(ActiveCol) == 0 } {
            if ![ info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),old_0)] { 
                set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),old_0) "" 
            }
            if ![ info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0) ] { 
                set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0) "" 
            }
            if { $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),old_0) != $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0) && \
                 $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0) != "" } {
                schettovt:hetovarnam u .schetfnr.schettovt.dat.tbl
            }
        }
    }
    
    set SCHETTOVT(ActiveRowCol) $rowcol 
    scan $SCHETTOVT(ActiveRowCol) "%\[^,]%*c%s" SCHETTOVT(ActiveRow) SCHETTOVT(ActiveCol)
    
    if { $SCHETTOVT(ActiveCol) == 0 } {
        if [info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)] {
            set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),old_0) $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)
        }
    }
    schettovt:summa
    if { $SCHETTOVT(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $SCHETTOVT(ActiveRow)
    }
}

proc schettovt {} {
    global SCHETTOV SCHETTOV_DATA VS SCHETTOVT SCHETTOVT_DATA tcl_platform
    
    set w .schetfnr.schettovt
    catch {
        unset SCHETTOVT(ActiveRowCol)
        unset SCHETTOVT(ActiveRow)
        unset SCHETTOVT(ActiveCol)
        unset SCHETTOVT_DATA
    }
    if [info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)] { 
        waiting "  ... " magenta
        if { [ set socks [checkpasswd] ] != -1 } {
            puts $socks "issostav $SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcod)"
            flush $socks
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set cnt $str
            }
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
        } else {
            errormsg nosocks "  !"
        }
        waiting "" ""
        if { $cnt == 0 } { 
            set SCHETTOVT(id) 1
            schettovtd
            schettovtd:tbl1
        }
        if { $cnt > 0 } {
            set SCHETTOVT(id) 2
            schettovtd
            schettovtd:tbl2
        }
        wm geometry $w [centerwindow $w]
        schettovt:read
    }
    tkwait window .schetfnr.schettovt
    set i 0
    set printnam ""
    while { [info exists SCHETTOVT_DATA($i,0)] } {
        if { [clipped $SCHETTOVT_DATA($i,0)] != "" } {
            append printnam "$SCHETTOVT_DATA($i,0)/"
        }
        incr i
    }
    return "\{$SCHETTOVT(scena)\} \{$printnam\}"
}

proc schettovtd {} {
    global VS SCHETTOVT SCHETTOVT_DATA SCHETTOV SCHETTOV_DATA tcl_platform
    
    set SCHETTOVT(skol) 0
    set SCHETTOVT(scena) 0
    set SCHETTOVT(delta) 0
    set SCHETTOVT(sortstr) ""
    set SCHETTOVT(sortdesc) ""
    
    set w .schetfnr.schettovt
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    wm title $w " "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<Ins>" -command schettovt:addrow
    $w1.1 add command -label "" -command schettovt:print
    $w1.1 add cascade -label "" -menu $w1.1.sort
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command schettovt:delete
    $w1.1 add separator
    $w1.1 add command -accelerator "<Control-F3>" -label "   " -command schettovt:lgotaproc
    $w1.1 add command -label "   " -accelerator "<F8>" -command schettovt:whomathtov
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label ""
    #$w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command schettovt:ok
    button $w.buttons.clear -text "" -command schettovt:clear
    button $w.buttons.exit -text "" -command "destroy $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
        
    foreach {i j} { insert "" print "" sort "" delete "" whomathtov "   " exit ""} {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { 
            $w.butimg.$i configure -command "destroy .balloon; $w.buttons.exit invoke"
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    button $w.butimg.lgota -takefocus 0 -bitmap @$VS(dir)Lgota.xbm -command schettovt:lgotaproc
    pack $w.butimg.lgota -before $w.butimg.exit -side left
    bind $w.butimg.lgota <Leave> { destroy .balloon }
    bind $w.butimg.lgota <Enter> { bindballoon %W }
    
    bind $w.butimg.delete <Button-1> {
        .schetfnr.schettovt.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        .schetfnr.schettovt.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind .schetfnr.schettovt <Button-3> { 
        set win .schetfnr.schettovt.dat.tbl
        .schetfnr.schettovt.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w <KeyPress-Insert>   { schettovt:addrow }
    bind $w <Key-Escape>        { .schetfnr.schettovt.buttons.exit invoke }
    bind $w <Control-u>         { schettovt:controlu }
    bind $w <Control-U>         { schettovt:controlu }
    bind $w <Control-atilde>    { schettovt:controlu }
    bind $w <Control-Atilde>    { schettovt:controlu }
    bind $w <Control-F3>        { schettovt:lgotaproc }
    bind $w <Key-F8>            { schettovt:whomathtov }
    bind $w <Key-F12>           { prodmattov $SCHETTOV_DATA($SCHETTOV(ActiveRow),cod) k " $SCHETTOV_DATA($SCHETTOV(ActiveRow),0))" .schetfnr.schettovt }
    
    if { $SCHETTOVT(id) == 1 } {
        set we 82
        set anc center
    } else {
        set we 70
        set anc e
    }
    entry $w.curfldval -width $we -textvar SCHETTOVT_DATA(active) -fg red -bg #fffff0
    label $w.tut -font $VS(fontn) -text "   " -relief raised -bd 1
    pack $w.tut
    foreach i { inptov dat itogo } {
        frame $w.$i
        pack $w.$i
        if { $i == "inptov" } { pack $w.curfldval -anchor $anc}
    }
    foreach { i j } { tovarnam 50 kol 8 cena 10 l1 7 delta 10 } {
        label $w.inptov.$i -bd 1 -relief sunken -bg gray40 -fg green -width $j
        pack $w.inptov.$i -side left
    }
    $w.inptov.tovarnam configure -anchor w -text $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)
    $w.inptov.kol configure -anchor e -text $SCHETTOV_DATA($SCHETTOV(ActiveRow),1)
    $w.inptov.cena configure -anchor e -text $SCHETTOV_DATA($SCHETTOV(ActiveRow),3)
    $w.inptov.l1 configure -text " " -relief flat -bg gray85 -fg black
    $w.inptov.delta configure -anchor e -textvar SCHETTOVT(delta) -anchor e -bg gray75
    if { $tcl_platform(platform) == "windows" } { wm geometry $w [centerwindow $w] }
}

proc schettovtd:tbl1 {} {
    global VS SCHETTOVT SCHETTOVT_DATA
    
    set SCHETTOVT(rows) 10
    set w .schetfnr.schettovt
    set w1 ${w}.menu
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "tnam" -command schettovt:read
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "kol" -command schettovt:read
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "enam" -command schettovt:read
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortstr) -value "cena" -command schettovt:read
    $w1.1.sort add separator
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortdesc) -value " " -command schettovt:read
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortdesc) -value "desc" -command schettovt:read
    $w1.1.sort add separator
    $w1.1.sort add command -label "" 
    
    scrollbar $w.dat.sby -takefocus 0 -command " $w.dat.tbl yview "
    table $w.dat.tbl -width 4 -height 10 -cols 4 -rows $SCHETTOVT(rows) \
        -yscrollcommand " $w.dat.sby set " \
        -cursor arrow \
        -variable SCHETTOVT_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { schettovt:browsecommand %S } \
        -wrap on
        
    $w.dat.tbl tag config title -fg yellow
    $w.dat.tbl tag config sel -bg grey85
    $w.dat.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.dat.tbl
    $w.dat.tbl tag col AnchorCenter 2 
    $w.dat.tbl tag col Disabled 2
    $w.dat.tbl tag col AnchorE 1 3
    $w.dat.tbl tag row AnchorCenter -1
    $w.dat.tbl width 0 50 1 8 2 10 3 11
    
    label $w.itogo.l1 -text "                                        :"
    label $w.itogo.skol -textvar SCHETTOVT(skol) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.l2 -text "         "
    label $w.itogo.scena -textvar SCHETTOVT(scena) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    foreach i { l1 skol l2 scena } {
        pack $w.itogo.$i -side left
    }
    
    pack $w.dat.tbl -side left
    pack $w.dat.sby -side right -fill y
    
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    focus $w.dat.tbl
#    schettovt:read
}

proc schettovtd:tbl2 {} {
    global VS SCHETTOVT SCHETTOVT_DATA
    
    set SCHETTOVT(rows) 18
    set w .schetfnr.schettovt
    set w1 ${w}.menu
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "5" -command schettovt:read
    $w1.1.sort add radio -label "   " -variable SCHETTOVT(sortstr) -value "4" -command schettovt:read
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "6" -command schettovt:read
    $w1.1.sort add radio -label "  " -variable SCHETTOVT(sortstr) -value "7" -command schettovt:read
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortstr) -value "8" -command schettovt:read
    $w1.1.sort add radio -label "  !" -variable SCHETTOVT(sortstr) -value "9" -command schettovt:read
    $w1.1.sort add separator
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortdesc) -value " " -command schettovt:read
    $w1.1.sort add radio -label " " -variable SCHETTOVT(sortdesc) -value "desc" -command schettovt:read
    $w1.1.sort add separator
    $w1.1.sort add command -label "" 
    
    scrollbar $w.dat.sby -takefocus 0 -command " $w.dat.tbl yview "
    table $w.dat.tbl -width 5 -height 18 -cols 5 -rows $SCHETTOVT(rows) \
        -yscrollcommand " $w.dat.sby set " \
        -cursor arrow \
        -variable SCHETTOVT_DATA \
        -titlerows 1 \
        -titlecols 1 \
        -roworigin -1 \
        -colorigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { schettovt:browsecommand %S } \
        -wrap on
        
    $w.dat.tbl tag config title -fg yellow
    $w.dat.tbl tag config sel -bg grey85
    $w.dat.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.dat.tbl
    $w.dat.tbl tag col AnchorCenter 2 
    $w.dat.tbl tag col Disabled 2
    $w.dat.tbl tag col AnchorE 1 3
    $w.dat.tbl tag row AnchorCenter -1
    $w.dat.tbl tag col FgGreen -1
    $w.dat.tbl width -1 24 0 40 1 9 2 8 3 10
    
    label $w.itogo.l1 -text "                                                       :"
    label $w.itogo.skol -textvar SCHETTOVT(skol) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.l2 -text "      "
    label $w.itogo.scena -textvar SCHETTOVT(scena) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    foreach i { l1 skol l2 scena } {
        pack $w.itogo.$i -side left
    }
    
    pack $w.dat.tbl -side left
    pack $w.dat.sby -side right -fill y
    
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    focus $w.dat.tbl
#    schettovt:read
}

proc schettovt:ok {} {
    global SCHETTOVT SCHETTOVT_DATA

    set i 0
    while 1 {
        if [info exists SCHETTOVT_DATA($i,1)] {
            if [ string length [clipped $SCHETTOVT_DATA($i,1)]] {
            if ![info exists SCHETTOVT_DATA($i,cod)] {
                schettovt:insert $i
            } else { 
                if { $SCHETTOVT_DATA($i,cod) <= 0 } {
                    schettovt:insert $i
                }
                if { $SCHETTOVT_DATA($i,cod) > 0 } {
                    if { $SCHETTOVT_DATA($i,old_1) != $SCHETTOVT_DATA($i,1) || \
                         $SCHETTOVT_DATA($i,old_3) != $SCHETTOVT_DATA($i,3) } {
                        schettovt:update $i
                    }
                }
            }
            }
        } else break
        incr i
    }
}

proc schettovt:addrow {} {
    global SCHETTOVT

    .schetfnr.schettovt.dat.tbl configure -rows [incr SCHETTOVT(rows)]
}

proc schettovt:controlu {} {
    global SCHETTOVT SCHETTOVT_DATA

    if [info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),cod)] { 
        controlu $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),cod) schfnrtovt
    }
}

proc schettovt:whomathtov {} {
    global SCHETTOVT_DATA SCHETTOVT
    
    if [info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovarcod)] {
        whomathtov .schetfnr.schettovt $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovarcod) $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)
    }
}
