proc sernum { tip } {
    global VS SERNUM SERNUMTOV SERNUMTOV_DATA

    catch [unset SERNUMTOV_DATA]
    sernumtov:clear
    set SERNUM(tip) $tip
    set SERNUM(find) ""
    switch $tip {
        "p" { set titstr "" }
        "r" { set titstr "" }
    }
    set SERNUM(titstr) $titstr
    set w .sernum
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+55
    wm geometry $w =0x0
    wm title $w "   $titstr"
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "sernum:find"
    $w1.1 add command -label "" -command "sernum:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "   " -variable SERNUM(sortstr) -value "2" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "3" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "4" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "5" -command sernum:read
        $w1.1.sort add radio -label " " -variable SERNUM(sortstr) -value "6" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "7" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "9" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "10" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "11" -command sernum:read
        $w1.1.sort add radio -label "  " -variable SERNUM(sortstr) -value "12" -command sernum:read
        $w1.1.sort add radio -label " " -variable SERNUM(sortstr) -value "13" -command sernum:read
        $w1.1.sort add radio -label " " -variable SERNUM(sortstr) -value "14" -command sernum:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable SERNUM(sortdesc) -value " " -command sernum:read
        $w1.1.sort add radio -label " " -variable SERNUM(sortdesc) -value "desc" -command sernum:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -command "sernumtov:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command  -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command sernum:ok
    button $w.buttons.clear -text "" -command sernum:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find  print  sort  delete  exit  } {
        if { $i == "print" } { findbox sernum 60 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroya $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    if { $SERNUM(tip) == "r" } {
        $w.butimg.delete configure -state disabled
        $w.menu.1 entryconfigure [$w.menu.1 index ""] -state disabled
    }
    
    bind $w.butimg.delete <Button-1> {
        .sernum.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        .sernum.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { .sernum.buttons.exit invoke }
    bind $w <Key-F5>     { sernum:find }
    sernumhead    
    wm geometry $w [centerwindow $w]
    sernum:read
}

proc sernum:entry:createvar {} {
    global SERNUM
    
    foreach i { tipdoc num dat skladnam operacianam klientnam tovarnam \
                sernum dat_gar cena cenad } {
        if ![info exists SERNUM(entry,$i)] {
            set SERNUM(entry,$i) ""
        }
    }
}

proc sernum:entry:clearvar {} {
    global SERNUM
    
    foreach i { tipdoc num dat skladnam operacianam klientnam tovarnam \
                sernum dat_gar cena cenad } {
        set SERNUM(entry,$i) ""
    }
}

proc sernum:entry {} {
    global VS SERNUM
    
    set w .sernum.entry
    set SERNUM(entrystatus) ""
    sernum:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tipdoc num dat sklad operacia klient tovar \
                    sernum dat_gar cena cenad } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "klient" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tipdoc   "       " \
                      num      "              " \
                      dat      "               " \
                      sklad    "              " \
                      operacia "           " \
                      klient   "             " \
                      tovar    " " \
                      sernum   "      " \
                      dat_gar  "       " \
                      cena     "               " \
                      cenad    "               " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {tipdoc   tipdoc      30 \
                       num      num         20 \
                       dat      dat         20 \
                       sklad    skladnam    50 \
                       operacia operacianam 50 \
                       klient   klientnam   50 \
                       tovar    tovarnam    50 \
                       sernum   sernum      30 \
                       dat_gar  dat_gar     15 \
                       cena     cena        20 \
                       cenad    cenad       20 \
                       } {
        entry $w.inf.$i.e -textvariable SERNUM(entry,$j) -width $k
    }
    button $w.inf.tipdoc.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sernum:hetipdoc r .sernum.entry }
    button $w.inf.sklad.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sernum:hesklad r .sernum.entry }
    button $w.inf.operacia.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sernum:heoperacia r .sernum.entry }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sernum:heklient r .sernum.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sernum:hetovar r .sernum.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SERNUM(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "sernum:entry:clearvar"
    button $w.buttons.exit -text "" -command "set SERNUM(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { tipdoc.e tipdoc.b num.e dat.e sklad.e sklad.b \
                operacia.e operacia.b klient.e klient.b \
                tovar.e tovar.b sernum.e dat_gar.e cena.e cenad.e \
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.tipdoc.e
    bind $w <Key-Escape>     { .sernum.entry.buttons.exit invoke }
    bind $w <Control-Return> { .sernum.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc sernum:ok {} {
    global SERNUMTOV_DATA SERNUM VS

    set i 0
    if { $SERNUM(tip) == "p" } {
        while 1 {
            if [info exists SERNUMTOV_DATA($i,opercod)] {
                if ![info exist SERNUMTOV_DATA($i,old_1)] {
                    set sernumold {}
                } else {
                    set sernumold $SERNUMTOV_DATA($i,old_1)
                }
                if ![info exist SERNUMTOV_DATA($i,old_2)] {
                    set dat_garold {}
                } else {
                    set dat_garold $SERNUMTOV_DATA($i,old_2)
                }
                
                if ![info exist SERNUMTOV_DATA($i,1)] {
                    set sernum {}
                } else {
                    set sernum $SERNUMTOV_DATA($i,1)
                }
                if ![info exist SERNUMTOV_DATA($i,2)] {
                    set dat_gar {}
                } else {
                    set dat_gar $SERNUMTOV_DATA($i,2)
                }
                if { $sernum != $sernumold || $dat_gar != $dat_garold } {
                    sernumtov:update $i
                }
            } else break
            incr i
        }
    }
    set VS(.sernum_update) 0
}

proc sernum:clear {} {
    global SERNUMTOV_DATA
    
    set i 0
    while 1 {
        if [info exists SERNUMTOV_DATA($i,opercod)] {
            if { $SERNUMTOV_DATA($i,old_1) != $SERNUMTOV_DATA($i,1) } {
                set SERNUMTOV_DATA($i,1) $SERNUMTOV_DATA($i,old_1)
            }
        } else break
        incr i
    }
}
