proc sernumhead { } {
    global VS SERNUM SERNUM_DATA SERNUMTOV SERNUMTOV_DATA

    set w .sernum
    # head ##################################################################
    
    label $w.tit -font $VS(fontn) -text "    $SERNUM(titstr) " \
        -relief raised -anchor center -bd 1
    pack $w.tit
    
    foreach { i } { tipdoc sklad klient prim1 tovar } {
        if { $i == "tipdoc" || $i == "sklad" || $i == "prim1" || $i == "tovar" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
    }
    frame $w.septov -bd 1 -height 10 -relief sunken
    pack  $w.septov -fill x
    foreach { i j } { tipdoc    "   " \
                      sklad     "     " \
                      klient    "    " \
                      prim1     "" \
                      tovar     "     "
                  } {
        label $w.$i.l1 -text $j
    }
    foreach { i j k } { tipdoc.tipdoc        tipdoc      40 \
                        tipdoc.num           num         10 \
                        tipdoc.dat           dat         10
                        sklad.skladnam       skladnam    30 \
                        sklad.operacianam    operacianam 30 \
                        klient.klientnam     klientnam   50 \
                        prim1.e              prim1       60 \
                        tovar.e              tovarnam    50 \
                        tovar.datotg         datotg      10 \
                      } {
        entry $w.$i -textvar SERNUM_DATA($j) -width $k -state disabled
    }
    foreach i { tipdoc.num tipdoc.dat tovar.datotg } {
        $w.$i configure -bg grey95
    }
    foreach { i j } { tipdoc.l2     "    " \
                      tipdoc.l3     " " \
                      sklad.l2      "           " \
                      tovar.l2      "  " \
                  } {
        label $w.$i -text $j
    }
    
    foreach i { tipdoc.l1 tipdoc.tipdoc tipdoc.l2 tipdoc.num tipdoc.l3 tipdoc.dat \
                sklad.l1 sklad.skladnam sklad.l2 sklad.operacianam \
                klient.l1 klient.klientnam \
                prim1.l1 prim1.e \
                tovar.l1 tovar.e
              } {
        pack $w.$i -side left
    }
    if { $SERNUM(tip) == "r" } {
        foreach i { tovar.l2 tovar.datotg } {
            pack $w.$i -side left
        }
    }

    # tov ####################################################################

    set SERNUMTOV(rows) 12
    frame $w.tov
    set w "$w.tov"
    pack $w
    entry $w.curfldval -textvar SERNUMTOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 6 -height 12 -cols 6 -rows $SERNUMTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable SERNUMTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { sernumtov:browsecommand %S } \
        -wrap on
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    $w.tbl tag row AnchorCenter -1
    $w.tbl tag col Disabled 0 3 4 5
    if { $SERNUM(tip) == "r" } { $w.tbl tag col Disabled 2 }
    $w.tbl width 0 31 1 20 2 11 3 10 4 11 5 11

    pack $w.curfldval -anchor w
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
            
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind .sernum.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        .sernum.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    focus $w.tbl
}

proc sernumtov:browsecommand { rowcol } {
    global SERNUMTOV SERNUMTOV_DATA SERNUM SERNUM_DATA
    
    set w .sernum
    if { [info exists SERNUMTOV(ActiveRow)] && \
         $SERNUMTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row UnSelectRow $SERNUMTOV(ActiveRow)
    }
    set SERNUMTOV(ActiveRowCol) $rowcol 
    scan $SERNUMTOV(ActiveRowCol) "%\[^,]%*c%s" SERNUMTOV(ActiveRow) SERNUMTOV(ActiveCol)
    
    if [info exists SERNUMTOV_DATA($SERNUMTOV(ActiveRow),opercod)] {
        foreach i {tipdoc num dat skladnam operacianam klientnam prim1 datotg } {
            set SERNUM_DATA($i) $SERNUMTOV_DATA($SERNUMTOV(ActiveRow),$i)
        }
        set SERNUM_DATA(tovarnam) $SERNUMTOV_DATA($SERNUMTOV(ActiveRow),0)
    } else {
        sernumhead:clear
    }
    if { $SERNUMTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row SelectRow $SERNUMTOV(ActiveRow)
    }
}

