proc sklad {} {
    global VS SKLAD SOTSS SKLAD_DATA

    catch [unset SKLAD_DATA]
    set SKLAD(entry,nam) {}
    set SKLAD(listbox,curselection) 0
    set SKLAD(sortdesc) {}
    set SKLAD_DATA(cod,0) 0
    
    set w .sotss.sklad
    catch [destroy $w]
    
    frame $w -bd 5
    pack $w -side right
    frame $w.nameform
    label $w.nameform.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3
    frame $w.namefield
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 35
    pack $w.nameform $w.nameform.l
    sklad:search
    pack $w.namefield
    pack $w.namefield.p1 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -yscroll "$w.lb.scrollbar set" -height 15 -width 32
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    bind $w.lb.listbox <Button-1> {
        set SOTSS(window) %W
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        event generate %W <<sklad:set:variable>>
        event generate %W <<sklad:run:read>>
    }
    bind $w.lb.listbox <<sklad:set:variable>> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set SOTSS(statusline) [ %W get $id ]
        set SKLAD(listbox,curselection) $id
        if { [winfo exists .sotss.sesot] == 0 } {
            sotss:select:element sot
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists SKLAD_DATA(nam,$SKLAD(listbox,curselection))] {
            sklad:view
        }
    }
    bind $w.lb.listbox <Button-3> {
        set SOTSS(window) %W
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <<sklad:set:variable>>
        .sotss.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
}

proc sklad:search {} {
    global VS
    
    set w .sotss.sklad.search
    frame $w
    label $w.lfind -relief sunken -width 31 -textvariable SKLAD(find) -anchor w
    button $w.lfindb -bitmap @$VS(dir)ComboBox.xbm -command sklad:search:lb 
    pack $w
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { sklad:search:lb }
}

proc sklad:search:lb {} {
    global VS SKLAD SOTSS
    
    set w .sotss.sklad.search.lfindlb
    catch [destroy $w]
    set x [winfo rootx .sotss.sklad.search.lfind]
    set y [winfo rooty .sotss.sklad.search.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width 31
    
    foreach {i} $SKLAD(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $SKLAD(find,listbox) $SKLAD(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set SKLAD(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable SKLAD(find)
    destroy $w
    sklad:read
}

proc sklad:entry {status} {
    global VS SKLAD
    
    set SKLAD(entrystatus) ""
    set w .sotss.sklad.skladentry
    if { $status != "view" && $status != "update"} {
        set SKLAD(entry,nam) ""
    }
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +215+218
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.nam
    pack $w.inf.nam -anchor w -padx 3 -pady 3
    label $w.inf.nam.l -text " "
    entry $w.inf.nam.e -textvariable SKLAD(entry,nam) -width 30
    
    if { $status == "view" } {
        $w.inf.nam.e configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SKLAD(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "set SKLAD(entry,nam) {} "
    button $w.buttons.exit -text "" -command "set SKLAD(entrystatus) 0; destroy $w"

    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.inf.nam.l $w.inf.nam.e -side left
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.nam.e
    } else {
        focus $w.buttons.exit
    }
    bind $w <Key-Escape> {
        .sotss.sklad.skladentry.buttons.exit invoke
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
