proc sklad:read {} {
    global VS SKLAD SKLAD_DATA SOTSS SOT SOT_DATA
    
    catch [destroy .sotss.sklad.search.lfindlb]
    set w .sotss.sklad.lb.listbox
    waiting "  ..." blue
    catch [unset SKLAD_DATA]
    if { $SKLAD(sortdesc) == "" }   { set SKLAD(sortdesc) " "  }
    if { $SKLAD(find) == "" } {
        set SKLAD(find) "1=1"
        lappend SKLAD(find,listbox) $SKLAD(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sklad_selmo \"$SOT_DATA(cod,$SOT(listbox,curselection))\" \"$SKLAD(find)\" \"nam $SKLAD(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SKLAD_DATA(cod,$i) "";      set SKLAD_DATA(nam,$i) ""
            scan $str "%\[^\t]%*c%\[^\n]" SKLAD_DATA(cod,$i) SKLAD_DATA(nam,$i)
            if { [clipped $SKLAD(entry,nam)] == [clipped $SKLAD_DATA(nam,$i)] } {
                set SKLAD(listbox,curselection) $i
            }
            $w insert end " $SKLAD_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set SOTSS(statusline) " $i ."
        }
        set SKLAD(listbox,count) [expr $i - 1]
        $w see $SKLAD(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc sklad:find {} {
    global VS SKLAD
    
    sklad:entry find
    if { $SKLAD(entrystatus) == 1 } {
        set SKLAD(find) "1=1"
        foreach {i j} "\"$SKLAD(entry,nam)\" nam" {
            if { $i != "" } {
                set SKLAD(find) "$SKLAD(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $SKLAD(find,listbox) $SKLAD(find)] == -1} {
            lappend SKLAD(find,listbox) $SKLAD(find)
        }
        sklad:read
    }
    set SKLAD(entrystatus) 0
}

proc sklad:delete {} {
    global VS SKLAD SKLAD_DATA
    
    set w .sotss.sklad.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id [$w curselection]
        puts $socks "sklad_del $SKLAD_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {
        }
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        sklad:read
    } else {
        errormsg nosocks "  !"
    }
       
    if { $id > $SKLAD(listbox,count)} {
        set id $SKLAD(listbox,count)
        set SKLAD(listbox,curselection) $SKLAD(listbox,count)
    }
    $w see $id
    $w selection set $id $id
}

proc sklad:insert {} {
    global VS SKLAD SOTSS SOT SOT_DATA
    
    sklad:entry insert
    set w .sotss.sklad.lb.listbox
    if { $SKLAD(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "sklad_ins \"$SOT_DATA(cod,$SOT(listbox,curselection))\" \
                                   \"$SKLAD(entry,nam)\""
            flush $socks
    
            while { [ set skladcod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sklad:read
        } else {
            errormsg nosocks "  !"
        }
        
        $w see $SKLAD(listbox,curselection)
    }
    set SKLAD(entrystatus) 0
}

proc sklad:update {} {
    global VS SKLAD SKLAD_DATA

    set w .sotss.sklad.lb.listbox
    set SKLAD(entry,nam) [clipped $SKLAD_DATA(nam,$SKLAD(listbox,curselection))]
    sklad:entry update
    if { $SKLAD(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "sklad_upd $SKLAD_DATA(cod,$SKLAD(listbox,curselection)) \"$SKLAD(entry,nam)\" "
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sklad:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $SKLAD(listbox,curselection)]
        $w selection set $id $id
    }
    set SKLAD(entrystatus) 0
}

proc sklad:view {} {
    global VS SKLAD SKLAD_DATA
    
    set SKLAD(entry,nam) $SKLAD_DATA(nam,$SKLAD(listbox,curselection))
    sklad:entry view
}

proc sklad:print {} {
    global VS SKLAD SOT SOT_DATA

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "sklad_repmo \"$SOT_DATA(cod,$SOT(listbox,curselection))\" \"$SKLAD(find)\" \"nam $SKLAD(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

