proc skladost { win tip } {
    # tip = f -  
    # tip = m -  
    # tip = p -       
    global VS SKLADOST SKLADOSTTOV SKLADOSTTOV_DATA STT
    
    catch [destroy $SKLADOST(inwin).skladost]
    catch [unset SKLADOSTTOV_DATA]
    if ![info exists SKLADOST(entry,clockdat)] {
        set SKLADOST(entry,clockdat) [expr $VS(clock) + 86400]
        set SKLADOST(entry,dat) [clock format $SKLADOST(entry,clockdat) -format %d.%m.%Y]
    }
    if ![info exists SKLADOST(entry,skladnam)] {
        set SKLADOST(entry,skladnam) $STT(sgpnam)
    }
    set SKLADOST(inwin) $win
    set SKLADOST(tip) $tip
    set SKLADOST(find) ""
    set SKLADOST(count) 0
    set SKLADOST(first) 0
    set SKLADOST(old_current) 0
    set SKLADOST(CurrentOk) 1
    set w $SKLADOST(inwin).skladost
    set SKLADOST(find,listbox) ""
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    switch $SKLADOST(tip) {
        f { 
            #wm geometry $w +12+55
            set SKLADOST(titstr)  "  " 
        }
        m { 
            #wm geometry $w +12+55
            set SKLADOST(titstr)  "   " 
        }
        p { 
            #wm geometry $w +12+55
            set SKLADOST(titstr)  "     " 
        }
    }
    wm geometry $w =0x0
    
    wm title $w $SKLADOST(titstr)
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.print -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "skladost:find"
    $w1.1 add cascade -label "" -menu $w1.1.print
        $w1.1.print add command -label " " -command "skladost:print1"
        $w1.1.print add command -label "  " -command "skladost:print2"
        $w1.1.print add separator
        $w1.1.print add command -label "" 
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable SKLADOSTTOV(sortstr) -value "10, 3, 7" -command skladost:read
        if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
            $w1.1.sort add radio -label "  " -variable SKLADOSTTOV(sortstr) -value "10, 4" -command skladost:read
        }
        $w1.1.sort add radio -label "  " -variable SKLADOSTTOV(sortstr) -value "10, 7, 3" -command skladost:read
        if { $SKLADOST(tip) == "p" } {
            $w1.1.sort add radio -label "   " -variable SKLADOSTTOV(sortstr) -value "13, 10, 3, 7" -command skladost:read
        }
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable SKLADOSTTOV(sortdesc) -value " " -command skladost:read
        $w1.1.sort add radio -label " " -variable SKLADOSTTOV(sortdesc) -value "desc" -command skladost:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -accelerator "<F6>" -command "skladost:nakl"
    if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
        $w1.1 add command -label "  " -accelerator "<F4>" -command "skladost:whorezdoc"
    }
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find "" print "" sort "" tovnakl "" exit  } {
        if { $i == "print" } skladost:search
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }

    if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
        button $w.butimg.whorezdoc -takefocus 0 -bitmap @$VS(dir)Whorezdoc.xbm -command skladost:whorezdoc
        pack $w.butimg.whorezdoc -before $w.butimg.exit -side left
        bind $w.butimg.whorezdoc <Leave> { destroy .balloon }
        bind $w.butimg.whorezdoc <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        $SKLADOST(inwin).skladost.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.print <Button-1> {
        $SKLADOST(inwin).skladost.menu.1.print post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { catch [destroy $SKLADOST(inwin).skladost] }
    bind $w <Key-F5>     { skladost:find }
    bind $w <Key-F6>     { skladost:nakl }
    if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
        bind $w <Key-F4>     { skladost:whorezdoc }
    }
    skladosthead    
    wm geometry $w [centerwindow $w]
    skladost:find
}

proc skladost:search {} {
    global VS SKLADOST
    
    set w $SKLADOST(inwin).skladost.butimg
    label $w.lfind -relief sunken -width 60 -textvariable SKLADOST(find) -anchor w
    button $w.lfindb -takefocus 0 -bitmap @$VS(dir)ComboBox.xbm -command skladost:search:lb 
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { skladost:search:lb }
}

proc skladost:search:lb {} {
    global VS SKLADOST
    
    set w $SKLADOST(inwin).skladost.butimg.lfindlb
    catch [destroy $w]
    set x [winfo rootx $SKLADOST(inwin).skladost.butimg.lfind]
    set y [winfo rooty $SKLADOST(inwin).skladost.butimg.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -setgrid 1 -height 5 -width 60
    
    foreach {i} $SKLADOST(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $SKLADOST(find,listbox) $SKLADOST(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set SKLADOST(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable SKLADOST(find)
    destroy $w
    skladosttov:clear
    skladost:read
    skladosttov:summa
}

proc skladost:entry:createvar {} {
    global SKLADOST
    
    foreach i { prim1 tovartipnam tovarnam dat skladnam } {
        if ![info exists SKLADOST(entry,$i)] {
            set SKLADOST(entry,$i) ""
        }
    }
}

proc skladost:entry:clearvar {} {
    global SKLADOST
    
    foreach i { prim1 tovartipnam tovarnam skladnam } {
        set SKLADOST(entry,$i) ""
    }
}

proc skladost:entry {} {
    global VS SKLADOST
    
    set w $SKLADOST(inwin).skladost.entry
    set SKLADOST(entrystatus) ""
    skladost:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +100+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { prim1 tovartipnam tovarnam dat skladnam } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 1
        if { $i == "tovarnam" || $i == "dat" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { prim1       "   " \
                      tovartipnam "             " \
                      tovarnam    "                 " \
                      dat         "   " \
                      skladnam    "                 " \
                  } {
        if { ($SKLADOST(tip) == "f" && $i != "prim1") || $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } { 
            label $w.inf.$i.l -text $j
            pack $w.inf.$i.l -side left
        }
    }
    foreach { i j k } {prim1       prim1         50 \
                       tovartipnam tovartipnam   50 \
                       tovarnam    tovarnam      50 \
                       dat         dat           10 \
                       skladnam    skladnam      30 \
                       } {
        entry $w.inf.$i.e -textvariable SKLADOST(entry,$j) -width $k
    }
    $w.inf.tovartipnam.e configure -state disabled
    
    foreach { i j } { ControlUp dat.bu ControlDown dat.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.dat.bd configure -command "skladost:incrdate - dat"
    $w.inf.dat.bu configure -command "skladost:incrdate + dat"
    
    button $w.inf.tovartipnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { skladost:hetovartip r $SKLADOST(inwin).skladost.entry }
    button $w.inf.tovarnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { skladost:hetovar r $SKLADOST(inwin).skladost.entry }
    button $w.inf.skladnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { skladost:hesklad r $SKLADOST(inwin).skladost.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SKLADOST(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "skladost:entry:clearvar"
    button $w.buttons.exit -text "" -command "set SKLADOST(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { tovartipnam.e tovartipnam.b \
                tovarnam.e tovarnam.b dat.e \
                skladnam.e skladnam.b } {
        pack $w.inf.$i -side left
    }
    if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
        foreach i { prim1.e } { pack $w.inf.$i -side left }
    }
    foreach i { dat.bu dat.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.tovarnam.e
    bind $w <Key-Escape>     { $SKLADOST(inwin).skladost.entry.buttons.exit invoke }
    bind $w <Control-Return> { $SKLADOST(inwin).skladost.entry.buttons.ok invoke }
    bind $w.inf.dat.e <KeyPress-Next>  { skladost:incrdate - dat }
    bind $w.inf.dat.e <KeyPress-Prior> { skladost:incrdate + dat }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc skladost:incrdate { k d } {
    global SKLADOST
    
    set SKLADOST(entry,clock$d) [expr $SKLADOST(entry,clock$d) $k 86400 ]
    set SKLADOST(entry,$d) [clock format $SKLADOST(entry,clock$d) -format %d.%m.%Y]
}

proc skladost:clear {} {

}

proc skladost:nakl {} {
    global SKLADOST SKLADOSTTOV SKLADOSTTOV_DATA NAKLPLIST
    
    if { [info exists SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),naklpcod)] && \
       $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),naklpcod) > 0 } {
        set NAKLPLIST(pr) p
        set ttip $SKLADOST(tip)
        if { $SKLADOST(tip) == "p" } { set ttip "m" }
        naklp 1 $ttip $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),naklpcod) $SKLADOST(inwin).skladost
    } else {
        errormsg nosocks " !!!   .  ."
    }
}

proc skladost:whorezdoc {} {
    global SKLADOST SKLADOSTTOV SKLADOSTTOV_DATA
    
    if { [info exists SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),tovarcod)] && \
       $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),tovarcod) > 0 } {
        whorezdoc $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),skladcod) $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),tovarcod) $SKLADOSTTOV_DATA($SKLADOSTTOV(ActiveRow),1) $SKLADOST(inwin).skladost
    }
}
