proc skladosthead { } {
    global VS SKLADOST SKLADOST_DATA SKLADOSTTOV SKLADOSTTOV_DATA

    set w $SKLADOST(inwin).skladost
    set SKLADOSTTOV(rows) 20
    if ![info exists SKLADOSTTOV(prih)] { set SKLADOSTTOV(prih) "o" }
    if ![info exists SKLADOSTTOV(cena)] { set SKLADOSTTOV(cena) "o" }
    if ![info exists SKLADOSTTOV(sernum)] { set SKLADOSTTOV(sernum) "o" }
    # head ##################################################################
    
    frame $w.tit
    label $w.tit.l1 -font $VS(fontn) -text " $SKLADOST(titstr) " \
        -relief raised -anchor center -bd 1
    label $w.tit.l2 -text "     " -anchor center -bd 1 -bg grey95
    label $w.tit.l3 -textvar SKLADOST(entry,dat) -relief sunken -anchor center -bd 1 -bg grey95
    pack $w.tit
    pack $w.tit.l1 $w.tit.l2 $w.tit.l3 -side left -fill y
    
    # tov ####################################################################

    switch $SKLADOST(tip) {
        f   { set wc 6; set wc2 6 }
        m   { set wc 9; set wc2 9 }
        p   { set wc 10; set wc2 8 }
    }
    frame $w.to
    frame $w.tov
    pack $w.to $w.tov -fill x
    entry $w.to.curfldval -textvar SKLADOSTTOV_DATA(active) -fg red \
        -bg #fffff0 -width 50 -state disabled
    scrollbar $w.tov.sby -takefocus 0 -command " $w.tov.tbl yview "
    scrollbar $w.tov.sbx -orient hor -takefocus 0 -command " $w.tov.tbl xview "
    table $w.tov.tbl -width $wc2 -height 20 -cols $wc -rows $SKLADOSTTOV(rows) \
        -yscrollcommand " $w.tov.sby set " \
        -xscrollcommand " $w.tov.sbx set " \
        -cursor arrow \
        -variable SKLADOSTTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { skladosttov:browsecommand %S } \
        -wrap on
        
    button $w.tov.tbl.bsernum -highlightbackground grey65 -cursor arrow -bd 1 -text ".." -bg grey65 -fg yellow -command skladosttov:trsernum
    button $w.tov.tbl.bprih -highlightbackground grey65 -cursor arrow -bd 1 -text " ." -bg grey65 -fg yellow -command skladosttov:trprih
    button $w.tov.tbl.bcena -highlightbackground grey65 -cursor arrow -bd 1 -text " ." -bg grey65 -fg yellow -command skladosttov:trcena
    if { $SKLADOST(tip) == "p" } {
        $w.tov.tbl window configure -1,3 -window $w.tov.tbl.bsernum -sticky wens
        $w.tov.tbl window configure -1,7 -window $w.tov.tbl.bprih -sticky wens
        $w.tov.tbl window configure -1,8 -window $w.tov.tbl.bcena -sticky wens
    }
    if { $SKLADOST(tip) == "m" } {
        $w.tov.tbl window configure -1,2 -window $w.tov.tbl.bsernum -sticky wens
        $w.tov.tbl window configure -1,6 -window $w.tov.tbl.bprih -sticky wens
        $w.tov.tbl window configure -1,7 -window $w.tov.tbl.bcena -sticky wens
    }
    if { $SKLADOST(tip) == "f" } {
        $w.tov.tbl window configure -1,4 -window $w.tov.tbl.bprih -sticky wens
        $w.tov.tbl window configure -1,5 -window $w.tov.tbl.bcena -sticky wens
    }
    skladosttov:trcolor

    
    tktableinittag $w.tov.tbl
    $w.tov.tbl tag row AnchorCenter -1
    if { $SKLADOST(tip) == "p" } {
        $w.tov.tbl tag col Disabled 4 5 7 8 9
        $w.tov.tbl width 0 6  1 10  2 44  3 8  4 8  5 8  6 4  7 7  8 10  9 10
    } 
    if { $SKLADOST(tip) == "m" } {
        $w.tov.tbl tag col Disabled 3 4 6 7 8
        $w.tov.tbl width 0 6  1 34  2 8  3 8  4 8  5 4  6 7  7 10  8 10
    } 
    if { $SKLADOST(tip) == "f" } {
        $w.tov.tbl tag col Disabled 2 4 5
        $w.tov.tbl width 0 7 1 50 2 8 3 10 4 7 5 10
    }
    pack $w.to.curfldval -side left
    pack $w.tov.sbx -side bottom -fill x
    pack $w.tov.tbl -side left
    pack $w.tov.sby -side right -fill y
    
    frame $w.itogo
    pack $w.itogo -anchor w
    if { $SKLADOST(tip) == "p" } {
        set ijkl {"                                        :" skolrez  8 50 \
                  "" skol  9 50 \
                  "           " scena 10 55 \
                  "" scenad 10 55 }
    }
    if { $SKLADOST(tip) == "m" } {
        set ijkl {"                                          :" skolrez  8 50 \
                  "" skol  9 50 \
                  "          " scena 10 55 \
                  "" scenad 10 55 }
    }
    if { $SKLADOST(tip) == "f" } {
        set ijkl {"                                                   :" skol  9 50 \
                  "                 " scena 10 55 }
    }
    label $w.itogo.lfuf1 -text "" -bd 0
    pack $w.itogo.lfuf1 -side left
    foreach { i j k l } $ijkl {
        label $w.itogo.l$j -text $i -bd 0
        pack $w.itogo.l$j -side left
        label $w.itogo.$j -textvar SKLADOSTTOV($j) -bd 0 -relief sunken -anchor e -width $k -bg gray$l -fg cyan
        pack $w.itogo.$j -side left
    }
            
    bind $w.to.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        $SKLADOST(inwin).skladost.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    focus $w.tov.tbl
}

proc skladosttov:summa {} {
    global SKLADOSTTOV SKLADOSTTOV_DATA SKLADOST_DATA SKLADOST
    
    set i 0
    set SKLADOSTTOV(skolrez) 0
    set SKLADOSTTOV(skol) 0
    set SKLADOSTTOV(scena) 0
    set SKLADOSTTOV(scenad) 0
    if { $SKLADOST(tip) == "p" } {
        set nkol 5
    }
    if { $SKLADOST(tip) == "m" } {
        set nkol 4
    }
    if { $SKLADOST(tip) == "f" } {
        set nkol 2
    }
    while { [info exists SKLADOSTTOV_DATA($i,0)] } {
        catch [set SKLADOSTTOV(skolrez) [expr $SKLADOSTTOV(skolrez) + $SKLADOSTTOV_DATA($i,[expr $nkol - 1])]]
        catch [set SKLADOSTTOV(skol) [expr $SKLADOSTTOV(skol) + $SKLADOSTTOV_DATA($i,$nkol)]]
        catch [set SKLADOSTTOV(scena) [expr $SKLADOSTTOV(scena) + $SKLADOSTTOV_DATA($i,[expr $nkol + 3])]]
        catch [set SKLADOSTTOV(scenad) [expr $SKLADOSTTOV(scenad) + $SKLADOSTTOV_DATA($i,[expr $nkol + 4])]]
        incr i
    }
}

proc skladosttov:browsecommand { rowcol } {
    global SKLADOSTTOV SKLADOSTTOV_DATA SKLADOST SKLADOST_DATA VS
    
    set w $SKLADOST(inwin).skladost.tov
    if { [info exists SKLADOSTTOV(ActiveRow)] && \
         $SKLADOSTTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $SKLADOSTTOV(ActiveRow)
    }
    
    set SKLADOSTTOV(ActiveRowCol) $rowcol 
    scan $SKLADOSTTOV(ActiveRowCol) "%\[^,]%*c%s" SKLADOSTTOV(ActiveRow) SKLADOSTTOV(ActiveCol)
    
#    skladosttov:summa
    if { $SKLADOSTTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $SKLADOSTTOV(ActiveRow)
    }
}


proc skladosttov:trprih {} {
    global SKLADOSTTOV
    
    if { $SKLADOSTTOV(prih) == "a" } {
        set SKLADOSTTOV(prih) "o"
    } else {
        set SKLADOSTTOV(prih) "a"
    }
    skladosttov:trcolor
    skladost:read
}

proc skladosttov:trsernum {} {
    global SKLADOSTTOV
    
    if { $SKLADOSTTOV(sernum) == "a" } {
        set SKLADOSTTOV(sernum) "o"
    } else {
        set SKLADOSTTOV(sernum) "a"
    }
    skladosttov:trcolor
    skladost:read
}

proc skladosttov:trcena {} {
    global SKLADOSTTOV
    
    if { $SKLADOSTTOV(cena) == "a" } {
        set SKLADOSTTOV(cena) "o"
    } else {
        set SKLADOSTTOV(cena) "a"
    }
    skladosttov:trcolor
    skladost:read
}

proc skladosttov:trcolor {} {
    global SKLADOSTTOV SKLADOST
    
    set w $SKLADOST(inwin).skladost.tov.tbl
    if { $SKLADOST(tip) == "m" || $SKLADOST(tip) == "p" } {
        if { $SKLADOSTTOV(sernum) == "a" } {
            $w.bsernum configure -fg yellow -bg gray65 -activeforeground yellow
        } else {
            $w.bsernum configure -fg black -bg yellow -activeforeground black
        }
        if { $SKLADOSTTOV(prih) == "a" } {
            $w.bprih configure -fg yellow -bg gray65 -activeforeground yellow
        } else {
            $w.bprih configure -fg black -bg yellow -activeforeground black
        }
        if { $SKLADOSTTOV(cena) == "a" } {
            $w.bcena configure -fg yellow -bg gray65 -activeforeground yellow
        } else {
            $w.bcena configure -fg black -bg yellow -activeforeground black
        }
    }
    if { $SKLADOST(tip) == "f" } {
        if { $SKLADOSTTOV(prih) == "a" } {
            $w.bprih configure -fg yellow -bg gray65 -activeforeground yellow
        } else {
            $w.bprih configure -fg black -bg yellow -activeforeground black
        }
        if { $SKLADOSTTOV(cena) == "a" } {
            $w.bcena configure -fg yellow -bg gray65 -activeforeground yellow
        } else {
            $w.bcena configure -fg black -bg yellow -activeforeground black
        }
    }
}
