proc skladosttov:clear {} {
    global SKLADOSTTOV_DATA SKLADOST
    
    catch [unset SKLADOSTTOV_DATA]
    set SKLADOSTTOV_DATA(active) {}
    if { $SKLADOST(tip) == "p" } {
        set SKLADOSTTOV_DATA(-1,0) ""
        set SKLADOSTTOV_DATA(-1,1) ""
        set SKLADOSTTOV_DATA(-1,2) " "
        set SKLADOSTTOV_DATA(-1,4) "."
        set SKLADOSTTOV_DATA(-1,5) "."
        set SKLADOSTTOV_DATA(-1,6) ".."
        set SKLADOSTTOV_DATA(-1,9) " ."
    }
    if { $SKLADOST(tip) == "m" } {
        set SKLADOSTTOV_DATA(-1,0) ""
        set SKLADOSTTOV_DATA(-1,1) " "
        set SKLADOSTTOV_DATA(-1,3) "."
        set SKLADOSTTOV_DATA(-1,4) "."
        set SKLADOSTTOV_DATA(-1,5) ".."
        set SKLADOSTTOV_DATA(-1,8) " ."
    }
    if { $SKLADOST(tip) == "f" } {
        set SKLADOSTTOV_DATA(-1,0) ""
        set SKLADOSTTOV_DATA(-1,1) " "
        set SKLADOSTTOV_DATA(-1,2) "."
        set SKLADOSTTOV_DATA(-1,3) ".."
        set SKLADOSTTOV_DATA(-1,5) " ."
    }
}

proc skladost:read {} {
    global VS SKLADOSTTOV_DATA SKLADOSTTOV SKLADOST SKLADOST_DATA
    
    skladosttov:clear
    set w $SKLADOST(inwin).skladost.tov.tbl
    if { $SKLADOSTTOV(sortstr) == "" }    { set SKLADOSTTOV(sortstr) "10, 3, 7" } 
    if { $SKLADOSTTOV(sortdesc) == "" }   { set SKLADOSTTOV(sortdesc) " "  }
    if { ![info exists SKLADOST(entry,dat)] || $SKLADOST(entry,dat) == "" } { 
        set SKLADOST(entry,dat) "$VS(day).$VS(month).$VS(year)" 
    }
    if { $SKLADOST(find) == "" } {
        set SKLADOST(find) "1=1"
        if [info exists SKLADOST(find,listbox)] {
            if { [lsearch -exact $SKLADOST(find,listbox) $SKLADOST(find)] == -1} {
                lappend SKLADOST(find,listbox) $SKLADOST(find)
            }
        } else {
            lappend SKLADOST(find,listbox) $SKLADOST(find)
        }
    } 
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "skladosttov_sel $SKLADOST(tip) \
                                    $SKLADOSTTOV(sernum)\
                                    $SKLADOSTTOV(prih) \
                                    $SKLADOSTTOV(cena) \
                                    $SKLADOST(entry,dat) \
                                    \"$SKLADOST(find)\" \
                                    \"$SKLADOSTTOV(sortstr) \
                                    $SKLADOSTTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach j { doccod operpacod 0 1 2 3 4 5 6 7 } {
                set SKLADOSTTOV_DATA($i,$j) "";
            }
            if { $SKLADOST(tip) == "p" } {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    SKLADOSTTOV_DATA($i,skladcod) \
                    SKLADOSTTOV_DATA($i,naklpcod) SKLADOSTTOV_DATA($i,tovarcod) \
                    SKLADOSTTOV_DATA($i,2)        SKLADOSTTOV_DATA($i,3) \
                    SKLADOSTTOV_DATA($i,5)        SKLADOSTTOV_DATA($i,6) \
                    SKLADOSTTOV_DATA($i,7)        SKLADOSTTOV_DATA($i,8) \
                    SKLADOSTTOV_DATA($i,9)        SKLADOSTTOV_DATA($i,0) \
                    SKLADOSTTOV_DATA($i,4)        SKLADOSTTOV_DATA($i,1)
                catch [set SKLADOSTTOV_DATA($i,0) [clipped $SKLADOSTTOV_DATA($i,0)]]
                catch [set SKLADOSTTOV_DATA($i,1) [clipped $SKLADOSTTOV_DATA($i,1)]]
                catch [set SKLADOSTTOV_DATA($i,2) [clipped $SKLADOSTTOV_DATA($i,2)]]
                catch [set SKLADOSTTOV_DATA($i,3) [clipped $SKLADOSTTOV_DATA($i,3)]]
                catch [set SKLADOSTTOV_DATA($i,4) [format "%7.2f" $SKLADOSTTOV_DATA($i,4)]]
                catch [set SKLADOSTTOV_DATA($i,5) [format "%7.2f" $SKLADOSTTOV_DATA($i,5)]]
                catch [set SKLADOSTTOV_DATA($i,6) [clipped $SKLADOSTTOV_DATA($i,6)]]
                catch [set SKLADOSTTOV_DATA($i,8) [format "%9.2f" $SKLADOSTTOV_DATA($i,8)]]
                catch [set SKLADOSTTOV_DATA($i,9) [format "%9.2f" $SKLADOSTTOV_DATA($i,9)]]
            }
            if { $SKLADOST(tip) == "m" } {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    SKLADOSTTOV_DATA($i,skladcod) \
                    SKLADOSTTOV_DATA($i,naklpcod) SKLADOSTTOV_DATA($i,tovarcod) \
                    SKLADOSTTOV_DATA($i,1)        SKLADOSTTOV_DATA($i,2) \
                    SKLADOSTTOV_DATA($i,4)        SKLADOSTTOV_DATA($i,5) \
                    SKLADOSTTOV_DATA($i,6)        SKLADOSTTOV_DATA($i,7) \
                    SKLADOSTTOV_DATA($i,8)        SKLADOSTTOV_DATA($i,0) \
                    SKLADOSTTOV_DATA($i,3)        fuf
                catch [set SKLADOSTTOV_DATA($i,0) [clipped $SKLADOSTTOV_DATA($i,0)]]
                catch [set SKLADOSTTOV_DATA($i,1) [clipped $SKLADOSTTOV_DATA($i,1)]]
                catch [set SKLADOSTTOV_DATA($i,2) [clipped $SKLADOSTTOV_DATA($i,2)]]
                catch [set SKLADOSTTOV_DATA($i,3) [format "%7.2f" $SKLADOSTTOV_DATA($i,3)]]
                catch [set SKLADOSTTOV_DATA($i,4) [format "%7.2f" $SKLADOSTTOV_DATA($i,4)]]
                catch [set SKLADOSTTOV_DATA($i,5) [clipped $SKLADOSTTOV_DATA($i,5)]]
                catch [set SKLADOSTTOV_DATA($i,7) [format "%9.2f" $SKLADOSTTOV_DATA($i,7)]]
                catch [set SKLADOSTTOV_DATA($i,8) [format "%9.2f" $SKLADOSTTOV_DATA($i,8)]]
            }
            if { $SKLADOST(tip) == "f" } {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    fuf SKLADOSTTOV_DATA($i,naklpcod) SKLADOSTTOV_DATA($i,tovarcod) \
                    SKLADOSTTOV_DATA($i,1)        fuf) \
                    SKLADOSTTOV_DATA($i,2)        SKLADOSTTOV_DATA($i,3) \
                    SKLADOSTTOV_DATA($i,4)        SKLADOSTTOV_DATA($i,5) \
                    fuf                           SKLADOSTTOV_DATA($i,0) \
                    fuf                           fuf
                catch [set SKLADOSTTOV_DATA($i,0) [clipped $SKLADOSTTOV_DATA($i,0)]]
                catch [set SKLADOSTTOV_DATA($i,1) [clipped $SKLADOSTTOV_DATA($i,1)]]
                catch [set SKLADOSTTOV_DATA($i,2) [format "%7.2f" $SKLADOSTTOV_DATA($i,2)]]
                catch [set SKLADOSTTOV_DATA($i,3) [clipped $SKLADOSTTOV_DATA($i,3)]]
                catch [set SKLADOSTTOV_DATA($i,4) [clipped $SKLADOSTTOV_DATA($i,4)]]
                catch [set SKLADOSTTOV_DATA($i,5) [format "%9.2f" $SKLADOSTTOV_DATA($i,5)]]
            }
        }
        
        set SKLADOSTTOV(rows) [expr $i + 2]
        if { $SKLADOSTTOV(rows) < 20 } { set SKLADOSTTOV(rows) 20 }
        $w configure -rows $SKLADOSTTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    skladosttov:summa
    waiting "" ""
}


proc skladost:find {} {
    global VS SKLADOST SKLADOSTTOV SKLADOST_DATA
    
    skladost:entry
    if { $SKLADOST(entrystatus) == 1 } {
        set SKLADOST(find) "1=1"
        foreach {i j} " \"$SKLADOST(entry,tovarnam)\"     b.nam \
                        \"$SKLADOST(entry,skladnam)\"     d.nam \
                        \"$SKLADOST(entry,prim1)\"        k.prim1 \
                       " {
            if { $i != "" } {
                set SKLADOST(find) "$SKLADOST(find) and $j [construct $i]"
            }    
        }
        if { [info exists SKLADOST(entry,tovartipcod)] && \
             $SKLADOST(entry,tovartipcod) > 0 } {
            set SKLADOST(find) "$SKLADOST(find) and b.tovartip_cod = $SKLADOST(entry,tovartipcod)"
        }
        if { [lsearch -exact $SKLADOST(find,listbox) $SKLADOST(find)] == -1} {
            lappend SKLADOST(find,listbox) $SKLADOST(find)
        }
        skladosttov:clear
        skladost:read
        skladosttov:summa
    }
    set SKLADOST(entrystatus) 0
}

proc skladost:hesklad { tip win } {
    global VS SKLADOST HE
    
    set w $SKLADOST(inwin).skladost.entry.inf.skladnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $SKLADOST(entry,skladnam) $tip $win
    set SKLADOST(entry,skladcod) $HE(cod)
    set SKLADOST(entry,skladnam) [clipped $HE(nam)]
}

proc skladost:hetovar { tip win } {
    global VS SKLADOST HE
    
    set w $SKLADOST(inwin).skladost.entry.inf.tovarnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $SKLADOST(entry,tovarnam) $tip $win
    set SKLADOST(entry,tovarcod) $HE(cod)
    set SKLADOST(entry,tovarnam) [clipped $HE(nam)]
}

proc skladost:hetovartip { tip win } {
    global VS SKLADOST HE
    
    set w $SKLADOST(inwin).skladost.entry.inf.tovartipnam.e
    set HE(tit) "  "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovartip "*" $tip $win
    set SKLADOST(entry,tovartipcod) $HE(cod)
    set SKLADOST(entry,tovartipnam) [clipped $HE(nam)]
}

proc skladost:print1 {} {
    global VS SKLADOSTTOV_DATA SKLADOSTTOV SKLADOST SKLADOST_DATA
    
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "skladosttov_rep1 $SKLADOST(tip) \
                                    $SKLADOSTTOV(sernum)\
                                    $SKLADOSTTOV(prih) \
                                    $SKLADOSTTOV(cena) \
                                    $SKLADOST(entry,dat) \
                                    \"$SKLADOST(find)\" \
                                    \"$SKLADOSTTOV(sortstr) \
                                    $SKLADOSTTOV(sortdesc)\" \
                                    \"$VS(lp)\""
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc skladost:print2 {} {
    global VS SKLADOSTTOV_DATA SKLADOSTTOV SKLADOST SKLADOST_DATA
    
    if ![regexp -- "k.prim" $SKLADOST(find)] {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." cyan
            puts $socks "skladosttov_rep2 $SKLADOST(tip) \
                                        $SKLADOSTTOV(sernum)\
                                        $SKLADOSTTOV(prih) \
                                        $SKLADOSTTOV(cena) \
                                        $SKLADOST(entry,dat) \
                                        \"$SKLADOST(find)\" \
                                        \"$SKLADOSTTOV(sortstr) \
                                        $SKLADOSTTOV(sortdesc)\" \
                                        \"$VS(lp)\""
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
            
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
        } else {
            errormsg nosocks "  !"
        }
    } else {
        errormsg nosocks "        "
    }
}
