proc snnno { } {
    global VS SNNNO SCHETTOV SNNNO_DATA

    catch [unset SNNNO SNNNO_DATA]
    set SNNNO(listbox,curselection) 0
    set SNNNO(find) ""
    set w .snnno
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+55
    wm geometry $w =0x0
    set titstr "  "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "snnno:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "snnno:insert"
    $w1.1 add command -label "" -command "snnno:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "schetnum" -command snnno:read
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "schetdat" -command snnno:read
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "naklnum" -command snnno:read
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "nakldat" -command snnno:read
        $w1.1.sort add radio -label "   " -variable SNNNO(sortstr) -value "nnakldat" -command snnno:read
        $w1.1.sort add radio -label "   " -variable SNNNO(sortstr) -value "opldat" -command snnno:read
        if { $VS(login) != "buh" } {
            $w1.1.sort add radio -label "   " -variable SNNNO(sortstr) -value "otgdat" -command snnno:read
        }
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "schetsumma" -command snnno:read
        $w1.1.sort add radio -label "  " -variable SNNNO(sortstr) -value "klientnam, schetnum" -command snnno:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable SNNNO(sortdesc) -value " " -command snnno:read
        $w1.1.sort add radio -label " " -variable SNNNO(sortdesc) -value "desc" -command snnno:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command snnno:view
    $w1.1 add command -state disabled -accelerator "<Enter>" -label "" -command snnno:update
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set SNNNO(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command snnno:delete -activebackground red -activeforeground yellow    
    $w1.1 add command -state disabled -label "" -accelerator "<F9>" -command snnno:schetopl
    $w1.1 add command -state disabled -label "  " -accelerator "<F2>" -command snnno:schetnnakl
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable SNNNO(statusline) -relief sunken -anchor w -padx 3 -width 60
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view  update  delete  exit } {
        if { $i == "insert" } { findbox snnno 60 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        if { $i == "print" } {
            pack $w.butimg.$i -side left -padx 4
        } else {
            pack $w.butimg.$i -side left
        }
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    button $w.butimg.oplata -state disabled -takefocus 0 -bitmap @$VS(dir)Oplata.xbm -command snnno:schetopl    
    pack $w.butimg.oplata -before $w.butimg.exit -side left
    bind $w.butimg.oplata <Leave> { destroy .balloon }
    bind $w.butimg.oplata <Enter> { bindballoon %W }
    button $w.butimg.nalnakl -state disabled -takefocus 0 -image img_nalnakl -command snnno:schetopl
    pack $w.butimg.nalnakl -before $w.butimg.exit -side left
    bind $w.butimg.nalnakl <Leave> { destroy .balloon }
    bind $w.butimg.nalnakl <Enter> { bindballoon %W }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    foreach i { p1 p2 p3 p4 p5 p6 p7 } {
        frame $w.namefield.$i
    }
    $w.namefield.p6 configure -relief raised -bd 1
    $w.namefield.p7 configure -relief raised -bd 1
    label $w.namefield.p1.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p2.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p3.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p4.1 -text "" -relief raised -anchor center -bd 1
    if { $VS(login) != "buh" } {
        label $w.namefield.p5.1 -text "" -relief raised -anchor center -bd 1
    }
    
    label $w.namefield.p1.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p1.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p2.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p2.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p3.2 -text "  ?" -relief raised -anchor center -bd 1 -padx 1 -width 9
    label $w.namefield.p4.2 -text "  ?" -relief raised -anchor center -bd 1 -padx 1 -width 9
    if { $VS(login) != "buh" } {
        label $w.namefield.p5.2 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 9
    }
    label $w.namefield.p6.1 -text "" -height 2 -anchor center -padx 1 -width 9
    label $w.namefield.p7.1 -text "" -height 2 -anchor center -padx 1 -width 27
    if { $VS(login) == "buh" } {
        $w.namefield.p7.1 configure -width 37
    }
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p1 p2 p3 p4 p5 p6 p7 } {
        pack $w.namefield.$i -anchor w -side left -fill y
    }
    foreach i { p1.1 p2.1 p3.1 p4.1 p5.1 p6.1 p7.1 } {
        catch [pack $w.namefield.$i -fill x]
    }
    foreach i { p1.2 p1.3 p2.2 p2.3 p3.2 p4.2 p5.2 } {
        catch [pack $w.namefield.$i -side left]
    }
    frame $w.lb
    frame $w.itogo
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 94
    label $w.itogo.l1 -text "                                                                 :"
    label $w.itogo.ssnnno1 -textvar SNNNO(ssnnno1) -bd 1 -relief sunken -anchor e -width 11
    pack $w.itogo.l1 $w.itogo.ssnnno1 -side left
    
    pack $w.lb $w.itogo -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    snnno:read
    
    bind $w.butimg.delete <Button-1> { .snnno.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]] }
    bind $w.butimg.sort <Button-1>   { .snnno.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]] }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .snnno.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        if [info exists SNNNO_DATA(schetnum,$id)] {
            set SNNNO(statusline) "$SNNNO_DATA(schetnum,$id) $SNNNO_DATA(schetdat,$id) $SNNNO_DATA(klientnam,$id)"
        }
        set SNNNO(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .snnno.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  oplata  nalnakl "  " } {
            .snnno.menu.1 entryconfigure [.snnno.menu.1 index $j] -state disabled
            .snnno.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { print  view  update  delete  oplata  nalnakl "  " } {
            .snnno.menu.1 entryconfigure [.snnno.menu.1 index $j] -state normal
            .snnno.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists SNNNO_DATA(cod,$SNNNO(listbox,curselection))] {
            snnno:update
        }
    }
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists SNNNO_DATA(cod,$SNNNO(listbox,curselection))] {
            snnno:update
        }
    }
    bind $w <KeyPress-F9> { 
        event generate %W <B1-ButtonRelease>
        snnno:schetopl 
    }
    bind $w <KeyPress-F2> { 
        event generate %W <B1-ButtonRelease>
        snnno:schetnnakl 
    }
    bind $w <KeyPress-F5>       { snnno:find }
    bind $w <KeyPress-Insert>   { snnno:insert }
    bind $w <Key-Escape>        { .snnno.buttons.exit invoke }
    bind $w <Key-F12>           { 
        event generate %W <B1-ButtonRelease>
        prodmattov $SNNNO_DATA(cod,$SNNNO(listbox,curselection)) \
            s " N - $SNNNO_DATA(schetnum,$SNNNO(listbox,curselection)) \
             $SNNNO_DATA(schetdat,$SNNNO(listbox,curselection)) " .snnno 
    }
    focus $w.lb.listbox
}

proc snnno:entry:createvar {} {
    global SNNNO
    
    foreach i { schetnum schetdat schetsumma naklnum nakldat nnaklnum nnakldat \
                opldat oplsumma otgdat otgkol klientcod klientnam tovarcod \
                tovarnam sostavtovcod sostavtovnam naklis nnaklis oplis otgis \
                prim1 prim2 nopl notg nnaklsumma \ 
              } {
        if ![info exists SNNNO(entry,$i)] {
            set SNNNO(entry,$i) ""
        }
    }
}

proc snnno:entry:clearvar {} {
    global SNNNO
    
    foreach i { schetnum schetdat schetsumma naklnum nakldat nnaklnum nnakldat \
                opldat oplsumma otgdat otgkol klientcod klientnam tovarcod \
                tovarnam naklis sostavtovcod sostavtovnam nnaklis oplis otgis \
                prim1 prim2 nopl notg nnaklsumma \  
              } {
        set SNNNO(entry,$i) ""
    }
}

proc snnno:entry {} {
    global VS SNNNO
    
    set w .snnno.entry
    set SNNNO(entrystatus) ""
    snnno:entry:createvar
    snnno:entry:clearvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +50+130
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach i { schet nakl nnakl opl otg klient tovar sostavtov prim1 prim2 nopl notg } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "schet" || $i == "nakl" || $i == "nnakl" || $i == "opl" || $i == "otg" || $i == "sostavtov" } {
            if { $i == "otg" && $VS(login) == "buh" } {
            } else {
                frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
                pack $w.inf.sep$i -fill x
            }
        }
    }
    foreach { i j } { schet.l1      "             :  " \
                      schet.l2      " " \
                      schet.l3      " " \
                      nakl.l1       ":  " \
                      nakl.l2       " " \
                      nnakl.l1      ":  " \
                      nnakl.l2      " " \
                      nnakl.l3      " " \
                      opl.l1        ":                        " \
                      opl.l2        " " \
                      otg.l1        ":                      " \
                      otg.l2        " " \
                      klient.l1     "        " \
                      tovar.l1      "         " \
                      sostavtov.l1  "  " \
                      prim1.l1      "                           " \
                      prim2.l1      "                           " \
                      nopl.l1       "                           " \
                      notg.l1       "                           " \
                    } {
        if { ($i == "otg.l1" || $i == "otg.l2" || $i == "notg.l1") && $VS(login) == "buh" } {
        } else {
            label $w.inf.$i -text $j
        }
    }
    foreach { i j k } { schet.num       schetnum        11 \
                        schet.dat       schetdat        17 \
                        schet.summa     schetsumma      15 \
                        nakl.num        naklnum         11 \
                        nakl.dat        nakldat         17 \
                        nnakl.num       nnaklnum        11 \
                        nnakl.dat       nnakldat        17 \
                        nnakl.summa     nnaklsumma      15 \
                        opl.dat         opldat          17 \
                        opl.summa       oplsumma        15 \
                        otg.dat         otgdat          17 \
                        otg.kol         otgkol          15 \
                        klient.nam      klientnam       50 \
                        tovar.nam       tovarnam        50 \
                        sostavtov.nam   sostavtovnam    50 \
                      } {
        if { ($i == "otg.dat" || $i == "otg.kol") && $VS(login) == "buh" } {
        } else {
            entry $w.inf.$i -textvariable SNNNO(entry,$j) -width $k
        }
    }
    foreach { i j } { nakl.is           naklis \
                      nnakl.is          nnaklis \
                      opl.is            oplis \
                      otg.is            otgis \
                  } {
        if { $i == "otg.is" && $VS(login) == "buh" } {
        } else {
            tk_optionMenu $w.inf.$i SNNNO(entry,$j)   ""
            $w.inf.$i configure -bd 1 -width 4 -bg grey80
        }
    }
    foreach { i j k } { prim1.cb  "  1  "  prim1 \
                        prim2.cb  "  2  "  prim2 \
                        nopl.cb   " "               nopl \
                        notg.cb   " "             notg \
                    } {
        if { $i == "notg.cb" && $VS(login) == "buh" } {
        } else {
            checkbutton $w.inf.$i -text $j -variable SNNNO(entry,$k) -offvalue "" -onvalue "*" -bd 1 -relief raised -padx 3 -bg grey80
        }
    }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { snnno:heklient r .snnno.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { snnno:hetovar r .snnno.entry }
    button $w.inf.sostavtov.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { snnno:hesostavtov r .snnno.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SNNNO(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "snnno:entry:clearvar"
    button $w.buttons.exit -text "" -command "set SNNNO(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { schet.l1 schet.num schet.l2 schet.dat schet.l3 schet.summa \
                nakl.is nakl.l1 nakl.num nakl.l2 nakl.dat \
                nnakl.is nnakl.l1 nnakl.num nnakl.l2 nnakl.dat nnakl.l3 nnakl.summa \
                opl.is opl.l1 opl.dat opl.l2 opl.summa \
                otg.is otg.l1 otg.dat otg.l2 otg.kol \
                klient.l1 klient.nam klient.b \
                tovar.l1 tovar.nam tovar.b \
                sostavtov.l1 sostavtov.nam sostavtov.b \
                prim1.l1 prim1.cb prim2.l1 prim2.cb \
                nopl.l1 nopl.cb notg.l1 notg.cb \
              } {
        if { ($i == "otg.is" || $i == "otg.l1" || $i == "otg.dat" || $i == "otg.l2" || $i == "otg.kol" || $i == "notg.l1" || $i == "notg.cb") && $VS(login) == "buh" } {
        } else {
            pack $w.inf.$i -side left
        }
    }
    focus $w.inf.schet.num
    bind $w <Key-Escape>     { .snnno.entry.buttons.exit invoke }
    bind $w <Control-Return> { .snnno.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
