proc sot:read {} {
    global VS SOT SOT_DATA SOTSS
    
    set w .sotss.sot.lb.listbox
    set SOTSS(listbox,curselection) 0
    waiting "  ..." blue
    if { $SOT(sortdesc) == "" }   { set SOT(sortdesc) " "  }
    if { $SOT(find) == "" } {
        set SOT(find) "1=1"
        lappend SOT(find,listbox) $SOT(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sotmany_sel \"$SOT(find)\" \"a.fio $SOT(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SOT_DATA(cod,$i) {}; set SOT_DATA(fio,$i) {}
            scan $str "%\[^\t]%*c%\[^\n]" SOT_DATA(cod,$i) SOT_DATA(fio,$i)
            if { [clipped $SOT(entry,fio)] == [clipped $SOT_DATA(fio,$i)] } {
                set SOT(listbox,curselection) $i
            }
            $w insert end " $SOT_DATA(fio,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set SOTSS(statusline) " $i ."
        }
        if { $i == 0 } { set i 1 }
        set SOT(listbox,count) [expr $i - 1]
        $w see $SOT(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    set SOTSS(window) .sotss.sot.lb.listbox
}

proc sotone:read {} {
    global VS SOT SOT_DATA
    
    waiting "  ..." blue
    sot:entry:clearvar
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sotone_sel $SOT_DATA(cod,$SOT(listbox,curselection))"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      SOT(entry,gorodcod) \
                      SOT(entry,fio) \
                      SOT(entry,matotv) \
                      SOT(entry,datborn) \
                      SOT(entry,gorodnam) \
                      SOT(entry,phonecod) \
                      SOT(entry,index) \
                      SOT(entry,ulica) \
                      SOT(entry,dom) \
                      SOT(entry,kv) \
                      SOT(entry,phone) \
                      SOT(entry,email) \
                      SOT(entry,prim) \
                      SOT(entry,login)
        }
        set SOT(entry,fio)      [clipped $SOT(entry,fio)]
        set SOT(entry,matotv)   [clipped $SOT(entry,matotv)]
        set SOT(entry,gorodnam) [clipped $SOT(entry,gorodnam)]
        set SOT(entry,index)    [clipped $SOT(entry,index)]
        set SOT(entry,ulica)    [clipped $SOT(entry,ulica)]
        set SOT(entry,dom)      [clipped $SOT(entry,dom)]
        set SOT(entry,kv)       [clipped $SOT(entry,kv)]
        set SOT(entry,phone)    [clipped $SOT(entry,phone)]
        set SOT(entry,email)    [clipped $SOT(entry,email)]
        set SOT(entry,prim)     [clipped $SOT(entry,prim)]
        set SOT(entry,login)    [clipped $SOT(entry,login)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc sot:find {} {
    global VS SOT
    
    sot:entry find
    if { $SOT(entrystatus) == 1 } {
        set SOT(find) "1=1"
        foreach {i j} "\"$SOT(entry,fio)\" a.fio \
                       \"$SOT(entry,matotv)\" a.matotv \
                       \"$SOT(entry,datborn)\" a.datborn \
                       \"$SOT(entry,gorodnam)\" b.nam \
                       \"$SOT(entry,phonecod)\" b.phone_cod \
                       \"$SOT(entry,index)\" a.index \
                       \"$SOT(entry,ulica)\" a.ulica \
                       \"$SOT(entry,dom)\" a.dom \
                       \"$SOT(entry,kv)\" a.kv \
                       \"$SOT(entry,phone)\" a.phone \
                       \"$SOT(entry,email)\" a.email
                       \"$SOT(entry,prim)\" a.prim \
                       \"$SOT(entry,login)\" a.login" \
        {
            if { $i != "" } {
                set SOT(find) "$SOT(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $SOT(find,listbox) $SOT(find)] == -1} {
            lappend SOT(find,listbox) $SOT(find)
        }
        sot:read
    }
    set SOT(entrystatus) 0
}

proc sot:delete {} {
    global VS SOT SOT_DATA
    
    set w .sotss.sot.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id $SOT(listbox,curselection)
        puts $socks "sot_del $SOT_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } { }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        sot:read
    } else {
        errormsg nosocks "  !"
    }
            
    if { $id > $SOT(listbox,count)} {
        set id $SOT(listbox,count)
        set SOT(listbox,curselection) $SOT(listbox,count)
    }
    $w see $id
}

proc sot:insert {} {
    global VS SOT
    
    sot:entry insert
    set w .sotss.sot.lb.listbox
    if { $SOT(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "sot_ins \"$SOT(entry,fio)\" \
                                 \"$SOT(entry,matotv)\" \
                                 \"$SOT(entry,datborn)\" \
                                 \"$SOT(entry,gorodcod)\" \
                                 \"$SOT(entry,index)\" \
                                 \"$SOT(entry,ulica)\" \
                                 \"$SOT(entry,dom)\" \
                                 \"$SOT(entry,kv)\" \
                                 \"$SOT(entry,phone)\" \
                                 \"$SOT(entry,email)\" \
                                 \"$SOT(entry,prim)\" \
                                 \"$SOT(entry,login)\" "
            flush $socks
    
            while { [ set sotcod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sot:read
        } else {
            errormsg nosocks "  !"
        }

        $w see $SOT(listbox,curselection)
    }
    set SOT(entrystatus) 0
}

proc sot:update {} {
    global VS SOT SOT_DATA

    set w .sotss.sot.lb.listbox
    sotone:read
    sot:entry update
    if { $SOT(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "sot_upd $SOT_DATA(cod,$SOT(listbox,curselection)) \
                                 \"$SOT(entry,fio)\" \
                                 \"$SOT(entry,matotv)\" \
                                 \"$SOT(entry,datborn)\" \
                                 \"$SOT(entry,gorodcod)\" \
                                 \"$SOT(entry,index)\" \
                                 \"$SOT(entry,ulica)\" \
                                 \"$SOT(entry,dom)\" \
                                 \"$SOT(entry,kv)\" \
                                 \"$SOT(entry,phone)\" \
                                 \"$SOT(entry,email)\" \
                                 \"$SOT(entry,prim)\" \
                                 \"$SOT(entry,login)\" "
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sot:read
        } else {
            errormsg nosocks "  !"
        }
    }
    $w see [set id $SOT(listbox,curselection)]
    $w selection set $id $id
    set SOT(entrystatus) 0
}

proc sot:view {} {
    global VS SOT SOT_DATA
    
    sotone:read
    sot:entry view
}

proc sot:print {} {
    global VS SOT    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "sot_rep \"$SOT(find)\" \"a.fio $SOT(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc sot:hegorod { tip win } {
    global VS SOT HE
    
    set w .sotss.sot.sotentry.inf.gorodnam.e
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$SOT(entry,gorodnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 11 37 gorod $namstr $tip $win
    set SOT(entry,gorodcod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%s" SOT(entry,gorodnam) SOT(entry,phonecod)
    set SOT(entry,gorodnam)     [clipped $SOT(entry,gorodnam)]
    set SOT(entry,old_gorodnam) $SOT(entry,gorodnam)
    set SOT(entry,phonecod) [clipped $SOT(entry,phonecod)]
    set SOT(hebutton) 0
}
