proc sotss {} {
    global VS SOTSS

    set w .sotss
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    trace vdelete SOTSS(window) w trace:sotss:window
    wm resizable $w 0 0
    #wm geometry $w +20+57
    wm geometry $w =0x0
    wm title $w ""
    set SOTSS(window) {}
    trace variable SOTSS(window) w trace:sotss:window
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "sotss:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "sotss:insert"
    $w1.1 add command -label "" -command "sotss:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command sotss:view
    $w1.1 add command -state disabled -label "" -command sotss:update
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -command "sotss:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy .balloon; destroy $w;"
    label $w.buttons.lm -textvariable SOTSS(statusline) -relief sunken -anchor w -padx 3 -width 50
    button $w.buttons.help -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view "" update "" delete "" exit ""} {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -state disabled -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        .sotss.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.delete <Button-1> {
        .sotss.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { .sotss.buttons.exit invoke }
    bind $w <Key-F5>     { sotss:find }
    bind $w <Key-Insert> { sotss:insert }
    sklad
    sot
    wm geometry $w [centerwindow $w]
}

proc sotss:sort {} {
    global  SOTSS VS SOT SKLAD
    
    set w .sotss.menu
    catch [$w.1.sort delete 0 20]
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox {
            $w.1.sort add radio -label " " -variable SOT(sortdesc) -value " "\
                 -command "sot:read; .sotss.sot.lb.listbox selection set 0 0"
            $w.1.sort add radio -label " " -variable SOT(sortdesc) -value "desc"\
                 -command "sot:read; .sotss.sot.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add command -label "" 
        }
        .sotss.sklad.lb.listbox {
            $w.1.sort add radio -label " " -variable SKLAD(sortdesc) -value " "\
                 -command "sklad:read; .sotss.sklad.lb.listbox selection set 0 0"
            $w.1.sort add radio -label " " -variable SKLAD(sortdesc) -value "desc"\
                 -command "sklad:read; .sotss.sklad.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add command -label "" 
        }
    }
}

proc sotss:insert {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox        { sot:insert }
        .sotss.sklad.lb.listbox      { sklad:insert }
    }
}

proc sotss:update {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox        { sot:update }
        .sotss.sklad.lb.listbox      { sklad:update }
    }
}

proc sotss:delete {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox        { sot:delete }
        .sotss.sklad.lb.listbox      { sklad:delete }
    }
}

proc sotss:view {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox        { sot:view }
        .sotss.sklad.lb.listbox      { sklad:view }
    }
}

proc sotss:find {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox       { sot:find }
        .sotss.sklad.lb.listbox     { sklad:find }
    }
}

proc sotss:print {} {
    global  SOTSS
    
    switch $SOTSS(window) {
        .sotss.sot.lb.listbox       { sot:print }
        .sotss.sklad.lb.listbox     { sklad:print }
    }
}

proc trace:sotss:window { name1 name2 op } {
    global SKLAD SOTSS SOT SOT_DATA

    
    .sotss.sot.nameform.l configure -fg black
    .sotss.sklad.nameform.l configure -fg black
    switch -regexp $SOTSS(window) {
        \.sklad\.        { .sotss.sklad.nameform.l configure -fg blue }
        \.sot\.          { .sotss.sot.nameform.l configure -fg blue }
    }
    
    if { $SOTSS(window) == "" } {
        sotss:iconmenu:state disabled "find  insert  print  sort  view  update  delete "
    }
    if { $SOTSS(window) != "" } {
        if { [ $SOTSS(window) index end ] == 0 } {
            sotss:iconmenu:state disabled "find  insert  print  sort  view  update  delete "
        } else {
            sotss:iconmenu:state normal "find  insert  print  sort  view  update  delete "
            sotss:sort
        }
        switch -regexp $SOTSS(window) {
            \.sot\. {
                sotss:iconmenu:state normal  "insert "
            }
            \.sklad\.    { 
                if { $SOT_DATA(cod,$SOT(listbox,curselection)) > 0 } { sotss:iconmenu:state normal  "insert " }
            }
        }
    }
}

proc sotss:iconmenu:state {s l} {
    set w .sotss
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        $w.butimg.$statei configure -state $s
    }
}

proc sotss:select:element { win } {
    global VS SOT_DATA SOT

    set w .sotss.se$win
    catch [destroy $w]
    if { [ .sotss.$win.lb.listbox index end ] != 0 } {
        set cursel $SOT(listbox,curselection)
        set txt $SOT_DATA(fio,$cursel)
        set x [lindex [.sotss.$win.lb.listbox bbox $cursel] 0]
        set y [lindex [.sotss.$win.lb.listbox bbox $cursel] 1]
        toplevel $w -cursor arrow
        wm overrideredirect $w 1
        wm geometry $w +[expr [winfo rootx .sotss.$win.lb.listbox] + $x - 1]+[expr [winfo rooty .sotss.$win.lb.listbox] + $y - 2]
        label $w.l -relief raised -bd 1 -anchor w -text " $txt" -padx 0 -pady 1 -width 52 -bg #00c0c0
        pack $w.l
    }
    bind $w <Button-1> {
        scan %W "%%*c%%\[^.]%%*c%%\[^.]" w1 w2
        set win ".${w1}.$w2"
        catch [destroy $win]
    }
}
