proc stt:entry:clearvar {} {
    global STT
    
    
    foreach i { vppcod vprcod sgpcod shtcod \
                zaimtocod pzaimtocod zaimfromcod pzaimfromcod \
                gklp1cod gklp2cod gklr1cod gklr2cod \
                gpsr1cod gpsr2cod gpsp1cod gpsp2cod \
                vppnam vprnam sgpnam shtnam \
                zaimtonam pzaimtonam zaimfromnam pzaimfromnam \
                gklp1nam gklp2nam gklr1nam gklr2nam \
                gpsr1nam gpsr2nam gpsp1nam gpsp2nam } {
        set STT($i) ""
    }
}

proc stt {} {
    global STT VS
    
    set w .allcfg.dat
    catch [destroy $w]
    
    frame $w
    pack $w
    frame $w.title -bd 3
    label $w.title.l -font $VS(fontn) -text "  " -relief raised -anchor center -bd 1 -padx 3 -width 26
    frame $w.inf -bd 1 -relief raised
    pack $w.title $w.title.l -fill x
    pack $w.inf
    
    foreach { i } { vpp vpr sgp sht zaimto pzaimto zaimfrom pzaimfrom \
                    gklp1 gklp2 gklr1 gklr2 gpsr1 gpsr2 gpsp1 gpsp2 } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 2 -pady 0
        if { $i == "vpr" || $i == "sht" || $i == "pzaimfrom" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { vpp       "   " \
                      vpr       "   " \
                      sgp       "            " \
                      sht       "          \"\"" \
                      zaimto    "                      -" \
                      pzaimto   "            -" \
                      zaimfrom  "                    -" \
                      pzaimfrom "          -" \
                      gklp1     "                  " \
                      gklp2     "       " \
                      gklr1     "                  " \
                      gklr2     "             " \
                      gpsr1     "            " \
                      gpsr2     "          " \
                      gpsp1     "     " \
                      gpsp2     "                 c " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    
    foreach { i j } { vpp  30 vpr  30 sgp  30 sht  10 zaimto 30 pzaimto 30 \
                      zaimfrom 30 pzaimfrom 30 \
                      gklp1 30 gklp2 30 gklr1 30 gklr2 30 \
                      gpsr1 30 gpsr2 30 gpsp1 30 gpsp2 30 } {
        entry $w.inf.$i.e -textvariable STT(${i}nam) -width $j -bd 1
        bind $w.inf.$i.e <Button-1> { 
            catch [destroy .allcfg.dat.he]
        }
    }
    
    button $w.inf.vpp.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.vpr.e"
    button $w.inf.vpr.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.sgp.e"
    button $w.inf.sgp.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.sht.e"
    button $w.inf.sht.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.zaimto.e"
    button $w.inf.zaimto.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.pzaimto.e"
    button $w.inf.pzaimto.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.zaimfrom.e"
    button $w.inf.zaimfrom.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.pzaimfrom.e"
    button $w.inf.pzaimfrom.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gklp1.e"
    
    button $w.inf.gklp1.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gklp2.e"
    button $w.inf.gklp2.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gklr1.e"
    button $w.inf.gklr1.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gklr2.e"
    button $w.inf.gklr2.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gpsr1.e"
    button $w.inf.gpsr1.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gpsr2.e"
    button $w.inf.gpsr2.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gpsp1.e"
    button $w.inf.gpsp1.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.gpsp2.e"
    button $w.inf.gpsp2.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command "focus $w.inf.vpp.e"
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "stt:insert"
    button $w.buttons.clear -bd 1 -text "" -command "stt:entry:clearvar"
    button $w.buttons.exit -bd 1 -text "" -command "destroy .allcfg"
        
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.inf
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 10
  
    foreach i { vpp.e vpp.b vpr.e vpr.b sgp.e sgp.b sht.e sht.b \
                zaimto.e zaimto.b pzaimto.e pzaimto.b \
                zaimfrom.e zaimfrom.b pzaimfrom.e pzaimfrom.b \
                gklp1.e gklp1.b gklp2.e gklp2.b gklr1.e gklr1.b gklr2.e gklr2.b \
                gpsr1.e gpsr1.b gpsr2.e gpsr2.b gpsp1.e gpsp1.b gpsp2.e gpsp2.b } {
        pack $w.inf.$i -side left
    }
    bind $w.inf.vpp.e <FocusOut> {
        if { "$STT(old_vppnam)" != "$STT(vppnam)" } {
            stt:heoperaciap u .allcfg.dat vpp
            set STT(old_vppnam) $STT(vppnam)
        }
    }
    bind $w.inf.vpr.e <FocusOut> {
        if { "$STT(old_vprnam)" != "$STT(vprnam)" } {
            stt:heoperaciar u .allcfg.dat vpr
            set STT(old_vprnam) $STT(vprnam)
        }
    }
    bind $w.inf.sgp.e <FocusOut> {
        if { "$STT(old_sgpnam)" != "$STT(sgpnam)" } {
            stt:hesklad u .allcfg.dat
            set STT(old_sgpnam) $STT(sgpnam)
        }
    }
    bind $w.inf.sht.e <FocusOut> {
        if { "$STT(old_shtnam)" != "$STT(shtnam)" } {
            stt:heei u .allcfg.dat
            set STT(old_shtnam) $STT(shtnam)
        }
    }
    
    bind $w.inf.zaimto.e <FocusOut> {
        if { "$STT(old_zaimtonam)" != "$STT(zaimtonam)" } {
            stt:heoperaciar u .allcfg.dat zaimto
            set STT(old_zaimtonam) $STT(zaimtonam)
        }
    }
    bind $w.inf.pzaimto.e <FocusOut> {
        if { "$STT(old_pzaimtonam)" != "$STT(pzaimtonam)" } {
            stt:heoperaciap u .allcfg.dat pzaimto
            set STT(old_pzaimtonam) $STT(pzaimtonam)
        }
    }
    bind $w.inf.zaimfrom.e <FocusOut> {
        if { "$STT(old_zaimfromnam)" != "$STT(zaimfromnam)" } {
            stt:heoperaciap u .allcfg.dat zaimfrom
            set STT(old_zaimfromnam) $STT(zaimfromnam)
        }
    }
    bind $w.inf.pzaimfrom.e <FocusOut> {
        if { "$STT(old_pzaimfromnam)" != "$STT(pzaimfromnam)" } {
            stt:heoperaciar u .allcfg.dat pzaimfrom
            set STT(old_pzaimfromnam) $STT(pzaimfromnam)
        }
    }
    
    bind $w.inf.gklp1.e <FocusOut> {
        if { "$STT(old_gklp1nam)" != "$STT(gklp1nam)" } {
            stt:heoperaciap u .allcfg.dat gklp1
            set STT(old_gklp1nam) $STT(gklp1nam)
        }
    }
    bind $w.inf.gklp2.e <FocusOut> {
        if { "$STT(old_gklp2nam)" != "$STT(gklp2nam)" } {
            stt:heoperaciap u .allcfg.dat gklp2
            set STT(old_gklp2nam) $STT(gklp2nam)
        }
    }
    bind $w.inf.gklr1.e <FocusOut> {
        if { "$STT(old_gklr1nam)" != "$STT(gklr1nam)" } {
            stt:heoperaciar u .allcfg.dat gklr1
            set STT(old_gklr1nam) $STT(gklr1nam)
        }
    }
    bind $w.inf.gklr2.e <FocusOut> {
        if { "$STT(old_gklr2nam)" != "$STT(gklr2nam)" } {
            stt:heoperaciar u .allcfg.dat gklr2
            set STT(old_gklr2nam) $STT(gklr2nam)
        }
    }
    bind $w.inf.gpsr1.e <FocusOut> {
        if { "$STT(old_gpsr1nam)" != "$STT(gpsr1nam)" } {
            stt:heoperaciar u .allcfg.dat gpsr1
            set STT(old_gpsr1nam) $STT(gpsr1nam)
        }
    }
    bind $w.inf.gpsr2.e <FocusOut> {
        if { "$STT(old_gpsr2nam)" != "$STT(gpsr2nam)" } {
            stt:heoperaciar u .allcfg.dat gpsr2
            set STT(old_gpsr2nam) $STT(gpsr2nam)
        }
    }
    bind $w.inf.gpsp1.e <FocusOut> {
        if { "$STT(old_gpsp1nam)" != "$STT(gpsp1nam)" } {
            stt:heoperaciap u .allcfg.dat gpsp1
            set STT(old_gpsp1nam) $STT(gpsp1nam)
        }
    }
    bind $w.inf.gpsp2.e <FocusOut> {
        if { "$STT(old_gpsp2nam)" != "$STT(gpsp2nam)" } {
            stt:heoperaciap u .allcfg.dat gpsp2
            set STT(old_gpsp2nam) $STT(gpsp2nam)
        }
    }
    stt:read
    tkwait window $w
}
