proc stt:read {} {
    global VS STT
    
    waiting "  ..." blue
    stt:entry:clearvar
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "stt_sel"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      STT(vppcod) \
                      STT(vprcod) \
                      STT(sgpcod) \
                      STT(shtcod) \
                      STT(zaimtocod) \
                      STT(pzaimtocod) \
                      STT(zaimfromcod) \
                      STT(pzaimfromcod) \
                      STT(gklp1cod) \
                      STT(gklp2cod) \
                      STT(gklr1cod) \
                      STT(gklr2cod) \
                      STT(gpsr1cod) \
                      STT(gpsr2cod) \
                      STT(gpsp1cod) \
                      STT(gpsp2cod) \
                      STT(vppnam) \
                      STT(vprnam) \
                      STT(sgpnam) \
                      STT(shtnam) \
                      STT(zaimtonam) \
                      STT(pzaimtonam) \
                      STT(zaimfromnam) \
                      STT(pzaimfromnam) \
                      STT(gklp1nam) \
                      STT(gklp2nam) \
                      STT(gklr1nam) \
                      STT(gklr2nam) \
                      STT(gpsr1nam) \
                      STT(gpsr2nam) \
                      STT(gpsp1nam) \
                      STT(gpsp2nam)
        }
        foreach i { vppcod vprcod sgpcod shtcod \
                zaimtocod pzaimtocod zaimfromcod pzaimfromcod \
                gklp1cod gklp2cod gklr1cod gklr2cod \
                gpsr1cod gpsr2cod gpsp1cod gpsp2cod \
                vppnam vprnam sgpnam shtnam \
                zaimtonam pzaimtonam zaimfromnam pzaimfromnam \
                gklp1nam gklp2nam gklr1nam gklr2nam \
                gpsr1nam gpsr2nam gpsp1nam gpsp2nam } {
            set STT($i) [clipped $STT($i)]
        }
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    foreach i { vppcod vprcod sgpcod shtcod \
                zaimtocod pzaimtocod zaimfromcod pzaimfromcod \
                gklp1cod gklp2cod gklr1cod gklr2cod \
                gpsr1cod gpsr2cod gpsp1cod gpsp2cod \
                vppnam vprnam sgpnam shtnam \
                zaimtonam pzaimtonam zaimfromnam pzaimfromnam \
                gklp1nam gklp2nam gklr1nam gklr2nam \
                gpsr1nam gpsr2nam gpsp1nam gpsp2nam } {
        set STT(old_$i) $STT($i)
    }
}

proc stt:insert {} {
    global VS STT
    
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "stt_ins $STT(vppcod) $STT(vprcod) $STT(sgpcod) $STT(shtcod) \
                             $STT(zaimtocod) $STT(pzaimtocod) $STT(zaimfromcod) $STT(pzaimfromcod) \
                             $STT(gklp1cod) $STT(gklp2cod) $STT(gklr1cod) $STT(gklr2cod) \
                             $STT(gpsr1cod) $STT(gpsr2cod) $STT(gpsp1cod) $STT(gpsp2cod) "
        flush $socks

        while { [ set sttcod [ gets $socks ] ] != $VS(sepdata) } {
        }
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc stt:heoperaciap { tip win vr } {
    global VS STT HE
    
    set w .allcfg.dat.inf.$vr.e
    set HE(tit) "   "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 30 operaciap $STT(${vr}nam) $tip $win
    set STT(${vr}cod) $HE(cod)
    set STT(${vr}nam) $HE(nam)
}

proc stt:heoperaciar { tip win vr } {
    global VS STT HE
    
    set w .allcfg.dat.inf.$vr.e
    set HE(tit) "   "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 30 operaciar $STT(${vr}nam) $tip $win
    set STT(${vr}cod) $HE(cod)
    set STT(${vr}nam) [clipped $HE(nam)]
}

proc stt:hesklad { tip win } {
    global VS STT HE
    
    set w .allcfg.dat.inf.sgp.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 30 sklad $STT(sgpnam) $tip $win
    set STT(sgpcod) $HE(cod)
    set STT(sgpnam) [clipped $HE(nam)]
}

proc stt:heei { tip win } {
    global VS STT HE
    
    set w .allcfg.dat.inf.sht.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 10 ei $STT(shtnam) $tip $win
    set STT(shtcod) $HE(cod)
    set STT(shtnam) [clipped $HE(nam)]
}
