proc tktableinit {} {

    #       .
    #     -   .
    bind Table <KeyPress-Right> {
        tkTableMoveCell %W 0 1
        set activecol [%W index active col]
        set cols [%W cget -cols]
        set disabledcol [%W tag col Disabled]
        if [regexp $activecol $disabledcol] {
            if { [expr 1 + $activecol] != $cols } {
                event generate %W <KeyPress-Right>
            } else {
                event generate %W <KeyPress-Left>
            }
        }
    }
    bind Table <KeyPress-Left> {
        tkTableMoveCell %W 0 -1
        set activecol [%W index active col]
        set disabledcol [%W tag col Disabled]
        if [regexp $activecol $disabledcol] {
            if { $activecol != 0 } {
                event generate %W <KeyPress-Left>
            } else {
                event generate %W <KeyPress-Right>
            }
        }
    }
    bind Table <ButtonRelease-1> {
        %W activate @%x,%y
        if [regexp [%W index active col] [%W tag col Disabled]] {
            event generate %W <KeyPress-Right>
        }
    }
#    bind Table <B1-Motion> {
#        %W activate @%x,%y
#    }
    bind Table <Map> {
        %W activate 0,0
    }
    bind Table <KeyRelease-Return> {
        regsub -all "\n|\r" [%W curvalue] "" str
        catch [%W set active $str]
        if { $str != "" } {
            event generate %W <KeyPress-Right>
        }
    }
    bind Table <KeyPress-Return> {
        set allcols ""
        set curcol ""
        catch [set allcols [expr [%W cget -cols] - 1 - [%W cget -titlecols]]]
        catch [scan "[%W curselection]" "%%\[^,]%%*c%%s" currow curcol]
        if { $allcols == $curcol } { %W activate [expr $currow + 1],0 }
    }
    bind Table <KP_Enter> {
        event generate %W <KeyPress-Return>
        event generate %W <KeyRelease-Return>
    }
}

proc tktableinittag { w } {
    global VS
    
    $w tag config RaisedBgRed1 -bg red -relief raised
    $w tag config RaisedBgRed2 -bg #ff8000 -relief raised
    $w tag config RaisedBgGreen -bg green -relief raised
    $w tag config FgBlue -fg blue
    $w tag config FgBlack -fg black
    $w tag config Raised -relief raised
    $w tag config AnchorCenter -anchor center
    $w tag config SelectRow -bg #00c0c0 -relief flat
    $w tag config UnSelectRow -bg grey85 -relief sunken -bd 1
    $w tag config Normal -bg grey85 -fg black
    $w tag config AnchorE -anchor e
    $w tag config AnchorW -anchor w
    $w tag config Disabled -state disabled
    $w tag config Enabled -state normal
    $w tag config Green -bg green
    $w tag config Magenta -bg magenta
    $w tag config FgGreen -fg green
    $w tag config FgYellow3 -fg yellow3
    $w tag config title -fg yellow
    $w tag config sel -bg #00c0c0 -relief flat
    $w tag config active -bd 1 -relief solid
    $w tag config BgGrey65 -bg grey65
    $w tag config FgCyan -fg cyan -bg grey65
    $w tag config ItogoActive -fg cyan -bg grey50
    $w tag config ItogoPassive -fg black -bg grey85
    $w tag config ItogoMenshe -fg black -bg magenta
    $w tag config ItogoBolshe -fg black -bg red
    $w tag config ItogoRavno -fg black -bg green
    $w tag config TovTip -fg blue3 -bg grey90 -font $VS(fontn) -relief flat -state disabled
}
