proc tovar {} {
    global VS TOVAR TOVARGTT TOVAR_DATA

    catch [unset TOVAR_DATA]
    set TOVAR(entry,nam) {}
    set TOVAR(listbox,curselection) 0
    set TOVAR(sortdesc) {}
    set TOVAR(sortstr) {}
    set TOVAR_DATA(cod,0) 0
    set TOVAR(entry,tovargroupnam) ""
    set TOVAR(entry,tovartipnam) ""
    
    set w .tovargtt.tovar
    catch [destroy $w]
    
    frame $w -bd 5
    pack $w -side bottom
    frame $w.nameform
    label $w.nameform.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3
    frame $w.namefield
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 47
    label $w.namefield.p2 -text ".." -relief raised -anchor center -bd 1 -padx 1 -width 8
    label $w.namefield.p3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p4 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 3
    label $w.namefield.p5 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 3
    label $w.namefield.p6 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 5
    label $w.namefield.p7 -text ".N" -relief raised -anchor center -bd 1 -padx 1 -width 5
    label $w.namefield.p8 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 5
    label $w.namefield.p9 -text "WWW" -relief raised -anchor center -bd 1 -padx 1 -width 5
    pack $w.nameform $w.nameform.l
    tovar:search
    pack $w.namefield
    foreach i { p1 p2 p3 p4 p5 p6 p7 p8 p9 } {
        pack $w.namefield.$i -side left
    }
    frame $w.lb
    scrollbar $w.lb.scrollbar -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -yscroll "$w.lb.scrollbar set" -height 11 -width 93 -exportselection 0
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    bind $w.lb.listbox <Button-1> {
        set TOVARGTT(window) %W
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        event generate %W <<tovar:set:variable>>
        event generate %W <<tovar:run:read>>
    }
    bind $w.lb.listbox <<tovar:set:variable>> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set TOVARGTT(statusline) [ %W get $id ]
        set TOVAR(listbox,curselection) $id
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists TOVAR_DATA(nam,$TOVAR(listbox,curselection))] {
            tovar:update
        }
    }
    bind $w.lb.listbox <Button-3> {
        set TOVARGTT(window) %W
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <<tovar:set:variable>>
        .tovargtt.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
}

proc tovar:search {} {
    global VS
    
    set w .tovargtt.tovar.search
    frame $w
    label $w.lfind -relief sunken -width 89 -textvariable TOVAR(find) -anchor w
    button $w.lfindb -bd 1 -bitmap @$VS(dir)ComboBox.xbm -command tovar:search:lb 
    pack $w
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { tovar:search:lb }
}

proc tovar:search:lb {} {
    global VS TOVAR TOVARGTT
    
    set w .tovargtt.tovar.search.lfindlb
    catch [destroy $w]
    set x [winfo rootx .tovargtt.tovar.search.lfind]
    set y [winfo rooty .tovargtt.tovar.search.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width 89
    
    foreach {i} $TOVAR(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $TOVAR(find,listbox) $TOVAR(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set TOVAR(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable TOVAR(find)
    destroy $w
    tovar:read
}

proc tovar:entry:clearvar {} {
    global TOVAR
    
    set TOVAR(entry,nam) ""
    set TOVAR(entry,eicod) ""
    set TOVAR(entry,einam) ""
    set TOVAR(entry,tovargroupcod) ""
    set TOVAR(entry,tovargroupnam) ""
    set TOVAR(entry,tovartipcod) ""
    set TOVAR(entry,tovartipnam) ""
    set TOVAR(entry,cena) ""
    set TOVAR(entry,gs) ""
    set TOVAR(entry,isnds) ""
    set TOVAR(entry,ispricelist) ""
    set TOVAR(entry,issernum) ""
    set TOVAR(entry,newbuy) ""
    set TOVAR(entry,saleviawww) ""
}

proc tovar:entry { status win } {
    global VS TOVAR TOVAR_DATA
    
    set TOVAR(entrystatus) {}
    set TOVAR(entry,inwin) $win
    set w $TOVAR(entry,inwin).tovarentry
    set TOVAR(hebutton) 0
    if { $status != "view" && $status != "update"} {
        tovar:entry:clearvar        
    }
    set TOVAR(entry,old_einam)          $TOVAR(entry,einam)
    set TOVAR(entry,old_tovargroupnam)  $TOVAR(entry,tovargroupnam)
    set TOVAR(entry,old_tovartipnam)    $TOVAR(entry,tovartipnam)
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +66+218
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.www
    
    if { $TOVAR(entry,inwin) != "" } {
        if [info exists TOVAR_DATA(cod,[.tovargtt.tovar.lb.listbox curselection])] {
            button $w.inf.www.b -text "WWW   " -command "tovarwww $w $TOVAR_DATA(cod,[.tovargtt.tovar.lb.listbox curselection])"
            pack $w.inf.www.b -side right -padx 80
        }
    }
    foreach { i j } {tovargroupnam  "      "\
                     tovartipnam    "        "\
                     nam            "            "\
                     einam          "              "\
                     cena           "                          "\
                     gs             "               "\
                     isnds          "                          "\
                     ispricelist    "           -"\
                     issernum       "    "\
                     www.newbuy     "                  "\
                     www.saleviawww "          " } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 3
        label $w.inf.$i.l -text $j
        if { ($i == "tovartipnam" && $TOVAR(entry,inwin) == "") || $i == "issernum" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    pack $w.inf.www -anchor w
    
    entry $w.inf.tovargroupnam.e -textvariable TOVAR(entry,tovargroupnam) -width 50
    button $w.inf.tovargroupnam.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set TOVAR(hebutton) 1; tovar:hetovargroupnam r $TOVAR(entry,inwin).tovarentry \"$TOVAR(entry,inwin)\""
    entry $w.inf.tovartipnam.e -textvariable TOVAR(entry,tovartipnam) -width 50
    button $w.inf.tovartipnam.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set TOVAR(hebutton) 1; tovar:hetovartipnam r $TOVAR(entry,inwin).tovarentry \"$TOVAR(entry,inwin)\""
    
    entry $w.inf.nam.e -textvariable TOVAR(entry,nam) -width 50
    entry $w.inf.einam.e -textvariable TOVAR(entry,einam) -width 10
    button $w.inf.einam.b -bd 1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set TOVAR(hebutton) 1; tovar:heeinam r $TOVAR(entry,inwin).tovarentry \"$TOVAR(entry,inwin)\""
    entry $w.inf.cena.e -textvariable TOVAR(entry,cena) -width 10
    entry $w.inf.gs.e -textvariable TOVAR(entry,gs) -width 2
    checkbutton $w.inf.isnds.e -variable TOVAR(entry,isnds) -offvalue "" \
        -onvalue "*" -bg grey80 -bd 1 -relief raised
    checkbutton $w.inf.ispricelist.e -variable TOVAR(entry,ispricelist) \
        -offvalue "" -onvalue "*" -bg grey80 -bd 1 -relief raised
    checkbutton $w.inf.issernum.e -variable TOVAR(entry,issernum) \
        -offvalue "" -onvalue "*" -bg grey80 -bd 1 -relief raised
    checkbutton $w.inf.www.newbuy.e -variable TOVAR(entry,newbuy) \
        -offvalue "" -onvalue "*" -bg grey80 -bd 1 -relief raised
    checkbutton $w.inf.www.saleviawww.e -variable TOVAR(entry,saleviawww) \
        -offvalue "" -onvalue "*" -bg grey80 -bd 1 -relief raised
    
    if { $status == "view" } {
        foreach i { nam einam cena gs isnds ispricelist issernum www.newbuy www.saleviawww } {
            $w.inf.$i.e configure -state disabled
        }
        $w.inf.einam.b configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" \
        -command "set VS($TOVAR(entry,inwin).tovarentry_update) 0; set TOVAR(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" \
        -command "tovar:entry:clearvar"
    button $w.buttons.exit -text "" \
        -command "set TOVAR(entrystatus) 0; destroya $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    
    foreach i { nam einam cena gs isnds ispricelist issernum www.newbuy www.saleviawww } {
        pack $w.inf.$i.l $w.inf.$i.e -side left
    }
    
    if { $TOVAR(entry,inwin) == "" } {
        foreach i { tovargroupnam tovartipnam } {
            pack $w.inf.$i.l $w.inf.$i.e -side left
        }
        foreach i { tovargroupnam tovartipnam } {
            pack $w.inf.$i.b -side left
        }
    }
    pack $w.inf.einam.b -side left
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        if { $TOVAR(entry,inwin) != "" } { 
            focus $w.inf.nam.e
        } else {
            focus $w.inf.tovargroupnam.e
        }
    } else {
        focus $w.buttons.exit
    }
    foreach { i } { tovargroupnam.e tovartipnam.e einam.e } {
        bind $w.inf.$i <FocusOut> {
            regexp "\[^\.]*\.\[^\.]*$" %W wn
            scan $wn "%%\[^\.]%%*c%%s" wn fuf
            if { $TOVAR(hebutton) == 0 } { 
                if { "$TOVAR(entry,old_$wn)" != "$TOVAR(entry,$wn)" } { 
                    regsub -all " " "$TOVAR(entry,$wn)" "" lng 
                    if { [string length $lng] > 0 } { 
                        tovar:he$wn u ${TOVAR(entry,inwin)}.tovarentry $TOVAR(entry,inwin)
                        set TOVAR(entry,old_$wn) $TOVAR(entry,$wn) 
                    } else { set TOVAR(entry,$wn) "" }
                }
            }
            set TOVAR(hebutton) 0
        }
    }
    bind $w <Key-Escape> {
        $TOVAR(entry,inwin).tovarentry.buttons.exit invoke
    }
    foreach i { tovargroupnam tovartipnam einam } {
        bind $w.inf.$i.e <Button-1> {
            catch [destroy $TOVAR(entry,inwin).tovarentry.he]
        }
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
