proc tovcard { win tip } {
    # tip = f -  
    # tip = m -  
    global VS TOVCARD TOVCARDTOV TOVCARDTOV_DATA STT
    
    catch [destroy $TOVCARD(inwin).tovcard]
    catch [unset TOVCARDTOV_DATA]
    if ![info exists TOVCARD(entry,clockdatbegin)] {
        set TOVCARD(entry,clockdatbegin) [clock scan "01/01/$VS(year)"]
        set TOVCARD(entry,clockdatend)   [ expr $VS(clock) + 86400 ]
        set TOVCARD(entry,datbegin) [clock format $TOVCARD(entry,clockdatbegin) -format %d.%m.%Y]
        set TOVCARD(entry,datend)   [clock format $TOVCARD(entry,clockdatend) -format %d.%m.%Y]
    }
    if ![info exists TOVCARD(entry,skladnam)] {
        set TOVCARD(entry,skladnam) $STT(sgpnam)
    }
    set TOVCARD(inwin) $win
    set TOVCARD(tip) $tip
    set TOVCARD(find) ""
    set TOVCARD(count) 0
    set TOVCARD(first) 0
    set TOVCARD(old_current) 0
    set TOVCARD(CurrentOk) 1
    set w $TOVCARD(inwin).tovcard
    set TOVCARD(find,listbox) ""
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    switch $TOVCARD(tip) {
        f { 
            #wm geometry $w +22+55
            set TOVCARD(titstr)  " " 
        }
        m { 
            #wm geometry $w +12+55
            set TOVCARD(titstr)  " ." 
        }
    }
    wm geometry $w =0x0
    
    wm title $w $TOVCARD(titstr)
    
    trace vdelete TOVCARD(current) w tovcard:trace:current    

    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "tovcard:find"
    $w1.1 add command -label "" -command "tovcardtov:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable TOVCARDTOV(sortstr) -value "4, 5, 12" -command tovcardtov:read
        $w1.1.sort add radio -label "  " -variable TOVCARDTOV(sortstr) -value "5, 4, 12" -command tovcardtov:read
        $w1.1.sort add radio -label "  " -variable TOVCARDTOV(sortstr) -value "6, 4, 12" -command tovcardtov:read
        $w1.1.sort add radio -label "    " -variable TOVCARDTOV(sortstr) -value "3, 2, 12, 4" -command tovcardtov:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable TOVCARDTOV(sortdesc) -value " " -command tovcardtov:read
        $w1.1.sort add radio -label " " -variable TOVCARDTOV(sortdesc) -value "desc" -command tovcardtov:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    # 
    frame $w.upr -relief raised -bd 3 
    button $w.upr.first -takefocus 0 -textvar TOVCARD(first) -width 5 \
        -command "tovcard:poz first"
    button $w.upr.left -takefocus 0 -bitmap @$VS(dir)UkLeftBig.xbm \
        -command "tovcard:poz decr"
    scale $w.upr.scale -takefocus 0 -orient horiz -from $TOVCARD(first) \
        -to $TOVCARD(count) -width 7 -var TOVCARD(current)
    bind $w.upr.scale <ButtonPress-1> {
        set TOVCARD(CurrentOk) 0
    }
    bind $w.upr.scale <ButtonRelease-1> {
        set TOVCARD(CurrentOk) 1
        set TOVCARD(current) $TOVCARD(current)
    }
    button $w.upr.right -takefocus 0 -bitmap @$VS(dir)UkRightBig.xbm \
        -command "tovcard:poz incr"
    button $w.upr.last -takefocus 0 -textvar TOVCARD(count) -width 5 \
        -command "tovcard:poz last"
    pack $w.upr -side bottom -fill x
    foreach i { first left right last scale } {
        bind $w.upr.$i <Leave> { destroy .balloon }
        bind $w.upr.$i <Enter> { bindballoon %W }
    }
    trace variable TOVCARD(current) w tovcard:trace:current
    
    foreach i { first left right last } {
        pack $w.upr.$i -side left -fill y
    }
    pack $w.upr.scale -padx 5 -fill x
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find "" print "" sort "" exit  } {
        if { $i == "print" } tovcard:search
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        $TOVCARD(inwin).tovcard.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { catch [destroy $TOVCARD(inwin).tovcard] }
    bind $w <Key-F5>     { tovcard:find }
    tovcardhead    
    wm geometry $w [centerwindow $w]
    tovcard:find
}

proc tovcard:trace:current { name1 name2 op } {
    global TOVCARD TOVCARD_DATA

    if { $TOVCARD(CurrentOk) == 1 && $TOVCARD(current) > 0 } {
        if { $TOVCARD(old_current) != $TOVCARD(current) } {
            foreach i { tovarcod skladcod tovarnam einam \
                        datbegin datend skladnam saldobegin saldoend } {
                set TOVCARD_DATA($i) $TOVCARD_DATA([expr $TOVCARD(current) - 1],$i)
            }
            set TOVCARD(old_current) $TOVCARD(current)
            tovcardtov:read
        }
    }
}

proc tovcard:poz { flg } {
    global TOVCARD

    if $TOVCARD(first) {
        switch $flg {
            first {
                set TOVCARD(current) 1
            }
            decr {
                set TOVCARD(current) [expr $TOVCARD(current) - 1]
                if { $TOVCARD(current) < 1 } { set TOVCARD(current) 1 }
            }
            incr {
                set TOVCARD(current) [expr $TOVCARD(current) + 1]
                if { $TOVCARD(current) > $TOVCARD(count) } { 
                    set TOVCARD(current) $TOVCARD(count) 
                }
            }
            last {
                set TOVCARD(current) $TOVCARD(count)
            }
        }
    }
}

proc tovcard:search {} {
    global VS TOVCARD
    
    set w $TOVCARD(inwin).tovcard.butimg
    label $w.lfind -relief sunken -width 60 -textvariable TOVCARD(find) -anchor w
    button $w.lfindb -takefocus 0 -bitmap @$VS(dir)ComboBox.xbm -command tovcard:search:lb 
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { tovcard:search:lb }
}

proc tovcard:search:lb {} {
    global VS TOVCARD
    
    set w $TOVCARD(inwin).tovcard.butimg.lfindlb
    catch [destroy $w]
    set x [winfo rootx $TOVCARD(inwin).tovcard.butimg.lfind]
    set y [winfo rooty $TOVCARD(inwin).tovcard.butimg.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -setgrid 1 -height 5 -width 60
    
    foreach {i} $TOVCARD(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $TOVCARD(find,listbox) $TOVCARD(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set TOVCARD(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable TOVCARD(find)
    destroy $w
    tovcardtov:clear
    tovcard:read
    tovcardtov:summa
}

proc tovcard:entry:createvar {} {
    global TOVCARD
    
    foreach i { tovartipnam tovarnam datbegin datend skladnam } {
        if ![info exists TOVCARD(entry,$i)] {
            set TOVCARD(entry,$i) ""
        }
    }
}

proc tovcard:entry:clearvar {} {
    global TOVCARD
    
    foreach i { tovartipnam tovarnam skladnam } {
        set TOVCARD(entry,$i) ""
    }
}

proc tovcard:entry {} {
    global VS TOVCARD
    
    set w $TOVCARD(inwin).tovcard.entry
    set TOVCARD(entrystatus) ""
    tovcard:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +140+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tovartipnam tovarnam datbegin datend skladnam } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 1
        if { $i == "tovarnam" || $i == "datend" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tovartipnam " " \
                      tovarnam    "     " \
                      datbegin    ":  " \
                      datend      "        " \
                      skladnam    "     " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {tovartipnam tovartipnam  50
                       tovarnam    tovarnam     50 \
                       datbegin    datbegin     10 \
                       datend      datend       10 \
                       skladnam    skladnam     30 \
                       } {
        entry $w.inf.$i.e -textvariable TOVCARD(entry,$j) -width $k
    }
    
    $w.inf.tovartipnam.e configure -state disabled
    
    foreach { i j } { ControlUp datbegin.bu ControlDown datbegin.bd ControlUp datend.bu ControlDown datend.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.datbegin.bd configure -command "tovcard:incrdate - datbegin"
    $w.inf.datbegin.bu configure -command "tovcard:incrdate + datbegin"
    $w.inf.datend.bd configure -command "tovcard:incrdate - datend"
    $w.inf.datend.bu configure -command "tovcard:incrdate + datend"
    
    
    button $w.inf.tovartipnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovcard:hetovartip r $TOVCARD(inwin).tovcard.entry }
    button $w.inf.tovarnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovcard:hetovar r $TOVCARD(inwin).tovcard.entry }
    button $w.inf.skladnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovcard:hesklad r $TOVCARD(inwin).tovcard.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set TOVCARD(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "tovcard:entry:clearvar"
    button $w.buttons.exit -text "" -command "set TOVCARD(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { tovartipnam.e tovartipnam.b \
                tovarnam.e tovarnam.b datbegin.e datend.e \
                skladnam.e skladnam.b } {
        pack $w.inf.$i -side left
    }
    foreach i { datbegin.bu datbegin.bd datend.bu datend.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.tovarnam.e
    bind $w <Key-Escape>     { $TOVCARD(inwin).tovcard.entry.buttons.exit invoke }
    bind $w <Control-Return> { $TOVCARD(inwin).tovcard.entry.buttons.ok invoke }
    bind $w.inf.datbegin.e <KeyPress-Next>  { tovcard:incrdate - datbegin }
    bind $w.inf.datbegin.e <KeyPress-Prior> { tovcard:incrdate + datbegin }
    bind $w.inf.datend.e   <KeyPress-Next>  { tovcard:incrdate - datend }
    bind $w.inf.datend.e   <KeyPress-Prior> { tovcard:incrdate + datend }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc tovcard:incrdate { k d } {
    global TOVCARD
    
    set TOVCARD(entry,clock$d) [expr $TOVCARD(entry,clock$d) $k 86400 ]
    set TOVCARD(entry,$d) [clock format $TOVCARD(entry,clock$d) -format %d.%m.%Y]
}

proc tovcard:clear {} {

}

proc tovcard:scale {args} {
    puts [list $args]
}

