proc tovdolg {} {
    global VS TOVDOLG TOVDOLGTOV TOVDOLGTOV_DATA

    catch [unset TOVDOLGTOV_DATA]
    tovdolgtov:clear
    set TOVDOLG(find) ""
    set w .tovdolg
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+55
    wm geometry $w =0x0
    wm title $w "    "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "tovdolg:find"
    $w1.1 add command -label "" -command "tovdolg:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable TOVDOLG(sortstr) -value "4, 10" -command tovdolg:read
        $w1.1.sort add radio -label "  " -variable TOVDOLG(sortstr) -value "5, 10" -command tovdolg:read
        $w1.1.sort add radio -label "  " -variable TOVDOLG(sortstr) -value "9, 10" -command tovdolg:read
        $w1.1.sort add radio -label "  " -variable TOVDOLG(sortstr) -value "10" -command tovdolg:read
        $w1.1.sort add radio -label "    " -variable TOVDOLG(sortstr) -value "11, 10" -command tovdolg:read
        $w1.1.sort add radio -label "   " -variable TOVDOLG(sortstr) -value "13, 10" -command tovdolg:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable TOVDOLG(sortdesc) -value " " -command tovdolg:read
        $w1.1.sort add radio -label " " -variable TOVDOLG(sortdesc) -value "desc" -command tovdolg:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -accelerator "<Enter>" -label "" -command tovdolg:document
    $w1.1 add separator
    $w1.1 add command  -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find  print  sort  schet  exit  } {
        if { $i == "print" } { findbox tovdolg 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} { button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        .tovdolg.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { .tovdolg.buttons.exit invoke }
    bind $w <Key-F5>     { tovdolg:find }
    bind $w <Key-Return> { .tovdolg.butimg.schet invoke }
    tovdolghead    
    wm geometry $w [centerwindow $w]
    tovdolg:read
}

proc tovdolg:entry:createvar {} {
    global TOVDOLG
    
    foreach i { tovarnam kol klientnam numdoc datdolg } {
        if ![info exists TOVDOLG(entry,$i)] {
            set TOVDOLG(entry,$i) ""
        }
    }
}

proc tovdolg:entry:clearvar {} {
    global TOVDOLG
    
    foreach i { tovarnam kol klientnam numdoc datdolg } {
        set TOVDOLG(entry,$i) ""
    }
}

proc tovdolg:entry {} {
    global VS TOVDOLG
    
    set w .tovdolg.entry
    set TOVDOLG(entrystatus) ""
    tovdolg:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tovar kol klient num dat } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "klient" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tovar    "   " \
                      kol      "           " \
                      klient   "               " \
                      num      "       " \
                      dat      "   " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {num      numdoc      20 \
                       dat      datdolg     20 \
                       klient   klientnam   50 \
                       tovar    tovarnam    50 \
                       kol      kol         15 \
                       } {
        entry $w.inf.$i.e -textvariable TOVDOLG(entry,$j) -width $k
    }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovdolg:heklient r .tovdolg.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovdolg:hetovar r .tovdolg.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set TOVDOLG(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "tovdolg:entry:clearvar"
    button $w.buttons.exit -text "" -command "set TOVDOLG(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e \
                klient.e klient.b \
                tovar.e tovar.b kol.e \
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.tovar.e
    bind $w <Key-Escape>     { .tovdolg.entry.buttons.exit invoke }
    bind $w <Control-Return> { .tovdolg.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc tovdolg:document {} {
    global TOVDOLG TOVDOLGTOV TOVDOLGTOV_DATA NAKLPLIST

    set w .tovdolg.tov.tbl
    scan [$w index active] "%\[^,]" row
    if [info exists TOVDOLGTOV_DATA($row,tip)] {
        switch -exact $TOVDOLGTOV_DATA($row,tip) {
            s   {
                schetfnr 1 $TOVDOLGTOV_DATA($row,cod)
            }
            i   {
                set NAKLPLIST(pr) r
                naklp 1 m $TOVDOLGTOV_DATA($row,cod) .tovdolg
            }
        }
    }
}
