proc tovdolghead { } {
    global VS TOVDOLG TOVDOLG_DATA TOVDOLGTOV TOVDOLGTOV_DATA

    set w .tovdolg
    # head ##################################################################
    
    label $w.tit -font $VS(fontn) -text "    " \
        -relief raised -anchor center -bd 1
    pack $w.tit
    
    # tov ####################################################################

    set TOVDOLGTOV(rows) 20
    frame $w.tov
    set w "$w.tov"
    pack $w
    entry $w.curfldval -textvar TOVDOLGTOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 7 -height 20 -cols 7 -rows $TOVDOLGTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable TOVDOLGTOV_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { tovdolgtov:browsecommand %S } \
        -wrap on \
        -drawmode fast
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    $w.tbl tag row AnchorCenter -1 -2
    $w.tbl tag col AnchorCenter 3
    $w.tbl width 0 32  1 8  2 7  3 4  4 25  5 7  6 11

    pack $w.curfldval -anchor w
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
            
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind .tovdolg.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        .tovdolg.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind .tovdolg.tov.tbl <KeyRelease-Return> {
        regsub -all "\n|\r" [%W curvalue] "" str
        catch [%W set active $str]
    }
    focus $w.tbl
}

proc tovdolgtov:browsecommand { rowcol } {
    global TOVDOLGTOV TOVDOLGTOV_DATA TOVDOLG TOVDOLG_DATA
    
    set w .tovdolg
    if { [info exists TOVDOLGTOV(ActiveRow)] && \
         $TOVDOLGTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row UnSelectRow $TOVDOLGTOV(ActiveRow)
    }
    set TOVDOLGTOV(ActiveRowCol) $rowcol 
    scan $TOVDOLGTOV(ActiveRowCol) "%\[^,]%*c%s" TOVDOLGTOV(ActiveRow) TOVDOLGTOV(ActiveCol)
    
    if { $TOVDOLGTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row SelectRow $TOVDOLGTOV(ActiveRow)
    }
}

