proc vp { st tip vpcod inwin } {
    global VS VP VPLIST VPTOV VPTOV_DATA VPLIST_DATA
    
    catch [unset VP VPTOV VPTOV_DATA]
    set VPTOV(scena1) 0
    set VPTOV(scena2) 0
    set VP(tip) $tip
    vphead:clear
    vptov:clear
    set VP(cod) $vpcod
    set VP(inwin) $inwin
    set VP(st) $st
    set w $VP(inwin).vp
    set w1 ${w}.menu
    
    switch $tip {
        "f" { 
            if { $VS(login) == "buh" } {
                set titstr ""
            } else {
                set titstr " "
            }
            
        }
        "m" { set titstr " " }
    }
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +$winx+78
    wm geometry $w =0x0
    wm title $w "${titstr}   "
        
    trace vdelete VP(window) w vp:trace:window
    trace variable VP(window) w vp:trace:window
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -state disabled -command vp:insert
    $w1.1 add command -label "" -state disabled -command vp:print
    $w1.1 add cascade -label "" -menu $w1.1.sort -state disabled
        $w1.1.sort add radio -label "  " -variable VPTOV(sortstr) -value "tnam" -command vptov:read
        if { $VP(tip) != "f" } {
            $w1.1.sort add radio -label "  " -variable VPTOV(sortstr) -value "sernumm" -command vptov:read
        }
        $w1.1.sort add radio -label "  " -variable VPTOV(sortstr) -value "koll" -command vptov:read
        $w1.1.sort add radio -label "  " -variable VPTOV(sortstr) -value "enam" -command vptov:read
        $w1.1.sort add radio -label " " -variable VPTOV(sortstr) -value "cenaa" -command vptov:read
        if { $VP(tip) != "f" } {
            $w1.1.sort add radio -label "  " -variable VPTOV(sortstr) -value "cenadd" -command vptov:read
        }
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable VPTOV(sortdesc) -value " " -command vptov:read
        $w1.1.sort add radio -label " " -variable VPTOV(sortdesc) -value "desc" -command vptov:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete -state disabled
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command vp:delete
    $w1.1 add separator
    $w1.1 add command -label ""
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command vp:ok
    button $w.buttons.clear -text "" -command vp:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    frame $w.head -bd 1 -relief raised
    frame $w.tov -bd 1 -relief raised
    pack $w.head $w.tov -padx 5 -fill x
        
    foreach {i j} { insert "" print  sort  delete  exit } {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -state disabled -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; $w.buttons.exit invoke"}
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        $VP(inwin).vp.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        $VP(inwin).vp.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Button-1> { 
        if [regexp \.vp\.head|\.vp\.tov %W] {
            set VP(window) %W 
        }
    }
    bind $w <Button-3> { 
        event generate %W <Button-1>
        if [regexp \.vp\.head|\.vp\.tov %W] {
            switch -regexp %W {
                \.vp\.head { set win $VP(inwin).vp.head }
                \.vp\.tov  { set win $VP(inwin).vp.tov }
            }
            $VP(inwin).vp.menu.1 post [winfo pointerx %W] [winfo pointery %W]
        }
    }
    bind $w <Key-Escape> { $VP(inwin).vp.buttons.exit invoke }
    bind $w <Control-u>          { vp:controlu }
    bind $w <Control-U>          { vp:controlu }
    bind $w <Control-atilde>     { vp:controlu }
    bind $w <Control-Atilde>     { vp:controlu }
    
    vphead
    vptov
    if { $VP(st) == 0 } vp:alldisabled
    wm geometry $w [centerwindow $w]
    if { $VP(cod) > 0 } {
        vphead:read
        vptov:read
    }
    
}

proc vp:iconmenu:state {s l} {
    global VP
    
    set w $VP(inwin).vp
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        catch [$w.butimg.$statei configure -state $s]
    }
}

proc vp:trace:window { name1 name2 op } {
    global VP VPTOV
    
    set w $VP(inwin).vp
    foreach i { head tov } {
        $w.$i.tut configure -fg black -bg gray70 -relief sunken
    }
    vp:iconmenu:state disabled " insert  print  sort  delete  "
    switch -regexp $VP(window) {
        \.vp\.head {
            vp:iconmenu:state normal "print "
            $w.head.tut configure -fg blue -bg gray90 -relief raised
        }
        \.vp\.tov {
            if { $VP(cod) > 0 } { 
                vp:iconmenu:state normal " insert  sort  delete "
            }
            $w.tov.tut configure -fg blue -bg gray90 -relief raised
        }
    }
    
}

proc vp:insert {} {
    global VP VPTOV VPTOV_DATA
    
    switch -regexp $VP(window) {
        \.vp\.tov {
            $VP(inwin).vp.tov.tbl configure -rows [incr VPTOV(rows)]
        }
    }        
}

proc vp:print {} {
    global VPTOV VP
    
    switch -regexp $VP(window) {
        \.vp\.head {
            vphead:print
        }
    }        
}

proc vp:delete {} {
    global VP
    
    switch -regexp $VP(window) {
        \.vp\.tov {
            vptov:delete
        }
    }        
}

proc vp:clear {} {
    global VP
    
    switch -regexp $VP(window) {
        \.vp\.head {
            vphead:clear
        }
    }        
}

proc vp:alldisabled {} {
    global VP
    
    set w $VP(inwin).vp
    foreach i { buttons.ok buttons.clear } { $w.$i configure -state disabled }
}

proc vp:ok {} {
    global VP VPTOV VPTOV_DATA VS

    #  
    if { $VP(cod) == 0 } {
        vphead:insert
    } elseif { $VP(cod) > 0 } {
        if { $VP(num) != $VP(old_num) \
             || $VP(dat) != $VP(old_dat) \
             || $VP(skladrcod) != $VP(old_skladrcod) \
             || $VP(skladpcod) != $VP(old_skladpcod) \
             || $VP(prim1) != $VP(old_prim1) } {
            vphead:update
        }
    }
    #   
    if { $VP(tip) == "m" } {
        set nkol 2
    } else {
        set nkol 1
    }
    if { $VP(cod) > 0 } {
        set i 0
        while 1 {
            if [info exists VPTOV_DATA($i,tovarcod)] {
                if { ![info exists VPTOV_DATA($i,operrcod)] && 
                     ![info exists VPTOV_DATA($i,vpoperpcod)] } {
                    vptov:insert $i
                } else { 
                    if { $VPTOV_DATA($i,operrcod) <= 0 && 
                         $VPTOV_DATA($i,vpoperpcod) <= 0 } {
                        vptov:insert $i
                    }
                    if { $VPTOV_DATA($i,operrcod) > 0 && 
                         $VPTOV_DATA($i,vpoperpcod) > 0 } {
                        if { $VPTOV_DATA($i,old_$nkol) != $VPTOV_DATA($i,$nkol) } {
                            vptov:update $i
                        }
                    }
                }
            } else break
            incr i
        }
    }
    set VS($VP(inwin).vp_update) 0
}

proc vp:controlu {} {
    global VP VPTOV VPTOV_DATA
    
    switch -regexp [focus] {
        \.vp\.head {
            if [info exists VP(cod)] { 
                controlu $VP(cod) vp 
            }
        }
        \.vp\.tov {
            if [info exists VPTOV_DATA($VPTOV(ActiveRow),operpcod)] { 
                if { $VP(tip) == "f" } {
                    controlu $VPTOV_DATA($VPTOV(ActiveRow),operpcod) finoperp
                } else {
                    controlu $VPTOV_DATA($VPTOV(ActiveRow),operpcod) matoperp
                }
            }
        }
    }
}
