proc vphead:clear {} {
    global VP
    
    set VP(cod) 0
    set VP(num) ""
    set VP(dat) ""
    set VP(skladrcod) ""
    set VP(skladrnam) ""
    set VP(skladpcod) ""
    set VP(skladpnam) ""
    set VP(prim1) ""
    vphead:old
}

proc vphead:old {} {
    global VP
    
    set VP(old_num)         $VP(num)
    set VP(old_dat)         $VP(dat)
    set VP(old_skladrcod)   $VP(skladrcod)
    set VP(old_skladrnam)   $VP(skladrnam)
    set VP(old_skladpcod)   $VP(skladpcod)
    set VP(old_skladpnam)   $VP(skladpnam)
    set VP(old_prim1)       $VP(prim1)
}

proc vphead:update {} {
    global VS VP

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ... " green
        puts $socks "vp_upd $VP(cod) \
                            \"$VP(num)\" \
                            \"$VP(dat)\" \
                            \"$VP(skladrcod)\" \
                            \"$VP(skladpcod)\" \
                            \"$VP(prim1)\" "
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        } else {
            vphead:old
        }

        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc vphead:read {} {
    global VS VP
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "vpone_sel $VP(cod)"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      VP(num) \
                      VP(dat) \
                      VP(skladrcod) \
                      VP(skladrnam) \
                      VP(skladpcod) \
                      VP(skladpnam) \
                      VP(prim1)
        }
        set VP(num)         [format "%5d" $VP(num)]
        set VP(skladrnam)   [clipped $VP(skladrnam)]
        set VP(skladpnam)   [clipped $VP(skladpnam)]
        set VP(prim1)       [clipped $VP(prim1)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    vphead:old
    waiting "" ""
}

proc vphead:insert {} {
    global VS VP
    
    if { $VP(skladrcod) > 0 && \
         $VP(skladpcod) > 0 && \
         [string length [clipped $VP(dat)]] > 0 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "vp_ins \"$VP(tip)\" \
                                \"$VP(dat)\" \
                                \"$VP(skladrcod)\" \
                                \"$VP(skladpcod)\" \
                                \"$VP(prim1)\""
            flush $socks
    
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set VP(cod) ""; set VP(num) "";
                scan $str "%\[^\t]%*c%\[^\n]" VP(cod) VP(num)
            }
       
            if { [ gets $socks ] != "0" } {
                errormsg $socks "     !"
            }
            close $socks
            waiting "" ""
        } else {
            errormsg nosocks "  !"
        }
        vphead:old
    }
}

proc vphead:print {} {
    global VS VP VPTOV

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "vphead_rep \"$VP(tip)\" $VP(cod) \"$VPTOV(sortstr) $VPTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc vphead:heskladrnam { tip win } {
    global VP HE
    
    set w $VP(inwin).vp.head.skladr.skladrnam
    set HE(tit) "  "
    set namstr "*"
    if { $tip == "u" } { set namstr "$VP(skladrnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $namstr $tip $win
    set VP(skladrcod)       $HE(cod)
    set VP(skladrnam)       [clipped $HE(nam)]
    set VP(old_skladrnam)   $VP(skladrnam)   
    set VP(hebutton) 0
}

proc vphead:heskladpnam { tip win } {
    global VP HE
    
    set w $VP(inwin).vp.head.skladp.skladpnam
    set HE(tit) "  "
    set namstr "*"
    if { $tip == "u" } { set namstr "$VP(skladpnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $namstr $tip $win
    set VP(skladpcod)       $HE(cod)
    set VP(skladpnam)       [clipped $HE(nam)]
    set VP(old_skladpnam)   $VP(skladpnam)   
    set VP(hebutton) 0
}

