proc vplist { tip } {
    global VS VPLIST VPLIST_DATA

    catch [unset VPLIST VPLIST_DATA]
    set VPLIST(listbox,curselection) 0
    set VPLIST(tip) $tip
    set VPLIST(find) ""
    set lw 94
    switch $tip {
        "f" { 
            if { $VS(login) == "buh" } {
                set titstr ""
            } else {
                set titstr " "
            }
            set lw 83
        }
        "m" { set titstr " " }
    }
    set w .vplist
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +$wmx+55
    wm geometry $w =0x0
    wm title $w "$titstr    "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "vplist:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "vplist:insert"
    $w1.1 add command -label "" -command "vplist:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable VPLIST(sortstr) -value "num" -command vplist:read
        $w1.1.sort add radio -label " " -variable VPLIST(sortstr) -value "dat" -command vplist:read
        $w1.1.sort add radio -label "   " -variable VPLIST(sortstr) -value "srnam" -command vplist:read
        $w1.1.sort add radio -label "   " -variable VPLIST(sortstr) -value "spnam" -command vplist:read
        $w1.1.sort add radio -label " " -variable VPLIST(sortstr) -value "summa1" -command vplist:read
        if { $VPLIST(tip) != "f" } {
            $w1.1.sort add radio -label " " -variable VPLIST(sortstr) -value "summa2" -command vplist:read
        }
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable VPLIST(sortdesc) -value " " -command vplist:read
        $w1.1.sort add radio -label " " -variable VPLIST(sortdesc) -value "desc" -command vplist:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command "vplist:vp 0"
    $w1.1 add command -state disabled -accelerator "<Enter>" -label "" -command "vplist:vp 1"
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set VPLIST(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set VPLIST(deletestatus) 1; vplist:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable VPLIST(statusline) -relief sunken -anchor w -padx 3 -width 60
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view  update  delete  exit } {
        if { $i == "insert" } { findbox vplist 60 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text " $titstr     " -relief raised -anchor center -bd 1 -padx 3
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p3 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 27
    label $w.namefield.p4 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 27
    label $w.namefield.p5 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    if { $VPLIST(tip) != "f" } {
        label $w.namefield.p6 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    }
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    pack $w.namefield.p1 $w.namefield.p2 $w.namefield.p3 $w.namefield.p4 $w.namefield.p5 -side left
    if { $VPLIST(tip) != "f" } {
        pack $w.namefield.p6 -side left
    }
    frame $w.lb
    frame $w.itogo
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 21 -width $lw
    label $w.itogo.l1 -text "                                                  :"
    label $w.itogo.svp1 -textvar VPLIST(svp1) -bd 1 -relief sunken -anchor e -width 11
    if { $VPLIST(tip) != "f" } {
        label $w.itogo.l2 -text ""
        label $w.itogo.svp2 -textvar VPLIST(svp2) -bd 1 -relief sunken -anchor e -width 11
    }
    pack $w.itogo.l1 $w.itogo.svp1 -side left
    if { $VPLIST(tip) != "f" } {
        pack $w.itogo.l2 $w.itogo.svp2 -side left
    }
    
    pack $w.lb $w.itogo -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    vplist:read
    
    bind $w.butimg.delete <Button-1> {
        .vplist.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        .vplist.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .vplist.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        if [info exists VPLIST_DATA(num,$id)] {
            set VPLIST(statusline) "$VPLIST_DATA(num,$id) $VPLIST_DATA(dat,$id) $VPLIST_DATA(skladrnam,$id) $VPLIST_DATA(skladpnam,$id)"
        }
        set VPLIST(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .vplist.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  } {
            .vplist.menu.1 entryconfigure [.vplist.menu.1 index $j] -state disabled
            .vplist.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { print  view  update  delete  } {
            .vplist.menu.1 entryconfigure [.vplist.menu.1 index $j] -state normal
            .vplist.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists VPLIST_DATA(cod,$VPLIST(listbox,curselection))] {
            vplist:vp 1
        }
    }
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists VPLIST_DATA(cod,$VPLIST(listbox,curselection))] {
            vplist:vp 1
        }
    }
    bind $w <Key-F5>    { vplist:find }
    bind $w <Key-Insert>    { vplist:insert }
    bind $w <Key-Escape> { .vplist.buttons.exit invoke }
    focus $w.lb.listbox
}

proc vplist:cor {} {
    global VP VPLIST VPLIST_DATA VP VPTOV VPTOV_DATA 

    set w .vplist.lb.listbox
    if [winfo exists $w] {
        set id $VPLIST(listbox,curselection)
        $w delete $id $id
        if { $VP(tip) == "m" } {
            $w insert $id [format "%5d %-10s %-27.27s %-27.27s %10.2f %10.2f" \
                $VP(num) \
                $VP(dat) \
                $VP(skladrnam) \
                $VP(skladpnam) \
                $VPTOV(scena1) \
                $VPTOV(scena2)]
            
            set VPLIST(statusline) "$VP(num) $VP(dat) $VP(skladrnam) $VP(skladpnam)"
            set VPLIST_DATA(num,$id)       $VP(num)
            set VPLIST_DATA(dat,$id)       $VP(dat)
            set VPLIST_DATA(skladrnam,$id) $VP(skladrnam)
            set VPLIST_DATA(skladpnam,$id) $VP(skladpnam)
            set VPLIST_DATA(summa1,$id)    $VPTOV(scena1)
            set VPLIST_DATA(summa2,$id)    $VPTOV(scena2)
        } else {
            $w insert $id [format "%5d %-10s %-27.27s %-27.27s %10.2f" \
                $VP(num) \
                $VP(dat) \
                $VP(skladrnam) \
                $VP(skladpnam) \
                $VPTOV(scena1)]
            $w selection set $id $id
            set VPLIST(statusline) "$VP(num) $VP(dat) $VP(skladrnam) $VP(skladpnam)"
            set VPLIST_DATA(num,$id)       $VP(num)
            set VPLIST_DATA(dat,$id)       $VP(dat)
            set VPLIST_DATA(skladrnam,$id) $VP(skladrnam)
            set VPLIST_DATA(skladpnam,$id) $VP(skladpnam)
            set VPLIST_DATA(summa1,$id)    $VPTOV(scena1)
        }
        vplist:summa
    }
    $w selection set $id $id
    $w activate $id
}

proc vplist:vp { st } {
    global VPLIST VPLIST_DATA
    
    vp $st $VPLIST(tip) $VPLIST_DATA(cod,$VPLIST(listbox,curselection)) .vplist
    tkwait window .vplist.vp
    vplist:cor
}

proc vplist:entry:createvar {} {
    global VPLIST
    
    foreach i { num dat skladnam prim summa1 summa2 tovarnam \
                kol cena cenad } {
        if ![info exists VPLIST(entry,$i)] {
            set VPLIST(entry,$i) ""
        }
    }
}

proc vplist:entry:clearvar {} {
    global VPLIST
    
    foreach i { num dat skladrnam skladpnam prim summa1 summa2 tovarnam \
                sernum kol cena cenad } {
        set VPLIST(entry,$i) ""
    }
}

proc vplist:entry {} {
    global VS VPLIST
    
    set w .vplist.entry
    set VPLIST(entrystatus) ""
    vplist:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+155
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { num dat skladr skladp prim summa1 summa2 tovar sernum \
                    kol cena cenad } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "summa2" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { num     "              " \
                      dat     "               " \
                      skladr  "           " \
                      skladp  "             " \
                      prim    "         " \
                      summa1  "              " \
                      summa2  "              " \
                      tovar   " " \
                      sernum  "      " \
                      kol     "         " \
                      cena    "               " \
                      cenad   "               " \
                  } {
        if { $i == "summa2" || $i == "cenad" } {
            if { $VPLIST(tip) != "f" } {
                label $w.inf.$i.l -text $j
                pack $w.inf.$i.l -side left
            }
        } else {
            label $w.inf.$i.l -text $j
            pack $w.inf.$i.l -side left
        }
    }
    foreach { i j k } {num      num         20 \
                       dat      dat         20 \
                       skladr   skladrnam   50 \
                       skladp   skladpnam   50 \
                       prim     prim        50 \
                       summa1   summa1      20 \
                       summa2   summa2      20 \
                       tovar    tovarnam    50 \
                       sernum   sernum      20 \
                       kol      kol         15 \
                       cena     cena        20 \
                       cenad    cenad       20 \
                       } {
        if { $i == "summa2" || $i == "cenad" } {
            if { $VPLIST(tip) != "f" } {
                entry $w.inf.$i.e -textvariable VPLIST(entry,$j) -width $k
            }
        } else {
            entry $w.inf.$i.e -textvariable VPLIST(entry,$j) -width $k
        }
    }
    button $w.inf.skladr.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { vplist:heskladr r .vplist.entry }
    button $w.inf.skladp.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { vplist:heskladp r .vplist.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { vplist:hetovar r .vplist.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set VPLIST(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "vplist:entry:clearvar"
    button $w.buttons.exit -text "" -command "set VPLIST(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e skladr.e skladr.b \
                skladp.e skladp.b prim.e summa1.e summa2.e \
                tovar.e tovar.b sernum.e kol.e cena.e cenad.e \
              } {
        if { $i == "summa2.e" || $i == "cenad.e" } {
            if { $VPLIST(tip) != "f" } {
                pack $w.inf.$i -side left
            }
        } else {
            pack $w.inf.$i -side left
        }
    }
    focus $w.inf.num.e
    bind $w <Key-Escape>     { .vplist.entry.buttons.exit invoke }
    bind $w <Control-Return> { .vplist.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
