proc vptov:varold { i } {
    global VPTOV_DATA
    set VPTOV_DATA($i,old_0)        $VPTOV_DATA($i,0)
    set VPTOV_DATA($i,old_tovarcod) $VPTOV_DATA($i,tovarcod)    
    set VPTOV_DATA($i,old_operpcod) $VPTOV_DATA($i,operpcod)    
}

proc vptov:clear {} {
    global VPTOV_DATA VPTOV VP
    
    catch [unset VPTOV_DATA]
    if { $VP(tip) == "m" } {
        set VPTOV_DATA(-1,0) " "
        set VPTOV_DATA(-1,1) ". "
        set VPTOV_DATA(-1,2) "."
        set VPTOV_DATA(-1,3) ". ."
        set VPTOV_DATA(-1,4) ""
        set VPTOV_DATA(-1,5) ""
    } else {
        set VPTOV_DATA(-1,0) " "
        set VPTOV_DATA(-1,1) "."
        set VPTOV_DATA(-1,2) ". ."
        set VPTOV_DATA(-1,3) ""
    }
}

proc vptov:read {} {
    global VS VPTOV_DATA VPTOV VP
    
    vptov:clear
    set w $VP(inwin).vp.tov.tbl
    waiting "  ..." blue
    if { $VPTOV(sortstr) == "" }    { set VPTOV(sortstr) "tnam" } 
    if { $VPTOV(sortdesc) == "" }   { set VPTOV(sortdesc) " "  }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "vptov_sel $VP(tip) $VP(cod) \"$VPTOV(sortstr) $VPTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set VPTOV_DATA($i,operrcod) "";  set VPTOV_DATA($i,vpoperpcod) ""
            set VPTOV_DATA($i,operpcod) "";  set VPTOV_DATA($i,tovarcod) ""
            set VPTOV_DATA($i,0) "";         set VPTOV_DATA($i,1) ""
            set VPTOV_DATA($i,2) "";         set VPTOV_DATA($i,3) ""
            set VPTOV_DATA($i,4) "";         set VPTOV_DATA($i,5) ""
            if { $VP(tip) == "m" } {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    VPTOV_DATA($i,operrcod)      VPTOV_DATA($i,vpoperpcod) \
                    VPTOV_DATA($i,operpcod)      VPTOV_DATA($i,tovarcod) \
                    VPTOV_DATA($i,0)             VPTOV_DATA($i,1) \
                    VPTOV_DATA($i,2)             VPTOV_DATA($i,3) \
                    VPTOV_DATA($i,4)             VPTOV_DATA($i,5)
                
                set VPTOV_DATA($i,1)            [clipped $VPTOV_DATA($i,1)]
                set VPTOV_DATA($i,4)            [format "%9.2f" $VPTOV_DATA($i,4)]
                set VPTOV_DATA($i,5)            [format "%9.2f" $VPTOV_DATA($i,5)]
                set VPTOV_DATA($i,old_2)        $VPTOV_DATA($i,2)
            } else {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    VPTOV_DATA($i,operrcod)      VPTOV_DATA($i,vpoperpcod) \
                    VPTOV_DATA($i,operpcod)      VPTOV_DATA($i,tovarcod) \
                    VPTOV_DATA($i,0)             VPTOV_DATA($i,1) \
                    VPTOV_DATA($i,2)             VPTOV_DATA($i,3)
            
                set VPTOV_DATA($i,3)            [format "%9.2f" $VPTOV_DATA($i,3)]
                set VPTOV_DATA($i,old_1)        $VPTOV_DATA($i,1)
            }
            set VPTOV_DATA($i,0)            [clipped $VPTOV_DATA($i,0)]
            vptov:varold $i
        }
        if [info exists VPTOV(ActiveRow)] { 
            if { $i < $VPTOV(ActiveRow) && $i >= 0 } { set VPTOV(ActiveRow) $i }
            $w see $VPTOV(ActiveRow),0
            $w activate $VPTOV(ActiveRow),$VPTOV(ActiveCol)
        }
        
        set VPTOV(rows) [expr $i + 2]
        if { $VPTOV(rows) < 8 } { set VPTOV(rows) 8 }
        $w configure -rows $VPTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    vptov:summa
    waiting "" ""
}

proc vptov:delete {} {
    global VS VPTOV VPTOV_DATA VP
    
    set w $VP(inwin).vp.tov.tbl
    if [info exists VPTOV(ActiveRow)] {
        if { [info exists VPTOV_DATA($VPTOV(ActiveRow),operrcod)] &&
             [info exists VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod)] } {
            set VPTOV_DATA(active) ""
            $w tag row UnSelectRow $VPTOV(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $VPTOV(ActiveRow)
                waiting "  ..." red
                puts $socks "vptov_del \"$VP(tip)\" \
                                         $VPTOV_DATA($VPTOV(ActiveRow),operrcod) \
                                         $VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $VPTOV(ActiveRow)
                waiting "" ""
                vptov:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc vptov:insert { row } {
    global VS VPTOV_DATA VPTOV VP
    
    if { $VP(tip) == "m" } {
        set nkol 2
    } else {
        set nkol 1
    }
    set w $VP(inwin).vp.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        if { $VP(tip) == "m" } { 
            set nkol 2
        } else {
            set nkol 1
        }
        puts $socks "vptov_ins \"$VP(tip)\" \
                                 $VP(cod) \
                                 $VPTOV_DATA($row,operpcod) \
                                 $VP(skladpcod) \
                                 $VP(dat) \
                                 $VPTOV_DATA($row,$nkol) "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\n]" VPTOV_DATA($row,operrcod) \
                                          VPTOV_DATA($row,vpoperpcod)
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set VPTOV_DATA($row,0)            [clipped $VPTOV_DATA($row,0)]
            set VPTOV_DATA($row,old_$nkol)    $VPTOV_DATA($row,$nkol)
            vptov:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc vptov:update { row } {
    global VS VPTOV_DATA VPTOV VP
    
    set w $VP(inwin).vp.tov.tbl
    if { $VP(tip) == "m" } {
        set nkol 2
    } else {
        set nkol 1
    }
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "vptov_upd \"$VP(tip)\" \
                                 $VPTOV_DATA($row,operrcod) \
                                 $VPTOV_DATA($row,vpoperpcod) \
                                 $VPTOV_DATA($row,$nkol)"
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set VPTOV_DATA($row,0)            [clipped $VPTOV_DATA($row,0)]
            set VPTOV_DATA($row,old_$nkol)    $VPTOV_DATA($row,$nkol)
            vptov:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc vptov:hetovarnam { tip win } {
    global VS VPTOV_DATA HE VPTOV VP
    
    if { $VPTOV_DATA($VPTOV(ActiveRow),0) != "" } {
        set sep \003
        set w $VP(inwin).vp.tov.curfldval
        set HE(tit) "                                    .              . ..                 "
        set xcor 30
        set wcor 93
        if { $VP(tip) == "f" } { 
            set xcor 33
            set wcor 84 
            set HE(tit) "                                      . ..           "
        }
        he [expr [winfo rootx $w] - $xcor ] [expr [winfo rooty $w] + [winfo height $w]] 8 $wcor tovarostatok "$VP(tip)$sep$VP(skladrcod)$sep$VP(dat)$sep$VPTOV_DATA($VPTOV(ActiveRow),0)" $tip $win
        scan $HE(cod) "%\[^\003]%*c%\[^\003]%*c%s" \
            VPTOV_DATA($VPTOV(ActiveRow),operpcod) \
            VPTOV_DATA($VPTOV(ActiveRow),tovarcod) \
            VPTOV_DATA($VPTOV(ActiveRow),eicod)
        if { $VP(tip) == "m" } {
            scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
                VPTOV_DATA($VPTOV(ActiveRow),datpokupki) \
                VPTOV_DATA($VPTOV(ActiveRow),0) \
                VPTOV_DATA($VPTOV(ActiveRow),1) \
                VPTOV_DATA($VPTOV(ActiveRow),2) \
                VPTOV_DATA($VPTOV(ActiveRow),3) \
                VPTOV_DATA($VPTOV(ActiveRow),4) \
                VPTOV_DATA($VPTOV(ActiveRow),5) \
                VPTOV_DATA($VPTOV(ActiveRow),isnds) \
                VPTOV_DATA($VPTOV(ActiveRow),issernum)
            catch [set VPTOV_DATA($VPTOV(ActiveRow),kol) $VPTOV_DATA($VPTOV(ActiveRow),2)]
            catch [set VPTOV_DATA($VPTOV(ActiveRow),1) [clipped $VPTOV_DATA($VPTOV(ActiveRow),1)]]
            catch [set VPTOV_DATA($VPTOV(ActiveRow),4) [format "%9.2f" $VPTOV_DATA($VPTOV(ActiveRow),4)]]
            catch [set VPTOV_DATA($VPTOV(ActiveRow),5) [format "%9.2f" $VPTOV_DATA($VPTOV(ActiveRow),5)]]
        }
        if { $VP(tip) == "f" } {
            scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
                VPTOV_DATA($VPTOV(ActiveRow),datpokupki) \
                VPTOV_DATA($VPTOV(ActiveRow),0) \
                VPTOV_DATA($VPTOV(ActiveRow),1) \
                VPTOV_DATA($VPTOV(ActiveRow),2) \
                VPTOV_DATA($VPTOV(ActiveRow),3) \
                VPTOV_DATA($VPTOV(ActiveRow),isnds)
            catch [set VPTOV_DATA($VPTOV(ActiveRow),kol) $VPTOV_DATA($VPTOV(ActiveRow),1)]
            catch [set VPTOV_DATA($VPTOV(ActiveRow),2) [clipped $VPTOV_DATA($VPTOV(ActiveRow),2)]]
            catch [set VPTOV_DATA($VPTOV(ActiveRow),3) [format "%9.2f" $VPTOV_DATA($VPTOV(ActiveRow),3)]]
        }
        set VPTOV_DATA($VPTOV(ActiveRow),0) [clipped $VPTOV_DATA($VPTOV(ActiveRow),0)]
    }
}

proc whattovarkol { tip operrcod } {
    global VS
    
    set kol 0
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "     ..." magenta
        puts $socks "whattovarkol $tip $operrcod"
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set kol $str
        }
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        } 
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
    return $kol
}
