proc whomathtov { inwin tovarcod tovarnam } {
    global VS WHOMATHTOV WHOMATHTOV_DATA

    catch [unset WHOMATHTOV_DATA]
    
    set WHOMATHTOV(inwin) $inwin
    set WHOMATHTOV(tovarnam) $tovarnam
    set w $WHOMATHTOV(inwin).whomathtov
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    wm title $w "   "
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy $w"
    pack $w.buttons -side bottom 
    pack $w.buttons.exit -side left -padx 5 
    
    frame $w.tit
    label $w.tit.l1 -font $VS(fontn) -text "     " -relief raised -anchor center -bd 1
    pack $w.tit $w.tit.l1
    frame $w.tov
    label $w.tov.l1 -textvar WHOMATHTOV(tovarnam) -bd 1 -relief sunken -bg gray40 -fg green -width 50 -anchor w
    pack $w.tov $w.tov.l1 -pady 3
    
    frame $w.namefield
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 30
    label $w.namefield.p2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p21 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 9
    label $w.namefield.p3 -text ".." -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p4 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p5 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 13
    pack $w.namefield -side top
    pack $w.namefield.p1 $w.namefield.p2 $w.namefield.p21 $w.namefield.p3 $w.namefield.p4 $w.namefield.p5 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 15 -width 83
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    focus $w.buttons.exit
    bind $w <Key-Escape> { $WHOMATHTOV(inwin).whomathtov.buttons.exit invoke }
    whomathtov:read $tovarcod
}

