proc whorezdoc { skladcod tovarcod tovarnam inwin } {
    global VS WHOREZDOC
    
    set w $inwin.whorezdoc
    set WHOREZDOC(inwin) $w
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    set titstr "  "
    wm title $w $titstr
    
    frame $w.tit
    label $w.tit.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    label $w.tit.tn -text " $tovarnam " -relief sunken -bd 1 -bg grey77 -fg green4
    frame $w.namefield
    pack $w.tit $w.tit.l $w.namefield
    pack $w.tit.tn -padx 3
    foreach { i j k } { 1 "N ." 10 \
                        2 " ." 11 \
                        3 "" 24 \
                        4 "." 9 \
                        5 " ." 11 \
                        6 "?" 3 \
                        7 " " 26 } {
        label $w.namefield.l$i -text $j -relief raised -anchor center -bd 1 -padx 1 -width $k
        pack $w.namefield.l$i -side left
    }
    
    frame $w.lb
    frame $w.itogo
    scrollbar $w.lb.sby -takefocus 0 -command "$w.lb.listbox yview"
    scrollbar $w.lb.sbx -takefocus 0 -command "$w.lb.listbox xview" -orient horizontal
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.sby set" -xscroll "$w.lb.sbx set" -height 12 -width 94
    label $w.itogo.l1 -text "                       :"
    label $w.itogo.skol -textvar WHOREZDOC(skol) -bd 1 -relief sunken -anchor e -width 11 -bg grey60 -fg cyan
    
    pack $w.lb $w.itogo -fill x
    pack $w.itogo.l1 $w.itogo.skol -side left
    pack $w.lb.sbx -side bottom -fill x
    pack $w.lb.sby -side right -fill y
    pack $w.lb.listbox -side left 
        
    wm geometry $w [centerwindow $w]
    whorezdoc:read $skladcod $tovarcod $inwin
    
    bind $w <Key-Escape> { destroy [winfo toplevel %W] }
    bind $w.lb.listbox <Double-Button-1> { whorezdoc:doc [%W index active] }
    bind $w.lb.listbox <Key-Return>      { whorezdoc:doc [%W index active] }
    focus $w.lb.listbox
}

proc whorezdoc:doc { row } {
    global WHOREZDOC_DATA NAKLPLIST WHOREZDOC
    
    if [info exists WHOREZDOC_DATA(doctip,$row)] {
        switch -exact $WHOREZDOC_DATA(doctip,$row) {
            s   {
                schetfnr 1 $WHOREZDOC_DATA(doccod,$row)
            }
            i   {
                set NAKLPLIST(pr) r
                naklp 1 m $WHOREZDOC_DATA(doccod,$row) $WHOREZDOC(inwin)
            }
        }
    }
}

