proc whorezdoc:read { skladcod tovarcod inwin } {
    global VS WHOREZDOC WHOREZDOC_DATA
    
    set w $inwin.whorezdoc.lb.listbox
    waiting "  ..." blue
    catch [unset WHOREZDOC_DATA]
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "whorezdoc_sel $skladcod $tovarcod"
        flush $socks
        set i 0
        set WHOREZDOC(skol) 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { doccod doctip docnum docdat klientnam kol mindatopl flgopl primrez } {
                set WHOREZDOC_DATA($j,$i) {}
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    WHOREZDOC_DATA(doccod,$i) \
                    WHOREZDOC_DATA(doctip,$i) \
                    WHOREZDOC_DATA(docnum,$i) \
                    WHOREZDOC_DATA(docdat,$i) \
                    WHOREZDOC_DATA(klientnam,$i) \
                    WHOREZDOC_DATA(kol,$i) \
                    WHOREZDOC_DATA(mindatopl,$i) \
                    WHOREZDOC_DATA(flgopl,$i) \
                    WHOREZDOC_DATA(primrez,$i)
            $w insert end [format "%10.10s %10.10s %25.25s %7.2f %10.10s  %1s  %s" \
                                      $WHOREZDOC_DATA(docnum,$i) \
                                      $WHOREZDOC_DATA(docdat,$i) \
                                      $WHOREZDOC_DATA(klientnam,$i) \
                                      $WHOREZDOC_DATA(kol,$i) \
                                      $WHOREZDOC_DATA(mindatopl,$i) \
                                      $WHOREZDOC_DATA(flgopl,$i) \
                                      $WHOREZDOC_DATA(primrez,$i) ]
            set WHOREZDOC(skol) [expr $WHOREZDOC(skol) + $WHOREZDOC_DATA(kol,$i)]
            incr i
        }
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}
