proc zaimlisttov:clear {} {
    global ZAIMLISTTOV_DATA ZAIMLIST_DATA
    
    catch [unset ZAIMLISTTOV_DATA]
    set ZAIMLISTTOV_DATA(-2,0) ""
    set ZAIMLISTTOV_DATA(-2,1) ""
    set ZAIMLISTTOV_DATA(-2,2) "."
    set ZAIMLISTTOV_DATA(-2,3) "-"
    set ZAIMLISTTOV_DATA(-2,4) "."
    set ZAIMLISTTOV_DATA(-2,5) "-"
    set ZAIMLISTTOV_DATA(-2,6) ""
    set ZAIMLISTTOV_DATA(-2,7) ""
    set ZAIMLISTTOV_DATA(-2,8) ""
    
    set ZAIMLISTTOV_DATA(-1,0) ""
    set ZAIMLISTTOV_DATA(-1,1) ""
    set ZAIMLISTTOV_DATA(-1,2) ""
    set ZAIMLISTTOV_DATA(-1,3) ""
    set ZAIMLISTTOV_DATA(-1,4) "."
    set ZAIMLISTTOV_DATA(-1,5) ""
    set ZAIMLISTTOV_DATA(-1,6) ""
    set ZAIMLISTTOV_DATA(-1,7) "."
    set ZAIMLISTTOV_DATA(-1,8) "."
}

proc zaimlist:read { } {
    global VS ZAIMLIST ZAIMLISTTOV ZAIMLISTTOV_DATA
    
    set w .zaimlist.tov
    waiting "  ..." blue
    zaimlisttov:clear
    if { $ZAIMLIST(sortstr) == "" }    { set ZAIMLIST(sortstr) "3, 10" } 
    if { $ZAIMLIST(sortdesc) == "" }   { set ZAIMLIST(sortdesc) " "  }
    if { $ZAIMLIST(find) == "" } {
        set ZAIMLIST(find) "1=1"
        if [info exists ZAIMLIST(find,listbox)] {
            if { [lsearch -exact $ZAIMLIST(find,listbox) $ZAIMLIST(find)] == -1} {
                lappend ZAIMLIST(find,listbox) $ZAIMLIST(find)
            }
        } else {
            lappend ZAIMLIST(find,listbox) $ZAIMLIST(find)
        }
    } 
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "zaimlist_sel $ZAIMLIST(tip) \"$ZAIMLIST(find)\" \"$ZAIMLIST(sortstr) $ZAIMLIST(sortdesc)\""
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { cod 0 1 2 3 4 5 6 7 8 } {
                set ZAIMLISTTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                ZAIMLISTTOV_DATA($i,cod) \
                ZAIMLISTTOV_DATA($i,0) \
                ZAIMLISTTOV_DATA($i,1) \
                ZAIMLISTTOV_DATA($i,2) \
                ZAIMLISTTOV_DATA($i,3) \
                ZAIMLISTTOV_DATA($i,4) \
                ZAIMLISTTOV_DATA($i,5) \
                ZAIMLISTTOV_DATA($i,6) \
                ZAIMLISTTOV_DATA($i,7) \
                ZAIMLISTTOV_DATA($i,8)
            
            set ZAIMLISTTOV_DATA($i,1)     [clipped $ZAIMLISTTOV_DATA($i,1)]
            set ZAIMLISTTOV_DATA($i,2)     [clipped $ZAIMLISTTOV_DATA($i,2)]
            set ZAIMLISTTOV_DATA($i,3)     [format "%7.2f" $ZAIMLISTTOV_DATA($i,3)]
            set ZAIMLISTTOV_DATA($i,4)     [clipped $ZAIMLISTTOV_DATA($i,4)]
            set ZAIMLISTTOV_DATA($i,6)     [clipped $ZAIMLISTTOV_DATA($i,6)]
            incr i
        }
        
        set ZAIMLISTTOV(rows) [expr $i + 2]
        if { $ZAIMLISTTOV(rows) < 20 } { set ZAIMLISTTOV(rows) 20 }
        $w.tbl configure -rows $ZAIMLISTTOV(rows)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    if ![info exists ZAIMLISTTOV(ActiveRowCol)] {
        $w.tbl activate 0,1
        zaimlisttov:browsecommand 0
    } else {
        $w.tbl activate $ZAIMLISTTOV(ActiveRow),1
        zaimlisttov:browsecommand $ZAIMLISTTOV(ActiveRow)
    }
    
    update
}

proc zaimlist:find {} {
    global VS ZAIMLIST ZAIMLISTTOV ZAIMLIST_DATA
    
    zaimlist:entry
    if { $ZAIMLIST(entrystatus) == 1 } {
        set ZAIMLIST(find) "1=1"
        foreach {i j} " \"$ZAIMLIST(entry,tovarnam)\"     c.nam \
                        \"$ZAIMLIST(entry,sernum)\"       sernum \
                        \"$ZAIMLIST(entry,kol)\"          b.kol \
                        \"$ZAIMLIST(entry,klientnam)\"    g.nam \
                        \"$ZAIMLIST(entry,numdoc)\"       a.num \
                        \"$ZAIMLIST(entry,datzaima)\"     a.dat \
                       " {
            if { $i != "" } {
                set ZAIMLIST(find) "$ZAIMLIST(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $ZAIMLIST(find,listbox) $ZAIMLIST(find)] == -1} {
            lappend ZAIMLIST(find,listbox) $ZAIMLIST(find)
        }
        zaimlist:read
    }
    set ZAIMLIST(entrystatus) 0
}

proc zaimlist:hesklad { tip win } {
    global VS ZAIMLIST HE
    
    set w .zaimlist.entry.inf.sklad.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $ZAIMLIST(entry,skladnam) $tip $win
    set ZAIMLIST(entry,skladcod) $HE(cod)
    set ZAIMLIST(entry,skladnam) [clipped $HE(nam)]
}

proc zaimlist:heoperacia { tip win } {
    global VS ZAIMLIST HE
    
    set w .zaimlist.entry.inf.operacia.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 operaciar $ZAIMLIST(entry,operacianam) $tip $win
    set ZAIMLIST(entry,operaciacod) $HE(cod)
    set ZAIMLIST(entry,operacianam) [clipped $HE(nam)]
}

proc zaimlist:heklient { tip win } {
    global VS ZAIMLIST HE
    
    set w .zaimlist.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 postpol $ZAIMLIST(entry,klientnam) $tip $win
    set ZAIMLIST(entry,klientcod) $HE(cod)
    set ZAIMLIST(entry,klientnam) [clipped $HE(nam)]
}

proc zaimlist:hetovar { tip win } {
    global VS ZAIMLIST HE
    
    set w .zaimlist.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 tovaronly $ZAIMLIST(entry,tovarnam) $tip $win
    set ZAIMLIST(entry,tovarcod) $HE(cod)
    set ZAIMLIST(entry,tovarnam) [clipped $HE(nam)]
}

proc zaimlist:print {} {
    global VS ZAIMLIST

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "zaimlist_rep $ZAIMLIST(tip) \"$ZAIMLIST(find)\" \"$ZAIMLIST(sortstr) $ZAIMLIST(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
