proc zaimlisthead { } {
    global VS ZAIMLIST ZAIMLIST_DATA ZAIMLISTTOV ZAIMLISTTOV_DATA

    set w .zaimlist
    # head ##################################################################
    
    if { $ZAIMLIST(tip) == "z" } { set strltit "    " }
    if { $ZAIMLIST(tip) == "g" } { set strltit "    " }
    label $w.tit -font $VS(fontn) -text $strltit -relief raised -anchor center -bd 1
    pack $w.tit
    
    # tov ####################################################################

    set ZAIMLISTTOV(rows) 20
    frame $w.tov
    set w "$w.tov"
    pack $w
    entry $w.curfldval -textvar ZAIMLISTTOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 9 -height 20 -cols 9 -rows $ZAIMLISTTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable ZAIMLISTTOV_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { zaimlisttov:browsecommand %S } \
        -wrap on \
        -drawmode fast
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    $w.tbl tag row AnchorCenter -1 -2
    $w.tbl tag col AnchorCenter 0 5
    $w.tbl width 0 3  1 30  2 10  3 8  4 6  5 5  6 18  7 7  8 7

    pack $w.curfldval -anchor w
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
            
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind .zaimlist.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        .zaimlist.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind .zaimlist.tov.tbl <KeyRelease-Return> {
        regsub -all "\n|\r" [%W curvalue] "" str
        catch [%W set active $str]
    }
    focus $w.tbl
}

proc zaimlisttov:browsecommand { rowcol } {
    global ZAIMLISTTOV ZAIMLISTTOV_DATA ZAIMLIST ZAIMLIST_DATA
    
    set w .zaimlist
    if { [info exists ZAIMLISTTOV(ActiveRow)] && \
         $ZAIMLISTTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row UnSelectRow $ZAIMLISTTOV(ActiveRow)
    }
    set ZAIMLISTTOV(ActiveRowCol) $rowcol 
    scan $ZAIMLISTTOV(ActiveRowCol) "%\[^,]%*c%s" ZAIMLISTTOV(ActiveRow) ZAIMLISTTOV(ActiveCol)
    
    if { $ZAIMLISTTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row SelectRow $ZAIMLISTTOV(ActiveRow)
    }
}

