globals "globals.4gl"

function docopl_ins(tip, cod, f0, f1, f2)
define
    tip     char(1),
    cod     integer,
    f0, f1, f2  char(12)

    whenever error call err
    
    case tip
        when 's' call schetopl_ins(cod, f1, f2)
        when 'n' call naklropl_ins(cod, f0, f1, f2)
    end case
end function

function docopl_sel(tip, cod)
define  
    tip     char(1),
    cod     integer
    
    case tip
        when 's' call schetopl_sel(cod)
        when 'n' call naklropl_sel(cod)
    end case
end function

function docopl_del(tip, cod)
define  
    tip     char(1),
    cod     integer
    
    case tip
        when 's' call schetopl_del(cod)
        when 'n' call naklropl_del(cod)
    end case
end function


function docopl_upd(tip, cod, f0, f1, f2)
define
    tip     char(1),
    cod     integer,
    f0, f1, f2  char(12)
    
    case tip
        when 's' call schetopl_upd(cod, f1, f2)
        when 'n' call naklropl_upd(cod, f0, f1, f2)
    end case
end function

function docopl_rep(tip, cod, pipe_str)
define  
    tip         char(1),
    cod         integer,
    pipe_str    char(256)
    
    case tip
        when 's' call schetopl_rep(cod, pipe_str)
        when 'n' call naklropl_rep(cod, pipe_str)
    end case
end function

