globals "globals.4gl"

function he(tbl, hematch)
define
    str     	    char(256),
    tbl             char(18),
    hematch         char(100),
    hecod	        integer,
    henam           char(100),
    flg, flgsep, i, j  smallint,
    sep             char(1),
    namsep1, namsep2, namsep3, namsep4   char(100)

    whenever error call err
    
    let sep = ascii 3
    let flgsep = 0
    initialize namsep1, namsep2, namsep3 to null
    
    for i = 1 to 100
        if hematch[i] = sep then 
            let flgsep = 1 
            exit for
        end if
    end for
    if flgsep = 1 then
        let i = 1
        let j = 1
        while i < 100
            if hematch[i] = sep then
                let j = 1
                let i = i + 1
                exit while
            end if
            let namsep1[j] = hematch[i]
            let i = i + 1
            let j = j + 1
        end while
        while i < 100
            if hematch[i] = sep then
                let j = 1
                let i = i + 1
                exit while
            end if
            let namsep2[j] = hematch[i]
            let i = i + 1
            let j = j + 1
        end while
        while i < 100
            if hematch[i] = sep then
                let j = 1
                let i = i + 1
                exit while
            end if
            let namsep3[j] = hematch[i]
            let i = i + 1
            let j = j + 1
        end while
        while i < 100
            if hematch[i] = sep then
                let j = 1
                let i = i + 1
                exit while
            end if
            let namsep4[j] = hematch[i]
            let i = i + 1
            let j = j + 1
        end while
    end if
    
    initialize hecod, henam to null
    case
        when tbl = "gorod"              call gorod_he(hematch)
        when tbl = "lgota"              call lgota_he(hematch)
        when tbl = "klientlg"           call klientlg_he(hematch)
        when tbl = "tovar"              call tovar_he(hematch)
        when tbl = "tovarp"             call tovarp_he(hematch)
        when tbl = "tovarbytip"         call tovarbytip_he(hematch)
        when tbl = "tovarostatok"       call tovarostatok_he(namsep1, namsep2, namsep3, namsep4)
        when tbl = "tovarostatokskl"    call tovarostatokskl_he(namsep1, namsep2, namsep3)
        when tbl = "tovarostatoksklg"   call tovarostatoksklg_he(namsep1, namsep2, namsep3)
        when tbl = "sernumostatok"      call sernumostatok_he(namsep1, namsep2)
        when tbl = "sernumostatoksk"    call sernumostatoksk_he(hematch)
        when tbl = "sernumostatokskg"   call sernumostatokskg_he(hematch)
        when tbl = "tovargtip"          call tovargtip_he(namsep1, namsep2)
        otherwise
            let str = "execute procedure ",tbl clipped,"_he(?)"
            prepare p_he from str
            declare cur_he cursor for p_he
        
            let transaction = 1
            begin work
            open cur_he using hematch
                while (TRUE)
                    fetch cur_he into hecod, henam, flg
                    if status = notfound then exit while end if
                    display hecod, "\t", henam clipped, "\t", flg
                end while
            close cur_he
            commit work
    end case
end function

