globals "globals.4gl"
    
function myorg_sel()
define  
    p   record
        nam         like myorg.nam,
        gorodnam    like myorg.gorod_nam,
        phonecod    like myorg.phone_cod,
        index       like myorg.index,
        ulica       like myorg.ulica,
        bossfio     like myorg.boss_fio,
        bossphone   like myorg.boss_phone,
        glbuhfio    like myorg.glbuh_fio,
        glbuhphone  like myorg.glbuh_phone,
        banknam     like myorg.bank_nam,
        bankmfo     like myorg.bank_mfo,
        bankschet1  like myorg.bank_schet1,
        bankschet2  like myorg.bank_schet2,
        zkpo        like myorg.zkpo,
        inn         like myorg.inn,
        ns          like myorg.ns,
        phoneo      like myorg.phone_o,
        fax         like myorg.fax,
        email       like myorg.email,
        www         like myorg.www
    end record
    
    whenever error call err

    initialize p to null
    
    let transaction = 1    
    begin work
    select *
        into p.*
        from myorg
    commit work
    
    display p.nam, "\t",
        p.gorodnam, "\t",
        p.phonecod, "\t",
        p.index, "\t",
        p.ulica, "\t",
        p.bossfio, "\t",
        p.bossphone, "\t",
        p.glbuhfio, "\t",
        p.glbuhphone, "\t",
        p.banknam, "\t",
        p.bankmfo, "\t",
        p.bankschet1, "\t",
        p.bankschet2, "\t",
        p.zkpo, "\t",
        p.inn, "\t",
        p.ns, "\t",
        p.phoneo, "\t",
        p.fax, "\t",
        p.email, "\t",
        p.www
end function

function myorg_ins(nam, gorodnam, phonecod, index, ulica, 
                   bossfio, bossphone, glbuhfio, glbuhphone, banknam, 
                   bankmfo, bankschet1, bankschet2, zkpo, inn, 
                   ns, phoneo, fax, email, www)
define
    str     	    char(128),
    nam         like myorg.nam,
    gorodnam    like myorg.gorod_nam,
    phonecod    like myorg.phone_cod,
    index       like myorg.index,
    ulica       like myorg.ulica,
    bossfio     like myorg.boss_fio,
    bossphone   like myorg.boss_phone,
    glbuhfio    like myorg.glbuh_fio,
    glbuhphone  like myorg.glbuh_phone,
    banknam     like myorg.bank_nam,
    bankmfo     like myorg.bank_mfo,
    bankschet1  like myorg.bank_schet1,
    bankschet2  like myorg.bank_schet2,
    zkpo        like myorg.zkpo,
    inn         like myorg.inn,
    ns          like myorg.ns,
    phoneo      like myorg.phone_o,
    fax         like myorg.fax,
    email       like myorg.email,
    www         like myorg.www
    
    let str = "execute procedure myorg_ins(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    
    let transaction = 1
    begin work
    execute p_ins using nam, gorodnam, phonecod, index, ulica, 
                   bossfio, bossphone, glbuhfio, glbuhphone, banknam, 
                   bankmfo, bankschet1, bankschet2, zkpo, inn, 
                   ns, phoneo, fax, email, www
    commit work
end function

