globals "globals.4gl"

function sernum_sel(tip, where_str, sort_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        opercod     integer,
        tipdoc      char(40),
        num         like naklp.num,
        dat         like naklp.dat,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        klientnam   like klient.nam,
        prim1       like naklp.prim1,
        datotg      date,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        dat_gar     date,
        einam       like ei.nam,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad
    end record,
    str         char(5096),
    tip         char(1)

    whenever error call err
    
    call myorg()
    call stt()
    
    if tip = 'p' then
        let str = "select b.cod, '   ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, date(null), f.nam, ",
                         "b.sernum, b.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from naklp a, matoperp b, sklad c, operacia d, klient e, ",
                         "tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'M' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, '   ', itoc(a.num), ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, date(null), f.nam, ",
                         "b.sernum, b.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from vp a, matoperp b, sklad c, operacia d, ",
                         "myorg e, tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "a.skladp_cod = c.cod and ",
                          "d.cod = ", p_stt.vpp, " and ",
                          "b.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, ' ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, date(null), f.nam, ",
                         "b.sernum, b.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from naklp a, matoperp b, sklad c, operacia d, klient e, ",
                         "tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'Z' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, ' ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, date(null), f.nam, ",
                         "b.sernum, b.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from naklp a, matoperp b, sklad c, operacia d, klient e, ",
                         "tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'G' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                    "order by ", sort_str clipped
    end if
    if tip = 'r' then
        let str = "select b.cod, '  ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from _finnaklr a, schfnrtov a1, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, klient e, tovar f, ei g ",
                    "where a.cod = a1.schetfnr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "a1.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'N' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, '  ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from _finnaklr a, schfnrtovt a1, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, klient e, tovar f, ei g ",
                    "where a.cod = a1.schetfnr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'N' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, '   ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from _naklr2 a, naklrtov a1, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, klient e, tovar f, ei g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "a.klient_cod = e.cod and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "a.tip = 'M' and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, '   ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from vp a, naklrtov a1, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, myorg e, tovar f, ei g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.skladr_cod = c.cod and ",
                          "d.cod = ", p_stt.vpr, " and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, ' ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from naklr a, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, myorg e, tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "d.cod in (", p_stt.zaimto, ",", p_stt.pzaimfrom, ") and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                  "union ",
                  "select b.cod, ' ', a.num, ",
                         "a.dat, c.nam, d.nam, ",
                         "e.nam, a.prim1, b.datotg, f.nam, ",
                         "b1.sernum, b1.dat_gar, g.nam, ",
                         "b.cena, b.cenad ",
                    "from naklr a, matoperr b, matoperp b1, ",
                         "sklad c, operacia d, myorg e, tovar f, ei g ",
                    "where a.cod = b.doc_cod and ",
                          "a.cod in (select slave_cod from garlink) and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b.datotg is not null and ",
                          "a.sklad_cod = c.cod and ",
                          "a.operacia_cod = d.cod and ",
                          "d.cod in (", p_stt.gklr1, ",", p_stt.gklr2, ",", p_stt.gpsr1, ",", p_stt.gpsr2, ") and ",
                          "b1.tovar_cod = f.cod and ",
                          "f.ei_cod = g.cod and ",
                          "f.issernum = '*' and ",
                           where_str clipped," ",
                     "order by ", sort_str clipped
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.cena  is null then let p.cena = 0  end if
        if p.cenad is null then let p.cenad = 0 end if
        if p.klientnam is null then let p.klientnam = p_myorg.nam end if
        display p.opercod, "\t", 
                p.tipdoc, "\t", 
                p.num, "\t", 
                p.dat using "dd.mm.yyyy", "\t", 
                p.skladnam, "\t",
                p.operacianam, "\t",
                p.klientnam, "\t",
                p.prim1, "\t",
                p.datotg using "dd.mm.yyyy", "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.dat_gar using "dd.mm.yyyy", "\t",
                p.einam, "\t",
                p.cena using "#######.##", "\t",
                p.cenad using "#######.##"
    end foreach
    commit work
end function

function sernumtov_upd( opercod, sernum, dat_gar)
define
    str     	        char(128),
    opercod     integer,
    sernum      like matoperp.sernum,
    dat_gar     date
    
    let str = "execute procedure sernumtov_upd(?,?, ?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using opercod, sernum, dat_gar
    commit work
end function

function sernumtov_del(opercod)
define
    str     	        char(128),
    opercod     integer
    
    let str = "execute procedure sernumtov_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using opercod
    commit work
end function

function sernum_rep(tip, where_str, sort_str, pipe_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        opercod     integer,
        tipdoc      char(40),
        num         like naklp.num,
        dat         like naklp.dat,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        klientnam   like klient.nam,
        prim1       like naklp.prim1,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad
    end record,
    str         char(2048),
    tip         char(1),
    pipe_str    char(256)
    
    let reppipe = pipe_str
    let str = "select b.cod, '  ', a.num, ",
                     "a.dat, c.nam, d.nam, ",
                     "e.nam, a.prim1, f.nam, ",
                     "b.sernum, b.kol, g.nam, ",
                     "b.cena, b.cenad ",
                "from naklp a, matoperp b, sklad c, operacia d, klient e, ",
                     "tovar f, ei g ",
                "where a.cod = b.doc_cod and ",
                      "a.sklad_cod = c.cod and ",
                      "a.operacia_cod = d.cod and ",
                      "a.klient_cod = e.cod and ",
                      "b.tovar_cod = f.cod and ",
                      "f.ei_cod = g.cod and ",
                      "a.tip = 'N' and ",
                      "f.issernum = '*' and ",
                       where_str clipped," ",
              "union ",
              "select b.cod, '   ', a.num, ",
                     "a.dat, c.nam, d.nam, ",
                     "e.nam, a.prim1, f.nam, ",
                     "b.sernum, b.kol, g.nam, ",
                     "b.cena, b.cenad ",
                "from naklp a, matoperp b, sklad c, operacia d, klient e, ",
                     "tovar f, ei g ",
                "where a.cod = b.doc_cod and ",
                      "a.sklad_cod = c.cod and ",
                      "a.operacia_cod = d.cod and ",
                      "a.klient_cod = e.cod and ",
                      "b.tovar_cod = f.cod and ",
                      "f.ei_cod = g.cod and ",
                      "a.tip = 'M' and ",
                      "f.issernum = '*' and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_rep from str
    
    initialize p to null
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_sernum
        foreach cur_rep into p.*
            if p.cena  is null then let p.cena = 0  end if
            if p.cenad is null then let p.cenad = 0 end if
            output to report r_sernum(tip, p.num, p.dat, p.skladnam,
                                      p.klientnam, p.tovarnam, p.sernum,
                                      p.cena, p.cenad)
        end foreach
    finish report r_sernum
    commit work
end function

report r_sernum(tip, num, dat, skladnam, klientnam, tovarnam, sernum, cena, cenad)
define	
    tip         char(1),
    num         like naklp.num,
    dat         like naklp.dat,
    klientnam   like klient.nam,
    skladnam    like sklad.nam,
    tovarnam    like tovar.nam,
    sernum      like matoperp.sernum,
    cena        like matoperp.cena,
    cenad       like matoperp.cenad,
    strtip      char(20)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      case tip
         when "p" let strtip = " "
         when "r" let strtip = " "
      end case
      print twicewidthon,vidon,"    ", strtip clipped,vidoff,twicewidthoff
      print "==========================================================================================================="
      print "  |      |             |             |              | . |    |  "
      print "-----------------------------------------------------------------------------------------------------------"
    on every row
      print num, " ", dat, passon, klientnam, " ", skladnam," ",tovarnam," ",sernum," ",cena using "#######.## ",cenad using "#######.##",passoff
    on last row
      print "==========================================================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

function sernumostatok_he(skladcod, hesernum)
define
    tip                 char(1),
    str                 char(128),
    skladcod            integer,
    hesernum            like matoperp.sernum,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            like tovar.nam,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    einam               like ei.nam,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds
    
    let hesernum = hesernum clipped
    let sep = ascii 3
    let str = "execute procedure sernumostatok_he(?,?)"
    prepare p_he4 from str
    declare cur_he4 cursor for p_he4
    
    let transaction = 1
    begin work
    open cur_he4 using skladcod, hesernum
        while (TRUE)
            fetch cur_he4 into operpcod,    tovarcod,   eicod,
                               datpokupki, tovarnam,    sernum,     kol,
                               einam,       cena,       cenad,  isnds, ret
            if status = notfound then exit while end if
            display operpcod, sep, 
                    tovarcod, sep, 
                    eicod, "\t", 
                    datpokupki using "ddmmyy", sep,
                    tovarnam, sep, 
                    sernum, sep,
                    kol using "-----.--", sep,
                    einam, sep, 
                    cena using "#####.##", sep,
                    cenad using "#####.##", sep,
                    " ",isnds, " \t", 
                    ret
        end while
    close cur_he4
    commit work
end function

function sernumostatoksk_he(hesernum)
define
    tip                 char(1),
    str                 char(128),
    hesernum            like matoperp.sernum,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            like tovar.nam,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    einam               like ei.nam,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds,
    skladnam            like sklad.nam
    
    let hesernum = hesernum clipped
    let sep = ascii 3
    let str = "execute procedure sernumostatoksk_he(?)"
    prepare p_he5 from str
    declare cur_he5 cursor for p_he5
    
    let transaction = 1
    begin work
    open cur_he5 using hesernum
        while (TRUE)
            fetch cur_he5 into operpcod,    tovarcod,   eicod,
                               datpokupki, tovarnam,    sernum,     kol,
                               einam,       cena,       cenad,  isnds, 
                               skladnam, ret
            if status = notfound then exit while end if
            display operpcod, sep, 
                    tovarcod, sep, 
                    eicod, "\t", 
                    datpokupki using "ddmmyy", sep,
                    tovarnam, sep, 
                    sernum, sep,
                    kol using "-----.--", sep,
                    einam, sep, 
                    cena using "#####.##", sep,
                    cenad using "#####.##", sep,
                    " ",isnds, sep,
                    skladnam, "\t", 
                    ret
        end while
    close cur_he5
    commit work
end function

function sernumostatokskg_he(hesernum)
define
    tip                 char(1),
    str                 char(128),
    hesernum            like matoperp.sernum,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            like tovar.nam,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    einam               like ei.nam,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds,
    skladnam            like sklad.nam,
    dat_gar             date
    
    let hesernum = hesernum clipped
    let sep = ascii 3
    let str = "execute procedure sernumostskg_he(?)"
    prepare p_he6 from str
    declare cur_he6 cursor for p_he6
    
    let transaction = 1
    begin work
    open cur_he6 using hesernum
        while (TRUE)
            fetch cur_he6 into operpcod,    tovarcod,   eicod,
                               datpokupki, tovarnam,    sernum,     kol,
                               einam,       cena,       cenad,  isnds, 
                               skladnam,    dat_gar,    ret
            if status = notfound then exit while end if
            display operpcod, sep, 
                    tovarcod, sep, 
                    eicod, "\t", 
                    datpokupki using "ddmmyy", sep,
                    tovarnam, sep, 
                    sernum, sep,
                    kol using "-----.--", sep,
                    einam, sep, 
                    cena using "#####.##", sep,
                    cenad using "#####.##", sep,
                    " ",isnds, sep,
                    skladnam, sep, 
                    dat_gar, "\t", 
                    ret
        end while
    close cur_he6
    commit work
end function
