globals "globals.4gl"

function tovcardtov_sel(tip, prih, rash, tovarcod, skladcod,
                        datbegin, datend, sort_str)
define  
    tip, prih, rash char(1),
    sort_str   char(64),
    datbegin    date,
    datend      date,
    tovarcod, skladcod  integer,
    p   record
        doccod      integer,
        operpcod    integer,
        datprih     date,
        datop       date,
        docnum      like naklp.num,
        klientnam   like klient.nam,
        kolp        decimal(7,2),
        kolr        decimal(7,2),
        cenawpdv    decimal(9,2),
        cenad       decimal(9,2),
        flgr        char(1)
    end record,
    str     char(6096),
    kolprih         decimal(7,2),
    kolrash         decimal(7,2)
    
    whenever error call err

    initialize p, kolrash, kolprih to null
    # mattov ################################################################
    if tip = 'm' then
        if prih = 'o' then
            select sum(a.kol) into kolprih
                from matoperp a
                where a.sklad_cod = skladcod and
                      a.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladp_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x1.cod
                                        from naklp x1
                                        where x1.sklad_cod = skladcod and
                                              x1.dat >= datbegin and x1.dat < datend
                                   )
                      )
            if kolprih is not null then
                display " \t \t \t \t               \t",
                        kolprih using "#####.##", "\t \t \t \t "
            end if
        end if
    end if
    
    if tip = 'm' then
        if prih = 'a' and rash = 'a' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('M','N') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from vp a, matoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, 'Z', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('Z') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, 'G', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('G') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from vp a, matoperr b, matoperp b1, sklad c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from naklr a, naklrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.naklr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), ",
                             "b.cenad, '', 1 ",
                        "from _schet a, schfnrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtovt
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), ",
                             "b.cenad, '', 1 ",
                        "from _schet a, schfnrtovt a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select 0, 0, date('31.12.2037'), date('31.12.2037'), nullchar(), '        ', ",
                             "nulldecimal(), sum(a.kol), nulldecimal(), nulldecimal(), 'R', 1 ",
                        "from matoperr a, matoperp b ",
                        "where a.matoperp_cod = b.cod and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "b.tovar_cod =  ", tovarcod, " and ",
                              "a.datotg is null ",
                        "group by 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12 ",
                      "union ",
                      #      
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, 'W', 1 ",
                        "from naklr a, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "(a.cod in (select slave_cod from zaimlink) or ",
                              "a.cod in (select slave_cod from garlink)) and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        else
            let str = "select cod from codes_doc where cod = -100"
        end if
        if prih = 'a' and rash = 'o' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('M','N') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from vp a, matoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, 'Z', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('Z') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, 'G', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('G') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
        if prih = 'o' and rash = 'a' then
                      #    
            let str = "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from vp a, matoperr b, matoperp b1, sklad c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from naklr a, naklrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.naklr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), b.cenad, '', 1 ",
                        "from _schet a, schfnrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtovt
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), b.cenad, '', 1 ",
                        "from _schet a, schfnrtovt a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select 0, 0, date('31.12.2037'), date('31.12.2037'), nullchar(), '        ', ",
                             "nulldecimal(), sum(a.kol), nulldecimal(), nulldecimal(), 'R', 1 ",
                        "from matoperr a, matoperp b ",
                        "where a.matoperp_cod = b.cod and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "b.tovar_cod =  ", tovarcod, " and ",
                              "a.datotg is null ",
                        "group by 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12 ",
                      "union ",
                      #      
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, 'W', 1 ",
                        "from naklr a, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "(a.cod in (select slave_cod from zaimlink) or ",
                              "a.cod in (select slave_cod from garlink)) and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
    end if
    
    # fintov ################################################################
    if tip = 'f' then
        if prih = 'o' then
            select sum(a.kol) into kolprih
                from finoperp a
                where a.sklad_cod = skladcod and
                      a.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladp_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x1.cod
                                        from naklp x1
                                        where x1.sklad_cod = skladcod and
                                              x1.dat >= datbegin and x1.dat < datend
                                   )
                      )
            if kolprih is not null then
                display " \t \t \t \t                  \t",
                        kolprih using "#####.##", "\t \t \t \t "
            end if
        end if
    end if
    
    if tip = 'f' then
        if prih = 'a' and rash = 'a' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from naklp a, finoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from vp a, finoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, nulldecimal(), nullchar(), 1 ",
                        "from vp a, finoperr b, finoperp b1, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, a.dat), nulldecimal(), nullchar(), 1 ",
                        "from _finnaklr a, schfnrtov a1, finoperr b, finoperp b1, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        else
            let str = "select cod from codes_doc where cod = -100"
        end if
        if prih = 'a' and rash = 'o' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from naklp a, finoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from vp a, finoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
        if prih = 'o' and rash = 'a' then
                      #    
            let str = "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, nulldecimal(), nullchar(), 1 ",
                        "from vp a, finoperr b, finoperp b1, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, a.dat), nulldecimal(), nullchar(), 1 ",
                        "from _finnaklr a, schfnrtov a1, finoperr b, finoperp b1, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
    end if

    prepare p_seltov from str
    
    declare cur_seltov cursor for p_seltov
    let transaction = 1    
    begin work
    foreach cur_seltov into p.*
        if p.datop = date('31.12.2037') then
            initialize p.datop to null
        end if
        display p.doccod, "\t", 
                p.operpcod, "\t",
                p.datop using "ddmmyy", "\t",
                p.docnum, "\t",
                p.klientnam, "\t",
                p.kolp using "#####.##", "\t",
                p.kolr using "#####.##", "\t",
                p.cenawpdv using "#######.##", "\t",
                p.cenad    using "#######.##", "\t",
                p.flgr
    end foreach
    
    if tip = 'm' then
        if rash = 'o' then
            select sum(a.kol) into kolrash
                from matoperr a, matoperp b
                where a.matoperp_cod = b.cod and
                      b.sklad_cod = skladcod and
                      b.tovar_cod = tovarcod and
                      (( a.datotg >= datbegin and 
                      a.datotg < datend ) or a.datotg is null)
            if kolrash is not null then
                display " \t \t \t \t               \t",
                        " \t", kolrash using "#####.##", "\t \t \t "
            end if
        end if
    end if
    if tip = 'f' then
        if rash = 'o' then
            select sum(a.kol) into kolrash
                from finoperp b, finoperr a
                where a.finoperp_cod = b.cod and
                      b.sklad_cod = skladcod and
                      b.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladr_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x4.cod
                                        from _finnaklr x3, schfnrtov x4
                                        where x3.sklad_cod = skladcod and
                                              x3.dat >= datbegin and x3.dat < datend and
                                              x3.cod = x4.schetfnr_cod
                                   )
                      )
            if kolrash is not null then
                display " \t \t \t \t                  \t",
                        " \t", kolrash using "#####.##", "\t \t \t "
            end if
        end if
    end if
    commit work
end function

function tovcardhead_sel(tip, datbegin, datend, where_str)
define  
    tip         char(1),
    where_str   char(512),
    datbegin    date,
    datend      date,
    p   record
        tovarcod        integer,
        skladcod        integer,
        tovarnam        like tovar.nam,
        einam           like ei.nam,
        datbegin        date,
        datend          date,
        skladnam        like sklad.nam,
        saldobegin      decimal(7,2),
        saldoend        decimal(7,2)
    end record,
    str     char(3096)
    
    if tip = 'm' then
        let str = "select unique a.cod, d.cod, a.nam, c.nam, '",
                         datbegin, "', '", datend, "', ",
                         "d.nam, saldomattovkolsd(d.cod, a.cod, '", datbegin, "'), ",
                         "saldomattovkolsd(d.cod, a.cod, '", datend, "') ",
                    "from tovar a, matoperp b, ei c, sklad d ",
                    "where a.cod = b.tovar_cod and ",
                          "a.ei_cod = c.cod and ",
                          "b.sklad_cod = d.cod and ",
                           where_str clipped," ",
                    "order by d.nam, a.nam, c.nam"
    end if
    if tip = 'f' then
        let str = "select unique a.cod, d.cod, a.nam, c.nam, '",
                         datbegin, "', '", datend, "', ",
                         "d.nam, saldofintovkolsd(d.cod, a.cod, '", datbegin, "'), ",
                         "saldofintovkolsd(d.cod, a.cod, '", datend, "') ",
                    "from tovar a, finoperp b, ei c, sklad d ",
                    "where a.cod = b.tovar_cod and ",
                          "a.ei_cod = c.cod and ",
                          "b.sklad_cod = d.cod and ",
                           where_str clipped," ",
                    "order by d.nam, a.nam, c.nam"
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.tovarcod, "\t", 
                p.skladcod, "\t",
                p.tovarnam, "\t",
                p.einam, "\t",
                p.datbegin using "dd.mm.yyyy", "\t",
                p.datend using "dd.mm.yyyy", "\t",
                p.skladnam, "\t", 
                p.saldobegin using "#####.##", "\t", 
                p.saldoend using "#####.##"
    end foreach
    commit work
end function

function tovcardtov_rep(tip, prih, rash, tovarcod, skladcod,
                        datbegin, datend, sort_str, pipe_str)
define  
    tip, prih, rash char(1),
    sort_str   char(64),
    datbegin    date,
    datend      date,
    pipe_str    char(256),
    tovarcod, skladcod  integer,
    p   record
        doccod      integer,
        operpcod    integer,
        datprih     date,
        datop       date,
        docnum      like naklp.num,
        klientnam   like klient.nam,
        kolp        decimal(7,2),
        kolr        decimal(7,2),
        cenawpdv    decimal(9,2),
        cenad       decimal(9,2),
        flgr        char(1)
    end record,
    str     char(5096),
    kolprih         decimal(7,2),
    kolrash         decimal(7,2),
    skladnam        like sklad.nam,
    tovarnam        like tovar.nam,
    saldobegin, saldoend, ostatok        decimal(7,2)
    
    select a.nam into tovarnam
        from tovar a
        where a.cod = tovarcod
    select a.nam into skladnam
        from sklad a
        where a.cod = skladcod
    select saldomattovkolsd(skladcod, tovarcod, datbegin) into saldobegin
        from systables
        where tabid = 1
    select saldomattovkolsd(skladcod, tovarcod, datend) into saldoend
        from systables
        where tabid = 1
    let ostatok = saldobegin
    
    let reppipe = pipe_str

    initialize p, kolrash, kolprih to null
    
    start report r_tovcardtov
    # mattov ################################################################
    if tip = 'm' then
        if prih = 'o' then
            select sum(a.kol) into kolprih
                from matoperp a
                where a.sklad_cod = skladcod and
                      a.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladp_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x1.cod
                                        from naklp x1
                                        where x1.sklad_cod = skladcod and
                                              x1.dat >= datbegin and x1.dat < datend
                                   )
                      )
            if kolprih is not null then
                let ostatok = ostatok + kolprih
                output to report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                                              '', '', '            :', kolprih, '', ostatok, '', '', '')
            end if
        end if
    end if
    
    if tip = 'm' then
        if prih = 'a' and rash = 'a' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('M','N') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from vp a, matoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from vp a, matoperr b, matoperp b1, sklad c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from naklr a, naklrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.naklr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), ",
                             "b.cenad, '', 1 ",
                        "from _schet a, schfnrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtovt
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), ",
                             "b.cenad, '', 1 ",
                        "from _schet a, schfnrtovt a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select 0, 0, date('31.12.2037'), date('31.12.2037'), nullchar(), '        ', ",
                             "nulldecimal(), sum(a.kol), nulldecimal(), nulldecimal(), 'R', 1 ",
                        "from matoperr a, matoperp b ",
                        "where a.matoperp_cod = b.cod and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "b.tovar_cod =  ", tovarcod, " and ",
                              "a.datotg is null ",
                        "group by 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12 ",
                        "order by ", sort_str clipped
        else
            let str = "select cod from codes_doc where cod = -100"
        end if
        if prih = 'a' and rash = 'o' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from naklp a, matoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip in ('M','N') and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, b.cenad, '', 0 ",
                        "from vp a, matoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
        if prih = 'o' and rash = 'a' then
                      #    
            let str = "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from vp a, matoperr b, matoperp b1, sklad c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'M' and ",
                              "a.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, b.cenad, '', 1 ",
                        "from naklr a, naklrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.naklr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), b.cenad, '', 1 ",
                        "from _schet a, schfnrtov a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtovt
                      "select a.cod, b1.cod, b1.dat_pokupki, b.datotg, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, b.datotg), b.cenad, '', 1 ",
                        "from _schet a, schfnrtovt a1, matoperr b, matoperp b1, klient c ",
                        "where b.datotg >= '", datbegin, "' and b.datotg < '", datend, "' and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.matoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #   
                      "select 0, 0, date('31.12.2037'), date('31.12.2037'), nullchar(), '        ', ",
                             "nulldecimal(), sum(a.kol), nulldecimal(), nulldecimal(), 'R', 1 ",
                        "from matoperr a, matoperp b ",
                        "where a.matoperp_cod = b.cod and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "b.tovar_cod =  ", tovarcod, " and ",
                              "a.datotg is null ",
                        "group by 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12 ",
                        "order by ", sort_str clipped
        end if
    end if
    
    # fintov ################################################################
    if tip = 'f' then
        if prih = 'o' then
            select sum(a.kol) into kolprih
                from finoperp a
                where a.sklad_cod = skladcod and
                      a.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladp_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x1.cod
                                        from naklp x1
                                        where x1.sklad_cod = skladcod and
                                              x1.dat >= datbegin and x1.dat < datend
                                   )
                      )
            if kolprih is not null then
                let ostatok = ostatok + kolprih
                output to report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                                              '', '', '            :', kolprih, '', ostatok, '', '', '')
            end if
        end if
    end if
    
    if tip = 'f' then
        if prih = 'a' and rash = 'a' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from naklp a, finoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from vp a, finoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, nulldecimal(), nullchar(), 1 ",
                        "from vp a, finoperr b, finoperp b1, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, a.dat), nulldecimal(), nullchar(), 1 ",
                        "from _finnaklr a, schfnrtov a1, finoperr b, finoperp b1, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        else
            let str = "select cod from codes_doc where cod = -100"
        end if
        if prih = 'a' and rash = 'o' then
                      #   
            let str = "select a.cod, b.cod, b.dat_pokupki, a.dat, a.num, c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from naklp a, finoperp b, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.klient_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #    
                      "select a.cod, b.cod, b.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "b.kol, nulldecimal(), b.cena, nulldecimal(), nullchar(), 0 ",
                        "from vp a, finoperp b, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladp_cod = ", skladcod, " and ",
                              "b.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "a.skladr_cod = c.cod and ",
                              "b.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
        if prih = 'o' and rash = 'a' then
                      #    
            let str = "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, b.cena, nulldecimal(), nullchar(), 1 ",
                        "from vp a, finoperr b, finoperp b1, sklad c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.skladr_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.tip = 'F' and ",
                              "a.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.skladp_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                      "union ",
                      #     schfnrtov
                      "select a.cod, b1.cod, b1.dat_pokupki, a.dat, itoc(a.num), c.nam, ",
                             "nulldecimal(), b.kol, cenawithoutpdv(b1.tovar_cod, b.cena, a.dat), nulldecimal(), nullchar(), 1 ",
                        "from _finnaklr a, schfnrtov a1, finoperr b, finoperp b1, klient c ",
                        "where a.dat >= '", datbegin, "' and a.dat < '", datend, "' and ",
                              "a.sklad_cod = ", skladcod, " and ",
                              "b1.sklad_cod = ", skladcod, " and ",
                              "a.cod = a1.schetfnr_cod and ",
                              "a1.cod = b.doc_cod and ",
                              "b.finoperp_cod = b1.cod and ",
                              "a.klient_cod = c.cod and ",
                              "b1.tovar_cod = ", tovarcod, " ",
                        "order by ", sort_str clipped
        end if
    end if

    prepare p_seltov from str
    
    declare cur_seltovrep cursor for p_seltov
    let transaction = 1    
    begin work
    foreach cur_seltovrep into p.*
        if p.kolp is not null then 
            let ostatok = ostatok + p.kolp
        end if
        if p.kolr is not null then 
            let ostatok = ostatok  - p.kolr
        end if
        if p.datop = date('31.12.2037') then
            initialize p.datop to null
        end if
        output to report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                                      p.datop, p.docnum, p.klientnam, p.kolp, p.kolr, ostatok, p.cenawpdv, p.cenad, p.flgr)
    end foreach
    
    if tip = 'm' then
        if rash = 'o' then
            select sum(a.kol) into kolrash
                from matoperr a, matoperp b
                where a.matoperp_cod = b.cod and
                      b.sklad_cod = skladcod and
                      b.tovar_cod = tovarcod and
                      a.datotg >= datbegin and a.datotg < datend
            if kolrash is not null then
                let ostatok = ostatok - kolrash
                output to report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                                              '', '', '            :', '', kolrash, ostatok, '', '', '')
            end if
        end if
    end if
    if tip = 'f' then
        if rash = 'o' then
            select sum(a.kol) into kolrash
                from finoperp b, finoperr a
                where a.finoperp_cod = b.cod and
                      b.sklad_cod = skladcod and
                      b.tovar_cod = tovarcod and
                      (a.doc_cod in ( select x0.cod
                                        from vp x0
                                        where x0.skladr_cod = skladcod and
                                              x0.dat >= datbegin and x0.dat < datend
                                   ) or
                      a.doc_cod in ( select x4.cod
                                        from _finnaklr x3, schfnrtov x4
                                        where x3.sklad_cod = skladcod and
                                              x3.dat >= datbegin and x3.dat < datend and
                                              x3.cod = x4.schetfnr_cod
                                   )
                      )
            if kolrash is not null then
                let ostatok = ostatok - kolrash
                output to report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                                              '', '', '            :', '', kolrash, ostatok, '', '', '')
            end if
        end if
    end if
    commit work
    finish report r_tovcardtov
end function

report r_tovcardtov(tovarnam, datbegin, datend, skladnam, saldobegin, saldoend,
                    dat, num, klientnam, kolp, kolr, ost, cena, cenad, flgr)
define	
    tovarnam                like tovar.nam,
    datbegin, datend        date,
    skladnam                like sklad.nam,
    saldobegin, saldoend    decimal(7,2),
    dat                     date,
    num                     char(10),
    klientnam               like klient.nam,
    kolp, kolr, ost         decimal(7,2),
    cena, cenad             decimal(9,2),
    flgr                    char(1)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		45
	
format	
    first page header
        print " : ", tovarnam
        print "  : ", datbegin using "dd.mm.yyyy", " : ", datend using "dd.mm.yyyy", "   ", skladnam
        print "  : ", saldobegin, "   : ", saldoend, passon
        print "==================================================================================================================================="
        print "      |     |                                            |   |   |  |      |      | F |"
        print "-----------------------------------------------------------------------------------------------------------------------------------"
    on every row
        print dat using "dd.mm.yyyy", " ", num, " ", klientnam, " ", kolp, " ", kolr, " ", ost, " ", cena, " ", cenad, "  ", flgr
    on last row
        print "==================================================================================================================================="
        call whatsot()
        print passoff, downindex, ": ", userfio clipped, indexoff, formfeed
end report
