globals "globals.4gl"

function vp_ins(tip, dat, skladrcod, skladpcod, prim1)
define
    str     	char(128),
    tip         char(1),
    num         like vp.num,
    dat         like vp.dat,
    vpcod, skladrcod, skladpcod integer,
    prim1       like vp.prim1

    whenever error call err
    
    initialize vpcod to null
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure vp_ins(?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tip, dat, skladrcod, skladpcod, prim1
        fetch cur_ins into vpcod, num
        display vpcod, "\t", num
    close cur_ins
    commit work
end function

function vp_del(vpcod)
define
    str         char(128),
    vpcod    integer
    
    let str = "execute procedure vp_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using vpcod
    commit work
end function

function vp_upd(vpcod, num, dat, skladrcod, skladpcod, prim1)
define
    str     	char(128),
    num         like vp.num,
    dat         like vp.dat,
    vpcod, skladrcod, skladpcod integer,
    prim1       like vp.prim1
    
    let str = "execute procedure vp_upd(?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using vpcod, num, dat, skladrcod, skladpcod, prim1
    commit work
end function
    
function vpone_sel(vpcod)
define  
    vpcod   integer,
    p   record
        num         like vp.num,
        dat         like vp.dat,
        skladrcod    integer,
        skladrnam    like sklad.nam,
        skladpcod    integer,
        skladpnam    like sklad.nam,
        prim1       like vp.prim1
    end record
    
    initialize p to null
    let transaction = 1    
    begin work
    select  a.num, a.dat, a.skladr_cod, b.nam, a.skladp_cod, c.nam, a.prim1
        into p.*
        from vp a, sklad b, sklad c
        where a.cod = vpcod and
              a.skladr_cod = b.cod and
              a.skladp_cod = c.cod
    commit work
    
    display p.num, "\t",
            p.dat using "dd.mm.yyyy", "\t",
            p.skladrcod, "\t",
            p.skladrnam, "\t",
            p.skladpcod, "\t",
            p.skladpnam, "\t",
            p.prim1
end function
