globals "globals.4gl"

function whorezdoc_sel(skladcod, tovarcod)
define  
    skladcod    integer,
    tovarcod    integer,
    p   record
        doccod      integer,
        doctip      char(1),
        docnum      char(10),
        docdat      date,
        klientnam   like klient.nam,
        kol         like matoperr.kol,
        mindatopl   date,
        sall        decimal(9,2),
        sopl        decimal(9,2),
        primrez     like primrez.nam
    end record,
    str         char(3096),
    flgopl      char(1)
    
    whenever error call err
    
    let str = "select c.cod, 's', c.num, c.dat, d.nam, sum(a.kol), ",
                     "e.dat, f.summa, e.summa, g.nam ",
                "from matoperr a, matoperp b, _schet c, klient d, ",
                     "outer _schetoplmindat e, _schets f, primrez g ",
                "where a.datotg is null and ",
                      "a.matoperp_cod = b.cod and ",
                      "b.sklad_cod = ", skladcod, " and ",
                      "b.tovar_cod = ", tovarcod, " and ",
                      "a.schetfnr_cod = c.cod and ",
                      "c.klient_cod = d.cod and ",
                      "a.schetfnr_cod = e.schet_cod and ",
                      "a.schetfnr_cod = f.cod and ",
                      "a.cod = g.matoperr_cod ",
                "group by 1, 2, 3, 4, 5, 7, 8, 9, 10 ",
              "union ",
              "select c.cod, 'i', c.num, c.dat, d.nam, sum(a.kol), ",
                     "e.mindat, f.summaall, e.summaall, g.nam ",
                "from matoperr a, matoperp b, naklr c, naklrtov c1, klient d, ",
                     "outer _naklroplmindat e, _naklrs f, primrez g ",
                "where a.datotg is null and ",
                      "a.matoperp_cod = b.cod and ",
                      "b.sklad_cod = ", skladcod, " and ",
                      "b.tovar_cod = ", tovarcod, " and ",
                      "a.doc_cod = c1.cod and ",
                      "c.cod = c1.naklr_cod and ",
                      "c.klient_cod = d.cod and ",
                      "c.cod = e.naklr_cod and ",
                      "c.cod = f.cod and ",
                      "a.cod = g.matoperr_cod ",
                "group by 1, 2, 3, 4, 5, 7, 8, 9, 10 ",
                "order by 3"

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.sopl is null then let p.sopl = 0 end if
        if p.sall = p.sopl then
            let flgopl = '='
        end if
        if p.sall > p.sopl then
            let flgopl = '+'
        end if
        if p.sall < p.sopl then
            let flgopl = '-'
        end if
        if p.sopl = 0 then
            let flgopl = '0'
        end if
        display p.doccod, "\t", 
                p.doctip, "\t", 
                p.docnum, "\t", 
                p.docdat using "dd.mm.yyyy", "\t", 
                p.klientnam, "\t",
                p.kol using "#####.##", "\t",
                p.mindatopl, "\t",
                flgopl, "\t",
                p.primrez
    end foreach
    commit work
end function
