proc bindballoon { win } {
    
    scan $win "%\[^:]" win
    switch -regexp $win {
        ^.*[\.]lfindb$       {set text "  "}
        ^.*[\.]lfind$        {set text " "}
        ^.*[\.]find$         {set text ""}
        ^.*[\.]insert$       {set text ""}
        ^.*[\.]printkwit$    {set text "   "}
        ^.*[\.]print$        {set text ""}
        ^.*[\.]sort$         {set text ""}
        ^.*[\.]view$         {set text ""}
        ^.*[\.]update$       {set text ""}
        ^.*[\.]delete$       {set text ""}
        ^.*[\.]exit$         {set text ""}
        ^.*[\.]nalnakl$      {set text " "}
        ^.*[\.]tovnakl$      {set text " "}
        ^.*[\.]tovt$         {set text " "}
        ^.*[\.]first$        {set text " "}
        ^.*[\.]last$         {set text " "}
        ^.*[\.]left$         {set text "  "}
        ^.*[\.]right$        {set text "  "}
        ^.*[\.]scale$        {set text "  "}
        ^.*[\.]schet$        {set text ""}
        ^.*[\.]oplata$       {set text ""}
        ^.*[\.]whomathtov$   {set text "   "}
        ^.*[\.]insstr$       {set text "  "}
        ^.*[\.]lgota$        {set text "   "}
        ^.*[\.]prikid$       {set text ""}
        ^.*[\.]whorezdoc$    {set text "  "}
        ^.*[\.]08$           {set text " 0.8%"}
    }
    
    set w .balloon
    catch [destroy $w]
    if [info exists text] {
        toplevel $w
        wm overrideredirect $w 1
        wm geometry $w +[expr [winfo rootx $win] + 10]+[expr [winfo rooty $win] + [winfo height $win]]
        label $w.l -text $text -relief sunken -bg #ffff10 -bd 2 -padx 5 -pady 1
        set cg {}
        catch [set cg [$win cget -state]]
        if { "$cg" == "disabled" } {
            $w.l configure -bg #ffdf00
        }
        pack $w.l
    }
}

