proc ei:read {} {
    global VS EI EI_DATA
    
    set w .ei.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset EI_DATA]
    if { $EI(sortdesc) == "" }   { set EI(sortdesc) " "  }
    if { $EI(find) == "" } {
        set EI(find) "1=1"
        lappend EI(find,listbox) $EI(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "ei_sel \"$EI(find)\" \"nam $EI(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set EI_DATA(cod,$i) {}; set EI_DATA(nam,$i) {}
            scan $str "%\[^\t]%*c%\[^\n]" EI_DATA(cod,$i) EI_DATA(nam,$i)
            if { [clipped $EI(entry,nam)] == [clipped $EI_DATA(nam,$i)] } {
                set EI(listbox,curselection) $i
            }
            $w insert end " $EI_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set EI(statusline) " $i ."
        }
        set EI(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc ei:find {} {
    global VS EI
    
    ei:entry find
    if { $EI(entrystatus) == 1 } {
        set EI(find) "1=1"
        foreach {i j} "\"$EI(entry,nam)\" nam" {
            if { $i != "" } {
                set EI(find) "$EI(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $EI(find,listbox) $EI(find)] == -1} {
            lappend EI(find,listbox) $EI(find)
        }
        ei:read
    }
    set EI(entrystatus) 0
}

proc ei:delete {} {
    global VS EI EI_DATA
    
    set w .ei.lb.listbox
    if { $EI(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $EI(listbox,curselection)
            puts $socks "ei_del $EI_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            ei:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $EI(listbox,count)} {
            set id $EI(listbox,count)
            set EI(listbox,curselection) $EI(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set EI(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set EI(deletestatus) 0
}

proc ei:insert {} {
    global VS EI
    
    set w .ei.lb.listbox
    ei:entry insert
    if { $EI(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "ei_ins \"$EI(entry,nam)\""
            flush $socks
    
            while { [ set eicod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            ei:read
        } else {
            errormsg nosocks "  !"
        }

        set id $EI(listbox,curselection)
        $w see $id
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set EI(entrystatus) 0
}

proc ei:update {} {
    global VS EI EI_DATA

    set w .ei.lb.listbox
    set EI(entry,nam) [clipped $EI_DATA(nam,$EI(listbox,curselection))]
    ei:entry update
    if { $EI(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "ei_upd $EI_DATA(cod,$EI(listbox,curselection)) \"$EI(entry,nam)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            ei:read
        } else {
            errormsg nosocks "  !"
        }

        set id $EI(listbox,curselection)
        $w see $id
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set EI(entrystatus) 0
}

proc ei:view {} {
    global VS EI EI_DATA
    
    set EI(entry,nam) $EI_DATA(nam,$EI(listbox,curselection))
    ei:entry view
    catch [event generate .ei.lb.listbox <<iconmenu-enabled>>]
}

proc ei:print {} {
    global VS EI    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "ei_rep \"$EI(find)\" \"nam $EI(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
