proc SmallToBigChar { ch } {
    set small [list a b c d e f g h i j k l m n o p q r s t u v w x y z .]
    set big   [list A B C D E F G H I J K L M N O P Q R S T U V W X Y Z _]
    return [lindex $big [lsearch $small $ch]]
}

proc SmallToBig { str } {
    regsub -all "." $str "& " ret
    set retstr {}
    foreach i "$ret" {
        set retstr $retstr[SmallToBigChar $i]
    }
    return $retstr
}

proc findbox { fun width } {

    regsub -all "^\\." $fun "" fun
    
    proc $fun:findbox:main { fun width } {
        global VS
        
        set w .$fun.butimg
        set FUN [SmallToBig $fun]
        label $w.lfind -relief sunken -width $width -textvariable ${FUN}(find) -anchor w
        button $w.lfindb -takefocus 0 -bd 1 -bitmap @$VS(dir)ComboBox.xbm -command "$fun:findbox:lb $fun $width"
        pack $w.lfind $w.lfindb -side left

        foreach i {lfind lfindb} {
            bind $w.$i <Enter> { bindballoon %W }
            bind $w.$i <Leave> { destroy .balloon }
        }
        bind $w.lfind <B1-ButtonRelease> [list $fun:findbox:lb $fun $width]
    }

    proc $fun:findbox:lb { fun width } {
        global VS
        
        set w .$fun.butimg.lfindlb
        set FUN [SmallToBig $fun]
        global $FUN
        catch [destroy $w]
        set x [winfo rootx .$fun.butimg.lfind]
        set y [winfo rooty .$fun.butimg.lfind]
        
        toplevel $w -cursor arrow
        wm overrideredirect $w 1
        wm geometry $w +$x+$y
        scrollbar $w.sbx -command "$w.lb xview" -orient h
        scrollbar $w.sby -command "$w.lb yview"
        listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width $width
        
        foreach {i} [subst $${FUN}(find,listbox)] {
            $w.lb insert end $i
        }
        
        set id [lsearch -exact [subst $${FUN}(find,listbox)] [subst $${FUN}(find)]]
        $w.lb see $id
        $w.lb selection set $id $id
        
        pack $w.sby -side right -fill y
        pack $w.sbx -side bottom -fill x
        pack $w.lb -side left

        
        bind $w.lb <B1-ButtonRelease> {
            scan %W "%%*c%%\[^.]%%*c%%s" fun fuf
            set [SmallToBig $fun](find) [ %W get [ %W curselection ] ]
        }
        tkwait variable ${FUN}(find)
        catch [scan [subst $${FUN}(find)] "%*s%*s%s%*s%s" ${FUN}(entry,datbegin) ${FUN}(entry,datend)]
        destroy $w
        catch [${fun}tov:clear]
        catch [$fun:read]
        catch [${fun}tov:summa]
    }
    $fun:findbox:main $fun $width
}
