proc naklp { st tip naklpcod inwin } {
    global VS NAKLP NAKLPLIST NAKLPTOV NAKLPTOV_DATA NAKLPLIST_DATA STT

    catch [unset NAKLP NAKLPTOV NAKLPTOV_DATA]
    naklphead:clear
    naklphead:old
    set NAKLP(pr)  $NAKLPLIST(pr)
    set NAKLP(tip) $tip
    naklptov:clear
    set NAKLP(cod) $naklpcod
    set NAKLP(inwin) $inwin
    set NAKLP(st) $st
    set w $NAKLP(inwin).naklp
    set w1 ${w}.menu
    set NAKLPTOV(sortstr) "tnam"
    
    switch $tip {
        "n" { set titstr "" }
        "f" { 
            if { $VS(login) == "buh" } {
                set titstr ""
            } else {
                set titstr " "
            }
            
        }
        "m" { set titstr " " }
    }
    switch $NAKLP(pr) {
        "p" { set titpr "" }
        "r" { set titpr "" }
    }
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +$winx+78
    wm geometry $w =0x0
    wm title $w "${titstr}  $titpr"
        
    trace vdelete NAKLP(window) w naklp:trace:window
    trace variable NAKLP(window) w naklp:trace:window
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<Ins>" -state disabled -command naklp:insert
    $w1.1 add command -label "" -state disabled -command naklp:print
    $w1.1 add cascade -label "" -menu $w1.1.sort -state disabled
        $w1.1.sort add radio -label "  " -variable NAKLPTOV(sortstr) -value "tnam" -command naklptov:read
        $w1.1.sort add radio -label "  " -variable NAKLPTOV(sortstr) -value "koll" -command naklptov:read
        $w1.1.sort add radio -label "  " -variable NAKLPTOV(sortstr) -value "enam" -command naklptov:read
        $w1.1.sort add radio -label " " -variable NAKLPTOV(sortstr) -value "cenaa" -command naklptov:read
        if { $NAKLP(tip) != "f" } {
            $w1.1.sort add radio -label "  " -variable NAKLPTOV(sortstr) -value "cenadd" -command naklptov:read
        }
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable NAKLPTOV(sortdesc) -value " " -command naklptov:read
        $w1.1.sort add radio -label " " -variable NAKLPTOV(sortdesc) -value "desc" -command naklptov:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete -state disabled
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command naklp:delete
    $w1.1 add separator
    $w1.1 add command -label "   " -accelerator "<F8>" -state disabled -command naklp:whomathtov
    if { $NAKLP(pr) == "r" } {
        $w1.1 add command -state disabled -label "" -accelerator "<F11>" -command "prikid $w n $NAKLP(cod)"
    }
    if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } {
        $w1.1 add command -state disabled -label "" -accelerator "<Control-Ins>" -command naklptov:instovrow
    }
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label ""
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command naklp:ok
    button $w.buttons.clear -text "" -command naklp:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    frame $w.head -bd 1 -relief raised
    frame $w.tov -bd 1 -relief raised
    pack $w.head $w.tov -padx 5 -fill x
        
    foreach {i j} { insert  print  sort  delete  whomathtov "   " exit } {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -state disabled -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; $w.buttons.exit invoke"}
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    if { $NAKLP(pr) == "r" } {
        button $w.butimg.prikid -state disabled -takefocus 0 -bitmap @$VS(dir)Prikid.xbm -command "prikid $w n $NAKLP(cod)"
        pack $w.butimg.prikid -before $w.butimg.exit -side left
        bind $w.butimg.prikid <Leave> { destroy .balloon }
        bind $w.butimg.prikid <Enter> { bindballoon %W }
    }
    if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } {
        button $w.butimg.insstr -state disabled -takefocus 0 -bitmap @$VS(dir)Instov.xbm -command naklptov:instovrow
        pack $w.butimg.insstr -before $w.butimg.exit -side left
        bind $w.butimg.insstr <Leave> { destroy .balloon }
        bind $w.butimg.insstr <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        $NAKLP(inwin).naklp.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        $NAKLP(inwin).naklp.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Button-1> { 
        if [regexp \.naklp\.head|\.naklp\.tov|\.naklp\.zaim %W] {
            set NAKLP(window) %W 
        }
    }
    bind $w <Button-3> { 
        event generate %W <Button-1>
        if [regexp \.naklp\.head|\.naklp\.tov|\.naklp\.zaim %W] {
            switch -regexp %W {
                \.naklp\.head       { set win $NAKLP(inwin).naklp.head }
                \.naklp\.tov        { set win $NAKLP(inwin).naklp.tov }
                \.naklp\.zaim\.tov  { set win $NAKLP(inwin).naklp.zaim.tov }
                \.naklp\.zaim\.opl  { set win $NAKLP(inwin).naklp.zaim.opl }
            }
            $NAKLP(inwin).naklp.menu.1 post [winfo pointerx %W] [winfo pointery %W]
        }
    }
    bind $w <Key-Escape>        { $NAKLP(inwin).naklp.buttons.exit invoke }
    bind $w <KeyPress-Insert>   { naklp:insert }
    bind $w <Key-F8>            { naklp:whomathtov }
    if { $NAKLP(pr) == "r" } {
        bind $w <Key-F4>        { naklp:naklrrez }
        bind $w <Key-F6>        { naklp:naklrotg }
        bind $w <Key-F9>        { naklp:naklropl }
        bind $w <Key-F11>       [list prikid $w n $NAKLP(cod)]
        bind $w <Key-F12>       { prodmattov $NAKLP(cod) i " N - $NAKLP(num)  $NAKLP(dat) " $NAKLP(inwin).naklp }
    }
    bind $w <Control-p>         { postpol:update naklp }
    bind $w <Control-P>         { postpol:update naklp }
    bind $w <Control-ccedilla>  { postpol:update naklp }
    bind $w <Control-Ccedilla>  { postpol:update naklp }
    bind $w <Control-u>         { naklp:controlu }
    bind $w <Control-U>         { naklp:controlu }
    bind $w <Control-atilde>    { naklp:controlu }
    bind $w <Control-Atilde>    { naklp:controlu }
    
    naklphead
    naklptov
    if { $NAKLP(st) == 0 } naklp:alldisabled
    wm geometry $w [centerwindow $w]
    if { $NAKLP(cod) > 0 } {
        naklphead:read
        naklptov:read
    }
    trace vdelete NAKLP(operaciacod) w naklphead:trace:operaciacod
    trace variable NAKLP(operaciacod) w naklphead:trace:operaciacod
    runzaim $w $naklpcod
}

proc runzaim { win doccod } {
    global STT NAKLP
    
    if { $NAKLP(operaciacod) == $STT(zaimtocod) || \
         $NAKLP(operaciacod) == $STT(pzaimtocod) || \
         $NAKLP(operaciacod) == $STT(zaimfromcod) || \
         $NAKLP(operaciacod) == $STT(pzaimfromcod) || \
         $NAKLP(operaciacod) == $STT(gklp1cod) || \
         $NAKLP(operaciacod) == $STT(gklp2cod) || \
         $NAKLP(operaciacod) == $STT(gklr1cod) || \
         $NAKLP(operaciacod) == $STT(gklr2cod) || \
         $NAKLP(operaciacod) == $STT(gpsr1cod) || \
         $NAKLP(operaciacod) == $STT(gpsr2cod) || \
         $NAKLP(operaciacod) == $STT(gpsp1cod) || \
         $NAKLP(operaciacod) == $STT(gpsp2cod) \
       } {
        if ![winfo exists $win.zaim] {
            zaim $win $doccod
        }
    } else {
        catch [destroy $win.zaim]
        $win.tov.tbl configure -height 9
    }
    wm geometry $win [centerwindow $win]
}

proc naklp:iconmenu:state {s l} {
    global NAKLP
    
    set w $NAKLP(inwin).naklp
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        catch [$w.butimg.$statei configure -state $s]
    }
}

proc naklp:trace:window { name1 name2 op } {
    global NAKLP NAKLPTOV
    
    set w $NAKLP(inwin).naklp
    foreach i { head tov zaim.tov zaim.opl } {
        catch [$w.$i.tut configure -fg black -bg gray70 -relief sunken]
    }
    if { $NAKLP(pr) == "r" } {
        naklp:iconmenu:state disabled " insert  print  sort  delete  whomathtov \"   \" prikid "
    } elseif { $NAKLP(tip) == "m" } {
        naklp:iconmenu:state disabled " insert  print  sort  delete  whomathtov \"   \" insstr "
    } else {
        naklp:iconmenu:state disabled " insert  print  sort  delete  whomathtov \"   \""
    }
    switch -regexp $NAKLP(window) {
        \.naklp\.head {
            if { $NAKLP(pr) == "r" } {
                naklp:iconmenu:state normal "print  prikid "
            } else {
                naklp:iconmenu:state normal "print "
            }
            $w.head.tut configure -fg blue -bg gray90 -relief raised
        }
        \.naklp\.tov {
            if { $NAKLP(cod) > 0 } { 
                if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } {
                    naklp:iconmenu:state normal " insert  sort  delete  whomathtov \"   \" insstr "
                } else {
                    naklp:iconmenu:state normal " insert  sort  delete  whomathtov \"   \""
                }
            }
            $w.tov.tut configure -fg blue -bg gray90 -relief raised
        }
        \.naklp\.zaim\.tov {
            if { $NAKLP(cod) > 0 } { 
                naklp:iconmenu:state normal " insert  delete  "
            }
            $w.zaim.tov.tut configure -fg blue -bg gray90 -relief raised
        }
        \.naklp\.zaim\.opl {
            if { $NAKLP(cod) > 0 } { 
                naklp:iconmenu:state normal " insert  delete  "
            }
            $w.zaim.opl.tut configure -fg blue -bg gray90 -relief raised
        }
    }
    
}

proc naklp:insert {} {
    global NAKLP NAKLPTOV ZAIMTOV ZAIMOPL
    
    switch -regexp $NAKLP(window) {
        \.naklp\.tov {
            $NAKLP(inwin).naklp.tov.tbl configure -rows [incr NAKLPTOV(rows)]
        }
        \.naklp\.zaim\.tov {
            $NAKLP(inwin).naklp.zaim.tov.tbl configure -rows [incr ZAIMTOV(rows)]
        }
        \.naklp\.zaim\.opl {
            $NAKLP(inwin).naklp.zaim.opl.tbl configure -rows [incr ZAIMOPL(rows)]
        }
    }        
}

proc naklp:print {} {
    global NAKLPTOV NAKLP
    
    switch -regexp $NAKLP(window) {
        \.naklp\.head {
            naklphead:print
        }
    }        
}

proc naklp:delete {} {
    global NAKLP
    
    switch -regexp $NAKLP(window) {
        \.naklp\.tov {
            naklptov:delete
        }
        \.naklp\.zaim\.tov {
            zaimtov:delete
        }
        \.naklp\.zaim\.opl {
            zaimopl:delete
        }
    }        
}

proc naklp:clear {} {
    global NAKLP
    
    switch -regexp $NAKLP(window) {
        \.naklp\.head {
            naklphead:clear
        }
    }        
}

proc naklp:alldisabled {} {
    global NAKLP
    
    set w $NAKLP(inwin).naklp
    foreach i { buttons.ok buttons.clear } { $w.$i configure -state disabled }
}

proc naklp:ok {} {
    global NAKLP NAKLPTOV NAKLPTOV_DATA VS STT

    #  
    if { $NAKLP(cod) == 0 } {
        naklphead:insert
    } elseif { $NAKLP(cod) > 0 } {
        if { $NAKLP(num) != $NAKLP(old_num) \
             || $NAKLP(dat) != $NAKLP(old_dat) \
             || $NAKLP(datdolga) != $NAKLP(old_datdolga) \
             || $NAKLP(skladcod) != $NAKLP(old_skladcod) \
             || $NAKLP(operaciacod) != $NAKLP(old_operaciacod) \
             || $NAKLP(klientcod) != $NAKLP(old_klientcod) \
             || $NAKLP(kurs) != $NAKLP(old_kurs) \
             || $NAKLP(lgotaproc) != $NAKLP(old_lgotaproc) \
             || $NAKLP(prim1) != $NAKLP(old_prim1) } {
            naklphead:update
        }
    }
    
    #   
    set kol 1
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } { set kol 2 }
    if { $NAKLP(cod) > 0 } {
        set i 0
        while 1 {
            if [info exists NAKLPTOV_DATA($i,tovarcod)] {
                if ![ info exists NAKLPTOV_DATA($i,[expr 2 + $kol]) ] {
                    set NAKLPTOV_DATA($i,[expr 2 + $kol]) .00
                }
                if ![ info exists NAKLPTOV_DATA($i,[expr 3 + $kol]) ] {
                    set NAKLPTOV_DATA($i,[expr 3 + $kol]) .00
                }
                if { ![info exists NAKLPTOV_DATA($i,finoperpcod)] || 
                     ![info exists NAKLPTOV_DATA($i,matoperpcod)] } {
                    naklptov:insert $i
                } else { 
                    if { $NAKLPTOV_DATA($i,finoperpcod) <= 0 && 
                         $NAKLPTOV_DATA($i,matoperpcod) <= 0 } {
                        naklptov:insert $i
                    }
                    if { $NAKLPTOV_DATA($i,finoperpcod) > 0 || 
                         $NAKLPTOV_DATA($i,matoperpcod) > 0 } {
                        if { $NAKLP(pr) == "p" } {
                            if { $NAKLPTOV_DATA($i,old_tovarcod) != $NAKLPTOV_DATA($i,tovarcod) || \
                                 $NAKLPTOV_DATA($i,old_$kol) != $NAKLPTOV_DATA($i,$kol) || \
                                 $NAKLPTOV_DATA($i,old_[expr 2 + $kol]) != $NAKLPTOV_DATA($i,[expr 2 + $kol]) || \
                                 $NAKLPTOV_DATA($i,old_[expr 3 + $kol]) != $NAKLPTOV_DATA($i,[expr 3 + $kol]) || \
                                 ![info exists NAKLPTOV_DATA($i,1)] || \
                                 $NAKLPTOV_DATA($i,old_1) != $NAKLPTOV_DATA($i,1) } {
                                naklptov:update $i
                            }
                        } else {
                            if { $NAKLPTOV_DATA($i,old_1) != $NAKLPTOV_DATA($i,1) || \
                                 $NAKLPTOV_DATA($i,old_3) != $NAKLPTOV_DATA($i,3) || \
                                 $NAKLPTOV_DATA($i,old_4) != $NAKLPTOV_DATA($i,4) } {
                                naklptov:update $i
                            }
                        }
                    }
                }
            } else break
            incr i
        }
    }
    if { $NAKLP(operaciacod) == $STT(zaimtocod) || \
         $NAKLP(operaciacod) == $STT(pzaimtocod) || \
         $NAKLP(operaciacod) == $STT(zaimfromcod) || \
         $NAKLP(operaciacod) == $STT(pzaimfromcod) || \
         $NAKLP(operaciacod) == $STT(gklp1cod) || \
         $NAKLP(operaciacod) == $STT(gklp2cod) || \
         $NAKLP(operaciacod) == $STT(gklr1cod) || \
         $NAKLP(operaciacod) == $STT(gklr2cod) || \
         $NAKLP(operaciacod) == $STT(gpsr1cod) || \
         $NAKLP(operaciacod) == $STT(gpsr2cod) || \
         $NAKLP(operaciacod) == $STT(gpsp1cod) || \
         $NAKLP(operaciacod) == $STT(gpsp2cod) \
       } {
        zaim:ok
    }
    set VS($NAKLP(inwin).naklp_update) 0
}

proc naklp:whomathtov {} {
    global NAKLPTOV_DATA NAKLPTOV NAKLP
    
    if [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod)] {
        whomathtov $NAKLP(inwin).naklp $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)
    }
}

proc naklp:naklropl {} {
    global NAKLP
    
    docopl $NAKLP(inwin).naklp n $NAKLP(cod)
}

proc naklp:naklrrez {} {
    global NAKLP
    
    spisanie r $NAKLP(inwin).naklp i
}

proc naklp:naklrotg {} {
    global NAKLP
    
    spisanie o $NAKLP(inwin).naklp i
}

proc naklp:controlu {} {
    global NAKLP NAKLPTOV NAKLPTOV_DATA
    
    switch -regexp [focus] {
        \.naklp\.head {
            if [info exists NAKLP(cod)] { 
                if { $NAKLP(pr) == "p" } {
                    controlu $NAKLP(cod) naklp 
                } else {
                    controlu $NAKLP(cod) naklr
                }
            }
        }
        \.naklp\.tov {
            if { $NAKLP(tip) == "f" } {
                catch [set cod $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod)]
            } else {
                catch [set cod $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod)]
            }
            if [info exists cod] { 
                if { $NAKLP(pr) == "p" } {
                    if { $NAKLP(tip) == "f" } {
                        controlu $cod finoperp
                    } else {
                        controlu $cod matoperp
                    }
                } else {
                    controlu $cod naklrtov
                }
            }
        }
    }
}
