proc naklplist { pr tip } {
    global VS NAKLPLIST NAKLPLIST_DATA NAKLP NAKLPTOV NAKLPTOV_DATA

    catch [unset NAKLPLIST NAKLPLIST_DATA NAKLP NAKLPTOV NAKLPTOV_DATA]
    set NAKLPLIST(listbox,curselection) 0
    set NAKLPLIST(find) ""
    set NAKLPLIST(tip) $tip
    set NAKLPLIST(pr)  $pr
    set lw 96
    switch $tip {
        "n" { set titstr "" }
        "f" { 
            if { $VS(login) == "buh" } {
                set titstr ""
            } else {
                set titstr " "
            }
            set lw 86
        }
        "m" { set titstr " " }
    }
    switch $pr {
        "p" { set titpr "" }
        "r" { set titpr "" }
    }
    set w .naklplist
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +$wmx+55
    wm geometry $w =0x0
    wm title $w "$titstr   $titpr"
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "naklplist:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "naklplist:insert"
    $w1.1 add command -label "" -command "naklplist:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable NAKLPLIST(sortstr) -value "num" -command naklplist:read
        $w1.1.sort add radio -label " " -variable NAKLPLIST(sortstr) -value "dat" -command naklplist:read
        if { $NAKLPLIST(pr) == "p" } {
            $w1.1.sort add radio -label "  " -variable NAKLPLIST(sortstr) -value "d.nam" -command naklplist:read
        } else {
            $w1.1.sort add radio -label "  " -variable NAKLPLIST(sortstr) -value "d.nam" -command naklplist:read
        }
        $w1.1.sort add radio -label "  " -variable NAKLPLIST(sortstr) -value "b.nam" -command naklplist:read
        $w1.1.sort add radio -label "  " -variable NAKLPLIST(sortstr) -value "c.nam" -command naklplist:read
        $w1.1.sort add radio -label " " -variable NAKLPLIST(sortstr) -value "summa1" -command naklplist:read
        if { $NAKLPLIST(tip) != "f" } {
            $w1.1.sort add radio -label " " -variable NAKLPLIST(sortstr) -value "summa2" -command naklplist:read
        }
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable NAKLPLIST(sortdesc) -value " " -command naklplist:read
        $w1.1.sort add radio -label " " -variable NAKLPLIST(sortdesc) -value "desc" -command naklplist:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command "naklplist:naklp 0"
    $w1.1 add command -state disabled -accelerator "<Enter>" -label "" -command "naklplist:naklp 1"
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set NAKLPLIST(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set NAKLPLIST(deletestatus) 1; naklplist:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -font $VS(fontm) -textvariable NAKLPLIST(statusline) -relief sunken -anchor w -width 112 -bg grey95 -fg blue4
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    #pack $w.buttons.exit $w.buttons.lm $w.buttons.help -side left -padx 3
    pack $w.buttons.lm
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view  update  delete  exit } {
        if { $i == "insert" } { findbox naklplist 60 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text " $titstr   $titpr " -relief raised -anchor center -bd 1 -padx 3
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 6
    if { $NAKLPLIST(pr) == "p" } {
        label $w.namefield.p3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 25
    } else {
        label $w.namefield.p3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 25
    }
    label $w.namefield.p4 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 15
    label $w.namefield.p41 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 15
    label $w.namefield.p5 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 12
    if { $NAKLPLIST(tip) != "f" } {
        label $w.namefield.p6 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 12
    }
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    pack $w.namefield.p1 $w.namefield.p2 $w.namefield.p3 $w.namefield.p4 $w.namefield.p41 $w.namefield.p5 -side left
    if { $NAKLPLIST(tip) != "f" } {
        pack $w.namefield.p6 -side left
    }
    frame $w.lb
    frame $w.itogo
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 21 -width $lw
    label $w.itogo.l1 -text "                                                    :"
    label $w.itogo.snaklp1 -textvar NAKLPLIST(snaklp1) -bd 1 -relief sunken -anchor e -width 11
    if { $NAKLPLIST(tip) != "f" } {
        label $w.itogo.l2 -text ""
        label $w.itogo.snaklp2 -textvar NAKLPLIST(snaklp2) -bd 1 -relief sunken -anchor e -width 11
    }
    pack $w.itogo.l1 $w.itogo.snaklp1 -side left
    if { $NAKLPLIST(tip) != "f" } {
        pack $w.itogo.l2 $w.itogo.snaklp2 -side left
    }
    
    pack $w.lb $w.itogo -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    naklplist:read
    
    bind $w.butimg.delete <Button-1> {
        .naklplist.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        .naklplist.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .naklplist.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        if [info exists NAKLPLIST_DATA(num,$id)] {
            set NAKLPLIST(statusline) [format "%%-50s %%-30s %%-30s" $NAKLPLIST_DATA(klientnam,$id) $NAKLPLIST_DATA(skladnam,$id) $NAKLPLIST_DATA(operacianam,$id)]
        }
        set NAKLPLIST(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .naklplist.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  } {
            .naklplist.menu.1 entryconfigure [.naklplist.menu.1 index $j] -state disabled
            .naklplist.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { print  view  update  delete  } {
            .naklplist.menu.1 entryconfigure [.naklplist.menu.1 index $j] -state normal
            .naklplist.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists NAKLPLIST_DATA(cod,$NAKLPLIST(listbox,curselection))] {
            naklplist:naklp 1
        }
    }
    bind $w <Key-Escape> { .naklplist.buttons.exit invoke }
    bind $w <Key-Insert> { naklplist:insert }
    bind $w <Key-F5>     { naklplist:find }
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists NAKLPLIST_DATA(cod,$NAKLPLIST(listbox,curselection))] {
            naklplist:naklp 1
        }
    }
    bind $w.lb.listbox <KeyRelease> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        if [info exists NAKLPLIST_DATA(num,$id)] {
            set NAKLPLIST(statusline) [format "%%-50s %%-30s %%-30s" $NAKLPLIST_DATA(klientnam,$id) $NAKLPLIST_DATA(skladnam,$id) $NAKLPLIST_DATA(operacianam,$id)]
            #set NAKLPLIST(statusline) "$NAKLPLIST_DATA(klientnam,$id) $NAKLPLIST_DATA(skladnam,$id) $NAKLPLIST_DATA(operacianam,$id)"
        }
    }
    focus $w.lb.listbox
}

proc naklplist:cor {} {
    global NAKLPLIST NAKLPLIST_DATA NAKLP NAKLPTOV NAKLPTOV_DATA 

    set w .naklplist.lb.listbox
    set id $NAKLPLIST(listbox,curselection)
    if [winfo exists $w] {
        $w delete $id $id
        if { $NAKLPTOV(scena1) < 0 } {
            set NAKLPTOV(scena1) 0
        }
        if { $NAKLPTOV(scena2) < 0 } {
            set NAKLPTOV(scena2) 0
        }
        regsub -all "\\." $NAKLP(dat) "" NAKLP(dat)
        if { [string length $NAKLP(dat)] == 8 } {
            set md $NAKLP(dat)
            set NAKLP(dat) [string range $md 0 3][string range $md 6 7]
        }
        set NAKLPLIST_DATA(num,$id)       $NAKLP(num)
        set NAKLPLIST_DATA(dat,$id)       $NAKLP(dat)
        set NAKLPLIST_DATA(klientnam,$id) $NAKLP(klientnam)
        set NAKLPLIST_DATA(skladnam,$id)  $NAKLP(skladnam)
        set NAKLPLIST_DATA(operacianam,$id)  $NAKLP(operacianam)
        set NAKLPLIST_DATA(summa1,$id)    $NAKLPTOV(scena1)
        set NAKLPLIST_DATA(summa2,$id)    $NAKLPTOV(scena2)
        set NAKLPLIST(statusline) [format "%-50s %-30s %-30s" $NAKLPLIST_DATA(klientnam,$id) $NAKLPLIST_DATA(skladnam,$id) $NAKLPLIST_DATA(operacianam,$id)]
        if { $NAKLP(pr) == "r" } {
             $w insert $id [format "%10.0f %-6s %-25.25s %-15.15s %-15.15s %10.2f %9.2f" \
                     $NAKLPLIST_DATA(num,$id) \
                     $NAKLPLIST_DATA(dat,$id) \
                     $NAKLPLIST_DATA(klientnam,$id) \
                     $NAKLPLIST_DATA(skladnam,$id) \
                     $NAKLPLIST_DATA(operacianam,$id) \
                     $NAKLPLIST_DATA(summa1,$id) \
                     $NAKLPLIST_DATA(summa2,$id)]
        } else {
            $w insert $id [format "%-10s %-6s %-25.25s %-15.15s %-15.15s %10.2f %9.2f" \
                     $NAKLPLIST_DATA(num,$id) \
                     $NAKLPLIST_DATA(dat,$id) \
                     $NAKLPLIST_DATA(klientnam,$id) \
                     $NAKLPLIST_DATA(skladnam,$id) \
                     $NAKLPLIST_DATA(operacianam,$id) \
                     $NAKLPLIST_DATA(summa1,$id) \
                     $NAKLPLIST_DATA(summa2,$id)]
        }
        $w selection set $id $id
        naklplist:summa
    }
    $w selection set $id $id
    $w activate $id
}

proc naklplist:naklp { st } {
    global NAKLPLIST NAKLPLIST_DATA
    
    naklp $st $NAKLPLIST(tip) $NAKLPLIST_DATA(cod,$NAKLPLIST(listbox,curselection)) .naklplist
    tkwait window .naklplist.naklp
    naklplist:cor
}

proc naklplist:entry:createvar {} {
    global NAKLPLIST
    
    foreach i { num dat klientnam skladnam operacianam summa1 summa2 tovarnam \
                kol cena cenad gashdat } {
        if ![info exists NAKLPLIST(entry,$i)] {
            set NAKLPLIST(entry,$i) ""
        }
    }
}

proc naklplist:entry:clearvar {} {
    global NAKLPLIST
    
    foreach i { num dat klientnam skladnam operacianam summa1 summa2 tovarnam \
                kol cena cenad gashdat } {
        set NAKLPLIST(entry,$i) ""
    }
}

proc naklplist:entry {} {
    global VS NAKLPLIST
    
    set w .naklplist.entry
    set NAKLPLIST(entrystatus) ""
    naklplist:entry:createvar
    naklplist:entry:clearvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+155
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { num dat klient sklad operacia summa1 summa2 tovar kol cena cenad gash } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "summa2" || $i == "cenad" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    if { $NAKLPLIST(pr) == "p" } {
        set klnnam "          "
    } else {
        set klnnam "             "
    }
    foreach { i j } { num      "                " \
                      dat      "                 " \
                      klient   "            " \
                      sklad    "                " \
                      operacia " " \
                      summa1   "                " \
                      summa2   "                " \
                      tovar    "   " \
                      kol      "           " \
                      cena     "                 " \
                      cenad    "                 " \
                      gash     "        : " \
                  } {
        if { $i == "summa2" || $i == "cenad" || $i == "gash" } {
            if { $NAKLPLIST(tip) != "f" } {
                label $w.inf.$i.l -text $j
                pack $w.inf.$i.l -side left
            }
        } else {
            if { $NAKLPLIST(pr) == "r" && $i == "klient" } {
                set j "               "
            }
            label $w.inf.$i.l -text $j
            pack $w.inf.$i.l -side left
        }
    }
    foreach { i j k } {num      num         20 \
                       dat      dat         20 \
                       klient   klientnam   50 \
                       sklad    skladnam    30 \
                       operacia operacianam 30 \
                       summa1   summa1      20 \
                       summa2   summa2      20 \
                       tovar    tovarnam    50 \
                       kol      kol         15 \
                       cena     cena        20 \
                       cenad    cenad       20 \
                       gash     gashdat     20 \
                       } {
        if { $i == "summa2" || $i == "cenad" || $i == "gash" } {
            if { $NAKLPLIST(tip) != "f" } {
                entry $w.inf.$i.e -textvariable NAKLPLIST(entry,$j) -width $k
            }
        } else {
            entry $w.inf.$i.e -textvariable NAKLPLIST(entry,$j) -width $k
        }
    }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { naklplist:heklient r .naklplist.entry }
    button $w.inf.sklad.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { naklplist:hesklad r .naklplist.entry }
    button $w.inf.operacia.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { naklplist:heoperacia r .naklplist.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { naklplist:hetovar r .naklplist.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set NAKLPLIST(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "naklplist:entry:clearvar"
    button $w.buttons.exit -text "" -command "set NAKLPLIST(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e klient.e klient.b sklad.e sklad.b operacia.e operacia.b \
                summa1.e summa2.e tovar.e tovar.b kol.e cena.e cenad.e \
                gash.e
              } {
        if { $i == "summa2.e" || $i == "cenad.e" || $i == "gash.e" } {
            if { $NAKLPLIST(tip) != "f" } {
                pack $w.inf.$i -side left
            }
        } else {
            pack $w.inf.$i -side left
        }
    }
    focus $w.inf.num.e
    bind $w <Key-Escape>     { .naklplist.entry.buttons.exit invoke }
    bind $w <Control-Return> { .naklplist.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

