proc naklplist:summa {} {
    global NAKLPLIST NAKLPLIST_DATA
    
    set i 0
    set NAKLPLIST(snaklp1) 0
    set NAKLPLIST(snaklp2) 0
    while { $i <= $NAKLPLIST(listbox,count) } {
        set NAKLPLIST(snaklp1) [expr $NAKLPLIST(snaklp1) + $NAKLPLIST_DATA(summa1,$i)]
        set NAKLPLIST(snaklp2) [expr $NAKLPLIST(snaklp2) + $NAKLPLIST_DATA(summa2,$i)]
        incr i
    }
}

proc naklplist:read { } {
    global VS NAKLPLIST NAKLPLIST_DATA
    
    set w .naklplist.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset NAKLPLIST_DATA]    
    #   
    set dat1 [clock format [expr $VS(clock) - 1209600 ] -format %d/%m/%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 604800 ] -format %d/%m/%Y]
    if { $NAKLPLIST(sortstr) == "" }    { set NAKLPLIST(sortstr) "dat" } 
    if { $NAKLPLIST(sortdesc) == "" }   { set NAKLPLIST(sortdesc) " "  }
    if { $NAKLPLIST(find) == "" } {
        set NAKLPLIST(find) "dat >= '$dat1' and dat <= '$dat2'"
        if [info exists NAKLPLIST(find,listbox)] {
            if { [lsearch -exact $NAKLPLIST(find,listbox) $NAKLPLIST(find)] == -1} {
                lappend NAKLPLIST(find,listbox) $NAKLPLIST(find)
            }
        } else {
            lappend NAKLPLIST(find,listbox) $NAKLPLIST(find)
        }
    } 
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "naklplist_sel $NAKLPLIST(pr) $NAKLPLIST(tip) \"$NAKLPLIST(find)\" \"$NAKLPLIST(sortstr) $NAKLPLIST(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set NAKLPLIST_DATA(cod,$i) "";  set NAKLPLIST_DATA(num,$i) ""
            set NAKLPLIST_DATA(dat,$i) "";  set NAKLPLIST_DATA(klientnam,$i) ""
            set NAKLPLIST_DATA(skladnam,$i) "";  set NAKLPLIST_DATA(summa1,$i) ""
            set NAKLPLIST_DATA(summa2,$i) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                NAKLPLIST_DATA(cod,$i) \
                NAKLPLIST_DATA(num,$i) \
                NAKLPLIST_DATA(dat,$i) \
                NAKLPLIST_DATA(klientnam,$i) \
                NAKLPLIST_DATA(skladnam,$i) \
                NAKLPLIST_DATA(operacianam,$i) \
                NAKLPLIST_DATA(summa1,$i) \
                NAKLPLIST_DATA(summa2,$i)
            if { $NAKLPLIST(pr) == "r" } {
                $w insert end [format "%10.0f %-6s %-25.25s %-15.15s %-15.15s %10.2f %9.2f" \
                    $NAKLPLIST_DATA(num,$i) \
                    $NAKLPLIST_DATA(dat,$i) \
                    $NAKLPLIST_DATA(klientnam,$i) \
                    $NAKLPLIST_DATA(skladnam,$i) \
                    $NAKLPLIST_DATA(operacianam,$i) \
                    $NAKLPLIST_DATA(summa1,$i) \
                    $NAKLPLIST_DATA(summa2,$i)]
            } else {
                $w insert end [format "%-10s %-6s %-25.25s %-15.15s %-15.15s %10.2f %9.2f" \
                    $NAKLPLIST_DATA(num,$i) \
                    $NAKLPLIST_DATA(dat,$i) \
                    $NAKLPLIST_DATA(klientnam,$i) \
                    $NAKLPLIST_DATA(skladnam,$i) \
                    $NAKLPLIST_DATA(operacianam,$i) \
                    $NAKLPLIST_DATA(summa1,$i) \
                    $NAKLPLIST_DATA(summa2,$i)]
            }
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set NAKLPLIST(statusline) " $i ."
        }
        set NAKLPLIST(listbox,count) [expr $i - 1]
        naklplist:summa
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    update
}

proc naklplist:delete {} {
    global VS NAKLPLIST NAKLPLIST_DATA
    
    set w .naklplist.lb.listbox
    if { $NAKLPLIST(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $NAKLPLIST(listbox,curselection)
            puts $socks "naklp_del $NAKLPLIST(pr) $NAKLPLIST_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {}
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            naklplist:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $NAKLPLIST(listbox,count)} {
            set id $NAKLPLIST(listbox,count)
            set NAKLPLIST(listbox,curselection) $NAKLPLIST(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set NAKLPLIST(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set NAKLPLIST(deletestatus) 0
}

proc naklplist:print {} {
    global VS NAKLPLIST

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "naklplist_rep $NAKLPLIST(pr) $NAKLPLIST(tip) \"$NAKLPLIST(find)\" \"$NAKLPLIST(sortstr) $NAKLPLIST(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc naklplist:find {} {
    global VS NAKLPLIST
    
    naklplist:entry
    if { $NAKLPLIST(entrystatus) == 1 } {
        set NAKLPLIST(find) "1=1"
        foreach {i j} " \"$NAKLPLIST(entry,num)\" num \
                        \"$NAKLPLIST(entry,dat)\" dat \
                        \"$NAKLPLIST(entry,klientnam)\" d.nam \
                        \"$NAKLPLIST(entry,skladnam)\" b.nam \
                        \"$NAKLPLIST(entry,operacianam)\" c.nam \
                        \"$NAKLPLIST(entry,summa1)\" summa1 \
                        \"$NAKLPLIST(entry,summa2)\" summa2 \
                       " {
            if { $i != "" } {
                set NAKLPLIST(find) "$NAKLPLIST(find) and $j [construct $i]"
            }    
        }
        if { [string length [clipped $NAKLPLIST(entry,tovarnam)]] > 0 || \
             [string length [clipped $NAKLPLIST(entry,kol)]] > 0 || \
             [string length [clipped $NAKLPLIST(entry,cena)]] > 0 || \
             [string length [clipped $NAKLPLIST(entry,gashdat)]] > 0 || \
             [string length [clipped $NAKLPLIST(entry,cenad)]] > 0 } {
            naklplist:find:podzapros
        }
        if { [lsearch -exact $NAKLPLIST(find,listbox) $NAKLPLIST(find)] == -1} {
            lappend NAKLPLIST(find,listbox) $NAKLPLIST(find)
        }
        naklplist:read
    }
    set NAKLPLIST(entrystatus) 0
}

proc naklplist:find:podzapros {} {
    global NAKLPLIST
    
    if { [string length [clipped $NAKLPLIST(entry,tovarnam)]] > 0 || \
         [string length [clipped $NAKLPLIST(entry,kol)]] > 0 || \
         [string length [clipped $NAKLPLIST(entry,cena)]] > 0 || \
         [string length [clipped $NAKLPLIST(entry,cenad)]] > 0 } {
        if { $NAKLPLIST(tip) == "f" } {
            set str_sel "select x1.cod from finoperp x1, tovar x2 where x1.tovar_cod = x2.cod and x1.naklp_cod = a.cod and x1.doc_cod = a.cod"
        } else {
            if { $NAKLPLIST(pr) == "p" } {
                set str_sel "select x1.cod from matoperp x1, tovar x2 where x1.tovar_cod = x2.cod and x1.naklp_cod = a.cod and x1.doc_cod = a.cod"
            } else {
                set str_sel "select x1.cod from naklrtov x1, tovar x2 where x1.tovar_cod = x2.cod and x1.naklr_cod = a.cod and x1.doc_cod = a.cod"
            }
        }
        foreach {i j} " \"$NAKLPLIST(entry,tovarnam)\"  x2.nam \
                        \"$NAKLPLIST(entry,kol)\"       x1.kol \
                        \"$NAKLPLIST(entry,cena)\"      x1.cena \
                        \"$NAKLPLIST(entry,cenad)\"     x1.cenad \
                       " {
            if { $i != "" } {
                set str_sel "$str_sel and $j [construct $i]"
            }    
        }
        set NAKLPLIST(find) "$NAKLPLIST(find) and exists ($str_sel)"
    }
    
    # 
    if { [string length [clipped $NAKLPLIST(entry,gashdat)]] > 0 } {
        set str_sel "select x8.master_cod from zaimlink x8, naklr x9 where x9.cod = x8.slave_cod"
        foreach {i j} " \"$NAKLPLIST(entry,gashdat)\"      x9.dat \
                      " {
            if { $i != "" } {
                set str_sel "a.cod in ($str_sel and $j [construct $i])"
            }    
        }
        set NAKLPLIST(find) "$NAKLPLIST(find) and ($str_sel"
        set str_sel "select x10.master_cod from garlink x10, naklr x11 where x10.slave_cod = x11.cod"
        foreach {i j} " \"$NAKLPLIST(entry,gashdat)\"      x11.dat \
                      " {
            if { $i != "" } {
                set str_sel "or a.cod in ($str_sel and $j [construct $i])"
            }    
        }
        set NAKLPLIST(find) "$NAKLPLIST(find) $str_sel)"
    } 
}

proc naklplist:heklient { tip win } {
    global VS NAKLPLIST HE
    
    set w .naklplist.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 postpol $NAKLPLIST(entry,klientnam) $tip $win
    set NAKLPLIST(entry,klientcod) $HE(cod)
    set NAKLPLIST(entry,klientnam) [clipped $HE(nam)]
}

proc naklplist:hesklad { tip win } {
    global VS NAKLPLIST HE
    
    set w .naklplist.entry.inf.sklad.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $NAKLPLIST(entry,skladnam) $tip $win
    set NAKLPLIST(entry,skladcod) $HE(cod)
    set NAKLPLIST(entry,skladnam) [clipped $HE(nam)]
}

proc naklplist:hetovar { tip win } {
    global VS NAKLPLIST HE
    
    set w .naklplist.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $NAKLPLIST(entry,tovarnam) $tip $win
    set NAKLPLIST(entry,tovarcod) $HE(cod)
    set NAKLPLIST(entry,tovarnam) [clipped $HE(nam)]
}

proc naklplist:heoperacia { tip win } {
    global NAKLPLIST HE
    
    set w .naklplist.entry.inf.operacia.e
    set HE(tit) "   "
    set prgnam "operaciap"
    if { $NAKLPLIST(pr) == "r" } {
        set HE(tit) "   "
        set prgnam "operaciar"
    }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 $prgnam $NAKLPLIST(entry,operacianam) $tip $win
    set NAKLPLIST(entry,operaciacod)      $HE(cod)
    set NAKLPLIST(entry,operacianam)      [clipped $HE(nam)]
}

proc naklplist:insert {} {
    global NAKLPLIST NAKLPLIST_DATA SCHET NAKLP

    set w .naklplist.lb.listbox
    naklp 1 $NAKLPLIST(tip) 0 .naklplist
    tkwait window .naklplist.naklp
    if { $NAKLP(cod) > 0 } {
        set id [expr $NAKLPLIST(listbox,count) + 1]
        set NAKLPLIST(listbox,curselection) $id
        set NAKLPLIST_DATA(cod,$id) $NAKLP(cod)
        naklplist:cor
    }
}


