proc naklptov:summa { flg } {
    global NAKLPTOV NAKLPTOV_DATA NAKLP
    
    set kol 1
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } { set kol 2 }
    if { $flg == 1 ||
         $NAKLPTOV(old_ActiveCol) == $kol ||
         $NAKLPTOV(old_ActiveCol) == [expr $kol + 2] ||
         $NAKLPTOV(old_ActiveCol) == [expr $kol + 3] } {
        set i 0
        set NAKLPTOV(skol) 0
        set NAKLPTOV(stovkol) 0
        set NAKLPTOV(scena1) 0
        set NAKLPTOV(scena2) 0
        while { [info exists NAKLPTOV_DATA($i,$kol)] } {
            catch [set NAKLPTOV(skol) [expr $NAKLPTOV(skol) + $NAKLPTOV_DATA($i,$kol)]]
            catch [set NAKLPTOV(scena1) [expr $NAKLPTOV(scena1) + $NAKLPTOV_DATA($i,$kol) * $NAKLPTOV_DATA($i,[expr 2 + $kol])]]
            if [info exists NAKLPTOV_DATA($i,[expr 3 + $kol])] {
                catch [set NAKLPTOV(scena2) [expr $NAKLPTOV(scena2) + $NAKLPTOV_DATA($i,$kol) * $NAKLPTOV_DATA($i,[expr 3 + $kol])]]
            }
            if { [info exists NAKLPTOV_DATA($i,tovarcod)] && \
                 [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod)] && \
                 $NAKLPTOV_DATA($i,tovarcod) == $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) } {
                catch [set NAKLPTOV(stovkol) [expr $NAKLPTOV(stovkol) + $NAKLPTOV_DATA($i,$kol)]]
            }
            incr i
        }
    }
}

proc naklptov:browsecommand { rowcol } {
    global NAKLPTOV NAKLPTOV_DATA NAKLP
    
    set w $NAKLP(inwin).naklp.tov
    if { [info exists NAKLPTOV(ActiveRow)] && \
         $NAKLPTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $NAKLPTOV(ActiveRow)
    }
    
    # after tovarnam
    if { [ info exists NAKLPTOV(ActiveRow) ] && $NAKLPTOV(ActiveRow) >=0 } {
        if { [ info exists NAKLPTOV(ActiveCol) ] && $NAKLPTOV(ActiveCol) == 0 } {
            if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_0)] { 
                set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_0) "" 
            }
            if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) ] { 
                set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) "" 
            }
            if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_0) != $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) && \
                 $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) != "" } {
                if { $NAKLP(pr) == "p" } {
                    naklptov:hetovarnam u $NAKLP(inwin).naklp.tov
                } else {
                    if ![info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod)] {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod) 0
                    }
                    if ![info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod)] {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod) 0
                    }
                    if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod) > 0 || \
                         $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod) > 0 } {
                        errormsg nosocks " !!!    .  ,   ."
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_0)
                    } else {
                        naklptov:hetovarnam u $NAKLP(inwin).naklp.tov
                    }
                }
            }
        }
    }
    
    # after kol
    set kol 1
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } { set kol 2 }
    if { [ info exists NAKLPTOV(ActiveRow) ] && $NAKLPTOV(ActiveRow) >=0 } {
        if { [ info exists NAKLPTOV(ActiveCol) ] && $NAKLPTOV(ActiveCol) == $kol } {
            if ![info exist NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$kol)] {
                set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$kol) {}
            }
            if { ( $NAKLP(tip) == "m" || $NAKLP(tip) == "n") &&
                 [ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),issernum) ] &&
                 $NAKLP(pr) == "p" } {
                if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),issernum) == "*" && \
                     $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$kol) != 1 && \
                     $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$kol) != "" } {
                    errormsg nosocks " !!!          ."
                    set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$kol) 1
                }
            }
            #if { $NAKLP(pr) == "r" } {
            #    if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_1) ] { 
            #        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_1) {}
            #    }
            #    if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_1) != $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) } {
            #        if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),kol) ] { 
            #            set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),kol) {}
            #        }
            #        if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod) ] { 
            #            set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod) 0 
            #        }
            #        if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod) > 0 } {
            #            if { [whattovarkol $NAKLP(tip) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod)] < \
            #                 [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) - $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_1)] } {
            #                errormsg nosocks " !!!       ."
            #                set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_1)
            #            }
            #        } else {
            #            if { $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),kol) < $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) } {
            #                errormsg nosocks " !!!       ."
            #                set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),kol)
            #            }
            #        }
            #    }
            #}
        }
    }
    
    # after cena
    set cen 3
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } { set cen 4 }
    if { $NAKLP(pr) == "p" } {
        if ![ info exists NAKLPTOV_DATA(old_cena) ] { set NAKLPTOV_DATA(old_cena) "" }
        if { [ info exists NAKLPTOV(ActiveCol) ] && $NAKLPTOV(ActiveCol) == $cen } {
            if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cen) ] { set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cen) "" }
            if { $NAKLPTOV_DATA(old_cena) != $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cen) } {
                if { $NAKLP(kurs) > 0 } {
                    if ![info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cen + 1])] {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cen + 1]) [format "%.2f" [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cen) / $NAKLP(kurs)]]
                    } elseif { [clipped $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cen + 1])] == "" } {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cen + 1]) [format "%.2f" [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cen) / $NAKLP(kurs)]]
                    }
                }
            }
        }
    }
    
    # after cenad
    set cend 4
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } { set cend 5 }
    if { $NAKLP(pr) == "p" } {
        if ![ info exists NAKLPTOV_DATA(old_cenad) ] { set NAKLPTOV_DATA(old_cenad) "" }
        if { [ info exists NAKLPTOV(ActiveCol) ] && $NAKLPTOV(ActiveCol) == $cend } {
            if ![ info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cend) ] { set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cend) "" }
            if { $NAKLPTOV_DATA(old_cenad) != $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cend) } {
                if { $NAKLP(kurs) > 0 } {
                    if ![info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cend - 1])] {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cend - 1]) [format "%.2f" [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cend) * $NAKLP(kurs)]]
                    } elseif { [clipped $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cend - 1])] == "" } {
                        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr $cend - 1]) [format "%.2f" [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),$cend) * $NAKLP(kurs)]]
                    }
                }
            }
        }
    }
    
    set NAKLPTOV(ActiveRowCol) $rowcol 
    if [info exists NAKLPTOV(ActiveCol)] {
        set NAKLPTOV(old_ActiveCol) $NAKLPTOV(ActiveCol)
    } else {
        set NAKLPTOV(old_ActiveCol) 0
    }
    scan $NAKLPTOV(ActiveRowCol) "%\[^,]%*c%s" NAKLPTOV(ActiveRow) NAKLPTOV(ActiveCol)
    
    # before tovarnam
    if { $NAKLPTOV(ActiveCol) == 0 } {
        if [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)] {
            set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),old_0) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)
        }
    }
    naklptov:summa 0
    if { $NAKLPTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $NAKLPTOV(ActiveRow)
    }
}

proc naklptov {} {
    global VS NAKLPTOV NAKLPTOV_DATA NAKLPTOV NAKLP
    
    set NAKLPTOV(rows) 9
    set w $NAKLP(inwin).naklp.tov
    set NAKLPTOV(width) 5
    set NAKLPTOV(cols) 5
    
    if { $NAKLP(tip) == "f" } {
        set NAKLPTOV(width) 4
        set NAKLPTOV(cols) 4
    }
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } {
        set NAKLPTOV(width) 6
        set NAKLPTOV(cols) 6
    }
    
    frame $w.itogo
    frame $w.curfldval
    entry $w.curfldval.e -width 50 -textvar NAKLPTOV_DATA(active) -fg red -bg #fffff0
    label $w.tut -bg gray70 -wraplength 1 -font $VS(fontn) -width 2 -height 5 -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    pack $w.curfldval -anchor nw
    pack $w.curfldval.e -side left
    pack $w.itogo -side bottom -fill x
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width $NAKLPTOV(width) -height 9 -cols $NAKLPTOV(cols) \
        -rows $NAKLPTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable NAKLPTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { naklptov:browsecommand %S } \
        -wrap on
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } {
        $w.tbl tag col AnchorCenter 3 
        $w.tbl tag col Disabled 3
        $w.tbl tag col AnchorE 2 4 5
    } else {
        $w.tbl tag col AnchorCenter 2 
        $w.tbl tag col Disabled 2
        $w.tbl tag col AnchorE 1 3 4
    }
    $w.tbl tag row AnchorCenter -1
    if { $NAKLP(tip) == "f" } {
        $w.tbl width 0 50 1 8 2 10 3 10
    } else {
        $w.tbl width 0 52 1 8 2 10 3 10 4 10
    }
    if { $NAKLP(tip) == "m" && $NAKLP(pr) == "p" } {
        $w.tbl width 0 32 1 20 2 8 3 10 4 10 5 10
    }
    
    label $w.itogo.l1 -text "                        :"
    label $w.itogo.stovkol -textvar NAKLPTOV(stovkol) -bd 1 -relief sunken -anchor e -width 8 -bg green4 -fg cyan
    label $w.itogo.l11 -text "           "
    label $w.itogo.skol -textvar NAKLPTOV(skol) -bd 1 -relief sunken -anchor e -width 8 -bg gray40 -fg cyan
    label $w.itogo.l2 -text "          "
    label $w.itogo.scena1 -textvar NAKLPTOV(scena1) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    if { $NAKLP(tip) != "f" } {
        label $w.itogo.l3 -text ""
        label $w.itogo.scena2 -textvar NAKLPTOV(scena2) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    }
    foreach i { l1 stovkol l11 skol l2 scena1 } {
        pack $w.itogo.$i -side left
    }
    if { $NAKLP(tip) != "f" } {
        foreach i { l3 scena2 } {
            pack $w.itogo.$i -side left
        }
    }
    
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } {
        bind $w.tbl <Control-KeyRelease-Insert> {
            naklptov:instovrow
        }
    }
    if { $NAKLP(cod) != 0 } { focus $w.tbl }
}

proc naklptov:instovrow {} {
    global NAKLP NAKLPTOV_DATA NAKLPTOV
    
    set w $NAKLP(inwin).naklp.tov.tbl
    if { [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod)] && \
         $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) > 0 } {
        set id [naklptov:whatcolsdata]
        set NAKLPTOV_DATA($id,tovarcod) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod)
        set NAKLPTOV_DATA($id,0)        $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)
        set NAKLPTOV_DATA($id,1)        {}
        set NAKLPTOV_DATA($id,2)        $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),2)
        set NAKLPTOV_DATA($id,3)        $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3)
        set NAKLPTOV_DATA($id,4)        $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),4)
        set NAKLPTOV_DATA($id,5)        $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),5)
        set NAKLPTOV_DATA($id,issernum) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),issernum)
        $w see $id,1
        $w activate $id,1
    }
}


proc naklptov:whatcolsdata {} {
    global NAKLPTOV_DATA
    
    set i 0
    while { [info exists NAKLPTOV_DATA($i,tovarcod)] } {
        incr i
    }
    return $i
}