proc nds:clear {} {
    global VS NDS_DATA NDS
    
    catch [unset NDS_DATA]
    set NDS_DATA(-1,0) ""
    set NDS_DATA(-1,1) ""

}

proc nds:read {} {
    global VS NDS_DATA NDS
    
    nds:clear
    set w .allcfg.dat.dat.tbl
    waiting "  ..." blue
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "nds_sel"
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set NDS_DATA($i,cod) ""
            set NDS_DATA($i,0) "";     set NDS_DATA($i,1) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                NDS_DATA($i,cod) NDS_DATA($i,0) NDS_DATA($i,1)
            set NDS_DATA($i,old_0)        $NDS_DATA($i,0)
            set NDS_DATA($i,old_1)        $NDS_DATA($i,1)
        }
        if [info exists NDS(ActiveRow)] { 
            if { $i < $NDS(ActiveRow) && $i >= 0 } { set NDS(ActiveRow) $i }
            $w see $NDS(ActiveRow),0
            $w activate $NDS(ActiveRow),$NDS(ActiveCol)
        }
        
        set NDS(rows) [expr $i + 2]
        if { $NDS(rows) < 11 } { set NDS(rows) 11 }
        $w configure -rows $NDS(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc nds:delete {} {
    global VS NDS NDS_DATA
    
    set w .allcfg.dat.dat.tbl
    if [info exists NDS(ActiveRow)] {
        if [info exists NDS_DATA($NDS(ActiveRow),cod)] {
            set NDS_DATA(active) ""
            $w tag row UnSelectRow $NDS(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $NDS(ActiveRow)
                waiting "  ..." red
                puts $socks "nds_del $NDS_DATA($NDS(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row Normal $NDS(ActiveRow)
                waiting "" ""
                nds:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc nds:insert { row } {
    global VS NDS_DATA NDS
    
    set w .allcfg.dat.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "nds_ins \"$NDS_DATA($row,0)\" \"$NDS_DATA($row,1)\" "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set NDS_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set NDS_DATA($row,old_0)        $NDS_DATA($row,0)
        set NDS_DATA($row,old_1)        $NDS_DATA($row,1)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc nds:update { row } {
    global VS NDS_DATA NDS SCHET
    
    set w .allcfg.dat.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "nds_upd \"$NDS_DATA($row,cod)\" \
                                  \"$NDS_DATA($row,0)\" \
                                  \"$NDS_DATA($row,1)\" "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set NDS_DATA($row,old_0)        $NDS_DATA($row,0)
        set NDS_DATA($row,old_1)        $NDS_DATA($row,1)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

