proc nnaklhead:clear {} {
    global NNAKL
    
    set NNAKL(cod) 0
    foreach i { num dat klientnam umova forma prim1 } {
        set NNAKL($i) ""
    }
    nnaklhead:old
}

proc nnaklhead:old {} {
    global NNAKL
    
    foreach i { num dat umova forma prim1 } {
        set NNAKL(old_$i)         $NNAKL($i)
    }
}

proc nnaklhead:update {} {
    global VS NNAKL

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ... " green
        puts $socks "nnakl_upd $NNAKL(cod) \
                               \"$NNAKL(num)\" \
                               \"$NNAKL(dat)\" \
                               \"$NNAKL(umova)\" \
                               \"$NNAKL(forma)\" \
                               \"$NNAKL(prim1)\" "
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "      !"
        } else {
            nnaklhead:old
        }

        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc nnaklhead:read {} {
    global VS NNAKL
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "nnakl_sel $NNAKL(cod)"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      NNAKL(klientcod) \
                      NNAKL(num) \
                      NNAKL(dat) \
                      NNAKL(klientnam) \
                      NNAKL(umova) \
                      NNAKL(forma) \
                      NNAKL(prim1)
        }
        set NNAKL(klientnam) [clipped $NNAKL(klientnam)]
        set NNAKL(umova)     [clipped $NNAKL(umova)]
        set NNAKL(forma)     [clipped $NNAKL(forma)]
        set NNAKL(prim1)     [clipped $NNAKL(prim1)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    nnaklhead:old
    waiting "" ""
}

proc nnakl:generate { st sofnrcod } {
    global VS SCHET
    
    if { $st == "finnaklr" } { set strst "" }
    if { $st == "schetopl" } { set strst "  " }
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "     $strst ..." magenta
        puts $socks "nnaklgenerate $SCHET(cod) $sofnrcod $st"
        flush $socks
    
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {}
       
        if { [ gets $socks ] != "0" } {
            errormsg $socks "       $strst !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc nnaklhead:print {} {
    global VS NNAKL NNAKLTOV SCHET

    set id ""
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "nnakl_rep $SCHET(cod) $NNAKL(cod) \"$NNAKLTOV(sortstr) $NNAKLTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [set str [ gets $socks ]] != $VS(sepdata) } {
            set id $str
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
    if { $id == "errklientnds" } {
        if [whatdoing "      ,     .    ?" $NNAKL(inwin).nnakl] {
            postpol:update schetfnr
        }
    }
}

