proc nnakltov:summa {} {
    global NNAKLTOV NNAKLTOV_DATA SCHETTOV NNAKL
    
    set w $NNAKL(inwin).nnakl.tov.itogo
    set i 0
    set NNAKLTOV(skol) 0
    set NNAKLTOV(sstnnakla) 0
    set NNAKLTOV(ssumma) 0
    set NNAKLTOV(sallnnakl) 0
    while { [info exists NNAKLTOV_DATA($i,1)] && [info exists NNAKLTOV_DATA($i,3)]} {
        catch [set NNAKLTOV(skol) [expr $NNAKLTOV(skol) + $NNAKLTOV_DATA($i,1)]]
        catch [set NNAKLTOV(sstnnakla) [expr $NNAKLTOV(sstnnakla) + $NNAKLTOV_DATA($i,5)]]
        catch [set NNAKLTOV(ssumma) [expr $NNAKLTOV(ssumma) + $NNAKLTOV_DATA($i,6)]]
        incr i
    }
    set NNAKLTOV(sallnnakl) [expr $NNAKLTOV(sstnnakla) + $NNAKLTOV(ssumma)]
    set id [expr $SCHETTOV(scena) - $NNAKLTOV(sallnnakl)]
    if { $id == 0 } { set color green }
    if { $id > 0 } { set color red }
    if { $id < 0 } { set color magenta }
    $w.2.sallnnakl configure -bg $color
}

proc nnakltov:browsecommand { rowcol } {
    global NNAKLTOV NNAKLTOV_DATA NNAKL
    
    set w $NNAKL(inwin).nnakl.tov
    if { [info exists NNAKLTOV(ActiveRow)] && \
         $NNAKLTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $NNAKLTOV(ActiveRow)
    }
    set NNAKLTOV(ActiveRowCol) $rowcol 
    scan $NNAKLTOV(ActiveRowCol) "%\[^,]%*c%s" NNAKLTOV(ActiveRow) NNAKLTOV(ActiveCol)
    set row $NNAKLTOV(ActiveRow)
    if { $row >= 0 && [info exists NNAKLTOV_DATA($row,6)] } {
        set NNAKLTOV(sonetovar) [expr $NNAKLTOV_DATA($row,4) - $NNAKLTOV_DATA($row,5)]
        set pd $NNAKLTOV_DATA($row,6)
        if { $pd == "" } { set pd 0 }
        set id [expr $NNAKLTOV(sonetovar) - $pd]
        if { $id == 0 } { set color green }
        if { $id > 0 } { set color red }
        if { $id < 0 } { set color magenta }
        $w.curfldval.l2 configure -bg $color
    }
    nnakltov:summa
    if { $NNAKLTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $NNAKLTOV(ActiveRow)
    }
}

proc nnakltov {} {
    global VS NNAKLTOV NNAKLTOV_DATA SCHETTOV NNAKL
    
    set NNAKLTOV(rows) 9
    set w $NNAKL(inwin).nnakl.tov
    
    frame $w.itogo
    frame $w.itogo.1
    frame $w.itogo.2
    frame $w.curfldval
    entry $w.curfldval.e -width 29 -textvar NNAKLTOV_DATA(active) -fg red -bg #fffff0
    label $w.curfldval.l1 -text "                       :"
    label $w.curfldval.l2 -textvar NNAKLTOV(sonetovar) -bd 1 -relief sunken -anchor e -width 9
    label $w.tut -bg gray70 -wraplength 1 -font $VS(fontn) -width 2 -height 5 -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    pack $w.curfldval -anchor nw
    pack $w.curfldval.e $w.curfldval.l1 $w.curfldval.l2 -side left
    pack $w.itogo -side bottom -fill x
    pack $w.itogo.1 -side top -fill x
    pack $w.itogo.2 -side bottom -fill x
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 7 -height 9 -cols 7 -rows $NNAKLTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable NNAKLTOV_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { nnakltov:browsecommand %S } \
        -wrap on \
        -drawmode fast
        
    tktableinittag $w.tbl
    $w.tbl tag col AnchorCenter 2
    $w.tbl tag col AnchorE 1 3 4 5 6
    $w.tbl tag row AnchorCenter -2 -1
    $w.tbl tag col Disabled 0 1 2 3 4 5
    $w.tbl width 0 29 1 8 2 10 3 10 4 10 5 10 6 10
    
    label $w.itogo.1.l1 -text "                       :"
    label $w.itogo.1.skol -textvar NNAKLTOV(skol) -bd 1 -relief sunken -anchor e -width 8 -bg gray40 -fg cyan
    label $w.itogo.1.l2 -text "          "
    label $w.itogo.1.scena -textvar SCHETTOV(scena) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.1.l3 -text ""
    label $w.itogo.1.sstschet -textvar SCHETTOV(scena) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.1.l4 -text ""
    label $w.itogo.1.sstnnakla -textvar NNAKLTOV(sstnnakla) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.1.l5 -text ""
    label $w.itogo.1.ssumma -textvar NNAKLTOV(ssumma) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    label $w.itogo.2.l1 -text "                                                              :"
    label $w.itogo.2.sallnnakl -textvar NNAKLTOV(sallnnakl) -bd 1 -relief sunken -anchor e -width 9
    foreach i { 1.l1 1.skol 1.l2 1.scena 1.l3 1.sstschet \
                1.l4 1.sstnnakla 1.l5 1.ssumma \
                2.l1 2.sallnnakl } {
        pack $w.itogo.$i -side left
    }
    
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    focus $w.tbl
}

