proc oplnototg { } {
    global VS OPLNOTOTG SCHETTOV OPLNOTOTG_DATA

    catch [unset OPLNOTOTG_DATA]
    set OPLNOTOTG(listbox,curselection) 0
    if ![info exists OPLNOTOTG(entry,clockdatbegin)] {
        set OPLNOTOTG(entry,datbegin) "$VS(day).$VS(month).$VS(year)"
        set OPLNOTOTG(entry,datend)   "$VS(day).$VS(month).$VS(year)"
        set OPLNOTOTG(entry,clockdatbegin) $VS(clock)
        set OPLNOTOTG(entry,clockdatend) $VS(clock)
    }
    set w .oplnototg
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +5+55
    wm geometry $w =0x0
    set titstr "    "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "oplnototg:entry"
    $w1.1 add command -label "" -command "oplnototg:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable OPLNOTOTG(sortstr) -value "6, 8, 9" -command oplnototg:read
        $w1.1.sort add radio -label "  " -variable OPLNOTOTG(sortstr) -value "3, 8, 9" -command oplnototg:read
        $w1.1.sort add radio -label "  " -variable OPLNOTOTG(sortstr) -value "4, 8, 9" -command oplnototg:read
        $w1.1.sort add radio -label "   " -variable OPLNOTOTG(sortstr) -value "5, 8, 9" -command oplnototg:read
        $w1.1.sort add radio -label "  " -variable OPLNOTOTG(sortstr) -value "7, 3, 8, 9" -command oplnototg:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable OPLNOTOTG(sortdesc) -value " " -command oplnototg:read
        $w1.1.sort add radio -label " " -variable OPLNOTOTG(sortdesc) -value "desc" -command oplnototg:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -accelerator "<Enter>" -command oplnototg:schet
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable OPLNOTOTG(statusline) -relief sunken -anchor w -padx 3 -width 60
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find  print  sort  schet  exit } {
        if { $i == "print" } { findbox oplnototg 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""}  { $w.butimg.$i configure -state disabled }
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    foreach i { p1 p2 p3 p4 p5 p6 p7 } {
        frame $w.namefield.$i
    }
    $w.namefield.p6 configure -relief raised -bd 1
    $w.namefield.p7 configure -relief raised -bd 1
    label $w.namefield.p1.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p2.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p3.1 -text "N" -relief raised -anchor center -bd 1
    label $w.namefield.p4.1 -text " " -relief raised -anchor center -bd 1
    label $w.namefield.p5.1 -text "" -relief raised -anchor center -bd 1
    
    label $w.namefield.p1.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p1.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p2.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p3.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p4.2 -text "  " -relief raised -anchor center -bd 1 -padx 1 -width 28
    label $w.namefield.p4.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p5.2 -text "." -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p5.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p5.4 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 10
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p1 p2 p3 p4 p5 } {
        pack $w.namefield.$i -anchor w -side left
    }
    foreach i { p1.1 p2.1 p3.1 p4.1 p5.1 } {
        pack $w.namefield.$i -fill x
    }
    foreach i { p1.2 p1.3 p2.2 p3.2 p4.2 p4.3 p5.2 p5.3 p5.4 } {
        pack $w.namefield.$i -side left
    }
    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 94
    
    pack $w.lb -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    oplnototg:entry
    
    bind $w.butimg.sort <Button-1> {
        .oplnototg.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .oplnototg.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set OPLNOTOTG(statusline) [ %W get $id ]
        set OPLNOTOTG(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .oplnototg.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { schet  } {
            .oplnototg.menu.1 entryconfigure [.oplnototg.menu.1 index $j] -state disabled
            .oplnototg.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { schet  } {
            .oplnototg.menu.1 entryconfigure [.oplnototg.menu.1 index $j] -state normal
            .oplnototg.butimg.$i configure -state normal
        }
    }
    bind $w <Key-Escape> { .oplnototg.buttons.exit invoke }
    bind $w <Key-F5>     { oplnototg:entry }
    bind $w <Key-Return> { oplnototg:schet }
    focus $w.lb.listbox
}

proc oplnototg:entry:createvar {} {
    global OPLNOTOTG
    
    foreach i { datbegin datend } {
        if ![info exists OPLNOTOTG(entry,$i)] {
            set OPLNOTOTG(entry,$i) ""
        }
    }
}

proc oplnototg:entry {} {
    global VS OPLNOTOTG
    
    set w .oplnototg.entry
    oplnototg:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +200+78
    wm geometry $w =0x0
    frame $w.msg
    wm title $w "    "
    label $w.msg.l -font $VS(fontn) -text "   "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tit datbegin datend } {
        frame $w.inf.$i
        pack $w.inf.$i -padx 3 -pady 3
        if { $i == "tit" || $i == "datend" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tit        ",   :"
                      datbegin   "  " \
                      datend     " " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {datbegin   datbegin      10 \
                       datend     datend        10 \
                       } {
        entry $w.inf.$i.e -textvariable OPLNOTOTG(entry,$j) -width $k
    }
    
    foreach { i j } { ControlUp datbegin.bu ControlDown datbegin.bd ControlUp datend.bu ControlDown datend.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.datbegin.bd configure -command "oplnototg:incrdate - datbegin"
    $w.inf.datbegin.bu configure -command "oplnototg:incrdate + datbegin"
    $w.inf.datend.bd configure -command "oplnototg:incrdate - datend"
    $w.inf.datend.bu configure -command "oplnototg:incrdate + datend"
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "destroy $w; oplnototg:read"
    button $w.buttons.exit -text "" -command "destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { datbegin.e datend.e } {
        pack $w.inf.$i -side left
    }
    foreach i { datbegin.bu datbegin.bd datend.bu datend.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.datbegin.e
    
    bind $w <Key-Escape>     { .oplnototg.entry.buttons.exit invoke }
    bind $w <Control-Return> { .oplnototg.entry.buttons.ok invoke }
    bind $w.inf.datbegin.e <KeyPress-Next>  { oplnototg:incrdate - datbegin }
    bind $w.inf.datbegin.e <KeyPress-Prior> { oplnototg:incrdate + datbegin }
    bind $w.inf.datend.e   <KeyPress-Next>  { oplnototg:incrdate - datend }
    bind $w.inf.datend.e   <KeyPress-Prior> { oplnototg:incrdate + datend }
    wm geometry $w [centerwindow $w]
    tkwait window $w
    oplnototg:createfind
    if ![info exists OPLNOTOTG(find,listbox)] { set OPLNOTOTG(find,listbox) "" }
    if { [lsearch -exact $OPLNOTOTG(find,listbox) $OPLNOTOTG(find)] == -1} {
        lappend OPLNOTOTG(find,listbox) $OPLNOTOTG(find)
    }
}

proc oplnototg:incrdate { k d } {
    global OPLNOTOTG
    
    set OPLNOTOTG(entry,clock$d) [expr $OPLNOTOTG(entry,clock$d) $k 86400 ]
    set OPLNOTOTG(entry,$d) [clock format $OPLNOTOTG(entry,clock$d) -format %d.%m.%Y]
}

proc oplnototg:createfind {} {
    global OPLNOTOTG
    
    catch [set OPLNOTOTG(find) ":  $OPLNOTOTG(entry,datbegin)  $OPLNOTOTG(entry,datend)"]
}

proc oplnototg:schet {} {
    global OPLNOTOTG_DATA2 OPLNOTOTG
    
    schetfnr 1 $OPLNOTOTG_DATA2(schetcod,$OPLNOTOTG(listbox,curselection))
}
