proc otgnotopl { } {
    global VS OTGNOTOPL SCHETTOV OTGNOTOPL_DATA

    catch [unset OTGNOTOPL_DATA]
    set OTGNOTOPL(listbox,curselection) 0
    if ![info exists OTGNOTOPL(entry,clockdatbegin)] {
        set OTGNOTOPL(entry,datbegin) "$VS(day).$VS(month).$VS(year)"
        set OTGNOTOPL(entry,datend)   "$VS(day).$VS(month).$VS(year)"
        set OTGNOTOPL(entry,clockdatbegin) $VS(clock)
        set OTGNOTOPL(entry,clockdatend) $VS(clock)
    }
    set w .otgnotopl
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +70+55
    wm geometry $w =0x0
    set titstr "    "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "otgnotopl:entry"
    $w1.1 add command -label "" -command "otgnotopl:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable OTGNOTOPL(sortstr) -value "2" -command otgnotopl:read
        $w1.1.sort add radio -label "  " -variable OTGNOTOPL(sortstr) -value "3" -command otgnotopl:read
        $w1.1.sort add radio -label "  " -variable OTGNOTOPL(sortstr) -value "4" -command otgnotopl:read
        $w1.1.sort add radio -label "  " -variable OTGNOTOPL(sortstr) -value "5" -command otgnotopl:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable OTGNOTOPL(sortdesc) -value " " -command otgnotopl:read
        $w1.1.sort add radio -label " " -variable OTGNOTOPL(sortdesc) -value "desc" -command otgnotopl:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -command otgnotopl:schet
    $w1.1 add command -label "" -accelerator "<Enter>" -command otgnotopl:nnakl
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable OTGNOTOPL(statusline) -relief sunken -anchor w -padx 3 -width 50
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find  print  sort  schet  nalnakl  exit } {
        if { $i == "print" } { findbox otgnotopl 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == "" || $j == "" }  { $w.butimg.$i configure -state disabled }
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3
    foreach i { p1 p2 } {
        frame $w.namefield.$i
    }
    $w.namefield.p2 configure -relief raised -bd 1
    label $w.namefield.p1.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p2.1 -text " "  -height 2 -anchor center -width 50
    
    label $w.namefield.p1.2 -text "N" -relief raised -anchor center -bd 1 -padx 1 -width 6
    label $w.namefield.p1.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p1.4 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 9
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p1 p2 } {
        pack $w.namefield.$i -anchor w -side left -fill y
    }
    foreach i { p1.1 p2.1 } {
        pack $w.namefield.$i -fill x
    }
    foreach i { p1.2 p1.3 p1.4 } {
        pack $w.namefield.$i -side left
    }
    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 78
    
    pack $w.lb -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    otgnotopl:entry
    
    bind $w.butimg.sort <Button-1> {
        .otgnotopl.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .otgnotopl.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set OTGNOTOPL(statusline) [ %W get $id ]
        set OTGNOTOPL(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .otgnotopl.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { schet  nalnakl  } {
            .otgnotopl.menu.1 entryconfigure [.otgnotopl.menu.1 index $j] -state disabled
            .otgnotopl.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { schet  nalnakl  } {
            .otgnotopl.menu.1 entryconfigure [.otgnotopl.menu.1 index $j] -state normal
            .otgnotopl.butimg.$i configure -state normal
        }
    }
    bind $w <Key-Escape> { .otgnotopl.buttons.exit invoke }
    bind $w <Key-F5>     { otgnotopl:entry }
    bind $w <Key-Return> { otgnotopl:nnakl }
    focus $w.lb.listbox
}

proc otgnotopl:entry:createvar {} {
    global OTGNOTOPL
    
    foreach i { datbegin datend } {
        if ![info exists OTGNOTOPL(entry,$i)] {
            set OTGNOTOPL(entry,$i) ""
        }
    }
}

proc otgnotopl:entry {} {
    global VS OTGNOTOPL
    
    set w .otgnotopl.entry
    otgnotopl:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +200+78
    wm geometry $w =0x0
    frame $w.msg
    wm title $w "    "
    label $w.msg.l -font $VS(fontn) -text "   "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tit datbegin datend } {
        frame $w.inf.$i
        pack $w.inf.$i -padx 3 -pady 3
        if { $i == "tit" || $i == "datend" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tit        "    :"
                      datbegin   "  " \
                      datend     " " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {datbegin   datbegin      10 \
                       datend     datend        10 \
                       } {
        entry $w.inf.$i.e -textvariable OTGNOTOPL(entry,$j) -width $k
    }
    
    foreach { i j } { ControlUp datbegin.bu ControlDown datbegin.bd ControlUp datend.bu ControlDown datend.bd } {
        button $w.inf.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.inf.datbegin.bd configure -command "otgnotopl:incrdate - datbegin"
    $w.inf.datbegin.bu configure -command "otgnotopl:incrdate + datbegin"
    $w.inf.datend.bd configure -command "otgnotopl:incrdate - datend"
    $w.inf.datend.bu configure -command "otgnotopl:incrdate + datend"
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "destroy $w; otgnotopl:read"
    button $w.buttons.exit -text "" -command "destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { datbegin.e datend.e } {
        pack $w.inf.$i -side left
    }
    foreach i { datbegin.bu datbegin.bd datend.bu datend.bd } {
        pack $w.inf.$i -fill y
    }
    focus $w.inf.datbegin.e
    bind $w <Key-Escape>     { .otgnotopl.entry.buttons.exit invoke }
    bind $w <Control-Return> { .otgnotopl.entry.buttons.ok invoke }
    bind $w.inf.datbegin.e <KeyPress-Next>  { otgnotopl:incrdate - datbegin }
    bind $w.inf.datbegin.e <KeyPress-Prior> { otgnotopl:incrdate + datbegin }
    bind $w.inf.datend.e   <KeyPress-Next>  { otgnotopl:incrdate - datend }
    bind $w.inf.datend.e   <KeyPress-Prior> { otgnotopl:incrdate + datend }
    wm geometry $w [centerwindow $w]
    tkwait window $w
    otgnotopl:createfind
    if ![info exists OTGNOTOPL(find,listbox)] { set OTGNOTOPL(find,listbox) "" }
    if { [lsearch -exact $OTGNOTOPL(find,listbox) $OTGNOTOPL(find)] == -1} {
        lappend OTGNOTOPL(find,listbox) $OTGNOTOPL(find)
    }
}

proc otgnotopl:incrdate { k d } {
    global OTGNOTOPL
    
    set OTGNOTOPL(entry,clock$d) [expr $OTGNOTOPL(entry,clock$d) $k 86400 ]
    set OTGNOTOPL(entry,$d) [clock format $OTGNOTOPL(entry,clock$d) -format %d.%m.%Y]
}

proc otgnotopl:createfind {} {
    global OTGNOTOPL
    
    catch [set OTGNOTOPL(find) ":  $OTGNOTOPL(entry,datbegin)  $OTGNOTOPL(entry,datend)"]
}

proc otgnotopl:schet {} {
    global OTGNOTOPL_DATA OTGNOTOPL

    schetfnr 1 $OTGNOTOPL_DATA(schetcod,$OTGNOTOPL(listbox,curselection))    
}

proc otgnotopl:nnakl {} {
    global OTGNOTOPL_DATA OTGNOTOPL SCHET
    
    set SCHET(cod) $OTGNOTOPL_DATA(schetcod,$OTGNOTOPL(listbox,curselection))
    nnakl 0 $OTGNOTOPL_DATA(nnaklcod,$OTGNOTOPL(listbox,curselection)) .otgnotopl
}
