proc otgnotopl:read {} {
    global VS OTGNOTOPL OTGNOTOPL_DATA OTGNOTOPL_DATA2
    
    set w .otgnotopl.lb.listbox
    event generate .otgnotopl.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset OTGNOTOPL_DATA]
    if { $OTGNOTOPL(sortstr) == "" }    { set OTGNOTOPL(sortstr) "3" } 
    if { $OTGNOTOPL(sortdesc) == "" }   { set OTGNOTOPL(sortdesc) " "  }
    if { $OTGNOTOPL(find) == "" } {
        otgnotopl:createfind
        lappend OTGNOTOPL(find,listbox) $OTGNOTOPL(find)
    } 
    
    $w delete 0 end
    
    set schetcodold ""
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "otgnotopl_sel \"$OTGNOTOPL(entry,datbegin)\" \"$OTGNOTOPL(entry,datend)\" \"$OTGNOTOPL(sortstr) $OTGNOTOPL(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { nnaklcod nnaklnum nnakldat nnaklsum klientnam } {
                set OTGNOTOPL_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                OTGNOTOPL_DATA(schetcod,$i) \
                OTGNOTOPL_DATA(nnaklcod,$i) \
                OTGNOTOPL_DATA(nnaklnum,$i) \
                OTGNOTOPL_DATA(nnakldat,$i) \
                OTGNOTOPL_DATA(nnaklsum,$i) \
                OTGNOTOPL_DATA(klientnam,$i)
            $w insert end [format "%6d %6s %9.2f %50s" \
                $OTGNOTOPL_DATA(nnaklnum,$i) \
                $OTGNOTOPL_DATA(nnakldat,$i) \
                $OTGNOTOPL_DATA(nnaklsum,$i) \
                $OTGNOTOPL_DATA(klientnam,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set OTGNOTOPL(statusline) " $i ."
        }
        set OTGNOTOPL(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc otgnotopl:print {} {
    global VS OTGNOTOPL    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "otgnotopl_rep \"$OTGNOTOPL(entry,datbegin)\" \"$OTGNOTOPL(entry,datend)\" \"$OTGNOTOPL(sortstr) $OTGNOTOPL(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
