proc postpol {} {
    global VS POSTPOL POSTPOL_DATA

    catch [unset POSTPOL_DATA]
    set POSTPOL(entry,nam) {}
    set POSTPOL(listbox,curselection) 0
    
    set w .postpol
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +175+60
    wm geometry $w =0x0
    wm title $w ""
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "postpol:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "postpol:insert l .postpol"
    $w1.1 add command -label "" -command "postpol:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable POSTPOL(sortstr) -value "a.cod" -command postpol:read
        $w1.1.sort add radio -label " " -variable POSTPOL(sortstr) -value "a.nam" -command postpol:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable POSTPOL(sortdesc) -value " " -command postpol:read
        $w1.1.sort add radio -label " " -variable POSTPOL(sortdesc) -value "desc" -command postpol:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command postpol:view
    $w1.1 add command -state disabled -label "" -command "postpol:update any"
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set POSTPOL(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set POSTPOL(deletestatus) 1; postpol:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable POSTPOL(statusline) -relief sunken -anchor w -padx 3 -width 30
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view "" update "" delete "" exit ""} {
        if { $i == "insert" } { findbox postpol 30 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3 -width 26
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 55
    pack $w.namefield $w.namefield.l -side top
    pack $w.namefield.p1

    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 52
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    postpol:read
    
    bind $w.butimg.sort <Button-1> {
        .postpol.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.delete <Button-1> {
        .postpol.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .postpol.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set POSTPOL(statusline) [ %W get $id ]
        set POSTPOL(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .postpol.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  } {
            .postpol.menu.1 entryconfigure [.postpol.menu.1 index $j] -state disabled
            .postpol.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { view  update  delete  } {
            .postpol.menu.1 entryconfigure [.postpol.menu.1 index $j] -state normal
            .postpol.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists POSTPOL_DATA(cod,$POSTPOL(listbox,curselection))] {
            postpol:update any
        }
    }
    focus $w.lb.listbox
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists POSTPOL_DATA(cod,$POSTPOL(listbox,curselection))] {
            postpol:update any
        }
    }
    bind $w <Key-Escape> { .postpol.buttons.exit invoke }
    bind $w <Key-F5>     { postpol:find }
    bind $w <Key-Insert> { postpol:insert l .postpol }
}

proc postpol:entry:clearvar {} {
    global POSTPOL
    
    foreach { i } { lgotacod gorodcod pgorodcod sotcod nam balans urlico nds post datreg \
                    lgotanam lgotaproc numcard \
                    gorodnam phonecod index ulica dom kv \
                    pgorodnam pphonecod pindex pulica pdom pkv \
                    phoneboss phonebuh phoneo fax email \
                    bossf bossi bosso bossi2 bosso2 bossi3 bosso3
                    bossborn bosssex contfio contdol contpr contpd \
                    zkpo inn ns banknam bankmfo bankschet sotfio prim} {
        set POSTPOL(entry,$i) ""
    }
}

proc postpol:entry { status win } {
    global VS POSTPOL
    
    set POSTPOL(status) $status
    set POSTPOL(entrystatus) {}
    set POSTPOL(entry,inwin) $win
    set w $POSTPOL(entry,inwin).postpolentry
    set POSTPOL(hebutton) 0
    
    if { $status != "view" && $status != "update"} {
        postpol:entry:clearvar
    }
    
    foreach { i } { lgotanam gorodnam pgorodnam sotfio } {
        set POSTPOL(entry,old_$i) $POSTPOL(entry,$i)
    }
    
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +15+45
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
            set POSTPOL(entry,datreg) "$VS(day).$VS(month).$VS(year)"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } {nam urlico lgota gorod ulica pgorod pulica phone email boss1 boss2 cont1 cont2 cont3 zkpo bank sot prim } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "urlico" || $i == "lgota" || $i == "ulica" || $i == "pulica" || $i == "email" || $i == "boss2" || $i == "cont3" || $i == "zkpo" || $i == "bank" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { nam       "  " \
                      lgota     "        " \
                      gorod     ".: " \
                      ulica     "         " \
                      pgorod    ".: " \
                      pulica    "         " \
                      phone     "   : " \
                      email     "                   E-mail" \
                      boss1     ": ." \
                      boss2     "   :" \
                      cont1     "           :" \
                      cont2     "                 " \
                      cont3     "                 : " \
                      zkpo      "         " \
                      bank      "  " \
                      sot       "                " \
                      prim      " " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    
    foreach { i j k } {nam.e            nam         50 \
                       nam.balans       balans      10 \
                       urlico.datreg    datreg      10 \
                       lgota.lgota      lgotanam    30 \
                       lgota.proc       lgotaproc   6 \
                       lgota.numcard    numcard     5
                       gorod.gorod      gorodnam    30 \
                       gorod.phonecod   phonecod    6 \
                       gorod.index      index       6 \
                       ulica.ulica      ulica       50 \
                       ulica.dom        dom         8 \
                       ulica.kv         kv          4 \
                       pgorod.pgorod    pgorodnam    30 \
                       pgorod.pphonecod pphonecod    6 \
                       pgorod.pindex    pindex       6 \
                       pulica.pulica    pulica       50 \
                       pulica.pdom      pdom         8 \
                       pulica.pkv       pkv          4 \
                       phone.phoneboss  phoneboss   9 \
                       phone.phonebuh   phonebuh    9 \
                       phone.phoneo     phoneo      9 \
                       phone.fax        fax         9 \
                       email.e          email       30 \
                       boss1.bossf      bossf       20 \
                       boss1.bossi      bossi       20 \
                       boss1.bosso      bosso       20 \
                       boss2.bossborn   bossborn    10 \
                       cont1.e          contfio     50 \
                       cont2.e          contdol     50 \
                       cont3.p1         contpr      10 \
                       cont3.p2         contpd      30 \
                       zkpo.zkpo        zkpo        8 \
                       zkpo.inn         inn         12 \
                       zkpo.ns          ns          8 \
                       bank.banknam     banknam     50 \
                       bank.bankmfo     bankmfo     6 \
                       bank.bankschet   bankschet   14 \
                       sot.e            sotfio      50 \
                       prim.e           prim        80 
                       } {
        entry $w.inf.$i -textvariable POSTPOL(entry,$j) -width $k
    }
    
    foreach i { lgota.proc gorod.phonecod pgorod.pphonecod } {
        $w.inf.$i configure -state disabled
    }
    
    foreach { i j } { urlico  "      " \
                      nds      "      " \
                      post      "     " } {
        checkbutton $w.inf.urlico.$i -text $j -variable POSTPOL(entry,$i) \
             -offvalue "" -onvalue "*" -bd 1 -relief raised -padx 3 -bg grey80
    }
    
    foreach { i j } { nam.l1        " " \
                      urlico.l1     "  " \
                      lgota.l1      " " \
                      lgota.l2      "  " \
                      gorod.l1      "  " \
                      gorod.l2      "  " \
                      ulica.l1      " " \
                      ulica.l2      " " \
                      pgorod.l1     "  " \
                      pgorod.l2     "  " \
                      pulica.l1     " " \
                      pulica.l2     " " \
                      phone.l1      " " \
                      phone.l2      " " \
                      phone.l3      " " \
                      boss1.l1      " ." \
                      boss1.l2      " ." \
                      boss2.l1      " " \
                      cont3.l1      " " \
                      zkpo.l1       "  " \
                      zkpo.l2       "  " \
                      bank.l1       " " \
                      bank.l2       " " } {
        label $w.inf.$i -text $j
    }
    
    button $w.inf.lgota.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set POSTPOL(hebutton) 1; postpol:helgota r $POSTPOL(entry,inwin).postpolentry \"$POSTPOL(entry,inwin)\""
    button $w.inf.gorod.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set POSTPOL(hebutton) 1; postpol:hegorod r $POSTPOL(entry,inwin).postpolentry \"$POSTPOL(entry,inwin)\""
    button $w.inf.pgorod.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set POSTPOL(hebutton) 1; postpol:hepgorod r $POSTPOL(entry,inwin).postpolentry \"$POSTPOL(entry,inwin)\""    
    button $w.inf.sot.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set POSTPOL(hebutton) 1; postpol:hesot r $POSTPOL(entry,inwin).postpolentry \"$POSTPOL(entry,inwin)\""
    button $w.inf.boss1.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "postpol:boss23 $w.inf.boss1.bossf"
    
    tk_optionMenu $w.inf.boss2.bosssex POSTPOL(entry,bosssex)   ""
    $w.inf.boss2.bosssex configure -bd 1 -width 1 -bg grey80
    foreach i { boss2.bosssex urlico.urlico urlico.nds urlico.post } {
        $w.inf.$i configure -disabledforeground black
    }
    
    if { $status == "view" } {
        foreach i { nam.e nam.balans email.e cont1.e cont2.e sot.e prim.e \
                    urlico.urlico urlico.nds urlico.post urlico.datreg \
                    lgota.lgota lgota.b lgota.proc lgota.numcard \
                    gorod.gorod gorod.b gorod.phonecod gorod.index \
                    ulica.ulica ulica.dom ulica.kv \
                    pgorod.pgorod pgorod.b pgorod.pphonecod pgorod.pindex \
                    pulica.pulica pulica.pdom pulica.pkv \
                    phone.phoneboss phone.phonebuh phone.phoneo phone.fax \
                    boss1.bossf boss1.bossi boss1.bosso boss1.b
                    boss2.bossborn boss2.bosssex \
                    cont3.p1 cont3.p2 \
                    zkpo.zkpo zkpo.inn zkpo.ns \
                    bank.banknam bank.bankmfo bank.bankschet sot.b } {
            $w.inf.$i configure -state disabled
        }
    }
    if { $status == "find" } {
        foreach i { gorod.phonecod pgorod.pphonecod lgota.proc sot.e } {
            $w.inf.$i configure -state normal
        }
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" \
        -command "set VS($POSTPOL(entry,inwin).postpolentry_update) 0; set POSTPOL(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "postpol:entry:clearvar"
    button $w.buttons.exit -text "" -command "set POSTPOL(entrystatus) 0; destroya $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { nam.e nam.l1 nam.balans email.e cont1.e cont2.e sot.e prim.e \
                urlico.urlico urlico.nds urlico.post urlico.l1 urlico.datreg \
                lgota.lgota lgota.b lgota.l1 lgota.proc lgota.l2 lgota.numcard \
                gorod.gorod gorod.b gorod.l1 gorod.phonecod gorod.l2 gorod.index \
                ulica.ulica ulica.l1 ulica.dom ulica.l2 ulica.kv \
                pgorod.pgorod pgorod.b pgorod.l1 pgorod.pphonecod pgorod.l2 pgorod.pindex \
                pulica.pulica pulica.l1 pulica.pdom pulica.l2 pulica.pkv \
                phone.phoneboss phone.l1 phone.phonebuh phone.l2 phone.phoneo \
                phone.l3 phone.fax \
                boss1.bossf boss1.l1 boss1.bossi boss1.l2 boss1.bosso boss1.b \
                boss2.bossborn boss2.l1 boss2.bosssex \
                cont3.p1 cont3.l1 cont3.p2 \
                zkpo.zkpo zkpo.l1 zkpo.inn zkpo.l2 zkpo.ns \
                bank.banknam bank.l1 bank.bankmfo bank.l2 bank.bankschet sot.b } {
        pack $w.inf.$i -side left
    }
    
    if { $status != "view" } {
        focus $w.inf.nam.e
    } else {
        focus $w.buttons.exit
    }
    foreach { i } { lgota.lgota gorod.gorod pgorod.pgorod sot.e } {
        bind $w.inf.$i <FocusOut> {
            regexp "\[^\.]*\.\[^\.]*$" %W wn
            scan $wn "%%\[^\.]%%*c%%s" wn fuf
            if { $wn == "sot" } {
                set nm "fio"
            } else {
                set nm "nam"
            }
            if { $POSTPOL(status) != "find" } {
                if { "$POSTPOL(entry,old_${wn}${nm})" != "$POSTPOL(entry,${wn}${nm})" } {
                    regsub -all " " "$POSTPOL(entry,${wn}${nm})" "" lng
                    if { $POSTPOL(hebutton) == 0 } {
                        if { [string length $lng] > 0 } {
                            postpol:he$wn u $POSTPOL(entry,inwin).postpolentry $POSTPOL(entry,inwin)
                            set POSTPOL(entry,old_${wn}${nm}) $POSTPOL(entry,${wn}${nm})
                        } else { set POSTPOL(entry,${wn}cod) "" }
                    }
                }
            }
        }
    }
    bind $w <Key-Escape>     { $POSTPOL(entry,inwin).postpolentry.buttons.exit invoke }
    bind $w <Control-Return> { $POSTPOL(entry,inwin).postpolentry.buttons.ok invoke }
    foreach { i } { lgota.lgota gorod.gorod pgorod.pgorod sot.e } {
        bind $w.inf.$i <Button-1> {
            catch [destroy $POSTPOL(entry,inwin).postpolentry.he]
        }
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc postpol:boss23 { win } {
    global POSTPOL
    
    set w $POSTPOL(entry,inwin).postpolentry.boss23
    catch [destroy $w]
    toplevel $w -cursor arrow 
    set x [winfo rootx $win] 
    set y [expr [winfo rooty $win] + [winfo height $win]]
    wm geometry $w +$x+$y
    wm overrideredirect $w 1
    frame $w.all -bd 2 -relief sunken
    pack $w.all
    frame $w.all.2
    frame $w.all.3
    frame $w.all.sep -bd 1 -height 2 -relief sunken
    button $w.all.ok -bd 3 -relief groove -text "" -command "destroy $w"
    foreach { i j } { 2.l1  "      : ." \
                      2.l2  " ." \
                      3.l1  "           : ." \
                      3.l2  " ." \
                      } {
        label $w.all.$i -text $j
    }
    foreach { i j k } {2.bossi2         bossi2      20 \
                       2.bosso2         bosso2      20 \
                       3.bossi3         bossi3      20 \
                       3.bosso3         bosso3      20 \
                       } {
        entry $w.all.$i -textvariable POSTPOL(entry,$j) -width $k
    }
    pack $w.all.2 $w.all.3 $w.all.sep -fill x
    pack $w.all.ok
    foreach i { 2.l1 2.bossi2 2.l2 2.bosso2 3.l1 3.bossi3 3.l2 3.bosso3 } {
        pack $w.all.$i -side left
    }
}
