proc postpol:read {} {
    global VS POSTPOL POSTPOL_DATA
    
    set POSTPOL(statusline) ""
    set w .postpol.lb.listbox
    event generate .postpol.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset POSTPOL_DATA]
    if { $POSTPOL(sortstr) == "" }    { set POSTPOL(sortstr) "a.nam" } 
    if { $POSTPOL(sortdesc) == "" }   { set POSTPOL(sortdesc) " "  }
    if { $POSTPOL(find) == "" } {
        set POSTPOL(find) "1=1"
        lappend POSTPOL(find,listbox) $POSTPOL(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "postpolmany_sel \"$POSTPOL(find)\" \"$POSTPOL(sortstr) $POSTPOL(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set POSTPOL_DATA(cod,$i) {}; set POSTPOL_DATA(nam,$i) {}
            scan $str "%\[^\t]%*c%\[^\n]" POSTPOL_DATA(cod,$i) POSTPOL_DATA(nam,$i)
            if { [clipped $POSTPOL(entry,nam)] == [clipped $POSTPOL_DATA(nam,$i)] } {
                set POSTPOL(listbox,curselection) $i
            }
            $w insert end " $POSTPOL_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set POSTPOL(statusline) " $i ."
        }
        set POSTPOL(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc postpolone:read { st } {
    global VS POSTPOL POSTPOL_DATA SCHET NAKLP NNAKL
    
    waiting "  ..." blue
    postpol:entry:clearvar
    
    if { $st == "any" }      { set cod $POSTPOL_DATA(cod,$POSTPOL(listbox,curselection)) }
    if { $st == "schetfnr" } { set cod $SCHET(klientcod) }
    if { $st == "naklp" }    { set cod $NAKLP(klientcod) }
    if [regexp "nnakl" $st]  { set cod $NNAKL(klientcod) }
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "postpolone_sel $cod"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      POSTPOL(entry,lgotacod) \
                      POSTPOL(entry,gorodcod) \
                      POSTPOL(entry,pgorodcod) \
                      POSTPOL(entry,sotcod) \
                      POSTPOL(entry,nam) \
                      POSTPOL(entry,balans) \
                      POSTPOL(entry,urlico) \
                      POSTPOL(entry,nds) \
                      POSTPOL(entry,post) \
                      POSTPOL(entry,datreg) \
                      POSTPOL(entry,lgotanam) \
                      POSTPOL(entry,lgotaproc) \
                      POSTPOL(entry,numcard) \
                      POSTPOL(entry,gorodnam) \
                      POSTPOL(entry,phonecod) \
                      POSTPOL(entry,index) \
                      POSTPOL(entry,ulica) \
                      POSTPOL(entry,dom) \
                      POSTPOL(entry,kv) \
                      POSTPOL(entry,pgorodnam) \
                      POSTPOL(entry,pphonecod) \
                      POSTPOL(entry,pindex) \
                      POSTPOL(entry,pulica) \
                      POSTPOL(entry,pdom) \
                      POSTPOL(entry,pkv) \
                      POSTPOL(entry,phoneboss) \
                      POSTPOL(entry,phonebuh) \
                      POSTPOL(entry,phoneo) \
                      POSTPOL(entry,fax) \
                      POSTPOL(entry,email) \
                      POSTPOL(entry,bossf) \
                      POSTPOL(entry,bossi) \
                      POSTPOL(entry,bosso) \
                      POSTPOL(entry,bossi2) \
                      POSTPOL(entry,bosso2) \
                      POSTPOL(entry,bossi3) \
                      POSTPOL(entry,bosso3) \
                      POSTPOL(entry,bossborn) \
                      POSTPOL(entry,bosssex) \
                      POSTPOL(entry,contfio) \
                      POSTPOL(entry,contdol) \
                      POSTPOL(entry,contpr) \
                      POSTPOL(entry,contpd) \
                      POSTPOL(entry,zkpo) \
                      POSTPOL(entry,inn) \
                      POSTPOL(entry,ns) \
                      POSTPOL(entry,banknam) \
                      POSTPOL(entry,bankmfo) \
                      POSTPOL(entry,bankschet) \
                      POSTPOL(entry,sotfio) \
                      POSTPOL(entry,prim)
        }
        set POSTPOL(entry,nam)       [clipped $POSTPOL(entry,nam)]
        set POSTPOL(entry,balans)    [format "%10.2f" $POSTPOL(entry,balans)]
        set POSTPOL(entry,lgotanam)  [clipped $POSTPOL(entry,lgotanam)]
        set POSTPOL(entry,numcard)   [clipped $POSTPOL(entry,numcard)]
        set POSTPOL(entry,gorodnam)  [clipped $POSTPOL(entry,gorodnam)]
        set POSTPOL(entry,index)     [clipped $POSTPOL(entry,index)]
        set POSTPOL(entry,ulica)     [clipped $POSTPOL(entry,ulica)]
        set POSTPOL(entry,dom)       [clipped $POSTPOL(entry,dom)]
        set POSTPOL(entry,kv)        [clipped $POSTPOL(entry,kv)]
        set POSTPOL(entry,pgorodnam)  [clipped $POSTPOL(entry,pgorodnam)]
        set POSTPOL(entry,pindex)     [clipped $POSTPOL(entry,pindex)]
        set POSTPOL(entry,pulica)     [clipped $POSTPOL(entry,pulica)]
        set POSTPOL(entry,pdom)       [clipped $POSTPOL(entry,pdom)]
        set POSTPOL(entry,pkv)        [clipped $POSTPOL(entry,pkv)]
        set POSTPOL(entry,phoneboss) [clipped $POSTPOL(entry,phoneboss)]
        set POSTPOL(entry,phonebuh)  [clipped $POSTPOL(entry,phonebuh)]
        set POSTPOL(entry,phoneo)    [clipped $POSTPOL(entry,phoneo)]
        set POSTPOL(entry,fax)       [clipped $POSTPOL(entry,fax)]
        set POSTPOL(entry,email)     [clipped $POSTPOL(entry,email)]
        set POSTPOL(entry,bossf)     [clipped $POSTPOL(entry,bossf)]
        set POSTPOL(entry,bossi)     [clipped $POSTPOL(entry,bossi)]
        set POSTPOL(entry,bosso)     [clipped $POSTPOL(entry,bosso)]
        set POSTPOL(entry,bossi2)    [clipped $POSTPOL(entry,bossi2)]
        set POSTPOL(entry,bosso2)    [clipped $POSTPOL(entry,bosso2)]
        set POSTPOL(entry,bossi3)    [clipped $POSTPOL(entry,bossi3)]
        set POSTPOL(entry,bosso3)    [clipped $POSTPOL(entry,bosso3)]
        set POSTPOL(entry,bossborn)  [clipped $POSTPOL(entry,bossborn)]
        set POSTPOL(entry,bosssex)   [clipped $POSTPOL(entry,bosssex)]
        set POSTPOL(entry,contfio)   [clipped $POSTPOL(entry,contfio)]
        set POSTPOL(entry,contdol)   [clipped $POSTPOL(entry,contdol)]
        set POSTPOL(entry,contpr)    [clipped $POSTPOL(entry,contpr)]
        set POSTPOL(entry,contpd)    [clipped $POSTPOL(entry,contpd)]
        set POSTPOL(entry,zkpo)      [clipped $POSTPOL(entry,zkpo)]
        set POSTPOL(entry,inn)       [clipped $POSTPOL(entry,inn)]
        set POSTPOL(entry,ns)        [clipped $POSTPOL(entry,ns)]
        set POSTPOL(entry,banknam)   [clipped $POSTPOL(entry,banknam)]
        set POSTPOL(entry,bankmfo)   [clipped $POSTPOL(entry,bankmfo)]
        set POSTPOL(entry,bankschet) [clipped $POSTPOL(entry,bankschet)]
        set POSTPOL(entry,sotfio)    [clipped $POSTPOL(entry,sotfio)]
        set POSTPOL(entry,prim)      [clipped $POSTPOL(entry,prim)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc postpol:find {} {
    global VS POSTPOL
    
    postpol:entry find .postpol
    if { $POSTPOL(entrystatus) == 1 } {
        set POSTPOL(find) "1=1"
        foreach {i j} " \"$POSTPOL(entry,nam)\" a.nam \
                        \"$POSTPOL(entry,balans)\" a.balans \
                        \"$POSTPOL(entry,urlico)\" a.nam \
                        \"$POSTPOL(entry,nds)\" a.nds \
                        \"$POSTPOL(entry,post)\" a.post \
                        \"$POSTPOL(entry,datreg)\" a.datreg \
                        \"$POSTPOL(entry,lgotanam)\" b.nam \
                        \"$POSTPOL(entry,lgotaproc)\" b.proc \
                        \"$POSTPOL(entry,numcard)\" a.numcard \
                        \"$POSTPOL(entry,gorodnam)\" c.nam \
                        \"$POSTPOL(entry,phonecod)\" c.phone_cod \
                        \"$POSTPOL(entry,index)\" a.index \
                        \"$POSTPOL(entry,ulica)\" a.ulica \
                        \"$POSTPOL(entry,dom)\" a.dom \
                        \"$POSTPOL(entry,kv)\" a.kv \
                        \"$POSTPOL(entry,pgorodnam)\" c.nam \
                        \"$POSTPOL(entry,pphonecod)\" c.phone_cod \
                        \"$POSTPOL(entry,pindex)\" a.index \
                        \"$POSTPOL(entry,pulica)\" a.ulica \
                        \"$POSTPOL(entry,pdom)\" a.dom \
                        \"$POSTPOL(entry,pkv)\" a.kv \
                        \"$POSTPOL(entry,phoneboss)\" a.phone_boss \
                        \"$POSTPOL(entry,phonebuh)\" a.phone_buh \
                        \"$POSTPOL(entry,phoneo)\" a.phone_o \
                        \"$POSTPOL(entry,fax)\" a.fax \
                        \"$POSTPOL(entry,email)\" a.email \
                        \"$POSTPOL(entry,bossf)\" a.boss_f \
                        \"$POSTPOL(entry,bossi)\" a.boss_i \
                        \"$POSTPOL(entry,bosso)\" a.boss_o \
                        \"$POSTPOL(entry,bossi2)\" a.boss_i2 \
                        \"$POSTPOL(entry,bosso2)\" a.boss_o2 \
                        \"$POSTPOL(entry,bossi3)\" a.boss_i3 \
                        \"$POSTPOL(entry,bosso3)\" a.boss_o3 \
                        \"$POSTPOL(entry,bossborn)\" a.boss_born \
                        \"$POSTPOL(entry,bosssex)\" a.boss_sex \
                        \"$POSTPOL(entry,contfio)\" a.cont_fio \
                        \"$POSTPOL(entry,contdol)\" a.cont_dol \
                        \"$POSTPOL(entry,contpr)\" a.cont_p_r \
                        \"$POSTPOL(entry,contpd)\" a.cont_p_d \
                        \"$POSTPOL(entry,zkpo)\" a.zkpo \
                        \"$POSTPOL(entry,inn)\" a.inn \
                        \"$POSTPOL(entry,ns)\" a.ns \
                        \"$POSTPOL(entry,banknam)\" a.bank_nam \
                        \"$POSTPOL(entry,bankmfo)\" a.bank_mfo \
                        \"$POSTPOL(entry,bankschet)\" a.bank_schet \
                        \"$POSTPOL(entry,sotfio)\" d.fio \
                        \"$POSTPOL(entry,prim)\" a.prim " \
        {
            if { $i != "" } {
                set POSTPOL(find) "$POSTPOL(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $POSTPOL(find,listbox) $POSTPOL(find)] == -1} {
            lappend POSTPOL(find,listbox) $POSTPOL(find)
        }
        postpol:read
    }
    set POSTPOL(entrystatus) 0
}

proc postpol:delete {} {
    global VS POSTPOL POSTPOL_DATA
    
    set w .postpol.lb.listbox
    if { $POSTPOL(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $POSTPOL(listbox,curselection)
            puts $socks "postpol_del $POSTPOL_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            postpol:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $POSTPOL(listbox,count)} {
            set id $POSTPOL(listbox,count)
            set POSTPOL(listbox,curselection) $POSTPOL(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set POSTPOL(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set POSTPOL(deletestatus) 0
}

proc postpol:insert { tip win } {
    global VS POSTPOL
    
    set w .postpol.lb.listbox
    set POSTPOL(entry,lgotacod) ""
    set POSTPOL(entry,sotcod) ""
    postpol:entry insert $win
    if { $POSTPOL(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "postpol_ins \"$POSTPOL(entry,nam)\" \
                                 \"$POSTPOL(entry,balans)\" \
                                 \"$POSTPOL(entry,urlico)\" \
                                 \"$POSTPOL(entry,nds)\" \
                                 \"$POSTPOL(entry,post)\" \
                                 \"$POSTPOL(entry,datreg)\" \
                                 \"$POSTPOL(entry,lgotacod)\" \
                                 \"$POSTPOL(entry,numcard)\" \
                                 \"$POSTPOL(entry,gorodcod)\" \
                                 \"$POSTPOL(entry,index)\" \
                                 \"$POSTPOL(entry,ulica)\" \
                                 \"$POSTPOL(entry,dom)\" \
                                 \"$POSTPOL(entry,kv)\" \
                                 \"$POSTPOL(entry,pgorodcod)\" \
                                 \"$POSTPOL(entry,pindex)\" \
                                 \"$POSTPOL(entry,pulica)\" \
                                 \"$POSTPOL(entry,pdom)\" \
                                 \"$POSTPOL(entry,pkv)\" \
                                 \"$POSTPOL(entry,phoneboss)\" \
                                 \"$POSTPOL(entry,phonebuh)\" \
                                 \"$POSTPOL(entry,phoneo)\" \
                                 \"$POSTPOL(entry,fax)\" \
                                 \"$POSTPOL(entry,email)\" \
                                 \"$POSTPOL(entry,bossf)\" \
                                 \"$POSTPOL(entry,bossi)\" \
                                 \"$POSTPOL(entry,bosso)\" \
                                 \"$POSTPOL(entry,bossi2)\" \
                                 \"$POSTPOL(entry,bosso2)\" \
                                 \"$POSTPOL(entry,bossi3)\" \
                                 \"$POSTPOL(entry,bosso3)\" \
                                 \"$POSTPOL(entry,bossborn)\" \
                                 \"$POSTPOL(entry,bosssex)\" \
                                 \"$POSTPOL(entry,contfio)\" \
                                 \"$POSTPOL(entry,contdol)\" \
                                 \"$POSTPOL(entry,contpr)\" \
                                 \"$POSTPOL(entry,contpd)\" \
                                 \"$POSTPOL(entry,zkpo)\" \
                                 \"$POSTPOL(entry,inn)\" \
                                 \"$POSTPOL(entry,ns)\" \
                                 \"$POSTPOL(entry,banknam)\" \
                                 \"$POSTPOL(entry,bankmfo)\" \
                                 \"$POSTPOL(entry,bankschet)\" \
                                 \"$POSTPOL(entry,sotcod)\" \
                                 \"$POSTPOL(entry,prim)\" "
            flush $socks
    
            while { [set str [gets $socks]] != $VS(sepdata) } {
                set POSTPOL(entry,cod) $str
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            if { $tip == "l" } { postpol:read }
        } else {
            errormsg nosocks "  !"
        }

        if { $tip == "l" } {
            $w see [set id $POSTPOL(listbox,curselection)]
            $w selection set $id $id
            $w activate $id
            event generate $w <<iconmenu-enabled>>
        }
    }
    set POSTPOL(entrystatus) 0
}

proc postpol:update { st } {
    global VS POSTPOL POSTPOL_DATA SCHET NAKLP NNAKL

    if ![winfo exists .postpol] { frame .postpol }
    set w .postpol.lb.listbox
    postpolone:read $st
    postpol:entry update .postpol
    if { $POSTPOL(entry,lgotanam) == "" } { set POSTPOL(entry,lgotacod) {} }
    if { $POSTPOL(entry,sotfio) == "" } { set POSTPOL(entry,sotcod) {} }
    if { $POSTPOL(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            if { $st == "any" }      { set cod $POSTPOL_DATA(cod,$POSTPOL(listbox,curselection)) }
            if { $st == "schetfnr" } { set cod $SCHET(klientcod) }
            if { $st == "naklp" }    { set cod $NAKLP(klientcod) }
            if [regexp "nnakl" $st]  { set cod $NNAKL(klientcod) }
            puts $socks "postpol_upd $cod \
                                 \"$POSTPOL(entry,nam)\" \
                                 \"$POSTPOL(entry,balans)\" \
                                 \"$POSTPOL(entry,urlico)\" \
                                 \"$POSTPOL(entry,nds)\" \
                                 \"$POSTPOL(entry,post)\" \
                                 \"$POSTPOL(entry,datreg)\" \
                                 \"$POSTPOL(entry,lgotacod)\" \
                                 \"$POSTPOL(entry,numcard)\" \
                                 \"$POSTPOL(entry,gorodcod)\" \
                                 \"$POSTPOL(entry,index)\" \
                                 \"$POSTPOL(entry,ulica)\" \
                                 \"$POSTPOL(entry,dom)\" \
                                 \"$POSTPOL(entry,kv)\" \
                                 \"$POSTPOL(entry,pgorodcod)\" \
                                 \"$POSTPOL(entry,pindex)\" \
                                 \"$POSTPOL(entry,pulica)\" \
                                 \"$POSTPOL(entry,pdom)\" \
                                 \"$POSTPOL(entry,pkv)\" \
                                 \"$POSTPOL(entry,phoneboss)\" \
                                 \"$POSTPOL(entry,phonebuh)\" \
                                 \"$POSTPOL(entry,phoneo)\" \
                                 \"$POSTPOL(entry,fax)\" \
                                 \"$POSTPOL(entry,email)\" \
                                 \"$POSTPOL(entry,bossf)\" \
                                 \"$POSTPOL(entry,bossi)\" \
                                 \"$POSTPOL(entry,bosso)\" \
                                 \"$POSTPOL(entry,bossi2)\" \
                                 \"$POSTPOL(entry,bosso2)\" \
                                 \"$POSTPOL(entry,bossi3)\" \
                                 \"$POSTPOL(entry,bosso3)\" \
                                 \"$POSTPOL(entry,bossborn)\" \
                                 \"$POSTPOL(entry,bosssex)\" \
                                 \"$POSTPOL(entry,contfio)\" \
                                 \"$POSTPOL(entry,contdol)\" \
                                 \"$POSTPOL(entry,contpr)\" \
                                 \"$POSTPOL(entry,contpd)\" \
                                 \"$POSTPOL(entry,zkpo)\" \
                                 \"$POSTPOL(entry,inn)\" \
                                 \"$POSTPOL(entry,ns)\" \
                                 \"$POSTPOL(entry,banknam)\" \
                                 \"$POSTPOL(entry,bankmfo)\" \
                                 \"$POSTPOL(entry,bankschet)\" \
                                 \"$POSTPOL(entry,sotcod)\" \
                                 \"$POSTPOL(entry,prim)\" "
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            if { $st == "any" } postpol:read
        } else {
            errormsg nosocks "  !"
        }
    }
    if { $st == "any" } {
        catch [$w see [set id $POSTPOL(listbox,curselection)]]
        catch [$w selection set $id $id]
        catch [$w activate $id]
        catch [event generate $w <<iconmenu-enabled>>]
    }
    if { $st == "only" } { catch [destroy .postpol] }
    set POSTPOL(entrystatus) 0
}

proc postpol:view {} {
    global VS POSTPOL POSTPOL_DATA
    
    postpolone:read any
    postpol:entry view .postpol
    catch [event generate .postpol.lb.listbox <<iconmenu-enabled>>]
}

proc postpol:print {} {
    global VS POSTPOL    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "postpol_rep \"$POSTPOL(find)\" \"$POSTPOL(sortstr) $POSTPOL(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc postpol:helgota { tip win wn } {
    global VS POSTPOL HE
    
    set w $wn.postpolentry.inf.lgota.lgota
    set HE(tit) "            "
    set namstr "*"
    if { $tip == "u" } { set namstr "$POSTPOL(entry,lgotanam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 37 lgota "$namstr" $tip $win
    set POSTPOL(entry,lgotacod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%s" POSTPOL(entry,lgotanam) POSTPOL(entry,lgotaproc)
    set POSTPOL(entry,lgotanam)     [clipped $POSTPOL(entry,lgotanam)]
    set POSTPOL(entry,oldlgotanam)  $POSTPOL(entry,lgotanam)
    set POSTPOL(entry,lgotaproc) [clipped $POSTPOL(entry,lgotaproc)]
    set POSTPOL(hebutton) 0
}

proc postpol:hegorod { tip win wn } {
    global VS POSTPOL HE
    
    set w $wn.postpolentry.inf.gorod.gorod
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$POSTPOL(entry,gorodnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 37 gorod "$namstr" $tip $win
    set POSTPOL(entry,gorodcod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%s" POSTPOL(entry,gorodnam) POSTPOL(entry,phonecod)
    set POSTPOL(entry,gorodnam) [clipped $POSTPOL(entry,gorodnam)]
    set POSTPOL(entry,old_gorodnam) $POSTPOL(entry,gorodnam)
    set POSTPOL(entry,phonecod) [clipped $POSTPOL(entry,phonecod)]
    set POSTPOL(hebutton) 0
}

proc postpol:hepgorod { tip win wn } {
    global VS POSTPOL HE
    
    set w $wn.postpolentry.inf.pgorod.pgorod
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$POSTPOL(entry,pgorodnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 37 gorod "$namstr" $tip $win
    set POSTPOL(entry,pgorodcod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%s" POSTPOL(entry,pgorodnam) POSTPOL(entry,pphonecod)
    set POSTPOL(entry,pgorodnam) [clipped $POSTPOL(entry,pgorodnam)]
    set POSTPOL(entry,old_pgorodnam) $POSTPOL(entry,pgorodnam)
    set POSTPOL(entry,pphonecod) [clipped $POSTPOL(entry,pphonecod)]
    set POSTPOL(hebutton) 0
}

proc postpol:hesot { tip win wn } {
    global VS POSTPOL HE
    
    set w $wn.postpolentry.inf.sot.e
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$POSTPOL(entry,sotfio)" }
    #he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 sot $POSTPOL(entry,sotfio) $tip $win
    he 207 365 5 50 sot "$namstr" $tip $win
    set POSTPOL(entry,sotcod) $HE(cod)
    set POSTPOL(entry,sotfio) [clipped $HE(nam)]
    set POSTPOL(entry,old_sotfio) [clipped $HE(nam)]
    set POSTPOL(hebutton) 0
}
