proc pricepost:clear {} {
    global PRICEPOST_DATA
    
    catch [unset PRICEPOST_DATA]
    set PRICEPOST_DATA(-2,0) ""
    set PRICEPOST_DATA(-1,0) ""
    set PRICEPOST_DATA(-2,1) ""
    set PRICEPOST_DATA(-1,1) ""
}

proc pricepost:read { w } {
    global VS PRICEPOST_DATA PRICEPOST PRICETOVHE
    
    pricepost:clear
    set w $w.tov.tbl
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "pricepost_sel"
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set PRICEPOST_DATA($i,0) "";   set PRICEPOST_DATA($i,1) "" 
            set PRICEPOST_DATA($i,cod) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                PRICEPOST_DATA($i,cod) PRICEPOST_DATA($i,0) PRICEPOST_DATA($i,1)
                set PRICEPOST_DATA($i,old_1) $PRICEPOST_DATA($i,1)
            lappend PRICETOVHE(cod) $PRICEPOST_DATA($i,cod)
            lappend PRICETOVHE(nam) $PRICEPOST_DATA($i,0)
            incr i
        }
        set PRICEPOST(rows) [expr $i + 2]
        if { $PRICEPOST(rows) < 20 } { set PRICEPOST(rows) 20 }
        $w configure -rows $PRICEPOST(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc pricepost:write {} {
    global VS PRICEPOST_DATA PRICEPOST
    
    waiting "  ..." red
    for { set i 0 } { $i < [expr $PRICEPOST(rows) - 2 ] } { incr i } {
        if { $PRICEPOST_DATA($i,old_1) != $PRICEPOST_DATA($i,1) } {
            if { [ set socks [checkpasswd] ] != -1 } {
                puts $socks "pricepost_write $PRICEPOST_DATA($i,cod) $PRICEPOST_DATA($i,1)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                set PRICEPOST_DATA($i,old_1) $PRICEPOST_DATA($i,1)
            } else {
                errormsg nosocks "  !"
            }
        }
    }
    waiting "" ""
}
