proc prodagamat { tip } {
    global VS PRODAGAMAT SCHETTOV PRODAGAMAT_DATA

    set PRODAGAMAT(tip) $tip
    catch [unset PRODAGAMAT_DATA]
    set PRODAGAMAT(listbox,curselection) 0
    set PRODAGAMAT(find,listbox) {}
    if ![info exists PRODAGAMAT(entry,clockdatbegin)] {
        set PRODAGAMAT(entry,datbegin) "$VS(day).$VS(month).$VS(year)"
        set PRODAGAMAT(entry,datend)   "$VS(day).$VS(month).$VS(year)"
        set PRODAGAMAT(entry,clockdatbegin) $VS(clock)
        set PRODAGAMAT(entry,clockdatend) $VS(clock)
    }
    set w .prodagamat
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +5+55
    wm geometry $w =0x0
    set titstrtip ""
    if { $tip == "n" } {
        set titstrtip " "
    }
    if { $tip == "S" } {
        set titstrtip "   "
    }
    set titstr "     $titstrtip "
    wm title $w $titstr
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "prodagamat:find"
    $w1.1 add command -label "" -command "prodagamat:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable PRODAGAMAT(sortstr) -value "2" -command prodagamat:read
        $w1.1.sort add radio -label " " -variable PRODAGAMAT(sortstr) -value "3" -command prodagamat:read
        $w1.1.sort add radio -label "  " -variable PRODAGAMAT(sortstr) -value "4" -command prodagamat:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable PRODAGAMAT(sortdesc) -value " " -command prodagamat:read
        $w1.1.sort add radio -label " " -variable PRODAGAMAT(sortdesc) -value "desc" -command prodagamat:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -label "" -accelerator "<Enter>" -command prodagamat:doc
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable PRODAGAMAT(statusline) -relief sunken -anchor w -padx 3 -width 60
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find  print  sort  schet  exit } {
        if { $i == "print" } { findbox prodagamat 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""}  { $w.butimg.$i configure -state disabled }
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text $titstr -relief raised -anchor center -bd 1 -padx 3

    foreach i { p1 p2 p3 p4 p5 p6 } { frame $w.namefield.$i }
    foreach i { p1 p2 p3 } { $w.namefield.$i configure -relief raised -bd 1 }
    label $w.namefield.p1.1 -text "" -height 2 -anchor center -padx 1 -width 5
    label $w.namefield.p2.1 -text "" -height 2 -anchor center -padx 1 -width 6
    label $w.namefield.p3.1 -text "" -height 2 -anchor center -padx 1 -width 23
    if { $tip == "S" } {
        label $w.namefield.p4.1 -text "." -relief raised -anchor center -bd 1
        label $w.namefield.p5.1 -text "." -relief raised -anchor center -bd 1
    } else {
        label $w.namefield.p4.1 -text "" -relief raised -anchor center -bd 1
        label $w.namefield.p5.1 -text "" -relief raised -anchor center -bd 1
    }
    label $w.namefield.p6.1 -text "" -relief raised -anchor center -bd 1
    label $w.namefield.p4.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 9
    label $w.namefield.p4.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p5.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 9
    label $w.namefield.p5.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    label $w.namefield.p6.2 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 9
    label $w.namefield.p6.3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 10
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    foreach i { p1 p2 p3 p4 p5 p6 } {
        pack $w.namefield.$i -anchor w -side left -fill y
    }
    foreach i { p1.1 p2.1 p3.1 p4.1 p5.1 p6.1 } {
        catch [pack $w.namefield.$i -fill x]
    }
    foreach i { p4.2 p4.3 p5.2 p5.3 p6.2 p6.3 } {
        catch [pack $w.namefield.$i -side left]
    }

    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 96
    
    pack $w.lb -fill y
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
 
    frame $w.itogo
    
    pack $w.itogo -fill x
    foreach { i j } { l1 "                             : " l2 "" l3 "" l4 "" l5 "" l6 "" } {
        label $w.itogo.$i -text $j -bd 0
    }
    foreach { i j k } { sprods 9 gray70 sprodsd 10 gray70 spoks 9 gray80 spoksd 10 gray80 snacenkas 9 gray90 snacenkasd 10 gray90 } {
        label $w.itogo.$i -textvar PRODAGAMAT($i) -relief sunken -bd 1 -width $j -anchor e -bg $k -fg blue
    }
    foreach i { l1 sprods sprodsd spoks spoksd snacenkas snacenkasd } { 
        pack $w.itogo.$i -side left 
    }
    
    wm geometry $w [centerwindow $w]
    prodagamat:find
    
    bind $w.butimg.sort <Button-1> {
        .prodagamat.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .prodagamat.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set PRODAGAMAT(statusline) [ %W get $id ]
        set PRODAGAMAT(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .prodagamat.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { schet  } {
            .prodagamat.menu.1 entryconfigure [.prodagamat.menu.1 index $j] -state disabled
            .prodagamat.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { schet  } {
            .prodagamat.menu.1 entryconfigure [.prodagamat.menu.1 index $j] -state normal
            .prodagamat.butimg.$i configure -state normal
        }
    }
    bind $w <Key-Escape> { .prodagamat.buttons.exit invoke }
    bind $w <Key-F5>     { prodagamat:find }
    bind $w <Key-Return> { 
        event generate %W <B1-ButtonRelease>
        prodagamat:doc 
    }
    bind $w <Double-Button-1> { prodagamat:doc }
    bind $w <Key-F12>         { 
        event generate %W <B1-ButtonRelease>
        prodagamat:prodmattov 
    }
    focus $w.lb.listbox
}

proc prodagamat:doc {} {
    global PRODAGAMAT NAKLPLIST PRODAGAMAT_DATA
    
    set NAKLPLIST(pr) "r"
    if { $PRODAGAMAT(tip) == "s" || $PRODAGAMAT(tip) == "S" } {
        schetfnr 1 $PRODAGAMAT_DATA(cod,$PRODAGAMAT(listbox,curselection))
    } else {
        naklp 1 m $PRODAGAMAT_DATA(cod,$PRODAGAMAT(listbox,curselection)) .prodagamat
    }
}

proc prodagamat:entry:createvar {} {
    global PRODAGAMAT
    
    foreach i { num dat klientnam operacianam } {
        if ![info exists PRODAGAMAT(entry,$i)] {
            set PRODAGAMAT(entry,$i) ""
        }
    }
}

proc prodagamat:entry:clearvar {} {
    global PRODAGAMAT
    
    foreach i { num dat klientnam operacianam } {
        set PRODAGAMAT(entry,$i) ""
    }
}

proc prodagamat:entry {} {
    global VS PRODAGAMAT
    
    set w .prodagamat.entry
    set PRODAGAMAT(entrystatus) ""
    prodagamat:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { num dat klient operacia datotg } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "dat" || $i == "operacia" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { num      " " \
                      dat      "  " \
                      klient   "         " \
                      operacia "       " \
                      datotg   "    " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {num      num         20 \
                       dat      dat         20 \
                       klient   klientnam   50 \
                       operacia operacianam 50 \
                       datotg   datotg      20 \
                       } {
        entry $w.inf.$i.e -textvariable PRODAGAMAT(entry,$j) -width $k
    }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { prodagamat:heklient r .prodagamat.entry }
    button $w.inf.operacia.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { prodagamat:heoperacia r .prodagamat.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set PRODAGAMAT(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "prodagamat:entry:clearvar"
    button $w.buttons.exit -text "" -command "set PRODAGAMAT(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e klient.e klient.b \
                operacia.e operacia.b \
                datotg.e \
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.num.e
    bind $w <Key-Escape>     { .prodagamat.entry.buttons.exit invoke }
    bind $w <Control-Return> { .prodagamat.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc prodagamat:prodmattov {} {
    global PRODAGAMAT NAKLPLIST PRODAGAMAT_DATA
    
    set NAKLPLIST(pr) "r"
    switch -exact $PRODAGAMAT(tip) {
        s   { prodmattov $PRODAGAMAT_DATA(cod,$PRODAGAMAT(listbox,curselection)) s "  N - $PRODAGAMAT_DATA(num,$PRODAGAMAT(listbox,curselection))  $PRODAGAMAT_DATA(dat,$PRODAGAMAT(listbox,curselection)) " .prodagamat }
        i   { prodmattov $PRODAGAMAT_DATA(cod,$PRODAGAMAT(listbox,curselection)) i " N - $PRODAGAMAT_DATA(num,$PRODAGAMAT(listbox,curselection))  $PRODAGAMAT_DATA(dat,$PRODAGAMAT(listbox,curselection)) " .prodagamat }
        S   { prodmattov $PRODAGAMAT_DATA(cod,$PRODAGAMAT(listbox,curselection)) S "  N - $PRODAGAMAT_DATA(num,$PRODAGAMAT(listbox,curselection))  $PRODAGAMAT_DATA(dat,$PRODAGAMAT(listbox,curselection)) " .prodagamat }
    }
}
