proc schetfnr:schet {} {
    global VS SCHET

    set w .schetfnr.top.head.schet
    set SCHET(hebutton) 0
    
    label $w.tut -bg gray70 -wraplength 1 -width 2 -height 8 -font $VS(fontn) -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill x
    foreach { i } { num klientnam lgotanam prim1 prim2 } {
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
        if { $i == "num" || $i == "lgotanam" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
    }
    foreach { i j } { num       "N" \
                      klientnam " " \
                      lgotanam  " " \
                      prim1     "  1" \
                      prim2     "  2" \
                  } {
        label $w.$i.l -text $j
        pack $w.$i.l -side left
    }
    foreach { i j k } {num.num              num         5 \
                       num.dat              dat         10 \
                       num.operacianam      operacianam 27 \
                       num.datdolga         datdolga    10 \
                       klientnam.klientnam  klientnam   50 \
                       lgotanam.lgotanam    lgotanam    30 \
                       lgotanam.proc        proc        6 \
                       lgotanam.lgotaproc   lgotaproc   6 \
                       prim1.e              prim1       60 \
                       prim2.e              prim2       60 \
                       } {
        entry $w.$i -textvar SCHET($j) -width $k
    }
    $w.lgotanam.proc configure -state disabled
    $w.lgotanam.lgotanam configure -state disabled
    $w.num.datdolga configure -takefocus 0
    set SCHET(klientbalans) ""
    foreach { i j } { num.l1            "" \
                      num.l2            "" \
                      num.l3            " " \
                      klientnam.balans  "" \
                      lgotanam.l1       "% " \
                      lgotanam.l2       "%" \
                  } {
        label $w.$i -text $j
    }
    $w.klientnam.balans configure -textvar SCHET(klientbalans) -relief raised -width 10
    
    button $w.num.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set SCHET(hebutton) 1; schet:heoperacianam r .schetfnr.top.head.schet"
    button $w.klientnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set SCHET(hebutton) 1;  schet:heklientnam r .schetfnr.top.head.schet"
    
    foreach i {num.num num.l1 num.dat num.l2 num.operacianam num.b num.l3 num.datdolga\
               klientnam.klientnam klientnam.b klientnam.balans \
               lgotanam.lgotanam  lgotanam.proc lgotanam.l1 lgotanam.lgotaproc lgotanam.l2 \
               prim1.e \
               prim2.e \
              } {
        pack $w.$i -side left -fill y
    }
    foreach { i } { num.operacianam klientnam.klientnam } {
        bind $w.$i <FocusOut> {
            scan %W "%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%\[^.]" wn
            if { $SCHET(hebutton) == 0 } {
                if { "$SCHET(old_$wn)" != "$SCHET($wn)" } {
                    regsub -all " " "$SCHET($wn)" "" lng
                    if { [string length $lng] > 0 } {
                        schet:he$wn u .schetfnr.top.head.schet
                    } else { set SCHET($wn) "" }
                }
            }
        }
    }
    foreach { i } { num.operacianam klientnam.klientnam } {
        bind $w.$i <Button-1> {
            catch [destroy .schetfnr.top.head.schet.he]
        }
    }
    bind $w.lgotanam.lgotaproc <FocusOut> {
        schet:lgotaproc
    }
    bind $w.num.dat <FocusIn> {
        if { [clipped $SCHET(dat)] == "" } {
            set SCHET(dat) $VS(day).$VS(month).$VS(year)
        }
    }
    bind $w.num.datdolga <FocusIn> {
        if { [clipped $SCHET(datdolga)] == "" } {
            set SCHET(datdolga) $VS(day).$VS(month).$VS(year)
        }
    }
    bind $w.klientnam.balans <Enter> {
        %W configure -bg #00c0c0
    }
    bind $w.klientnam.balans <Leave> {
        %W configure -bg grey85
    }
    bind $w.klientnam.balans <ButtonPress-1> {
        %W configure -relief sunken
        schetfnr:schet:klientbalans
    }
    bind $w.klientnam.balans <ButtonRelease-1> {
        %W configure -relief raised
    }
    if { $SCHET(cod) == 0 } {
        focus $w.num.dat
    }
}

proc schetfnr:schet:klientbalans {} {
    global VS SCHET
    
    set w .schetfnr.top.head.schet.klientnam.balans
    if [info exists SCHET(klientcod)] {
        waiting "   $SCHET(klientnam) ..." magenta
        if { [ set socks [checkpasswd] ] != -1 } {
            puts $socks "klientbalans $SCHET(klientcod)"
            flush $socks
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set SCHET(klientbalans) [format "%9.2f" $str]
            }
            if { [ gets $socks ] != "0" } {
                errormsg $socks "     !"
            }
            close $socks
        } else {
            errormsg nosocks "  !"
        }
        waiting "" ""
    }
    if { $SCHET(klientbalans) < 0 } {
        $w configure -fg red
    }
    if { $SCHET(klientbalans) == 0 } {
        $w configure -fg green4
    }
    if { $SCHET(klientbalans) > 0 } {
        $w configure -fg blue
    }
}
