proc schetfnr { st schetcod } {
    global VS SCHETFNR SCHET FINNAKLR SCHETTOV SCHETTOV_DATA

    catch [unset SCHETFNR SCHET FINNAKLR SCHETTOV SCHETTOV_DATA]
    set SCHETFNR(st) $st
    schet:clear
    finnaklr:clear
    schettov:clear
    
    set SCHET(cod) $schetcod
    trace vdelete SCHETFNR(widthtbl) w schetfnr:trace:widthtbl
    set SCHETFNR(widthtbl) 1
    
    set w .schetfnr
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+50
    wm geometry $w =0x0
    wm title $w ""
    
    trace vdelete SCHETFNR(window) w schetfnr:trace:window
    trace variable SCHETFNR(window) w schetfnr:trace:window
    trace variable SCHETFNR(widthtbl) w schetfnr:trace:widthtbl
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.nala -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.width -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<Ins>" -state disabled -command schetfnr:insert
    $w1.1 add command -label "" -state disabled -command schetfnr:print
    $w1.1 add cascade -label " " -menu $w1.1.nala -state disabled
        $w1.1.nala add command -label " " -command schet:printkwit
        $w1.1.nala add command -label "   0.8%" -command "schet:objava n"
        $w1.1.nala add command -label "   0.8%" -command "schet:objava y"
        $w1.1.nala add separator
        $w1.1.nala add command -label "" 
    $w1.1 add cascade -label "" -menu $w1.1.sort -state disabled
        $w1.1.sort add radio -label "  " -variable SCHETTOV(sortstr) -value "tnam" -command schettov:read
        $w1.1.sort add radio -label "  " -variable SCHETTOV(sortstr) -value "koll" -command schettov:read
        $w1.1.sort add radio -label "  " -variable SCHETTOV(sortstr) -value "enam" -command schettov:read
        $w1.1.sort add radio -label " " -variable SCHETTOV(sortstr) -value "cenaa" -command schettov:read
        $w1.1.sort add radio -label "  " -variable SCHETTOV(sortstr) -value "pnam" -command schettov:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable SCHETTOV(sortdesc) -value " " -command schettov:read
        $w1.1.sort add radio -label " " -variable SCHETTOV(sortdesc) -value "desc" -command schettov:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete -state disabled
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command schetfnr:delete
    $w1.1 add separator
    $w1.1 add cascade -label "" -state disabled -menu $w1.1.width
        $w1.1.width add radio -label "" -variable SCHETFNR(widthtbl) -value 1
        $w1.1.width add radio -label "" -variable SCHETFNR(widthtbl) -value 2
    $w1.1 add separator
    $w1.1 add command -label " " -state disabled -command "nnakl:ident finnaklr"
    $w1.1 add command -label " " -accelerator "<F3>" -state disabled -command schetfnr:schettovt
    $w1.1 add command -label "   " -accelerator "<F8>" -state disabled -command schetfnr:whomathtov
    $w1.1 add command -state disabled -label "" -accelerator "<F11>" -command "prikid $w s $SCHET(cod)"
    $w1.1 add command -state disabled -label " 0.8%" -accelerator "Ctrl-b" -command schet:08
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command schetfnr:ok
    button $w.buttons.clear -text "" -command schetfnr:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    frame $w.top
    frame $w.top.head -bd 1 -relief raised
    frame $w.top.head.schet -bd 1
    frame $w.top.head.sep -bd 1 -height 3 -relief sunken
    frame $w.top.head.fnr -bd 1
    frame $w.top.other -bd 1 -relief ridge
    frame $w.tov -bd 1 -relief raised
    frame $w.top.sep -bd 1 -height 2 -relief sunken
    pack $w.top $w.tov -padx 5 -fill x
    pack $w.top.head -side left
    pack $w.top.other -side left -fill both
    pack $w.top.head.schet $w.top.head.sep $w.top.head.fnr -fill x
        
    foreach {i j} { insert "" print "" printkwit " " sort "" delete "" nalnakl " " tovt " " whomathtov "   " exit ""  } {
        if { $j != "" && $j != "" && $j != " " } {
            button $w.butimg.$i -state disabled -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} { button $w.butimg.$i -state disabled -takefocus 0 -image img_$i}
        if { $j == ""}     { button $w.butimg.$i -state disabled -takefocus 0 -image img_$i }
        if { $j == " "} { button $w.butimg.$i -state disabled -takefocus 0 -image img_$i }
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; $w.buttons.exit invoke"}
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    button $w.butimg.prikid -state disabled -takefocus 0 -bitmap @$VS(dir)Prikid.xbm -command "prikid $w s $SCHET(cod)"
    pack $w.butimg.prikid -before $w.butimg.exit -side left
    bind $w.butimg.prikid <Leave> { destroy .balloon }
    bind $w.butimg.prikid <Enter> { bindballoon %W }
    
    button $w.butimg.08 -state disabled -takefocus 0 -bitmap @$VS(dir)08.xbm -command schet:08
    pack $w.butimg.08 -before $w.butimg.exit -side left
    bind $w.butimg.08 <Leave> { destroy .balloon }
    bind $w.butimg.08 <Enter> { bindballoon %W }
    
    bind $w.butimg.delete <Button-1> {
        .schetfnr.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.sort <Button-1> {
        .schetfnr.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.printkwit <Button-1> {
        .schetfnr.menu.1.nala post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind .schetfnr <Button-1> { 
        if [regexp ^\.schetfnr\.top\.head\.schet|^\.schetfnr\.top\.head\.fnr|^\.schetfnr\.tov %W] {
            set SCHETFNR(window) %W 
        }
    }
    bind .schetfnr <Button-3> { 
        event generate %W <Button-1>
        if [regexp ^\.schetfnr\.top\.head\.schet|^\.schetfnr\.top\.head\.fnr|^\.schetfnr\.tov %W] {
            switch -regexp %W {
                ^\.schetfnr\.top\.head\.schet { set win ".schetfnr.top.head.schet" }
                ^\.schetfnr\.top\.head\.fnr   { set win ".schetfnr.top.head.fnr" }
                ^\.schetfnr\.tov              { set win ".schetfnr.tov" }
            }
            .schetfnr.menu.1 post [winfo pointerx %W] [winfo pointery %W]
        }
    }
    bind $w <Key-Escape>         { .schetfnr.buttons.exit invoke }
    bind $w <Key-F2>             { schetnnakl %W }
    bind $w <Key-F3>             { schetfnr:schettovt }
    bind $w <Key-F7>             { schetspis }
    bind $w <Key-F8>             { schetfnr:whomathtov }
    bind $w <Key-F9>             { schetfnr:schetopl }
    bind $w <Key-F11>            [list prikid $w s $SCHET(cod)]
    bind $w <Key-F12>            { prodmattov $SCHET(cod) s " N - $SCHET(num)  $SCHET(dat) " .schetfnr }
    bind $w <Control-p>          { postpol:update schetfnr }
    bind $w <Control-P>          { postpol:update schetfnr }
    bind $w <Control-ccedilla>   { postpol:update schetfnr }
    bind $w <Control-Ccedilla>   { postpol:update schetfnr }
    bind $w <Control-u>          { schetfnr:controlu }
    bind $w <Control-U>          { schetfnr:controlu }
    bind $w <Control-b>          { schet:08 }
    bind $w <Control-B>          { schet:08 }
    bind $w <Control-egrave>     { schet:08 }
    bind $w <Control-Egrave>     { schet:08 }
    bind $w <Control-atilde>     { schetfnr:controlu }
    bind $w <Control-Atilde>     { schetfnr:controlu }
    if { $VS(login) != "buh" } {
        bind $w <Key-F4>     { schetrez }
        bind $w <Key-F6>     { schetotg }
    }
    schetfnr:schet
    schetfnr:fnr
    schetfnr:other
    schetfnr:tov
    schetfnr:alldisabled
    wm geometry $w [centerwindow $w]
    update
    
    if { $SCHET(cod) > 0 } {
        schet:read
        finnaklr:read
        schettov:read
    }
}

proc schetfnr:iconmenu:state {s l} {
    set w .schetfnr
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        catch [$w.butimg.$statei configure -state $s]
    }
}

proc schetfnr:trace:widthtbl { name1 name2 op } {
    global SCHETFNR
    
    .schetfnr.tov.tbl configure -rowheight $SCHETFNR(widthtbl) -height [expr 8 / $SCHETFNR(widthtbl)]
}

proc schetfnr:trace:window { name1 name2 op } {
    global SCHETFNR SCHETTOV SCHET FINNAKLR
    
    foreach i { top.head.schet top.head.fnr tov } {
        .schetfnr.$i.tut configure -fg black -bg gray70 -relief sunken
    }
    schetfnr:iconmenu:state disabled "insert  print  printkwit \" \" sort  delete  nalnakl \" \" tovt \" \" width  whomathtov \"   \" prikid  08 \" 0.8%\""
    switch -regexp $SCHETFNR(window) {
        ^\.schetfnr\.top\.head\.schet {
            schetfnr:iconmenu:state normal "print  printkwit \" \" delete  prikid  08 \" 0.8%\""
            .schetfnr.top.head.schet.tut configure -fg blue -bg gray90 -relief raised
            if { $SCHET(cod) == 0 } { 
                .schetfnr.top.head.schet.num.num configure -state disabled 
            } else {
                .schetfnr.top.head.schet.num.num configure -state normal
            }
        }
        ^\.schetfnr\.top\.head\.fnr {
            if { $SCHET(cod) > 0 } { 
                schetfnr:iconmenu:state normal "print  delete  nalnakl \" \" prikid  08 \" 0.8%\""
            }
            .schetfnr.top.head.fnr.tut configure -fg blue -bg gray90 -relief raised
            if { [clipped $FINNAKLR(num)] == "" } { 
                .schetfnr.top.head.fnr.num.num configure -state disabled 
            } else {
                .schetfnr.top.head.fnr.num.num configure -state normal
            }
        }
        ^\.schetfnr\.tov {
            if { $SCHET(cod) > 0 } { 
                schetfnr:iconmenu:state normal "insert  print  sort  delete  width  tovt \" \" whomathtov \"   \" prikid  08 \" 0.8%\""
            }
            .schetfnr.tov.tut configure -fg blue -bg gray90 -relief raised
        }
    }
    schetfnr:alldisabled
}

proc schetfnr:insert {} {
    global SCHETFNR SCHET FINNAKLR SCHETTOV SCHETTOV_DATA
    
    switch -regexp $SCHETFNR(window) {
        ^\.schetfnr\.top\.head\.schet {
            #schet:clear
            #finnaklr:clear
            #schettov:clear
        }
        ^\.schetfnr\.top\.head\.fnr {
        }
        ^\.schetfnr\.tov {
            .schetfnr.tov.tbl configure -rows [incr SCHETTOV(rows)]
        }
    }        
}

proc schetfnr:print {} {
    global SCHETTOV SCHETFNR SCHET
    
    switch -regexp $SCHETFNR(window) {
        ^\.schetfnr\.top\.head\.schet {
            schet:print
        }
        ^\.schetfnr\.top\.head\.fnr {
            finnaklr:print
        }
        ^\.schetfnr\.tov {
            schettov:print
        }
    }        
}

proc schetfnr:delete {} {
    global SCHETTOV SCHETFNR SCHET
    
    switch -regexp $SCHETFNR(window) {
        ^\.schetfnr\.top\.head\.schet {
            schet:delete $SCHET(cod)
        }
        ^\.schetfnr\.top\.head\.fnr {
            finnaklr:delete
        }
        ^\.schetfnr\.tov {
            schettov:delete
        }
    }        
}

proc schetfnr:clear {} {
    global SCHETFNR
    
    switch -regexp $SCHETFNR(window) {
        ^\.schetfnr\.top\.head\.schet {
            schet:clear
        }
        ^\.schetfnr\.top\.head\.fnr {
            finnaklr:clear
        }
        ^\.schetfnr\.tov {
            schettov:clear
        }
    }        
}

proc schetfnr:other {} {
    global VS
    
    set w .schetfnr.top.other
    if { $VS(login) == "buh" } {
        foreach { i j } { nnakl " <F2>" opl " <F9>" spis " <F7>" } {
            button $w.$i -text $j -width 9 -takefocus 0 -wraplength 75 -bg grey80 -command schet$i
            pack $w.$i -padx 2 -pady 0 -fill x
        }
        $w.nnakl configure -command "schetnnakl .schetfnr"
        $w.opl configure -command "schetfnr:schetopl"
    } else {
        foreach { i j } { nnakl " <F2>" opl " <F9>" rez " <F4>" otg " <F6>" spis " <F7>" } {
            button $w.$i -text $j -width 9 -takefocus 0 -wraplength 75 -bg grey80 -command schet$i
            pack $w.$i -padx 2 -pady 0 -fill x
        }
        $w.nnakl configure -command "schetnnakl .schetfnr"
        $w.opl configure -command "schetfnr:schetopl"
    }
}

proc schetfnr:ok {} {
    global VS SCHET FINNAKLR SCHETTOV SCHETTOV_DATA

    #   
    if { $SCHET(cod) == 0 } {
        schet:insert
    } elseif { $SCHET(cod) > 0 } {
        if { $SCHET(num) != $SCHET(old_num) \
             || $SCHET(dat) != $SCHET(old_dat) \
             || $SCHET(datdolga) != $SCHET(old_datdolga) \
             || $SCHET(operaciacod) != $SCHET(old_operaciacod) \
             || $SCHET(klientcod) != $SCHET(old_klientcod) \
             || $SCHET(lgotaproc) != $SCHET(old_lgotaproc) \
             || $SCHET(prim1) != $SCHET(old_prim1) \
             || $SCHET(prim2) != $SCHET(old_prim2) } {
            schet:update
        }
    }
    #   
    if { $SCHET(cod) > 0 } {
        if { [clipped $FINNAKLR(num)] == "" && \
             $FINNAKLR(skladcod) > 0 && \
             [clipped $FINNAKLR(dat)] != "" } {
            finnaklr:insert
        } elseif { $FINNAKLR(old_num) != $FINNAKLR(num) || \
                   $FINNAKLR(old_dat) != $FINNAKLR(dat) || \
                   $FINNAKLR(old_skladcod) != $FINNAKLR(skladcod) || \
                   $FINNAKLR(old_dovnum) != $FINNAKLR(dovnum) || \
                   $FINNAKLR(old_dovdat) != $FINNAKLR(dovdat) || \
                   $FINNAKLR(old_dovwho) != $FINNAKLR(dovwho) } {
            finnaklr:update
        }
    }
    #     
    if { $SCHET(cod) > 0 } {
        set i 0
        while 1 {
            if [info exists SCHETTOV_DATA($i,tovarcod)] {
                if ![info exists SCHETTOV_DATA($i,cod)] {
                    schettov:insert $i
                } else { 
                    if { $SCHETTOV_DATA($i,cod) <= 0 } {
                        schettov:insert $i
                    }
                    if { $SCHETTOV_DATA($i,cod) > 0 } {
                        if { $SCHETTOV_DATA($i,old_tovarcod) != $SCHETTOV_DATA($i,tovarcod) || \
                             $SCHETTOV_DATA($i,old_1) != $SCHETTOV_DATA($i,1) || \
                             $SCHETTOV_DATA($i,old_3) != $SCHETTOV_DATA($i,3) || \
                             "$SCHETTOV_DATA($i,old_4)" != "$SCHETTOV_DATA($i,4)" } {
                            schettov:update $i
                        }
                    }
                }
            } else break
            incr i
        }
    }
    set VS(.schetfnr_update) 0
}

proc schetfnr:schettovt {} {
    global SCHETTOV SCHETTOV_DATA
    
    set rt [schettovt]
    if ![info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),4)] {
        set SCHETTOV_DATA($SCHETTOV(ActiveRow),4) [lindex $rt 1]
    }
    if { $SCHETTOV_DATA($SCHETTOV(ActiveRow),3) == 0 } {
        set SCHETTOV_DATA($SCHETTOV(ActiveRow),3) [lindex $rt 0]
    }
}

proc schetfnr:whomathtov {} {
    global SCHETTOV_DATA SCHETTOV
    
    if [info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcod)] {
        whomathtov .schetfnr $SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcod) $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)
    }
}

proc schetfnr:alldisabled {} {
    global SCHETFNR
    
    if { $SCHETFNR(st) == 0 } {
        set w .schetfnr.buttons
        foreach i { clear ok } { $w.$i configure -state disabled }
        set w .schetfnr.top.other
        foreach i { nnakl opl rez otg spis } { catch [$w.$i configure -state disabled] }
        set w .schetfnr.butimg
        foreach i { insert delete nalnakl } { $w.$i configure -state disabled }
        set w .schetfnr.menu.1
        foreach i {   " " } { $w entryconfigure [$w index $i] -state disabled }
        $w.delete entryconfigure [$w.delete index " !!!"] -state disabled
    }
}

proc schetrez {} {
    spisanie r .schetfnr s
}

proc schetotg {} {
    spisanie o .schetfnr s
}

proc schetspis {} {
    spisanie s .schetfnr s
}

proc schetfnr:schetopl {} {
    global SCHET

    docopl .schetfnr s $SCHET(cod)
}

proc schetfnr:controlu {} {
    global SCHETFNR SCHET SCHETTOV SCHETTOV_DATA

    switch -regexp [focus] {
        ^\.schetfnr\.top\.head\.schet {
            if [info exists SCHET(cod)] { 
                controlu $SCHET(cod) schetfnr 
            }
        }
        ^\.schetfnr\.top\.head\.fnr {
            if [info exists SCHET(cod)] { 
                controlu $SCHET(cod) schetfnr
            }
        }
        ^\.schetfnr\.tov {
            if [info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)] { 
                controlu $SCHETTOV_DATA($SCHETTOV(ActiveRow),cod) schfnrtov
            }
        }
    }
}
