proc schetnnakl { win } {
    global VS SCHETNNAKL SCHETTOV

    set SCHETNNAKL(listbox,curselection) 0
    
    set SCHETNNAKL(inwin) $win
    set w $SCHETNNAKL(inwin).schetnnakl
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +176+70
    wm geometry $w =0x0
    wm title $w "  "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -state disabled -label "" -command "schetnnakl:print"
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command "schetnnakl:nnakl 0"
    $w1.1 add command -state disabled -accelerator "<Enter>" -label "" -command "schetnnakl:nnakl 1"
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set SCHETNNAKL(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set SCHETNNAKL(deletestatus) 1; schetnnakl:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -label "" -accelerator "<Esc>" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable SCHETNNAKL(statusline) -relief sunken -anchor w -padx 3 -width 30
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {print  view  update  delete  exit } {
        if { $j != "" } {
            button $w.butimg.$i -state disabled -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text "  " -relief raised -anchor center -bd 1 -padx 3 -width 27
    label $w.namefield.p1 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 14
    label $w.namefield.p2 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p3 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 7
    label $w.namefield.p4 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p5 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    label $w.namefield.p6 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 11
    pack $w.namefield -side top -anchor w
    pack $w.namefield.l -side top
    pack $w.namefield.p1 $w.namefield.p2 $w.namefield.p3 $w.namefield.p4 $w.namefield.p5 $w.namefield.p6 -side left

    frame $w.lb
    frame $w.itogo1
    frame $w.itogo2
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 10 -width 67
    label $w.itogo1.l1 -text "                           :"
    label $w.itogo1.snnakl -textvar SCHETNNAKL(snnakl) -bd 1 -relief sunken -anchor e -width 11
    label $w.itogo1.snnakl2 -textvar SCHETNNAKL(snnakl2) -bd 1 -relief sunken -anchor e -width 11
    label $w.itogo2.l1 -text "                               :"
    label $w.itogo2.sschet -textvar SCHETTOV(scena) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    pack $w.itogo1.l1 $w.itogo1.snnakl $w.itogo1.snnakl2 $w.itogo2.l1 $w.itogo2.sschet -side left
    
    pack $w.lb $w.itogo1 $w.itogo2 -fill both
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    schetnnakl:read
    
    bind $w.butimg.delete <Button-1> {
        $SCHETNNAKL(inwin).schetnnakl.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy $SCHETNNAKL(inwin).schetnnakl.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        scan [ %W get $id ] "%%s%%s%%s%%s" po num dat summa
        if [info exists num] {
            set SCHETNNAKL(statusline) "$num $dat $summa"
        }
        set SCHETNNAKL(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        $SCHETNNAKL(inwin).schetnnakl.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { print  view  update  delete  } {
            $SCHETNNAKL(inwin).schetnnakl.menu.1 entryconfigure [$SCHETNNAKL(inwin).schetnnakl.menu.1 index $j] -state disabled
            $SCHETNNAKL(inwin).schetnnakl.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { print  view  update  delete  } {
            $SCHETNNAKL(inwin).schetnnakl.menu.1 entryconfigure [$SCHETNNAKL(inwin).schetnnakl.menu.1 index $j] -state normal
            $SCHETNNAKL(inwin).schetnnakl.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists SCHETNNAKL_DATA(cod,$SCHETNNAKL(listbox,curselection))] {
            schetnnakl:nnakl 1
        }
    }
    bind $w.lb.listbox <Key-Return> {
        if [info exists SCHETNNAKL_DATA(cod,$SCHETNNAKL(listbox,curselection))] {
            schetnnakl:nnakl 1
        }
        event generate %W <B1-ButtonRelease>
    }
    bind $w <Key-Escape> {
        $SCHETNNAKL(inwin).schetnnakl.buttons.exit invoke
    }
    focus $w.lb.listbox
}

proc schetnnakl:cor {} {
    global SCHETNNAKL SCHETNNAKL_DATA NNAKL NNAKL_DATA NNAKLTOV

    set w $SCHETNNAKL(inwin).schetnnakl.lb.listbox
    if [winfo exists $w] {
        set id $SCHETNNAKL(listbox,curselection)
        $w delete $id $id
        $w insert $id [format "       %-1s            %-1s      %6i %-10s %10.2f" \
            $SCHETNNAKL_DATA(pon,$id) \
            $SCHETNNAKL_DATA(poo,$id) \
            $NNAKL(num) \
            $NNAKL(dat) \
            $NNAKLTOV(ssumma)]
        set SCHETNNAKL_DATA(num,$id) $NNAKL(num)
        set SCHETNNAKL_DATA(dat,$id) $NNAKL(dat)
        set SCHETNNAKL_DATA(summa,$id) $NNAKLTOV(ssumma)
        $w selection set $id $id
        set SCHETNNAKL(statusline) "$NNAKL(num) $NNAKL(dat) $NNAKLTOV(ssumma)"
        schetnnakl:summa
    }
}

proc schetnnakl:nnakl { st } {
    global SCHETNNAKL SCHETNNAKL_DATA
    
    nnakl $st $SCHETNNAKL_DATA(cod,$SCHETNNAKL(listbox,curselection)) $SCHETNNAKL(inwin).schetnnakl
}
