proc schetnnakl:summa {} {
    global SCHETNNAKL SCHETNNAKL_DATA SCHETTOV
    
    set w $SCHETNNAKL(inwin).schetnnakl.itogo1.snnakl
    set i 0
    set SCHETNNAKL(snnakl) 0
    set SCHETNNAKL(snnakl2) 0
    while { $i <= $SCHETNNAKL(listbox,count) } {
        catch [set SCHETNNAKL(snnakl) [expr $SCHETNNAKL(snnakl) + $SCHETNNAKL_DATA(summa,$i)]]
        catch [set SCHETNNAKL(snnakl2) [expr $SCHETNNAKL(snnakl2) + $SCHETNNAKL_DATA(summands,$i)]]
        incr i
    }
    if { $SCHETNNAKL(snnakl) == $SCHETTOV(scena) } { set color green }
    if { $SCHETNNAKL(snnakl) < $SCHETTOV(scena) } { set color red }
    if { $SCHETNNAKL(snnakl) > $SCHETTOV(scena) } { set color magenta }
    $w configure -bg $color
}

proc schetnnakl:read {} {
    global VS SCHETNNAKL SCHETNNAKL_DATA SCHET
    
    set w $SCHETNNAKL(inwin).schetnnakl.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    
    $w delete 0 end
    
    catch [unset SCHETNNAKL_DATA]
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "schetnnakl_sel $SCHET(cod)"
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach { j } { cod pon poo num dat summa summands } {
                set SCHETNNAKL_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SCHETNNAKL_DATA(cod,$i) \
                SCHETNNAKL_DATA(pon,$i) \
                SCHETNNAKL_DATA(poo,$i) \
                SCHETNNAKL_DATA(num,$i) \
                SCHETNNAKL_DATA(dat,$i) \
                SCHETNNAKL_DATA(summa,$i) \
                SCHETNNAKL_DATA(summands,$i)
            if { [clipped $SCHETNNAKL_DATA(summa,$i)] == "" } {
                set SCHETNNAKL_DATA(summa,$i) "      0.00"
            }
            $w insert end [format "       %-1s            %-1s      %-5s %-10s %-10s %-10s " \
                $SCHETNNAKL_DATA(pon,$i) \
                $SCHETNNAKL_DATA(poo,$i) \
                $SCHETNNAKL_DATA(num,$i) \
                $SCHETNNAKL_DATA(dat,$i) \
                $SCHETNNAKL_DATA(summa,$i) \
                $SCHETNNAKL_DATA(summands,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set SCHETNNAKL(statusline) " $i ."
        }
        set SCHETNNAKL(listbox,count) [expr $i - 1]
        schetnnakl:summa
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc schetnnakl:delete {} {
    global VS SCHETNNAKL SCHETNNAKL_DATA
    
    set w $SCHETNNAKL(inwin).schetnnakl.lb.listbox
    if { $SCHETNNAKL(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $SCHETNNAKL(listbox,curselection)
            puts $socks "nnakl_del $SCHETNNAKL_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            schetnnakl:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $SCHETNNAKL(listbox,count)} {
            set id $SCHETNNAKL(listbox,count)
            set SCHETNNAKL(listbox,curselection) $SCHETNNAKL(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        set SCHETNNAKL(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set SCHETNNAKL(deletestatus) 0
}

proc schetnnakl:print {} {
    global VS SCHET

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schetnnakl_rep $SCHET(cod) \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
