proc schettovt:varold { i } {
    global SCHETTOVT_DATA

    set SCHETTOVT_DATA($i,old_tovarcod) $SCHETTOVT_DATA($i,tovarcod)
    set SCHETTOVT_DATA($i,old_0)        $SCHETTOVT_DATA($i,0)
    set SCHETTOVT_DATA($i,old_1)        $SCHETTOVT_DATA($i,1)
    set SCHETTOVT_DATA($i,old_3)        $SCHETTOVT_DATA($i,3)
}

proc schettovt:clear {} {
    global VS SCHETTOVT_DATA SCHETTOVT SCHET
    
    catch [unset SCHETTOVT_DATA]
    set SCHETTOVT_DATA(-1,-1) " "
    set SCHETTOVT_DATA(-1,0) " "
    set SCHETTOVT_DATA(-1,1) "."
    set SCHETTOVT_DATA(-1,2) ". ."
    set SCHETTOVT_DATA(-1,3) ""
}

proc schettovt:read {} {
    global VS SCHETTOVT_DATA SCHETTOVT SCHETTOV SCHETTOV_DATA
    
    schettovt:clear
    set w .schetfnr.schettovt.dat.tbl
    waiting "  ..." blue
    if { $SCHETTOVT(id) == 1 } {
        if { $SCHETTOVT(sortstr) == "" }    { set SCHETTOVT(sortstr) "tnam" } 
    } else {
        if { $SCHETTOVT(sortstr) == "" }    { set SCHETTOVT(sortstr) "9" } 
    }
    if { $SCHETTOVT(sortdesc) == "" }   { set SCHETTOVT(sortdesc) " "  }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        if { $SCHETTOVT(id) == 1 } {
            puts $socks "schettovt_sel \"$SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)\" \"$SCHETTOVT(sortstr) $SCHETTOVT(sortdesc)\""
        } else {
            puts $socks "schettovt2_sel \"$SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)\" \"$SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcod)\" \"$SCHETTOVT(sortstr) $SCHETTOVT(sortdesc)\""
        }
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set SCHETTOVT_DATA($i,cod) "";   set SCHETTOVT_DATA($i,tovarcod) "" 
            set SCHETTOVT_DATA($i,-1) "";    set SCHETTOVT_DATA($i,tovarcena) ""
            set SCHETTOVT_DATA($i,0) "";     set SCHETTOVT_DATA($i,1) ""
            set SCHETTOVT_DATA($i,2) "";     set SCHETTOVT_DATA($i,3) ""
            
            if { $SCHETTOVT(id) == 1 } {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    SCHETTOVT_DATA($i,cod)       SCHETTOVT_DATA($i,tovarcod) \
                    SCHETTOVT_DATA($i,tovarcena) \
                    SCHETTOVT_DATA($i,0)         SCHETTOVT_DATA($i,1) \
                    SCHETTOVT_DATA($i,2)         SCHETTOVT_DATA($i,3)
            } else {
                scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    SCHETTOVT_DATA($i,cod)         SCHETTOVT_DATA($i,tovarcod) \
                    SCHETTOVT_DATA($i,tovartipcod) SCHETTOVT_DATA($i,tovarcena) \
                    SCHETTOVT_DATA($i,-1)          SCHETTOVT_DATA($i,0) \
                    SCHETTOVT_DATA($i,1)           SCHETTOVT_DATA($i,2) \
                    SCHETTOVT_DATA($i,3)
            }
            
            set SCHETTOVT_DATA($i,0)            [clipped $SCHETTOVT_DATA($i,0)]
            set SCHETTOVT_DATA($i,1)            [clipped $SCHETTOVT_DATA($i,1)]            
            schettovt:varold $i
        }
        if [info exists SCHETTOVT(ActiveRow)] { 
            if { $i < $SCHETTOVT(ActiveRow) && $i >= 0 } { set SCHETTOVT(ActiveRow) $i }
            $w see $SCHETTOVT(ActiveRow),0
            $w activate $SCHETTOVT(ActiveRow),$SCHETTOVT(ActiveCol)
        }
        
        set SCHETTOVT(rows) [expr $i + 2]
        if { $SCHETTOVT(id) == 1 } {  
            if { $SCHETTOVT(rows) < 10 } { set SCHETTOVT(rows) 10 }
        } else {
            if { $SCHETTOVT(rows) < 18 } { set SCHETTOVT(rows) 18 }
        }
        $w configure -rows $SCHETTOVT(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    schettovt:summa
    waiting "" ""
}

proc schettovt:delete {} {
    global VS SCHETTOVT SCHETTOVT_DATA
    
    set w .schetfnr.schettovt.dat.tbl
    if [info exists SCHETTOVT(ActiveRow)] {
        if [info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),cod)] {
            set SCHETTOVT_DATA(active) ""
            $w tag row UnSelectRow $SCHETTOVT(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $SCHETTOVT(ActiveRow)
                waiting "  ..." red
                puts $socks "schettovt_del $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row Normal $SCHETTOVT(ActiveRow)
                waiting "" ""
                schettovt:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc schettovt:insert { row } {
    global VS SCHETTOVT_DATA SCHETTOVT SCHETTOV SCHETTOV_DATA SCHET
    
    set w .schetfnr.schettovt.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "schettovt_ins $SCHET(cod) $SCHETTOV_DATA($SCHETTOV(ActiveRow),cod) \
                                  $SCHETTOVT_DATA($row,tovarcod) \
                                  \"$SCHETTOVT_DATA($row,1)\" \
                                  \"$SCHETTOVT_DATA($row,3)\" "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SCHETTOVT_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set SCHETTOVT_DATA($row,0)  [clipped $SCHETTOVT_DATA($row,0)]
            schettovt:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schettovt:update { row } {
    global VS SCHETTOVT_DATA SCHETTOVT SCHET
    
    set w .schetfnr.schettovt.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "schettovt_upd \"$SCHETTOVT_DATA($row,cod)\" \
                                  \"$SCHETTOVT_DATA($row,tovarcod)\" \
                                  \"$SCHETTOVT_DATA($row,1)\" \
                                  \"$SCHETTOVT_DATA($row,3)\" "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            schettovt:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schettovt:hetovarnam { tip win } {
    global VS SCHETTOVT_DATA HE SCHETTOVT SCHETTOV SCHETTOV_DATA SCHET
    
    set w .schetfnr.schettovt.curfldval
    set HE(tit) "                                 ..               "
    if { $SCHETTOVT(id) == 1 } {
        set tt ""
        set tbl tovar
        set pop 0
    } else {
        if [info exists SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovartipcod)] {
            if { $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovartipcod) > 0 } {
                set tt "$SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovartipcod):"
                set tbl tovarbytip
                set pop 45
            } else {
                set tt ""
                set tbl tovar
                set pop 45
            }
        } else {
            set tt ""
            set tbl tovar
            set pop 45
        }
    }
    he [expr [winfo rootx $w] - $pop ] [expr [winfo rooty $w] + [winfo height $w]] 6 75 $tbl "$tt$SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)" $tip $win
    scan $HE(cod) "%\[^\003]%*c%s" \
        SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovarcod) \
        SCHETTOVT_DATA($SCHETTOVT(ActiveRow),eicod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
        SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0) \
        SCHETTOVT_DATA($SCHETTOVT(ActiveRow),2) \
        SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3) \
        fuf
    set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)         [clipped $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),0)]
    set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),tovarcena) $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3)
    if { $SCHET(lgotaproc) >= 0 } {
        catch [set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3) [expr $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3) - $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3) * $SCHET(lgotaproc) / 100 ]]
    }
    set SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3) [clipped $SCHETTOVT_DATA($SCHETTOVT(ActiveRow),3)]
}

proc schettovt:print {} {
    global VS SCHETTOV SCHETTOV_DATA SCHETTOVT

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        if { $SCHETTOVT(id) == 1 } {
            puts $socks "schettovt1_rep \"$SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)\" \"$SCHETTOVT(sortstr) $SCHETTOVT(sortdesc)\" \"$VS(lp)\""
        } else {
            puts $socks "schettovt2_rep \"$SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)\" \"$SCHETTOVT(sortstr) $SCHETTOVT(sortdesc)\" \"$VS(lp)\""
        }
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc schettovt:lgotaproc {} {
    global SCHET SCHETTOVT_DATA
    
    if { [string length $SCHET(lgotaproc)] > 0 } {
        set i 0
        waiting "      ..." cyan4
        for { set j 0 } { $j < 50000 } { incr j } {set a 0}
        while 1 {
            if [ info exists SCHETTOVT_DATA($i,3) ] {
                if { $SCHETTOVT_DATA($i,3) >= "0" } {
                    set SCHETTOVT_DATA($i,3) [expr $SCHETTOVT_DATA($i,tovarcena) - $SCHETTOVT_DATA($i,tovarcena) * $SCHET(lgotaproc) / 100 ]
                }
            } else break
            incr i
        }
        waiting "" ""
    }
}
