proc sernumhead:clear {} {
    global SERNUM_DATA SERNUMTOV_DATA
    
    catch [unset SERNUM_DATA]
    foreach i {tipdoc num dat skladnam operacianam klientnam prim1 \
               tovarnam datotg } {
        set SERNUM_DATA($i) ""
    }
#    set SERNUMTOV_DATA(active) ""
}

proc sernumtov:clear {} {
    global SERNUMTOV_DATA SERNUM_DATA
    
    sernumhead:clear
    catch [unset SERNUMTOV_DATA]
    set SERNUMTOV_DATA(-1,0) " "
    set SERNUMTOV_DATA(-1,1) " "
    set SERNUMTOV_DATA(-1,2) " ."
    set SERNUMTOV_DATA(-1,3) ". ."
    set SERNUMTOV_DATA(-1,4) ""
    set SERNUMTOV_DATA(-1,5) ""
}

proc sernum:read { } {
    global VS SERNUM SERNUMTOV SERNUMTOV_DATA
    
    set w .sernum.tov
    waiting "  ..." blue
    sernumtov:clear
    # 1  
    set dat1 [clock format [expr $VS(clock) - 604800 ] -format %d/%m/%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 86400 ] -format %d/%m/%Y]
    if { $SERNUM(sortstr) == "" }    { set SERNUM(sortstr) "3" } 
    if { $SERNUM(sortdesc) == "" }   { set SERNUM(sortdesc) " "  }
    if { $SERNUM(find) == "" } {
        set SERNUM(find) "a.dat >= '$dat1' and a.dat <= '$dat2'"
        if [info exists SERNUM(find,listbox)] {
            if { [lsearch -exact $SERNUM(find,listbox) $SERNUM(find)] == -1} {
                lappend SERNUM(find,listbox) $SERNUM(find)
            }
        } else {
            lappend SERNUM(find,listbox) $SERNUM(find)
        }
    } 
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sernum_sel $SERNUM(tip) \"$SERNUM(find)\" \"$SERNUM(sortstr) $SERNUM(sortdesc)\""
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { opercod tipdoc num dat skladnam operacianam \
                        klientnam prim1 0 1 2 3 4 5 } {
                set SERNUMTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SERNUMTOV_DATA($i,opercod) \
                SERNUMTOV_DATA($i,tipdoc) \
                SERNUMTOV_DATA($i,num) \
                SERNUMTOV_DATA($i,dat) \
                SERNUMTOV_DATA($i,skladnam) \
                SERNUMTOV_DATA($i,operacianam) \
                SERNUMTOV_DATA($i,klientnam) \
                SERNUMTOV_DATA($i,prim1) \
                SERNUMTOV_DATA($i,datotg) \
                SERNUMTOV_DATA($i,0) \
                SERNUMTOV_DATA($i,1) \
                SERNUMTOV_DATA($i,2) \
                SERNUMTOV_DATA($i,3) \
                SERNUMTOV_DATA($i,4) \
                SERNUMTOV_DATA($i,5)
            
            set SERNUMTOV_DATA($i,1)     [clipped $SERNUMTOV_DATA($i,1)]
            set SERNUMTOV_DATA($i,2)     [clipped $SERNUMTOV_DATA($i,2)]
            set SERNUMTOV_DATA($i,old_1) $SERNUMTOV_DATA($i,1)
            set SERNUMTOV_DATA($i,old_2) $SERNUMTOV_DATA($i,2)
            incr i
        }
        
        set SERNUMTOV(rows) [expr $i + 1]
        if { $SERNUMTOV(rows) < 12 } { set SERNUMTOV(rows) 12 }
        $w.tbl configure -rows $SERNUMTOV(rows)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    if ![info exists SERNUMTOV(ActiveRowCol)] {
        $w.tbl activate 0,1
        sernumtov:browsecommand 0
    } else {
        $w.tbl activate $SERNUMTOV(ActiveRow),1
        sernumtov:browsecommand $SERNUMTOV(ActiveRow)
    }
    
    update
}

proc sernum:find {} {
    global VS SERNUM SERNUMTOV SERNUM_DATA
    
    sernum:entry
    if { $SERNUM(tip) == "p" } {
        set snfield "b.sernum"
    } else {
        set snfield "b1.sernum"
    }
    if { $SERNUM(entrystatus) == 1 } {
        set SERNUM(find) "1=1"
        foreach {i j} " \"$SERNUM(entry,num)\"          a.num \
                        \"$SERNUM(entry,dat)\"          a.dat \
                        \"$SERNUM(entry,skladnam)\"     c.nam \
                        \"$SERNUM(entry,operacianam)\"  d.nam \
                        \"$SERNUM(entry,klientnam)\"    e.nam \
                        \"$SERNUM(entry,tovarnam)\"     f.nam \
                        \"$SERNUM(entry,sernum)\"       $snfield \
                        \"$SERNUM(entry,dat_gar)\"      b.dat_gar \
                        \"$SERNUM(entry,cena)\"         b.cena \
                        \"$SERNUM(entry,cenad)\"        b.cenad \
                       " {
            if { $i != "" } {
                set SERNUM(find) "$SERNUM(find) and $j [construct $i]"
            }    
        }
        if { [string length [clipped $SERNUM(entry,tipdoc)]] > 0 } {
            if { $SERNUM(entry,tipdoc) == "null" } {
                set SERNUM(find) "$SERNUM(find) and b.sernum [construct $SERNUM(entry,tipdoc)]"
            } else {
                set SERNUM(find) "$SERNUM(find) and a.tip = $SERNUM(entry,tipdoccod)"
            }
        }
        if { [lsearch -exact $SERNUM(find,listbox) $SERNUM(find)] == -1} {
            lappend SERNUM(find,listbox) $SERNUM(find)
        }
        sernum:read
    }
    set SERNUM(entrystatus) 0
}

proc sernum:hetipdoc { tip win } {
    global VS SERNUM HE
    
    set w .sernum.entry.inf.tipdoc.e
    if { $SERNUM(tip) == "p" } {
        set HE(tit) "  "
        set runprg tipdocp
    } else {
        set HE(tit) "  "
        set runprg tipdocr
    }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 35 $runprg $SERNUM(entry,tipdoc) $tip $win
    set SERNUM(entry,tipdoccod) $HE(cod)
    if { $SERNUM(entry,tipdoccod) == 1 } { set SERNUM(entry,tipdoccod) "'M'" }
    if { $SERNUM(entry,tipdoccod) == 2 } { set SERNUM(entry,tipdoccod) "'N'" }
    if { $SERNUM(entry,tipdoccod) == 3 } { set SERNUM(entry,tipdoccod) "'Z'" }
    set SERNUM(entry,tipdoc)    [clipped $HE(nam)]
}

proc sernum:hesklad { tip win } {
    global VS SERNUM HE
    
    set w .sernum.entry.inf.sklad.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $SERNUM(entry,skladnam) $tip $win
    set SERNUM(entry,skladcod) $HE(cod)
    set SERNUM(entry,skladnam) [clipped $HE(nam)]
}

proc sernum:heoperacia { tip win } {
    global VS SERNUM HE
    
    set w .sernum.entry.inf.operacia.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 operaciap $SERNUM(entry,operacianam) $tip $win
    set SERNUM(entry,operaciacod) $HE(cod)
    set SERNUM(entry,operacianam) [clipped $HE(nam)]
}

proc sernum:heklient { tip win } {
    global VS SERNUM HE
    
    set w .sernum.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 postpol $SERNUM(entry,klientnam) $tip $win
    set SERNUM(entry,klientcod) $HE(cod)
    set SERNUM(entry,klientnam) [clipped $HE(nam)]
}

proc sernum:hetovar { tip win } {
    global VS SERNUM HE
    
    set w .sernum.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $SERNUM(entry,tovarnam) $tip $win
    set SERNUM(entry,tovarcod) $HE(cod)
    set SERNUM(entry,tovarnam) [clipped $HE(nam)]
}

proc sernumtov:update { row } {
    global VS SERNUMTOV_DATA SERNUMTOV SERNUM
    
    set w .sernum.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        if ![info exist SERNUMTOV_DATA($row,1)] {
            set sernum {}
        } else {
            set sernum [clipped $SERNUMTOV_DATA($row,1)]
        }
        if ![info exist SERNUMTOV_DATA($row,2)] {
            set dat_gar {}
        } else {
            set dat_gar [clipped $SERNUMTOV_DATA($row,2)]
        }
        puts $socks "sernumtov_upd \"$SERNUMTOV_DATA($row,opercod)\" \
                                   \"$sernum\" $dat_gar"
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set SERNUMTOV_DATA($row,old_1) $sernum
            set SERNUMTOV_DATA($row,old_2) $dat_gar
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc sernumtov:delete {} {
    global VS SERNUMTOV SERNUMTOV_DATA SERNUM
    
    if { $SERNUM(tip) == "p" } {
        set w .sernum.tov.tbl
        if [info exists SERNUMTOV(ActiveRow)] {
            if [info exists SERNUMTOV_DATA($SERNUMTOV(ActiveRow),opercod)] {
                set SERNUMTOV_DATA(active) ""
                $w tag row UnSelectRow $SERNUMTOV(ActiveRow)
                if { [ set socks [checkpasswd] ] != -1 } {
                    $w tag row flash $SERNUMTOV(ActiveRow)
                    waiting "  ..." red
                    puts $socks "sernumtov_del $SERNUMTOV_DATA($SERNUMTOV(ActiveRow),opercod)"
                    flush $socks
                    while { [ gets $socks ] != $VS(sepdata) } { }
                    if { [ gets $socks ] != "0" } {
                        errormsg $socks "    !"
                    }
                    close $socks
                    $w tag row Normal $SERNUMTOV(ActiveRow)
                    waiting "" ""
                    sernum:read
                } else {
                    errormsg nosocks "  !"
                }
            }
        }
    }
}

proc sernum:print {} {
    global VS SERNUM

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "sernum_rep $SERNUM(tip) \"$SERNUM(find)\" \"$SERNUM(sortstr) $SERNUM(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}