proc snnno:summa {} {
    global SNNNO SNNNO_DATA
    
    set i 0
    set SNNNO(ssnnno1) 0
    while { $i <= $SNNNO(listbox,count) } {
        set SNNNO(ssnnno1) [expr $SNNNO(ssnnno1) + $SNNNO_DATA(summa,$i)]
        incr i
    }
}

proc snnno:read { } {
    global VS SNNNO SNNNO_DATA SCHET
    
    set w .snnno.lb.listbox
    catch [unset SNNNO_DATA]
    if [winfo exists $w] {
        event generate $w <<iconmenu-disabled>>
        waiting "  ..." blue
        
        # 1  
        set dat1 [clock format [expr $VS(clock) - 604800 ] -format %d/%m/%Y]
        # 1    
        set dat2 [clock format [expr $VS(clock) + 86400 ] -format %d/%m/%Y]
        if ![info exist SNNNO(fromstr,opl)]   { set SNNNO(fromstr,opl) "outer _schetoplmindat c," }
        if ![info exist SNNNO(fromstr,otg)]   { set SNNNO(fromstr,otg) "outer _schetotgmindat d," }
        if { $SNNNO(sortstr) == "" }    { set SNNNO(sortstr) "schetnum" } 
        if { $SNNNO(sortdesc) == "" }   { set SNNNO(sortdesc) " "  }
        if { $SNNNO(find) == "" } {
            set SNNNO(find) "a.sdat >= '$dat1' and a.sdat <= '$dat2'"
            if [info exists SNNNO(find,listbox)] {
                if { [lsearch -exact $SNNNO(find,listbox) $SNNNO(find)] == -1} {
                    lappend SNNNO(find,listbox) $SNNNO(find)
                }
            } else {
                lappend SNNNO(find,listbox) $SNNNO(find)
            }
        } 
        $w delete 0 end
        
        if { [ set socks [checkpasswd] ] != -1 } {
            puts $socks "snnno_sel \"$SNNNO(fromstr,opl)$SNNNO(fromstr,otg)\" \"$SNNNO(find)\" \"$SNNNO(sortstr) $SNNNO(sortdesc)\" "
            flush $socks
            set i 0
            set k 1
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                snnno:VarnullScanInsert $str $i "end"
                if [ info exists SCHET(cod) ] {
                    set idcod [expr $SCHET(cod) - $SNNNO_DATA(cod,$i)]
                    if { $idcod == 0 } {
                        set SNNNO(listbox,curselection) $i
                    }
                }
                if { [ expr [incr i] % $k ] == 0 } {
                    update
                    scan [ expr 1.15 * [incr k] ] "%\[^.]" k
                }
                set SNNNO(statusline) " $i ."
            }
            set SNNNO(listbox,count) [expr $i - 1]
            snnno:summa
            
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
        } else {
            errormsg nosocks "  !"
        }
        waiting "" ""
    }
}

proc snnno:find {} {
    global VS SNNNO
    
    snnno:entry
    if { $SNNNO(entrystatus) == 1 } {
        set SNNNO(find) "1=1"
        set SNNNO(fromstr,otg) "outer _schetotgmindat d,"
        set SNNNO(fromstr,opl) "outer _schetoplmindat c,"
        foreach {i j} " \"$SNNNO(entry,schetnum)\" a.snum \
                        \"$SNNNO(entry,schetdat)\" a.sdat \
                        \"$SNNNO(entry,naklnum)\" a.nnum \
                        \"$SNNNO(entry,nakldat)\" a.ndat \
                        \"$SNNNO(entry,schetsumma)\" a.summa \
                        \"$SNNNO(entry,klientnam)\" e.nam \
                       " {
            if { $i != "" } {
                set SNNNO(find) "$SNNNO(find) and $j [construct $i]"
            }    
        }
        if { [string length [clipped $SNNNO(entry,naklis)]] > 0 || \
             [string length [clipped $SNNNO(entry,nnaklnum)]] > 0 || \
             [string length [clipped $SNNNO(entry,nnakldat)]] > 0 || \
             [string length [clipped $SNNNO(entry,nnaklsumma)]] > 0 || \
             [string length [clipped $SNNNO(entry,oplis)]] > 0 || \
             [string length [clipped $SNNNO(entry,opldat)]] > 0 || \
             [string length [clipped $SNNNO(entry,oplsumma)]] > 0 || \
             
             [string length [clipped $SNNNO(entry,otgis)]] > 0 || \
             [string length [clipped $SNNNO(entry,otgdat)]] > 0 || \
             [string length [clipped $SNNNO(entry,otgkol)]] > 0 || \
             
             [string length [clipped $SNNNO(entry,tovarnam)]] > 0 || \
             [string length [clipped $SNNNO(entry,sostavtovnam)]] > 0 || \
             [string length [clipped $SNNNO(entry,nnaklis)]] > 0 || \
             [string length [clipped $SNNNO(entry,prim1)]] > 0 || \
             [string length [clipped $SNNNO(entry,prim2)]] > 0 || \
             [string length [clipped $SNNNO(entry,nopl)]] > 0 || \
             [string length [clipped $SNNNO(entry,notg)]] > 0 } {
            snnno:find:podzapros
        }
        if { [lsearch -exact $SNNNO(find,listbox) $SNNNO(find)] == -1} {
            lappend SNNNO(find,listbox) $SNNNO(find)
        }
        snnno:read
    }
    set SNNNO(entrystatus) 0
}

proc snnno:find:podzapros {} {
    global SNNNO
    
    # 
    if { [string length [clipped $SNNNO(entry,naklis)]] > 0 } {
        set str_not ""
        if { $SNNNO(entry,naklis) == "" } { set str_not "not" }
        set SNNNO(find) "$SNNNO(find) and a.nnum is $str_not null"
    }
    
    # 
    if { [string length [clipped $SNNNO(entry,nnaklis)]] > 0  || \
         [string length [clipped $SNNNO(entry,nnaklnum)]] > 0 || \
         [string length [clipped $SNNNO(entry,nnakldat)]] > 0 || \
         [string length [clipped $SNNNO(entry,nnaklsumma)]] > 0 } {
        set str_not ""
        if { $SNNNO(entry,nnaklis) == "" } { set str_not "not" }
        set str_sel "select x1.cod from _nnakls x1 where x1.schetfnr_cod = a.schet_cod"
        foreach {i j} " \"$SNNNO(entry,nnaklnum)\"      x1.num \
                        \"$SNNNO(entry,nnakldat)\"      x1.dat \
                        \"$SNNNO(entry,nnaklsumma)\"    x1.summa \
                      " {
            if { $i != "" } {
                set str_sel "$str_sel and $j [construct $i]"
            }    
        }
        set SNNNO(find) "$SNNNO(find) and $str_not exists ($str_sel)"
    }
    
    # 
    if { [string length [clipped $SNNNO(entry,oplis)]] > 0  || \
         [string length [clipped $SNNNO(entry,opldat)]] > 0 || \
         [string length [clipped $SNNNO(entry,oplsumma)]] > 0 } {
        set str_not ""
        if { $SNNNO(entry,oplis) == "" } { set str_not "not" }
        set str_sel "select x2.cod from schetopl x2 where x2.schet_cod = a.schet_cod"
        foreach {i j} " \"$SNNNO(entry,opldat)\"      x2.dat \
                        \"$SNNNO(entry,oplsumma)\"    x2.summa \
                      " {
            if { $i != "" } {
                set str_sel "$str_sel and $j [construct $i]"
            }    
        }
        set SNNNO(find) "$SNNNO(find) and $str_not exists ($str_sel)"
    }
    
    # 
    if { [string length [clipped $SNNNO(entry,otgis)]] > 0  || \
         [string length [clipped $SNNNO(entry,otgdat)]] > 0 || \
         [string length [clipped $SNNNO(entry,otgkol)]] > 0 } {
        set str_not ""
        if { $SNNNO(entry,otgis) == "" } { set str_not "not" }
        set str_sel "select x3.cod from matoperr x3 where x3.schetfnr_cod = a.schet_cod and x3.datotg is not null"
        foreach {i j} " \"$SNNNO(entry,otgdat)\"      x3.datotg \
                        \"$SNNNO(entry,otgkol)\"      x3.kol \
                      " {
            if { $i != "" } {
                set str_sel "$str_sel and $j [construct $i]"
            }    
        }
        set SNNNO(find) "$SNNNO(find) and $str_not exists ($str_sel)"
    }
    
    #  
    if { [string length [clipped $SNNNO(entry,tovarnam)]] > 0 } {
        set str_sel "select x4.cod from schfnrtov x4, tovar x5 where x4.schetfnr_cod = a.schet_cod and x4.tovar_cod = x5.cod"
        set str_sel "$str_sel and x5.nam [construct $SNNNO(entry,tovarnam)]"
        set SNNNO(find) "$SNNNO(find) and exists ($str_sel)"
    }
    
    #   
    if { [string length [clipped $SNNNO(entry,sostavtovnam)]] > 0 } {
        set str_sel "select x6.cod from schfnrtovt x6, tovar x7 where x6.schetfnr_cod = a.schet_cod and x6.tovar_cod = x7.cod"
        set str_sel "$str_sel and x7.nam [construct $SNNNO(entry,sostavtovnam)]"
        set SNNNO(find) "$SNNNO(find) and exists ($str_sel)"
    }
    
    #   1
    if { $SNNNO(entry,prim1) == "*" } {
        set SNNNO(find) "$SNNNO(find) and a.prim1 is not null"
    }
    
    #   2
    if { $SNNNO(entry,prim2) == "*" } {
        set SNNNO(find) "$SNNNO(find) and a.prim2 is not null"
    }
    
    #  
    if { $SNNNO(entry,nopl) == "*" } {
        set SNNNO(fromstr,opl) "_schetoplmindat c,"
        set SNNNO(find) "$SNNNO(find) and a.summa != c.summa"
    } 
 
    #  
    if { $SNNNO(entry,notg) == "*" } {
        set SNNNO(fromstr,otg) "_schetotgmindat d,"
        set SNNNO(find) "$SNNNO(find) and a.kol != d.kol"
    } 
}

proc snnno:heklient { tip win } {
    global VS SNNNO HE
    
    set w .snnno.entry.inf.klient.nam
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 50 postpol $SNNNO(entry,klientnam) $tip $win
    set SNNNO(entry,klientcod) $HE(cod)
    set SNNNO(entry,klientnam) [clipped $HE(nam)]
}

proc snnno:hetovar { tip win } {
    global VS SNNNO HE
    
    set w .snnno.entry.inf.tovar.nam
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 50 tovaronly $SNNNO(entry,tovarnam) $tip $win
    set SNNNO(entry,tovarcod) $HE(cod)
    set SNNNO(entry,tovarnam) [clipped $HE(nam)]
}

proc snnno:hesostavtov { tip win } {
    global VS SNNNO HE
    
    set w .snnno.entry.inf.sostavtov.nam
    set HE(tit) "  "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 50 tovaronly $SNNNO(entry,sostavtovnam) $tip $win
    set SNNNO(entry,sostavtovcod) $HE(cod)
    set SNNNO(entry,sostavtovnam) [clipped $HE(nam)]
}

proc snnno:delete {} {
    global SNNNO SNNNO_DATA
    
    set w .snnno.lb.listbox
    set id $SNNNO(listbox,curselection)
    if { [schet:delete $SNNNO_DATA(cod,$id)] != -1 } {
        snnno:sdvig $id
        set SNNNO(listbox,count) [ expr $SNNNO(listbox,count) - 1 ]
        $w delete $id $id
        if { $id > $SNNNO(listbox,count)} {
            set id $SNNNO(listbox,count)
            set SNNNO(listbox,curselection) $id
        }
        $w see $id
        $w selection clear 0 end
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
}

proc snnno:sdvig { id } {
    global SNNNO SNNNO_DATA
    
    for { set i $id } { $i < $SNNNO(listbox,count) } { incr i } {
        set SNNNO_DATA(cod,$i)          $SNNNO_DATA(cod,[expr $i + 1])
        set SNNNO_DATA(schetnum,$i)     $SNNNO_DATA(schetnum,[expr $i + 1])
        set SNNNO_DATA(schetdat,$i)     $SNNNO_DATA(schetdat,[expr $i + 1])
        set SNNNO_DATA(naklnum,$i)      $SNNNO_DATA(naklnum,[expr $i + 1])
        set SNNNO_DATA(nakldat,$i)      $SNNNO_DATA(nakldat,[expr $i + 1])
        set SNNNO_DATA(nnmindat,$i)     $SNNNO_DATA(nnmindat,[expr $i + 1])
        set SNNNO_DATA(nnsr,$i)         $SNNNO_DATA(nnsr,[expr $i + 1])
        set SNNNO_DATA(oplmindat,$i)    $SNNNO_DATA(oplmindat,[expr $i + 1])
        set SNNNO_DATA(oplsr,$i)        $SNNNO_DATA(oplsr,[expr $i + 1])
        set SNNNO_DATA(otgmindat,$i)    $SNNNO_DATA(otgmindat,[expr $i + 1])
        set SNNNO_DATA(otgsr,$i)        $SNNNO_DATA(otgsr,[expr $i + 1])
        set SNNNO_DATA(summa,$i)        $SNNNO_DATA(summa,[expr $i + 1])
        set SNNNO_DATA(klientnam,$i)    $SNNNO_DATA(klientnam,[expr $i + 1])
    }
}

proc snnno:insert {} {
    global SNNNO SNNNO_DATA SCHET

    set w .snnno.lb.listbox
    schetfnr 1 0
    tkwait window .schetfnr
    if { $SCHET(cod) > 0 } {
        set id [expr $SNNNO(listbox,count) + 1]
        set SNNNO(listbox,count) $id
        set SNNNO(listbox,curselection) $id
        set SNNNO_DATA(cod,$id) $SCHET(cod)
        snnno:readone $id
        set SNNNO(statusline) "$SNNNO_DATA(schetnum,$id) $SNNNO_DATA(schetdat,$id) $SNNNO_DATA(klientnam,$id)"
    }
}

proc snnno:update {} {
    global SNNNO SNNNO_DATA VS

    set w .snnno.lb.listbox
    set id $SNNNO(listbox,curselection)
    $w delete $id $id
    schetfnr 1 $SNNNO_DATA(cod,$id)
    tkwait window .schetfnr
    snnno:readone $id
    set SNNNO(statusline) "$SNNNO_DATA(schetnum,$id) $SNNNO_DATA(schetdat,$id) $SNNNO_DATA(klientnam,$id)"
}

proc snnno:schetopl {} {
    global SNNNO_DATA SNNNO SCHET SCHETTOV
    
    set w .snnno.lb.listbox
    set id $SNNNO(listbox,curselection)
    if [info exists SNNNO_DATA(cod,$id)] {
        set SCHET(cod) $SNNNO_DATA(cod,$id)
        set SCHETTOV(scena) $SNNNO_DATA(summa,$id)
        docopl .snnno s $SCHET(cod)
        tkwait window .snnno.docopl
        $w delete $id $id
        snnno:readone $id
    }
}

proc snnno:schetnnakl {} {
    global SNNNO_DATA SNNNO SCHET SCHETTOV
    
    set w .snnno.lb.listbox
    set id $SNNNO(listbox,curselection)
    if [info exists SNNNO_DATA(cod,$id)] {
        set SCHET(cod) $SNNNO_DATA(cod,$id)
        set SCHETTOV(scena) $SNNNO_DATA(summa,$id)
        schetnnakl .snnno
        tkwait window .snnno.schetnnakl
        $w delete $id $id
        snnno:readone $id
    }
}

proc snnno:VarnullScanInsert { str id poz } {
    global SNNNO SNNNO_DATA VS
    
    set w .snnno.lb.listbox
    if [winfo exists $w] {
        set SNNNO_DATA(cod,$id) ""  
        set SNNNO_DATA(schetnum,$id) "";     set SNNNO_DATA(schetdat,$id) "";
        set SNNNO_DATA(naklnum,$id) "";      set SNNNO_DATA(nakldat,$id) "";
        set SNNNO_DATA(nnmindat,$id) "";     set SNNNO_DATA(nnsr,$id) "";
        set SNNNO_DATA(oplmindat,$id) "";    set SNNNO_DATA(oplsr,$id) "";
        set SNNNO_DATA(otgmindat,$id) "";    set SNNNO_DATA(otgsr,$id) "";
        set SNNNO_DATA(summa,$id) "";        set SNNNO_DATA(klientnam,$id) ""
                
        scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
            SNNNO_DATA(cod,$id) \
            SNNNO_DATA(schetnum,$id)     SNNNO_DATA(schetdat,$id) \
            SNNNO_DATA(naklnum,$id)      SNNNO_DATA(nakldat,$id) \
            SNNNO_DATA(nnmindat,$id)     SNNNO_DATA(nnsr,$id) \
            SNNNO_DATA(oplmindat,$id)    SNNNO_DATA(oplsr,$id) \
            SNNNO_DATA(otgmindat,$id)    SNNNO_DATA(otgsr,$id) \
            SNNNO_DATA(summa,$id)        SNNNO_DATA(klientnam,$id)    
       
       if { $VS(login) != "buh" } {
           catch [$w insert $poz [format "%5s %6s %5s %6s %6s %1s  %6s %1s %6s %1s %9.2f %s" \
               $SNNNO_DATA(schetnum,$id)    $SNNNO_DATA(schetdat,$id) \
               $SNNNO_DATA(naklnum,$id)     $SNNNO_DATA(nakldat,$id) \
               $SNNNO_DATA(nnmindat,$id)    $SNNNO_DATA(nnsr,$id) \
               $SNNNO_DATA(oplmindat,$id)   $SNNNO_DATA(oplsr,$id) \
               $SNNNO_DATA(otgmindat,$id)   $SNNNO_DATA(otgsr,$id) \
               $SNNNO_DATA(summa,$id)       $SNNNO_DATA(klientnam,$id) ] ]
       } else {
           catch [$w insert $poz [format "%5s %6s %5s %6s %6s %1s  %6s %1s %9.2f %s" \
               $SNNNO_DATA(schetnum,$id)    $SNNNO_DATA(schetdat,$id) \
               $SNNNO_DATA(naklnum,$id)     $SNNNO_DATA(nakldat,$id) \
               $SNNNO_DATA(nnmindat,$id)    $SNNNO_DATA(nnsr,$id) \
               $SNNNO_DATA(oplmindat,$id)   $SNNNO_DATA(oplsr,$id) \
               $SNNNO_DATA(summa,$id)       $SNNNO_DATA(klientnam,$id) ] ]
       }
   }
}

proc snnno:readone { id } {
    global SNNNO SNNNO_DATA VS

    set w .snnno.lb.listbox
    if [winfo exists $w] {
        waiting "  ..." blue
        if { [ set socks [checkpasswd] ] != -1 } {
            puts $socks "snnnoone_sel $SNNNO_DATA(cod,$id)"
            flush $socks
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                snnno:VarnullScanInsert $str $id $id
            }
            snnno:summa
            
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
        } else {
            errormsg nosocks "  !"
        }
        waiting "" ""
        if [winfo exists $w] {
            $w see $id
            $w selection clear 0 end
            $w selection set $id $id
            $w activate $id
            event generate $w <<iconmenu-enabled>>
        }
    }
}

proc snnno:view {} {
    global SNNNO SNNNO_DATA

    schetfnr 0 $SNNNO_DATA(cod,$SNNNO(listbox,curselection))
}

proc snnno:print {} {
    global VS SNNNO    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        regsub -all "_schetoplmindat" $SNNNO(fromstr,opl) "_schetoplmaxdat" SNNNO(fromstr,opl)
        #regsub -all "c.mindat" $SNNNO(find) "c.maxdat" SNNNO(find)
        
        #puts $socks "snnno_rep \"$SNNNO(fromstr,opl)$SNNNO(fromstr,otg)\" \"$SNNNO(find)\" \"$SNNNO(sortstr) $SNNNO(sortdesc)\" \"$VS(lp)\""
        puts $socks "snnno_rep \"$SNNNO(fromstr,opl)$SNNNO(fromstr,otg)\" \"$SNNNO(find)\" \"$SNNNO(sortstr) $SNNNO(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
