proc sostavm:read {} {
    global VS SOSTAVM SOSTAVM_DATA SOSTAVMS
    
    set w .allcfg.dat.sostavm.lb.listbox
    set SOSTAVMS(listbox,curselection) 0
    waiting "  ..." blue
    if { $SOSTAVM(sortstr) == "" }    { set SOSTAVM(sortstr) "tovargroup_cod, nam" } 
    if { $SOSTAVM(sortdesc) == "" }   { set SOSTAVM(sortdesc) " "  }
    if { $SOSTAVM(find) == "" } {
        set SOSTAVM(find) "1=1"
        lappend SOSTAVM(find,listbox) $SOSTAVM(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sostavm_sel \"$SOSTAVM(find)\" \"$SOSTAVM(sortstr) $SOSTAVM(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SOSTAVM_DATA(tovargroupcod,$i) {}; set SOSTAVM_DATA(cod,$i) {}; set SOSTAVM_DATA(nam,$i) {}
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" SOSTAVM_DATA(tovargroupcod,$i) SOSTAVM_DATA(cod,$i) SOSTAVM_DATA(nam,$i)
            $w insert end " $SOSTAVM_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set SOSTAVMS(statusline) " $i ."
        }
        if { $i == 0 } { set i 1 }
        set SOSTAVM(listbox,count) [expr $i - 1]
        $w see $SOSTAVM(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    set SOSTAVMS(window) .allcfg.dat.sostavm.lb.listbox
}

proc sostavm:find {} {
    global VS SOSTAVM
    
    sostavm:entry find
    if { $SOSTAVM(entrystatus) == 1 } {
        set SOSTAVM(find) "1=1"
        foreach {i j} "\"$SOSTAVM(entry,nam)\" nam " {
            if { $i != "" } {
                set SOSTAVM(find) "$SOSTAVM(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $SOSTAVM(find,listbox) $SOSTAVM(find)] == -1} {
            lappend SOSTAVM(find,listbox) $SOSTAVM(find)
        }
        sostavm:read
    }
    set SOSTAVM(entrystatus) 0
}

