proc sot {} {
    global VS SOT SOT_DATA SOTSS

    catch [unset SOT_DATA]
    set SOT(entry,fio) {}
    set SOT(listbox,curselection) 0
    set SOT(sortdesc) {}
    set SOT_DATA(cod,0) 0
    set SOT(hebutton) 0
    
    set w .sotss.sot
    catch [destroy $w]
    
    frame $w -bd 5
    pack $w -side left
    frame $w.nameform
    label $w.nameform.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3
    frame $w.namefield
    label $w.namefield.p1 -text ", , " -relief raised -anchor center -bd 1 -padx 1 -width 55
    pack $w.nameform $w.nameform.l
    sot:search
    pack $w.namefield
    pack $w.namefield.p1 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 15 -width 52
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    update
    sot:read
    
    bind $w.lb.scrollbar <Button-1> {
        catch [destroy .sotss.sesot]
    }
    bind $w.lb.listbox <Button-1> {
        set SOTSS(window) %W
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        event generate %W <<sot:set:variable>>
        event generate %W <<sot:run:read>>
    }
    bind $w.lb.listbox <<sot:set:variable>> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set SOTSS(statusline) [ %W get $id ]
        set SOT(listbox,curselection) $id
        catch [destroy .sotss.sesot]
    }
    bind $w.lb.listbox <<sot:run:read>> {
        sklad:read
    }
    bind $w.lb.listbox <Button-3> {
        set SOTSS(window) %W
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <<sot:set:variable>>
        .sotss.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
}

proc sot:search {} {
    global VS
    
    set w .sotss.sot.search
    frame $w
    pack $w
    label $w.lfind -relief sunken -width 50 -textvariable SOT(find) -anchor w
    button $w.lfindb -takefocus 0 -bitmap @$VS(dir)ComboBox.xbm -command sot:search:lb 
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { sot:search:lb }
}

proc sot:search:lb {} {
    global VS SOT SOTSS
    
    set w .sotss.sot.search.lfindlb
    set x [winfo rootx .sotss.sot.search.lfind]
    set y [winfo rooty .sotss.sot.search.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width 50
    
    foreach {i} $SOT(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $SOT(find,listbox) $SOT(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set SOT(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable SOT(find)
    destroy $w
    sot:read
}

proc sot:entry:clearvar {} {
    global SOT
    
    set SOT(entry,fio) ""
    set SOT(entry,matotv) ""
    set SOT(entry,datborn) ""
    set SOT(entry,gorodnam) ""
    set SOT(entry,phonecod) ""
    set SOT(entry,index) ""
    set SOT(entry,ulica) ""
    set SOT(entry,dom) ""
    set SOT(entry,kv) ""
    set SOT(entry,phone) ""
    set SOT(entry,email) ""
    set SOT(entry,prim) ""
    set SOT(entry,login) ""
    
}

proc sot:entry {status} {
    global VS SOT
    
    set SOT(status) $status
    set SOT(entrystatus) {}
    set w .sotss.sot.sotentry
    if { $status != "view" && $status != "update"} {
        sot:entry:clearvar
    }
    set SOT(entry,old_gorodnam) $SOT(entry,gorodnam)
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +70+79
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    foreach { i j } {fio            "                           "\
                     login          "                         Login"\
                     matotv         "- "\
                     datborn        "                  "\
                     gorodnam       "         :          "\
                     phonecod       "                 "\
                     index          "                        "\
                     ulica          "                         "\
                     dom            "                           "\
                     kv             "                      "\
                     phone          "               "\
                     email          "                        E-mail"\
                     prim           "                    "} {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        label $w.inf.$i.l -text $j
        if { $i == "datborn" || $i == "kv" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }

    foreach { i j } { fio 50 login 8 datborn 10 gorodnam 30 phonecod 6 \
                      index 6 ulica 50 dom 8 kv 4 phone 9 email 30 } {
        entry $w.inf.$i.e -textvariable SOT(entry,$i) -width $j
    }    
    $w.inf.phonecod.e configure -state disabled
    
    checkbutton $w.inf.matotv.e -variable SOT(entry,matotv) -offvalue "" -onvalue "*"
    button $w.inf.gorodnam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set SOT(hebutton) 1; sot:hegorod r .sotss.sot.sotentry"
    text  $w.inf.prim.e -relief sunken -width 40 -height 2 -wrap word
    $w.inf.prim.e insert 0.0 $SOT(entry,prim)
    
    if { $status == "view" } {
        foreach i { fio login matotv datborn gorodnam index ulica dom kv phone email prim } {
            $w.inf.$i.e configure -state disabled
        }
        $w.inf.gorodnam.b configure -state disabled
    }
    if { $status == "find" } {
            $w.inf.phonecod.e configure -state normal
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SOT(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "sot:entry:clearvar; .sot.sotentry.inf.prim.e delete 0.0 end"
    button $w.buttons.exit -text "" -command "set SOT(entrystatus) 0; destroy $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    
    foreach i { fio login matotv datborn gorodnam phonecod index ulica dom kv phone email prim } {
        pack $w.inf.$i.l $w.inf.$i.e -side left
    }
    pack $w.inf.gorodnam.b -side left
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.fio.e
    } else {
        focus $w.buttons.exit
    }
    bind $w.inf.gorodnam.e <FocusOut> {
        if { $SOT(status) != "find" } {
            if { $SOT(hebutton) == 0 } {
                if { "$SOT(entry,old_gorodnam)" != "$SOT(entry,gorodnam)" } {
                    sot:hegorod u .sotss.sot.sotentry
                    set SOT(entry,old_gorodnam) $SOT(entry,gorodnam)
                }
            }
        }
    }
    bind $w <Key-Escape>     { .sotss.sot.sotentry.buttons.exit invoke }
    bind $w <Control-Return> { .sotss.sot.sotentry.buttons.ok invoke }
    bind $w.inf.prim.e <Leave> {
        if { [%W cget -state] != "disabled" } {
            regsub -all \n [%W get 0.0 end] "" SOT(entry,prim)
        }
    }
    bind $w.inf.gorodnam.e <Button-1> {
        catch [destroy .sotss.sot.sotentry.he]
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
