proc spisaniehead { } {
    global VS SPISANIE SPISANIE_DATA SPISANIETOV SPISANIETOV_DATA

    set w $SPISANIE(inwin).spisanie
    set SPISANIETOV(rows) 8
    # head ##################################################################
    
    label $w.tit -font $VS(fontn) -text " $SPISANIE(titstr) " \
        -relief raised -anchor center -bd 1
    pack $w.tit
    
    foreach { i } { tovar printnam primrez schet kol sklad klient } {
        if { $i == "tovar" || $i == "schet" || $i == "kol" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
        if { [regexp "r|o" $SPISANIE(ros)] && $i == "primrez" } {
            frame $w.$i
            pack $w.$i -anchor w -padx 3 -pady 2
        } else {
            frame $w.$i
            pack $w.$i -anchor w -padx 3 -pady 2
        }
    }
    frame $w.septov -bd 1 -height 10 -relief sunken
    pack  $w.septov -fill x
    foreach { i j } [subst { tovar    "$SPISANIE(titstr) " \
                      schet    " : " \
                      kol      " " \
                      sklad    "    " \
                      printnam "" \
                      klient   "      " \
                      primrez  " ." \
                  }] {
        label $w.$i.l1 -text $j
    }
    foreach { i j k } { tovar.tovarnam       tovarnam    50 \
                        schet.schetnum       schetnum     6 \
                        schet.schetdat       schetdat    10 \
                        schet.naklnum        naklnum      6 \
                        schet.nakldat        nakldat     10 \
                        kol.kol              kol          8 \
                        kol.einam            einam       10 \
                        kol.cena             cena        10 \
                        kol.cenawpdv         cenawpdv    10 \
                        kol.cenad            cenad       10 \
                        kol.kolrez           kolrez       8 \
                        kol.kolotg           kolotg       8 \
                        sklad.skladnam       skladnam    30 \
                        printnam.printnam    printnam    70 \
                        primrez.primreznam   primreznam  70 \
                        klient.klientnam     klientnam   50 \
                      } {
        entry $w.$i -textvar SPISANIE_DATA($j) -width $k -state disabled
    }
    $w.primrez.primreznam configure -state normal
    foreach i { tovar.tovarnam kol.kol kol.einam klient.klientnam kol.kolrez \
                kol.kolotg } {
        $w.$i configure -bg grey95
    }
    if { $SPISANIE(ros) == "s" } { $w.kol.cenawpdv configure -bg grey95 }
    foreach { i j } { schet.l2      " " \
                      schet.l3      " : " \
                      schet.l4      " " \
                      kol.l2        "  " \
                      kol.l3        "  " \
                      kol.l4        " " \
                      kol.l5        " " \
                  } {
        label $w.$i -text $j
    }
    
    foreach i { tovar.l1 tovar.tovarnam \
                schet.l1 schet.schetnum schet.l2 schet.schetdat schet.l3 \
                schet.naklnum schet.l4 schet.nakldat \
                kol.l1 kol.kol kol.einam kol.l2 kol.cena \
                sklad.l1 sklad.skladnam \
                printnam.l1 printnam.printnam \
                klient.l1 klient.klientnam
              } {
        pack $w.$i -side left
    }
    if { $SPISANIE(ros) == "s" } {
        foreach i { kol.l3 kol.cenawpdv } {
            pack $w.$i -side left
        }
    }
    if [regexp "r|o" $SPISANIE(ros)] {
        foreach i { primrez.l1 primrez.primreznam kol.cenad } {
            pack $w.$i -side left
        }
    }
    if { $SPISANIE(ros) == "o" } {
        foreach i { kol.l4 kol.kolrez } {
            pack $w.$i -side left
        }
    }
    if { $SPISANIE(ros) == "r" } {
        foreach i { kol.l5 kol.kolotg } {
            pack $w.$i -side left
        }
    }
    bind $w.primrez.primreznam <FocusIn> {
        catch [set SPISANIE_DATA(old_primreznam) $SPISANIE_DATA(primreznam)]
    }
    
    # tov ####################################################################

    switch $SPISANIE(ros) {
        r   { 
            set wc 5 
            set wcc 5 
        }
        o   { 
            set wc 7 
            set wcc 9
        }
        s   { 
            set wc 5 
            set wcc 5 
        }
    }
    frame $w.tov
    pack $w.tov
    entry $w.tov.curfldval -textvar SPISANIETOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.tov.sby -takefocus 0 -command " $w.tov.tbl yview "
    scrollbar $w.tov.sbx -takefocus 0 -command " $w.tov.tbl xview " -orient horizontal
    table $w.tov.tbl -width $wc -height 8 -cols $wcc -rows $SPISANIETOV(rows) \
        -yscrollcommand " $w.tov.sby set " \
        -xscrollcommand " $w.tov.sbx set " \
        -cursor arrow \
        -variable SPISANIETOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { spisanietov:browsecommand %S } \
        -wrap on
        
    tktableinittag $w.tov.tbl
    $w.tov.tbl tag row AnchorCenter -1
    if { $SPISANIE(ros) == "s" } {
        $w.tov.tbl tag col AnchorE 1 3
        $w.tov.tbl tag col Disabled 2 3
        $w.tov.tbl width 0 50 1 9 2 10 3 11 4 14
    }
    if { $SPISANIE(ros) == "r" } {
        $w.tov.tbl tag col AnchorE 2
        $w.tov.tbl tag col Disabled 1 3 
        $w.tov.tbl width 0 41 1 20 2 9 3 10 4 14
    }
    if { $SPISANIE(ros) == "o" } {
        $w.tov.tbl tag col AnchorE 2
        $w.tov.tbl tag col Disabled 1 3 7 8
        $w.tov.tbl width 0 27 1 15 2 9 3 7 4 11 5 14 6 11 7 11 8 11
    }
    pack $w.tov.sbx  -side bottom -fill x
    pack $w.tov.curfldval -anchor w
    pack $w.tov.tbl -side left
    pack $w.tov.sby -side right -fill y
    
    frame $w.itogo
    pack $w.itogo -anchor w
    switch $SPISANIE(ros) {
        r   {
            set ijkl { "                                                       :" skol 9 40 }
        }
        o   {
            set ijkl { "                                    :" skol 9 40 }
        }
        s   {
            set ijkl {"   " spisat 8 50 \
                      "                       :" skol 9 50 \
                      "         " scena 11 50 \
                      "" nacenka 9 100}
        }
    }
    foreach { i j k l } $ijkl {
        label $w.itogo.l$j -text $i
        pack $w.itogo.l$j -side left
        label $w.itogo.$j -textvar SPISANIETOV($j) -bd 1 -relief sunken -anchor e -width $k -bg gray$l -fg cyan
        pack $w.itogo.$j -side left
    }
            
    bind $w.tov.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        $SPISANIE(inwin).spisanie.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.tov.tbl <KeyPress-F2> {
        set c1 [expr $SPISANIE(current) - 1]
        if { $SPISANIETOV(ActiveRow) >= 0 && $SPISANIETOV(ActiveCol) == 0 && \
             [info exists SPISANIE_DATA($c1,tovarnam)] } {
            set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) [clipped $SPISANIE_DATA($c1,tovarnam)]
        }
        if { $SPISANIETOV(ActiveRow) >= 0 && $SPISANIETOV(ActiveCol) == 4 && \
             [info exists SPISANIE_DATA($c1,tovarnam)] } {
            set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),4) $VS(day).$VS(month).$VS(year)
        }
        if { $SPISANIETOV(ActiveRow) >= 0 && $SPISANIETOV(ActiveCol) == 6 && \
             [info exists SPISANIE_DATA($c1,tovarnam)] } {
            if [info exists SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])] {
                set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),6) $SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])
            } else {
               #errormsg nosocks ",           !!!"
                if { [string length [clipped $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),datgarleft)]] > 0 } {
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),6) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),datgarleft)
                } elseif { [string length [clipped $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),gsleft)]] > 0 } {
                    set d $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),datpokupkileft)
                    set convdat "[string range $d 3 4]/[string range $d 0 1]/[string range $d 8 9]"
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),6) [clock format [clock scan "$SPISANIETOV_DATA($SPISANIETOV(ActiveRow),gsleft) month" -base [clock scan "$convdat"]] -format %%d.%%m.%%Y]
                }
            }
        }
    }
    foreach { i } [subst { $w.primrez.primreznam $w.tov.curfldval }] {
        bind $i <KeyPress-Next>     { spisanie:poz incr }
        bind $i <KeyPress-Prior>    { spisanie:poz decr }
    }
    foreach { i } [subst { $w.tov.tbl }] {
        bind $i <KeyPress-Next>     { spisanie:poz incr }
        bind $i <KeyPress-Prior>    { spisanie:poz decr }
        bind $i <KeyPress-Home>     { spisanie:poz first }
        bind $i <KeyPress-End>      { spisanie:poz last }
    }
    focus $w.tov.tbl
}

proc spisanietov:summa {} {
    global SPISANIETOV SPISANIETOV_DATA SPISANIE_DATA SPISANIE
    
    set i 0
    set SPISANIETOV(spisat) 0
    set SPISANIETOV(skol) 0
    set SPISANIETOV(scena) 0
    set SPISANIETOV(nacenka) 0
    set SPISANIE_DATA(kolrez) 0
    if { $SPISANIE(ros) == "s" } {
        set nkol 1
    } else {
        set nkol 2
    }
    while { [info exists SPISANIETOV_DATA($i,$nkol)] && \
            [info exists SPISANIETOV_DATA($i,3)] } {
        catch [set SPISANIETOV(skol)  [expr $SPISANIETOV(skol)  + $SPISANIETOV_DATA($i,$nkol)]]
        catch [set SPISANIETOV(scena) [expr $SPISANIETOV(scena) + $SPISANIETOV_DATA($i,$nkol) * $SPISANIETOV_DATA($i,3)]]
        catch [set SPISANIETOV(nacenka) [expr $SPISANIETOV(nacenka) + $SPISANIETOV_DATA($i,$nkol) * $SPISANIETOV_DATA($i,3)]]
        if ![info exists SPISANIETOV_DATA($i,4)] {
            set SPISANIE_DATA(kolrez) [expr $SPISANIE_DATA(kolrez) + $SPISANIETOV_DATA($i,$nkol)]
        } elseif { $SPISANIETOV_DATA($i,4) == "" } {
            set SPISANIE_DATA(kolrez) [expr $SPISANIE_DATA(kolrez) + $SPISANIETOV_DATA($i,$nkol)]
        }
        incr i
    }

    set SPISANIE_DATA(kolrez) [format "%8.2f" $SPISANIE_DATA(kolrez)]
    catch [set SPISANIETOV(spisat) [expr $SPISANIE_DATA(kol) - $SPISANIETOV(skol)]]
    catch [set SPISANIETOV(nacenka) [expr $SPISANIE_DATA(cenawpdv) * $SPISANIE_DATA(kol) - $SPISANIETOV(nacenka)]]
    set cl grey50
    set cl2 green3
    if { $SPISANIETOV(spisat) == 0 } { set cl green4 }
    if { $SPISANIETOV(spisat) < 0 } { set cl red3 }
    if { $SPISANIETOV(nacenka) < 0 } { set cl2 red3 }
    if { $SPISANIE(ros) == "s" } {
        $SPISANIE(inwin).spisanie.itogo.spisat configure -bg $cl
        $SPISANIE(inwin).spisanie.itogo.nacenka configure -fg $cl2
        if { $SPISANIETOV(spisat) != 0 } {
            $SPISANIE(inwin).spisanie.itogo.nacenka configure -bg peachpuff
        } else {
            $SPISANIE(inwin).spisanie.itogo.nacenka configure -bg grey100
        }
    }
    
}

proc spisanietov:browsecommand { rowcol } {
    global SPISANIETOV SPISANIETOV_DATA SPISANIE SPISANIE_DATA VS
    
    set w $SPISANIE(inwin).spisanie.tov
    if { [info exists SPISANIETOV(ActiveRow)] && \
         $SPISANIETOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $SPISANIETOV(ActiveRow)
    }
    # after tovarnam
    if { [ info exists SPISANIETOV(ActiveRow) ] && $SPISANIETOV(ActiveRow) >= 0 } {
        if { [ info exists SPISANIETOV(ActiveCol) ] && $SPISANIETOV(ActiveCol) == 0 } {
            if ![ info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_0)] { 
                set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_0) "" 
            }
            if ![ info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) ] { 
                set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) "" 
            }
            if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_0) != $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) && \
                 $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) != "" } {
                if ![info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod)] {
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod) 0
                }
                if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod) > 0 } {
                    errormsg nosocks " !!!    .  ,   ."
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_0)
                } else {
                    spisanietov:hetovarnam u $SPISANIE(inwin).spisanie.tov
                    if { $SPISANIE(ros) == "o" } {
                        set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),4) $SPISANIE_DATA(nakldat)
                    }
                }
            }
        }
    }
    # after sernum
    if { $SPISANIE(ros) == "r" || $SPISANIE(ros) == "o" } {
        if { [ info exists SPISANIETOV(ActiveRow) ] && $SPISANIETOV(ActiveRow) >= 0 } {
            if { [ info exists SPISANIETOV(ActiveCol) ] && $SPISANIETOV(ActiveCol) == 1 } {
                if ![ info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_1)] { 
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_1) "" 
                }
                if ![ info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) ] { 
                    set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) "" 
                }
                if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_1) != $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) && \
                     $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) != "" } {
                    if ![info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod)] {
                        set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod) 0
                    }
                    if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod) > 0 } {
                        errormsg nosocks " !!!    .  ,   ."
                        set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_1)
                    } else {
                        spisanietov:hesernum u $SPISANIE(inwin).spisanie.tov
                        if { $SPISANIE(ros) == "o" } {
                            set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),4) $SPISANIE_DATA(nakldat)
                        }
                    }
                }
            }
        }
    }
    
    # after kol
    
    set SPISANIETOV(ActiveRowCol) $rowcol 
    scan $SPISANIETOV(ActiveRowCol) "%\[^,]%*c%s" SPISANIETOV(ActiveRow) SPISANIETOV(ActiveCol)
    
    # before tovarnam
    if { $SPISANIETOV(ActiveCol) == 0 } {
        if [info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0)] {
            set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_0) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0)
        }
    }
    # before sernum
    if { $SPISANIE(ros) == "r" || $SPISANIE(ros) == "o" } {
        if { $SPISANIETOV(ActiveCol) == 1 } {
            if [info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1)] {
                set SPISANIETOV_DATA($SPISANIETOV(ActiveRow),old_1) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1)
            }
        }
    }
    spisanietov:summa
    if { $SPISANIETOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $SPISANIETOV(ActiveRow)
    }
}

