proc tovar:read {} {
    global VS TOVAR TOVAR_DATA TOVARGTT TOVARTIP TOVARTIP_DATA
    
    catch [destroy .tovargtt.tovar.search.lfindlb]
    set w .tovargtt.tovar.lb.listbox
    waiting "  ..." blue
    catch [unset TOVAR_DATA]
    if { $TOVAR(sortstr) == "" }    { set TOVAR(sortstr) "a.nam" } 
    if { $TOVAR(sortdesc) == "" }   { set TOVAR(sortdesc) " "  }
    if { $TOVAR(find) == "" } {
        set TOVAR(find) "1=1"
        lappend TOVAR(find,listbox) $TOVAR(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovar_sel \"$TOVARTIP_DATA(cod,$TOVARTIP(listbox,curselection))\" \"$TOVAR(find)\" \"$TOVAR(sortstr) $TOVAR(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { cod eicod nam einam cena gs isnds ispricelist issernum newbuy saleviawww } {
                set TOVAR_DATA($j,$i) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                 TOVAR_DATA(cod,$i)   TOVAR_DATA(eicod,$i) TOVAR_DATA(nam,$i)\
                 TOVAR_DATA(einam,$i) TOVAR_DATA(cena,$i) TOVAR_DATA(gs,$i)\
                 TOVAR_DATA(isnds,$i) TOVAR_DATA(ispricelist,$i) TOVAR_DATA(issernum,$i) \
                 TOVAR_DATA(newbuy,$i) TOVAR_DATA(saleviawww,$i)
            if { $TOVAR_DATA(isnds,$i) == " " }       { set TOVAR_DATA(isnds,$i) "" }
            if { $TOVAR_DATA(ispricelist,$i) == " " } { set TOVAR_DATA(ispricelist,$i) "" }
            if { $TOVAR_DATA(issernum,$i) == " " }    { set TOVAR_DATA(issernum,$i) "" }
            if { $TOVAR_DATA(newbuy,$i) == " " }      { set TOVAR_DATA(newbuy,$i) "" }
            if { $TOVAR_DATA(saleviawww,$i) == " " }  { set TOVAR_DATA(saleviawww,$i) "" }
            if { [clipped $TOVAR(entry,nam)] == [clipped $TOVAR_DATA(nam,$i)] } {
                set TOVAR(listbox,curselection) $i
            }
            $w insert end [ format "%47.47s %8.8s %10.10s %-2s  %-1s   %-1s    %-1s     %-1s    %-1s" $TOVAR_DATA(nam,$i) $TOVAR_DATA(einam,$i) $TOVAR_DATA(cena,$i) $TOVAR_DATA(gs,$i) $TOVAR_DATA(isnds,$i) $TOVAR_DATA(ispricelist,$i) $TOVAR_DATA(issernum,$i) $TOVAR_DATA(newbuy,$i) $TOVAR_DATA(saleviawww,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set TOVARGTT(statusline) " $i ."
        }
        set TOVAR(listbox,count) [expr $i - 1]
        $w see $TOVAR(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc tovar:find {} {
    global VS TOVAR
    
    tovar:entry find .tovargtt.tovar
    if { $TOVAR(entrystatus) == 1 } {
        set TOVAR(find) "1=1"
        foreach {i j} "\"$TOVAR(entry,nam)\" a.nam \"$TOVAR(entry,einam)\" b.nam \"$TOVAR(entry,cena)\" a.cena \"$TOVAR(entry,gs)\" a.gs \"$TOVAR(entry,isnds)\" a.isnds \"$TOVAR(entry,ispricelist)\" a.ispricelist \"$TOVAR(entry,issernum)\" a.issernum \"$TOVAR(entry,newbuy)\" a.newbuy \"$TOVAR(entry,saleviawww)\" a.saleviawww" {
            if { $i != "" } {
                set TOVAR(find) "$TOVAR(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $TOVAR(find,listbox) $TOVAR(find)] == -1} {
            lappend TOVAR(find,listbox) $TOVAR(find)
        }
        tovar:read
    }
    set TOVAR(entrystatus) 0
}

proc tovar:delete {} {
    global VS TOVAR TOVAR_DATA
    
    set w .tovargtt.tovar.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id [$w curselection]
        puts $socks "tovar_del $TOVAR_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {
        }
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        tovar:read
    } else {
        errormsg nosocks "  !"
    }
       
    if { $id > $TOVAR(listbox,count)} {
        set id $TOVAR(listbox,count)
        set TOVAR(listbox,curselection) $TOVAR(listbox,count)
    }
    $w see $id
    $w selection set $id $id
}

proc tovar:insert { tip win } {
    global VS TOVAR TOVARGTT TOVARTIP TOVARTIP_DATA TOVARGROUP TOVARGROUP_DATA
    
    tovar:entry insert $win
    set w .tovargtt.tovar.lb.listbox
    if { $TOVAR(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            if { $tip == "he" } {
                set TOVARGROUP(listbox,curselection) -1
                set TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection)) $TOVAR(entry,tovargroupcod)
                set TOVARTIP(listbox,curselection) -1
                set TOVARTIP_DATA(cod,$TOVARTIP(listbox,curselection)) $TOVAR(entry,tovartipcod)
            }
            puts $socks "tovar_ins \"$TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection))\" \
                                   \"$TOVARTIP_DATA(cod,$TOVARTIP(listbox,curselection))\" \
                                   \"$TOVAR(entry,nam)\" \
                                   \"$TOVAR(entry,eicod)\" \
                                   \"$TOVAR(entry,cena)\" \
                                   \"$TOVAR(entry,gs)\" \
                                   \"$TOVAR(entry,isnds)\" \
                                   \"$TOVAR(entry,ispricelist)\" \
                                   \"$TOVAR(entry,issernum)\" \
                                   \"$TOVAR(entry,newbuy)\" \
                                   \"$TOVAR(entry,saleviawww)\""
            flush $socks
    
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set TOVAR(entry,cod) $str
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            if { $tip == "l" } { tovar:read }
        } else {
            errormsg nosocks "  !"
        }
        if { $tip == "l" } { $w see $TOVAR(listbox,curselection) }
        
    }
    set TOVAR(entrystatus) 0
}

proc tovar:update {} {
    global VS TOVAR TOVAR_DATA

    set w .tovargtt.tovar.lb.listbox
    set TOVAR(entry,nam)         [clipped $TOVAR_DATA(nam,[set id $TOVAR(listbox,curselection)])]
    set TOVAR(entry,eicod)       $TOVAR_DATA(eicod,$id)
    set TOVAR(entry,einam)       [clipped $TOVAR_DATA(einam,$id)]
    set TOVAR(entry,cena)        $TOVAR_DATA(cena,$id)
    set TOVAR(entry,gs)          $TOVAR_DATA(gs,$id)
    set TOVAR(entry,isnds)       $TOVAR_DATA(isnds,$id)
    set TOVAR(entry,ispricelist) $TOVAR_DATA(ispricelist,$id)
    set TOVAR(entry,issernum)    $TOVAR_DATA(issernum,$id)
    set TOVAR(entry,newbuy)      $TOVAR_DATA(newbuy,$id)
    set TOVAR(entry,saleviawww)  $TOVAR_DATA(saleviawww,$id)
    tovar:entry update .tovargtt.tovar
    if { $TOVAR(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "tovar_upd $TOVAR_DATA(cod,$id) \"$TOVAR(entry,nam)\" \"$TOVAR(entry,eicod)\" \"$TOVAR(entry,cena)\" \"$TOVAR(entry,gs)\" \"$TOVAR(entry,isnds)\" \"$TOVAR(entry,ispricelist)\" \"$TOVAR(entry,issernum)\" \"$TOVAR(entry,newbuy)\" \"$TOVAR(entry,saleviawww)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            tovar:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $TOVAR(listbox,curselection)]
        $w selection set $id $id
    }
    set TOVAR(entrystatus) 0
}

proc tovar:view {} {
    global VS TOVAR TOVAR_DATA
    
    set TOVAR(entry,nam)         $TOVAR_DATA(nam,[set id $TOVAR(listbox,curselection)])
    set TOVAR(entry,eicod)       $TOVAR_DATA(eicod,$id)
    set TOVAR(entry,einam)       $TOVAR_DATA(einam,$id)
    set TOVAR(entry,cena)        $TOVAR_DATA(cena,$id)
    set TOVAR(entry,gs)          $TOVAR_DATA(gs,$id)
    set TOVAR(entry,isnds)       $TOVAR_DATA(isnds,$id)
    set TOVAR(entry,ispricelist) $TOVAR_DATA(ispricelist,$id)
    set TOVAR(entry,issernum)    $TOVAR_DATA(issernum,$id)
    set TOVAR(entry,newbuy)      $TOVAR_DATA(newbuy,$id)
    set TOVAR(entry,saleviawww)  $TOVAR_DATA(saleviawww,$id)
    tovar:entry view .tovargtt.tovar
}

proc tovar:print {} {
    global VS TOVAR TOVARTIP TOVARTIP_DATA

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovar_rep \"$TOVARTIP_DATA(cod,$TOVARTIP(listbox,curselection))\" \"$TOVAR(find)\" \"$TOVAR(sortstr) $TOVAR(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc tovar:heeinam { tip win wn } {
    global VS TOVAR HE
    
    set w $wn.tovarentry.inf.einam.e
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$TOVAR(entry,einam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 10 ei $namstr $tip $win
    set TOVAR(entry,eicod) $HE(cod)
    set TOVAR(entry,einam) [clipped $HE(nam)]
    set TOVAR(entry,old_einam) $TOVAR(entry,einam)
    set TOVAR(hebutton) 0
}

proc tovar:hetovargroupnam { tip win wn } {
    global VS TOVAR HE
    
    set w $wn.tovarentry.inf.tovargroupnam.e
    set HE(tit) " "
    set TOVAR(entry,tovartipnam) {}
    set TOVAR(entry,tovartipcod) 0
    set namstr "*"
    if { $tip == "u" } { set namstr "$TOVAR(entry,tovargroupnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 30 tovargroup $namstr $tip $win
    set TOVAR(entry,tovargroupcod) $HE(cod)
    set TOVAR(entry,tovargroupnam) [clipped $HE(nam)]
    set TOVAR(entry,old_tovargroupnam) $TOVAR(entry,tovargroupnam)
    set TOVAR(hebutton) 0
}

proc tovar:hetovartipnam { tip win wn } {
    global VS TOVAR HE
    
    set w $wn.tovarentry.inf.tovartipnam.e
    set HE(tit) " "
    set sep \003
    set namstr "*"
    if { $tip == "u" } { set namstr "$TOVAR(entry,tovartipnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 7 30 tovargtip $TOVAR(entry,tovargroupcod)$sep$namstr $tip $win
    set TOVAR(entry,tovartipcod) $HE(cod)
    set TOVAR(entry,tovartipnam) [clipped $HE(nam)]
    set TOVAR(entry,old_tovartipnam) $TOVAR(entry,tovartipnam)
    set TOVAR(hebutton) 0
}

