proc tovargroup:read {} {
    global VS TOVARGROUP TOVARGROUP_DATA TOVARGTT
    
    set w .tovargtt.tovargroup.lb.listbox
    set TOVARGROUP(listbox,curselection) 0
    waiting "  ..." blue
    if { $TOVARGROUP(sortdesc) == "" }   { set TOVARGROUP(sortdesc) " "  }
    if { $TOVARGROUP(find) == "" } {
        set TOVARGROUP(find) "1=1"
        lappend TOVARGROUP(find,listbox) $TOVARGROUP(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovargroup_sel \"$TOVARGROUP(find)\" \"nam $TOVARGROUP(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set TOVARGROUP_DATA(cod,$i) {}; set TOVARGROUP_DATA(nam,$i) {}
            scan $str "%\[^\t]%*c%\[^\n]" TOVARGROUP_DATA(cod,$i) TOVARGROUP_DATA(nam,$i)
            if { [clipped $TOVARGROUP(entry,nam)] == [clipped $TOVARGROUP_DATA(nam,$i)] } {
                set TOVARGROUP(listbox,curselection) $i
            }
            $w insert end " $TOVARGROUP_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set TOVARGTT(statusline) " $i ."
        }
        if { $i == 0 } { set i 1 }
        set TOVARGROUP(listbox,count) [expr $i - 1]
        $w see $TOVARGROUP(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    set TOVARGTT(window) $w
}

proc tovargroup:find {} {
    global VS TOVARGROUP
    
    tovargroup:entry find
    if { $TOVARGROUP(entrystatus) == 1 } {
        set TOVARGROUP(find) "1=1"
        foreach {i j} "\"$TOVARGROUP(entry,nam)\" nam" {
            if { $i != "" } {
                set TOVARGROUP(find) "$TOVARGROUP(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $TOVARGROUP(find,listbox) $TOVARGROUP(find)] == -1} {
            lappend TOVARGROUP(find,listbox) $TOVARGROUP(find)
        }
        tovargroup:read
    }
    set TOVARGROUP(entrystatus) 0
}

proc tovargroup:delete {} {
    global VS TOVARGROUP TOVARGROUP_DATA
    
    set w .tovargtt.tovargroup.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id [$w curselection]
        puts $socks "tovargroup_del $TOVARGROUP_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {
        }
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        tovargroup:read
    } else {
        errormsg nosocks "  !"
    }
       
    if { $id > $TOVARGROUP(listbox,count)} {
        set id $TOVARGROUP(listbox,count)
        set TOVARGROUP(listbox,curselection) $TOVARGROUP(listbox,count)
    }
    set TOVARGROUP(deletestatus) 0
    $w see $id
#    $w selection set $id $id
}

proc tovargroup:insert {} {
    global VS TOVARGROUP
    
    tovargroup:entry insert
    set w .tovargtt.tovargroup.lb.listbox
    if { $TOVARGROUP(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "tovargroup_ins \"$TOVARGROUP(entry,nam)\""
            flush $socks
    
            while { [ set tovargroupcod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            tovargroup:read
        } else {
            errormsg nosocks "  !"
        }
        
        $w see $TOVARGROUP(listbox,curselection)
#        $w selection set $TOVARGROUP(listbox,curselection) $TOVARGROUP(listbox,curselection)
    }
    set TOVARGROUP(entrystatus) 0
}

proc tovargroup:update {} {
    global VS TOVARGROUP TOVARGROUP_DATA

    set w .tovargtt.tovargroup.lb.listbox
    set TOVARGROUP(entry,nam) [clipped $TOVARGROUP_DATA(nam,$TOVARGROUP(listbox,curselection))]
    tovargroup:entry update
    if { $TOVARGROUP(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "tovargroup_upd $TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection)) \"$TOVARGROUP(entry,nam)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            tovargroup:read
        } else {
            errormsg nosocks "  !"
        }

        $w see $TOVARGROUP(listbox,curselection)
        $w selection set $TOVARGROUP(listbox,curselection) $TOVARGROUP(listbox,curselection)
    }
    set TOVARGROUP(entrystatus) 0
}

proc tovargroup:view {} {
    global VS TOVARGROUP TOVARGROUP_DATA
    
    set TOVARGROUP(entry,nam) $TOVARGROUP_DATA(nam,$TOVARGROUP(listbox,curselection))
    tovargroup:entry view
}

proc tovargroup:print {} {
    global VS TOVARGROUP    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovargroup_rep \"$TOVARGROUP(find)\" \"nam $TOVARGROUP(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
