proc tovartip:read {} {
    global VS TOVARTIP TOVARTIP_DATA TOVARGTT TOVARGROUP TOVARGROUP_DATA
    
    catch [destroy .tovargtt.tovartip.search.lfindlb]
    set TOVARTIP_DATA(cod,0) 0
    set w .tovargtt.tovartip.lb.listbox
    set TOVARTIP(listbox,curselection) 0
    waiting "  ..." blue
    if { $TOVARTIP(sortdesc) == "" }   { set TOVARTIP(sortdesc) " "  }
    if { "$TOVARTIP(find)" == "" } {
        set TOVARTIP(find) "1=1"
        lappend TOVARTIP(find,listbox) $TOVARTIP(find)
    }
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovartip_sel \"$TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection))\" \"$TOVARTIP(find)\" \"nam $TOVARTIP(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set TOVARTIP_DATA(cod,$i) {}; set TOVARTIP_DATA(nam,$i) {}
            scan $str "%\[^\t]%*c%\[^\n]" TOVARTIP_DATA(cod,$i) TOVARTIP_DATA(nam,$i)
            if { [clipped $TOVARTIP(entry,nam)] == [clipped $TOVARTIP_DATA(nam,$i)] } {
                set TOVARTIP(listbox,curselection) $i
            }
            $w insert end " $TOVARTIP_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set TOVARGTT(statusline) " $i ."
        }
        set TOVARTIP(listbox,count) [expr $i - 1]
        $w see $TOVARTIP(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc tovartip:find {} {
    global VS TOVARTIP
    
    tovartip:entry find
    if { $TOVARTIP(entrystatus) == 1 } {
        set TOVARTIP(find) "1=1"
        foreach {i j} "\"$TOVARTIP(entry,nam)\" nam" {
            if { $i != "" } {
                set TOVARTIP(find) "$TOVARTIP(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $TOVARTIP(find,listbox) $TOVARTIP(find)] == -1} {
            lappend TOVARTIP(find,listbox) $TOVARTIP(find)
        }
        tovartip:read
    }
    set TOVARTIP(entrystatus) 0
}

proc tovartip:delete {} {
    global VS TOVARTIP TOVARTIP_DATA
    
    set w .tovargtt.tovartip.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id [$w curselection]
        puts $socks "tovartip_del $TOVARTIP_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        tovartip:read
    } else {
        errormsg nosocks "  !"
    }
       
    if { $id > $TOVARTIP(listbox,count)} {
        set id $TOVARTIP(listbox,count)
        set TOVARTIP(listbox,curselection) $TOVARTIP(listbox,count)
    }
    $w see $id
#    $w selection set $id $id
}

proc tovartip:insert {} {
    global VS TOVARTIP TOVARGTT TOVARGROUP TOVARGROUP_DATA
    
    tovartip:entry insert
    set w .tovargtt.tovartip.lb.listbox
    if { $TOVARTIP(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "tovartip_ins \"$TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection))\" \"$TOVARTIP(entry,nam)\""
            flush $socks
    
            while { [ set tovartipcod [ gets $socks ] ] != $VS(sepdata) } {}
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            tovartip:read
        } else {
            errormsg nosocks "  !"
        }
        
        $w see $TOVARTIP(listbox,curselection)
#        $w selection set $TOVARTIP(listbox,curselection) $TOVARTIP(listbox,curselection)
    }
    set TOVARTIP(entrystatus) 0
}

proc tovartip:update {} {
    global VS TOVARTIP TOVARTIP_DATA

    set w .tovargtt.tovartip.lb.listbox
    set TOVARTIP(entry,nam) [clipped $TOVARTIP_DATA(nam,$TOVARTIP(listbox,curselection))]
    tovartip:entry update
    if { $TOVARTIP(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "tovartip_upd $TOVARTIP_DATA(cod,$TOVARTIP(listbox,curselection)) \"$TOVARTIP(entry,nam)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {}
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            tovartip:read
        } else {
            errormsg nosocks "  !"
        }

        $w see $TOVARTIP(listbox,curselection)
        $w selection set $TOVARTIP(listbox,curselection) $TOVARTIP(listbox,curselection)
    }
    set TOVARTIP(entrystatus) 0
}

proc tovartip:view {} {
    global VS TOVARTIP TOVARTIP_DATA
    
    set TOVARTIP(entry,nam) $TOVARTIP_DATA(nam,$TOVARTIP(listbox,curselection))
    tovartip:entry view
}

proc tovartip:print {} {
    global VS TOVARTIP TOVARGROUP TOVARGROUP_DATA

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovartip_rep \"$TOVARGROUP_DATA(cod,$TOVARGROUP(listbox,curselection))\" \"$TOVARTIP(find)\" \"nam $TOVARTIP(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
