proc tovcardtov:clear {} {
    global TOVCARDTOV_DATA TOVCARD
    
    catch [unset TOVCARDTOV_DATA]
    set TOVCARDTOV_DATA(active) {}
    set TOVCARDTOV_DATA(-1,0) ""
    set TOVCARDTOV_DATA(-1,1) ""
    set TOVCARDTOV_DATA(-1,2) ""
    set TOVCARDTOV_DATA(-1,5) ""
    set TOVCARDTOV_DATA(-1,6) ""
    set TOVCARDTOV_DATA(-1,7) ""
}

proc tovcardtov:read {} {
    global VS TOVCARDTOV_DATA TOVCARDTOV TOVCARD TOVCARD_DATA
    
    set c1 [expr $TOVCARD(current) - 1]
    tovcardtov:clear
    set w $TOVCARD(inwin).tovcard.tov.tbl
    if { $TOVCARDTOV(sortstr) == "" }    { set TOVCARDTOV(sortstr) "4, 5, 12" } 
    if { $TOVCARDTOV(sortdesc) == "" }   { set TOVCARDTOV(sortdesc) " "  }
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovcardtov_sel $TOVCARD(tip) \
                                    $TOVCARDTOV(prih) \
                                    $TOVCARDTOV(rash) \
                                    $TOVCARD_DATA(tovarcod) \
                                    $TOVCARD_DATA(skladcod) \
                                    $TOVCARD(entry,datbegin) \
                                    $TOVCARD(entry,datend) \
                                    \"$TOVCARDTOV(sortstr) \
                                    $TOVCARDTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach j { doccod operpacod 0 1 2 3 4 5 6 7 } {
                set TOVCARDTOV_DATA($i,$j) "";
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                TOVCARDTOV_DATA($i,doccod)  TOVCARDTOV_DATA($i,operpcod) \
                TOVCARDTOV_DATA($i,0)       TOVCARDTOV_DATA($i,1) \
                TOVCARDTOV_DATA($i,2)       TOVCARDTOV_DATA($i,3) \
                TOVCARDTOV_DATA($i,4)       TOVCARDTOV_DATA($i,6) \
                TOVCARDTOV_DATA($i,7)       TOVCARDTOV_DATA($i,8)
            catch [set TOVCARDTOV_DATA($i,3) [format "%7.2f" $TOVCARDTOV_DATA($i,3)]]
            catch [set TOVCARDTOV_DATA($i,4) [format "%7.2f" $TOVCARDTOV_DATA($i,4)]]
            catch [set TOVCARDTOV_DATA($i,6) [format "%9.2f" $TOVCARDTOV_DATA($i,6)]]
            catch [set TOVCARDTOV_DATA($i,7) [format "%9.2f" $TOVCARDTOV_DATA($i,7)]]
        
        }
        #if [info exists TOVCARDTOV(ActiveRow)] { 
        #    if { $i < $TOVCARDTOV(ActiveRow) && $i >= 0 } { set TOVCARDTOV(ActiveRow) $i }
        #    $w see $TOVCARDTOV(ActiveRow),0
        #    $w activate $TOVCARDTOV(ActiveRow),$TOVCARDTOV(ActiveCol)
        #}
        
        set TOVCARDTOV(rows) [expr $i + 2]
        if { $TOVCARDTOV(rows) < 14 } { set TOVCARDTOV(rows) 14 }
        $w configure -rows $TOVCARDTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    tovcardtov:summa
    waiting "" ""
}

proc tovcardtov:print {} {
    global VS TOVCARDTOV_DATA TOVCARDTOV TOVCARD TOVCARD_DATA

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovcardtov_rep $TOVCARD(tip) \
                                    $TOVCARDTOV(prih) \
                                    $TOVCARDTOV(rash) \
                                    $TOVCARD_DATA(tovarcod) \
                                    $TOVCARD_DATA(skladcod) \
                                    $TOVCARD(entry,datbegin) \
                                    $TOVCARD(entry,datend) \
                                    \"$TOVCARDTOV(sortstr) \
                                    $TOVCARDTOV(sortdesc)\" \
                                    \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
