proc tovinrez {} {
    global VS TOVINREZ TOVINREZTOV TOVINREZTOV_DATA

    catch [unset TOVINREZTOV_DATA]
    tovinreztov:clear
    set TOVINREZ(find) ""
    set w .tovinrez
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+55
    wm geometry $w =0x0
    wm title $w " "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "tovinrez:find"
    $w1.1 add command -label "" -command "tovinrez:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "   " -variable TOVINREZ(sortstr) -value "3, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "5" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "6, 4" -command tovinrez:read
        $w1.1.sort add radio -label " " -variable TOVINREZ(sortstr) -value "7, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "8, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "11, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "12, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "13, 4" -command tovinrez:read
        $w1.1.sort add radio -label "   " -variable TOVINREZ(sortstr) -value "15, 4" -command tovinrez:read
        $w1.1.sort add radio -label "  " -variable TOVINREZ(sortstr) -value "18, 4" -command tovinrez:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable TOVINREZ(sortdesc) -value " " -command tovinrez:read
        $w1.1.sort add radio -label " " -variable TOVINREZ(sortdesc) -value "desc" -command tovinrez:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command  -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find  print  sort  exit  } {
        if { $i == "print" } { findbox tovinrez 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        .tovinrez.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { .tovinrez.buttons.exit invoke }
    bind $w <Key-F5>     { tovinrez:find }
    tovinrezhead    
    wm geometry $w [centerwindow $w]
    tovinrez:read
}

proc tovinrez:entry:createvar {} {
    global TOVINREZ
    
    foreach i { num dat skladnam operacianam klientnam tovarnam \
                sernum kol } {
        if ![info exists TOVINREZ(entry,$i)] {
            set TOVINREZ(entry,$i) ""
        }
    }
}

proc tovinrez:entry:clearvar {} {
    global TOVINREZ
    
    foreach i { num dat skladnam operacianam klientnam tovarnam \
                sernum kol } {
        set TOVINREZ(entry,$i) ""
    }
}

proc tovinrez:entry {} {
    global VS TOVINREZ
    
    set w .tovinrez.entry
    set TOVINREZ(entrystatus) ""
    tovinrez:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { num dat sklad operacia klient tovar sernum kol } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "klient" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { num      "              " \
                      dat      "               " \
                      sklad    "              " \
                      operacia "           " \
                      klient   "             " \
                      tovar    " " \
                      sernum   "      " \
                      kol      "         " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {num      num         20 \
                       dat      dat         20 \
                       sklad    skladnam    50 \
                       operacia operacianam 50 \
                       klient   klientnam   50 \
                       tovar    tovarnam    50 \
                       sernum   sernum      30 \
                       kol      kol         15 \
                       } {
        entry $w.inf.$i.e -textvariable TOVINREZ(entry,$j) -width $k
    }
    button $w.inf.sklad.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovinrez:hesklad r .tovinrez.entry }
    button $w.inf.operacia.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovinrez:heoperacia r .tovinrez.entry }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovinrez:heklient r .tovinrez.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { tovinrez:hetovar r .tovinrez.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set TOVINREZ(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "tovinrez:entry:clearvar"
    button $w.buttons.exit -text "" -command "set TOVINREZ(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e sklad.e sklad.b \
                operacia.e operacia.b klient.e klient.b \
                tovar.e tovar.b sernum.e kol.e \
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.num.e
    bind $w <Key-Escape>     { .tovinrez.entry.buttons.exit invoke }
    bind $w <Control-Return> { .tovinrez.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

