proc tovinrezhead:clear {} {
    global TOVINREZ_DATA TOVINREZTOV_DATA
    
    catch [unset TOVINREZ_DATA]
    foreach i {tipdoc num dat skladnam operacianam klientnam prim1 primrez } {
        set TOVINREZ_DATA($i) ""
    }
#    set TOVINREZTOV_DATA(active) ""
}

proc tovinreztov:clear {} {
    global TOVINREZTOV_DATA TOVINREZ_DATA
    
    tovinrezhead:clear
    catch [unset TOVINREZTOV_DATA]
    set TOVINREZTOV_DATA(-1,0) " "
    set TOVINREZTOV_DATA(-1,1) " "
    set TOVINREZTOV_DATA(-1,2) "."
    set TOVINREZTOV_DATA(-1,3) ".."
    set TOVINREZTOV_DATA(-1,4) ""
    set TOVINREZTOV_DATA(-1,5) "?"
}

proc tovinrez:read { } {
    global VS TOVINREZ TOVINREZTOV TOVINREZTOV_DATA
    
    set w .tovinrez.tov
    waiting "  ..." blue
    tovinreztov:clear
    if { $TOVINREZ(sortstr) == "" }    { set TOVINREZ(sortstr) "4" } 
    if { $TOVINREZ(sortdesc) == "" }   { set TOVINREZ(sortdesc) " "  }
    if { $TOVINREZ(find) == "" } {
        set TOVINREZ(find) "1=1"
        if [info exists TOVINREZ(find,listbox)] {
            if { [lsearch -exact $TOVINREZ(find,listbox) $TOVINREZ(find)] == -1} {
                lappend TOVINREZ(find,listbox) $TOVINREZ(find)
            }
        } else {
            lappend TOVINREZ(find,listbox) $TOVINREZ(find)
        }
    } 
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovinrez_sel \"$TOVINREZ(find)\" \"$TOVINREZ(sortstr) $TOVINREZ(sortdesc)\""
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { doccod tipdoc num dat skladnam operacianam \
                        klientnam prim1 primrez 0 1 2 3 4 5 } {
                set TOVINREZTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                TOVINREZTOV_DATA($i,doccod) \
                TOVINREZTOV_DATA($i,tipdoc) \
                TOVINREZTOV_DATA($i,num) \
                TOVINREZTOV_DATA($i,dat) \
                TOVINREZTOV_DATA($i,skladnam) \
                TOVINREZTOV_DATA($i,operacianam) \
                TOVINREZTOV_DATA($i,klientnam) \
                TOVINREZTOV_DATA($i,prim1) \
                TOVINREZTOV_DATA($i,primrez) \
                TOVINREZTOV_DATA($i,0) \
                TOVINREZTOV_DATA($i,1) \
                TOVINREZTOV_DATA($i,2) \
                TOVINREZTOV_DATA($i,3) \
                TOVINREZTOV_DATA($i,4) \
                TOVINREZTOV_DATA($i,5)
            
            set TOVINREZTOV_DATA($i,1)     [clipped $TOVINREZTOV_DATA($i,1)]
            set TOVINREZTOV_DATA($i,old_1) $TOVINREZTOV_DATA($i,1)
            incr i
        }
        
        set TOVINREZTOV(rows) [expr $i + 1]
        if { $TOVINREZTOV(rows) < 12 } { set TOVINREZTOV(rows) 12 }
        $w.tbl configure -rows $TOVINREZTOV(rows)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    if ![info exists TOVINREZTOV(ActiveRowCol)] {
        $w.tbl activate 0,1
        tovinreztov:browsecommand 0
    } else {
        $w.tbl activate $TOVINREZTOV(ActiveRow),1
        tovinreztov:browsecommand $TOVINREZTOV(ActiveRow)
    }
    
    update
}

proc tovinrez:find {} {
    global VS TOVINREZ TOVINREZTOV TOVINREZ_DATA
    
    tovinrez:entry
    if { $TOVINREZ(entrystatus) == 1 } {
        set TOVINREZ(find) "1=1"
        foreach {i j} " \"$TOVINREZ(entry,num)\"          b.num \
                        \"$TOVINREZ(entry,dat)\"          b.dat \
                        \"$TOVINREZ(entry,skladnam)\"     c.nam \
                        \"$TOVINREZ(entry,operacianam)\"  d.nam \
                        \"$TOVINREZ(entry,klientnam)\"    e.nam \
                        \"$TOVINREZ(entry,tovarnam)\"     g.nam \
                        \"$TOVINREZ(entry,sernum)\"       f.sernum \
                        \"$TOVINREZ(entry,kol)\"          a.kol \
                       " {
            if { $i != "" } {
                set TOVINREZ(find) "$TOVINREZ(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $TOVINREZ(find,listbox) $TOVINREZ(find)] == -1} {
            lappend TOVINREZ(find,listbox) $TOVINREZ(find)
        }
        tovinrez:read
    }
    set TOVINREZ(entrystatus) 0
}

proc tovinrez:hesklad { tip win } {
    global VS TOVINREZ HE
    
    set w .tovinrez.entry.inf.sklad.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $TOVINREZ(entry,skladnam) $tip $win
    set TOVINREZ(entry,skladcod) $HE(cod)
    set TOVINREZ(entry,skladnam) [clipped $HE(nam)]
}

proc tovinrez:heoperacia { tip win } {
    global VS TOVINREZ HE
    
    set w .tovinrez.entry.inf.operacia.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 operaciar $TOVINREZ(entry,operacianam) $tip $win
    set TOVINREZ(entry,operaciacod) $HE(cod)
    set TOVINREZ(entry,operacianam) [clipped $HE(nam)]
}

proc tovinrez:heklient { tip win } {
    global VS TOVINREZ HE
    
    set w .tovinrez.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 postpol $TOVINREZ(entry,klientnam) $tip $win
    set TOVINREZ(entry,klientcod) $HE(cod)
    set TOVINREZ(entry,klientnam) [clipped $HE(nam)]
}

proc tovinrez:hetovar { tip win } {
    global VS TOVINREZ HE
    
    set w .tovinrez.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 tovaronly $TOVINREZ(entry,tovarnam) $tip $win
    set TOVINREZ(entry,tovarcod) $HE(cod)
    set TOVINREZ(entry,tovarnam) [clipped $HE(nam)]
}

proc tovinrez:print {} {
    global VS TOVINREZ

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovinrez_rep \"$TOVINREZ(find)\" \"$TOVINREZ(sortstr) $TOVINREZ(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
