proc tovinrezhead { } {
    global VS TOVINREZ TOVINREZ_DATA TOVINREZTOV TOVINREZTOV_DATA

    set w .tovinrez
    # head ##################################################################
    
    label $w.tit -font $VS(fontn) -text "   " \
        -relief raised -anchor center -bd 1
    pack $w.tit
    
    foreach { i } { tipdoc sklad klient prim1 primrez } {
        if { $i == "tipdoc" || $i == "sklad" || $i == "prim1" || $i == "primrez" || $i == "tovar" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
    }
    frame $w.septov -bd 1 -height 10 -relief sunken
    pack  $w.septov -fill x
    foreach { i j } { tipdoc    "   " \
                      sklad     "     " \
                      klient    "    " \
                      prim1     "" \
                      primrez   " " \
                  } {
        label $w.$i.l1 -text $j
    }
    foreach { i j k } { tipdoc.tipdoc        tipdoc      40 \
                        tipdoc.num           num         6 \
                        tipdoc.dat           dat         10
                        sklad.skladnam       skladnam    30 \
                        sklad.operacianam    operacianam 30 \
                        klient.klientnam     klientnam   50 \
                        prim1.e              prim1       60 \
                        primrez.e            primrez     70 \
                      } {
        entry $w.$i -textvar TOVINREZ_DATA($j) -width $k -state disabled
    }
    foreach i { tipdoc.num tipdoc.dat } {
        $w.$i configure -bg grey95
    }
    foreach { i j } { tipdoc.l2     "    " \
                      tipdoc.l3     " " \
                      sklad.l2      "           " \
                  } {
        label $w.$i -text $j
    }
    
    foreach i { tipdoc.l1 tipdoc.tipdoc tipdoc.l2 tipdoc.num tipdoc.l3 tipdoc.dat \
                sklad.l1 sklad.skladnam sklad.l2 sklad.operacianam \
                klient.l1 klient.klientnam \
                prim1.l1 prim1.e \
                primrez.l1 primrez.e \
              } {
        pack $w.$i -side left
    }

    # tov ####################################################################

    set TOVINREZTOV(rows) 12
    frame $w.tov
    set w "$w.tov"
    pack $w
    entry $w.curfldval -textvar TOVINREZTOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 6 -height 12 -cols 6 -rows $TOVINREZTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable TOVINREZTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { tovinreztov:browsecommand %S } \
        -wrap on
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    $w.tbl tag row AnchorCenter -1
    $w.tbl tag col AnchorCenter 5
    $w.tbl width 0 45 1 20 2 9 3 6 4 11 5 3

    pack $w.curfldval -anchor w
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
            
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind .tovinrez.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        .tovinrez.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    focus $w.tbl
}

proc tovinreztov:browsecommand { rowcol } {
    global TOVINREZTOV TOVINREZTOV_DATA TOVINREZ TOVINREZ_DATA
    
    set w .tovinrez
    if { [info exists TOVINREZTOV(ActiveRow)] && \
         $TOVINREZTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row UnSelectRow $TOVINREZTOV(ActiveRow)
    }
    set TOVINREZTOV(ActiveRowCol) $rowcol 
    scan $TOVINREZTOV(ActiveRowCol) "%\[^,]%*c%s" TOVINREZTOV(ActiveRow) TOVINREZTOV(ActiveCol)
    
    if [info exists TOVINREZTOV_DATA($TOVINREZTOV(ActiveRow),doccod)] {
        foreach i {tipdoc num dat skladnam operacianam klientnam prim1 primrez } {
            set TOVINREZ_DATA($i) $TOVINREZTOV_DATA($TOVINREZTOV(ActiveRow),$i)
        }
    } else {
        tovinrezhead:clear
    }
    if { $TOVINREZTOV(ActiveRow) >= 0 } {
        $w.tov.tbl tag row SelectRow $TOVINREZTOV(ActiveRow)
    }
}

