proc valuta {} {
    global VS VALUTA VALUTA_DATA

    catch [unset VALUTA_DATA]
    set VALUTA(entry,dat) {}
    set VALUTA(listbox,curselection) 0
    
    set w .valuta
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +176+70
    wm geometry $w =0x0
    wm title $w " "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "valuta:find"
    $w1.1 add command -label "" -accelerator "<Ins>" -command "valuta:insert"
    $w1.1 add command -label "" -command "valuta:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label " " -variable VALUTA(sortstr) -value "dat" -command valuta:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable VALUTA(sortdesc) -value " " -command valuta:read
        $w1.1.sort add radio -label " " -variable VALUTA(sortdesc) -value "desc" -command valuta:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command valuta:view
    $w1.1 add command -state disabled -label "" -command valuta:update
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  " -command "set VALUTA(deletestatus) 0"
        $w1.1.delete add command -label " !!!" -command "set VALUTA(deletestatus) 1; valuta:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -takefocus 0 -text "" -command "destroy .balloon; destroy $w"
    label $w.buttons.lm -textvariable VALUTA(statusline) -relief sunken -anchor w -padx 3 -width 30
    button $w.buttons.help -takefocus 0 -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view "" update "" delete "" exit ""} {
        if { $i == "insert" } { findbox valuta 30 }
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w"; }
        if { $i == "update" || $i == "view" } {
            $w.butimg.$i configure -state disabled 
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3 -width 26
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 12
    label $w.namefield.p2 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 12
    label $w.namefield.p3 -text " " -relief raised -anchor center -bd 1 -padx 1 -width 12
    label $w.namefield.p4 -text " ." -relief raised -anchor center -bd 1 -padx 1 -width 13
    pack $w.namefield $w.namefield.l -side top
    pack $w.namefield.p1 $w.namefield.p2 $w.namefield.p3 $w.namefield.p4 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -takefocus 0 -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -takefocus 0 -yscroll "$w.lb.scrollbar set" -height 20 -width 48
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    wm geometry $w [centerwindow $w]
    valuta:read
    
    bind $w.butimg.sort <Button-1> {
        .valuta.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.delete <Button-1> {
        .valuta.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        catch [destroy .valuta.deal]
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set VALUTA(statusline) [ %W get $id ]
        set VALUTA(listbox,curselection) $id
        event generate %W <<iconmenu-enabled>>
    }
    bind $w.lb.listbox <Button-3> {
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <B1-ButtonRelease>
        .valuta.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.lb.listbox <<iconmenu-disabled>> {
        foreach {i j} { view  update  delete  } {
            .valuta.menu.1 entryconfigure [.valuta.menu.1 index $j] -state disabled
            .valuta.butimg.$i configure -state disabled
        }
    }
    bind $w.lb.listbox <<iconmenu-enabled>> {
        foreach {i j} { view  update  delete  } {
            .valuta.menu.1 entryconfigure [.valuta.menu.1 index $j] -state normal
            .valuta.butimg.$i configure -state normal
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists VALUTA_DATA(cod,$VALUTA(listbox,curselection))] {
            valuta:update
        }
    }
    focus $w.lb.listbox
    bind $w.lb.listbox <Key-Return> {
        event generate %W <B1-ButtonRelease>
        if [info exists VALUTA_DATA(cod,$VALUTA(listbox,curselection))] {
            valuta:update
        }
    }
    bind $w <Key-Escape> { .valuta.buttons.exit invoke }
    bind $w <Key-F5>     { valuta:find }
    bind $w <Key-Insert> { valuta:insert }
}

proc valuta:entry {status} {
    global VS VALUTA
    
    set VALUTA(entrystatus) {}
    set w .valuta.valutaentry
    if { $status != "view" && $status != "update"} {
        set VALUTA(entry,dat) {}
        set VALUTA(entry,kurs_p) {}
        set VALUTA(entry,kurs_s) {}
        set VALUTA(entry,kurs_i) {}
    }
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +186+220
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl ""
            set ttx "  "
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx" -width 35
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.l
    label $w.inf.l.dat -text    "                " -anchor e
    label $w.inf.l.kurs_p -text "         " -anchor e
    label $w.inf.l.kurs_s -text "           " -anchor e
    label $w.inf.l.kurs_i -text "  " -anchor e
    
    frame $w.inf.e
    entry $w.inf.e.dat -textvariable VALUTA(entry,dat) -width 10
    entry $w.inf.e.kurs_p -textvariable VALUTA(entry,kurs_p) -width 7
    entry $w.inf.e.kurs_s -textvariable VALUTA(entry,kurs_s) -width 7
    entry $w.inf.e.kurs_i -textvariable VALUTA(entry,kurs_i) -width 7
    if { $status == "view" } {
        $w.inf.e.dat configure -state disabled
        $w.inf.e.kurs_p configure -state disabled
        $w.inf.e.kurs_s configure -state disabled
        $w.inf.e.kurs_i configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set VALUTA(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "set VALUTA(entry,dat) {}; set VALUTA(entry,kurs_p) {}; set VALUTA(entry,kurs_s) {}; set VALUTA(entry,kurs_i) {}"
    button $w.buttons.exit -text "" -command "set VALUTA(entrystatus) 0; destroy $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.inf.l $w.inf.e -side left
    pack $w.msg.l -padx 5 -pady 5
    pack $w.inf.l.dat $w.inf.l.kurs_p $w.inf.l.kurs_s $w.inf.l.kurs_i -padx 2 -pady 2 -anchor e
    pack $w.inf.e.dat $w.inf.e.kurs_p $w.inf.e.kurs_s $w.inf.e.kurs_i -padx 2 -pady 2 -anchor w
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.e.dat
    } else {
        focus $w.buttons.exit
    }
    wm geometry $w [centerwindow $w]
    bind $w <Key-Escape> { .valuta.valutaentry.buttons.exit invoke }
    tkwait window $w
}
