proc valuta:read {} {
    global VS VALUTA VALUTA_DATA
    
    set w .valuta.lb.listbox
    event generate .valuta.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset VALUTA_DATA]
    if { $VALUTA(sortstr) == "" }    { set VALUTA(sortstr) "dat" } 
    if { $VALUTA(sortdesc) == "" }   { set VALUTA(sortdesc) " "  }
    if { $VALUTA(find) == "" } {
        set VALUTA(find) "1=1"
        lappend VALUTA(find,listbox) $VALUTA(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "valuta_sel \"$VALUTA(find)\" \"$VALUTA(sortstr) $VALUTA(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set VALUTA_DATA(cod,$i) {}; 
            set VALUTA_DATA(dat,$i) {}; 
            set VALUTA_DATA(kurs_p,$i) {}
            set VALUTA_DATA(kurs_s,$i) {}
            set VALUTA_DATA(kurs_i,$i) {}
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                    VALUTA_DATA(cod,$i) \
                    VALUTA_DATA(dat,$i) \
                    VALUTA_DATA(kurs_p,$i) \
                    VALUTA_DATA(kurs_s,$i) \
                    VALUTA_DATA(kurs_i,$i)
            if { [clipped $VALUTA(entry,dat)] == [clipped $VALUTA_DATA(dat,$i)] } {
                set VALUTA(listbox,curselection) $i
            }
            $w insert end [format " %10s      %5.4f      %5.4f      %5.4f " \
                    $VALUTA_DATA(dat,$i) \
                    $VALUTA_DATA(kurs_p,$i) \
                    $VALUTA_DATA(kurs_s,$i) \
                    $VALUTA_DATA(kurs_i,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set VALUTA(statusline) " $i ."
        }
        set VALUTA(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc valuta:find {} {
    global VS VALUTA
    
    valuta:entry find
    if { $VALUTA(entrystatus) == 1 } {
        set VALUTA(find) "1=1"
        foreach {i j} "\"$VALUTA(entry,dat)\" dat \
                       \"$VALUTA(entry,kurs_p)\" kurs_p \
                       \"$VALUTA(entry,kurs_s)\" kurs_s \
                       \"$VALUTA(entry,kurs_i)\" kurs_i" {
            if { $i != "" } {
                set VALUTA(find) "$VALUTA(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $VALUTA(find,listbox) $VALUTA(find)] == -1} {
            lappend VALUTA(find,listbox) $VALUTA(find)
        }
        valuta:read
    }
    set VALUTA(entrystatus) 0
}

proc valuta:delete {} {
    global VS VALUTA VALUTA_DATA
    
    set w .valuta.lb.listbox
    if { $VALUTA(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $VALUTA(listbox,curselection)
            puts $socks "valuta_del $VALUTA_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            valuta:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $VALUTA(listbox,count)} {
            set id $VALUTA(listbox,count)
            set VALUTA(listbox,curselection) $VALUTA(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set VALUTA(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set VALUTA(deletestatus) 0
}

proc valuta:insert {} {
    global VS VALUTA
    
    set w .valuta.lb.listbox
    valuta:entry insert
    if { $VALUTA(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "valuta_ins \"$VALUTA(entry,dat)\" \"$VALUTA(entry,kurs_p)\" \"$VALUTA(entry,kurs_s)\" \"$VALUTA(entry,kurs_i)\""
            flush $socks
    
            while { [ set valutacod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            valuta:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $VALUTA(listbox,curselection)]
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set VALUTA(entrystatus) 0
}

proc valuta:update {} {
    global VS VALUTA VALUTA_DATA

    set w .valuta.lb.listbox
    set VALUTA(entry,dat)    [clipped $VALUTA_DATA(dat,$VALUTA(listbox,curselection))]
    set VALUTA(entry,kurs_p) [clipped $VALUTA_DATA(kurs_p,$VALUTA(listbox,curselection))]
    set VALUTA(entry,kurs_s) [clipped $VALUTA_DATA(kurs_s,$VALUTA(listbox,curselection))]
    set VALUTA(entry,kurs_i) [clipped $VALUTA_DATA(kurs_i,$VALUTA(listbox,curselection))]
    valuta:entry update
    if { $VALUTA(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "valuta_upd $VALUTA_DATA(cod,$VALUTA(listbox,curselection)) \"$VALUTA(entry,dat)\" \"$VALUTA(entry,kurs_p)\" \"$VALUTA(entry,kurs_s)\" \"$VALUTA(entry,kurs_i)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            valuta:read
        } else {
            errormsg nosocks "  !"
        }
    }
    
    $w see [set id $VALUTA(listbox,curselection)]
    $w selection set $id $id
    $w activate $id
    event generate $w <<iconmenu-enabled>>
    set VALUTA(entrystatus) 0
}

proc valuta:view {} {
    global VS VALUTA VALUTA_DATA
    
    set VALUTA(entry,dat)    $VALUTA_DATA(dat,$VALUTA(listbox,curselection))
    set VALUTA(entry,kurs_p) $VALUTA_DATA(kurs_p,$VALUTA(listbox,curselection))
    set VALUTA(entry,kurs_s) $VALUTA_DATA(kurs_s,$VALUTA(listbox,curselection))
    set VALUTA(entry,kurs_i) $VALUTA_DATA(kurs_i,$VALUTA(listbox,curselection))
    valuta:entry view
    catch [event generate .valuta.lb.listbox <<iconmenu-enabled>>]
}

proc valuta:print {} {
    global VS VALUTA    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "valuta_rep \"$VALUTA(find)\" \"$VALUTA(sortstr) $VALUTA(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
