proc vphead {} {
    global VS VP

    set w $VP(inwin).vp.head
    set VP(hebutton) 0
    
    label $w.tut -bg gray70 -wraplength 1 -width 2 -height 6 -font $VS(fontn) -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    foreach { i } { num skladr skladp prim1 } {
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
        if { $i == "num" || $i == "klient" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
    }
    foreach { i j } { num       "     " \
                      skladr    "  " \
                      skladp    "    " \
                      prim1     "" \
                  } {
        label $w.$i.l1 -text $j
    }
    foreach { i j k } {num.num              num         6 \
                       num.dat              dat         10 \
                       skladr.skladrnam     skladrnam    30 \
                       skladp.skladpnam     skladpnam    30 \
                       prim1.e              prim1       60 \
                       } {
        entry $w.$i -textvar VP($j) -width $k
    }
    if { $VP(cod) == 0 } {
        $w.num.num configure -state disabled
    }
    foreach { i j } { num.l2    " " } {
        label $w.$i -text $j
    }
    
    button $w.skladr.b1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set VP(hebutton) 1; vphead:heskladrnam r $VP(inwin).vp.head"
    button $w.skladp.b1 -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 \
        -command "set VP(hebutton) 1; vphead:heskladpnam r $VP(inwin).vp.head"
    
    foreach i { num.l1 num.num num.l2 num.dat \
                skladr.l1 skladr.skladrnam skladr.b1 \
                skladp.l1 skladp.skladpnam skladp.b1 \
                prim1.l1 prim1.e
              } {
        pack $w.$i -side left
    }

    foreach { i } { skladr.skladrnam skladp.skladpnam } {
        bind $w.$i <FocusOut> {
            scan %W "%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%*\[^.]%%*c%%\[^.]" wn
            if { "$VP(old_$wn)" != "$VP($wn)" } {
                regsub -all " " "$VP($wn)" "" lng
                if { $VP(hebutton) == 0 } {
                    if { [string length $lng] > 0 } {
                        vphead:he$wn u $VP(inwin).vp.head
                        set VP(old_$wn) $VP($wn)
                    } else { set VP($wn) "" }
                }
            }
        }
    }
    foreach { i } { skladr.skladrnam skladp.skladpnam } {
        bind $w.$i <Button-1> {
            catch [ destroy $VP(inwin).vp.head.he ]
        }
    }
    bind $w.num.dat <FocusIn> {
        if { $VP(dat) == "" } {
            set VP(dat) $VS(day).$VS(month).$VS(year)
        }
    }
    if { $VP(cod) == 0 } { focus $w.num.dat }
}

