proc vptov:summa {} {
    global VPTOV VPTOV_DATA VP
    
    if { $VPTOV(ActiveCol) == 2 } {
        set i 0
        set VPTOV(skol) 0
        set VPTOV(scena1) 0
        set VPTOV(scena2) 0
        if { $VP(tip) == "m" } {
            set nkol 2
            set nscena1 4
        } else {
            set nkol 1
            set nscena1 3
        }
        while { [info exists VPTOV_DATA($i,$nkol)] && [info exists VPTOV_DATA($i,$nscena1)]} {
            catch [set VPTOV(skol) [expr $VPTOV(skol) + $VPTOV_DATA($i,$nkol)]]
            catch [set VPTOV(scena1) [expr $VPTOV(scena1) + $VPTOV_DATA($i,$nkol) * $VPTOV_DATA($i,$nscena1)]]
            catch [set VPTOV(scena2) [expr $VPTOV(scena2) + $VPTOV_DATA($i,$nkol) * $VPTOV_DATA($i,5)]]
            incr i
        }
    }
}

proc vptov:browsecommand { rowcol } {
    global VPTOV VPTOV_DATA VP
    
    set w $VP(inwin).vp.tov
    if { [info exists VPTOV(ActiveRow)] && \
         $VPTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $VPTOV(ActiveRow)
    }
    # after tovarnam
    if { [ info exists VPTOV(ActiveRow) ] && $VPTOV(ActiveRow) >= 0 } {
        if { [ info exists VPTOV(ActiveCol) ] && $VPTOV(ActiveCol) == 0 } {
            if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),old_0)] { 
                set VPTOV_DATA($VPTOV(ActiveRow),old_0) "" 
            }
            if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),0) ] { 
                set VPTOV_DATA($VPTOV(ActiveRow),0) "" 
            }
            if { $VPTOV_DATA($VPTOV(ActiveRow),old_0) != $VPTOV_DATA($VPTOV(ActiveRow),0) && \
                 $VPTOV_DATA($VPTOV(ActiveRow),0) != "" } {
                if ![info exists VPTOV_DATA($VPTOV(ActiveRow),operrcod)] {
                    set VPTOV_DATA($VPTOV(ActiveRow),operrcod) 0
                }
                if ![info exists VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod)] {
                    set VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod) 0
                }
                if { $VPTOV_DATA($VPTOV(ActiveRow),operrcod) > 0 || \
                     $VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod) > 0 } {
                    errormsg nosocks " !!!    .  ,   ."
                    set VPTOV_DATA($VPTOV(ActiveRow),0) $VPTOV_DATA($VPTOV(ActiveRow),old_0)
                } else {
                    vptov:hetovarnam u $VP(inwin).vp.tov
                }
            }
        }
    }
    # after kol
    set nkol 1
    if { $VP(tip) == "m" } { set nkol 2 }
    if [ info exists VPTOV(ActiveRow) ] {
        if { $VPTOV(ActiveCol) == $nkol && $VPTOV(ActiveRow) >= 0 } {
            if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),$nkol) ] { 
                set VPTOV_DATA($VPTOV(ActiveRow),$nkol) {} 
            }
            if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),old_$nkol) ] { 
                set VPTOV_DATA($VPTOV(ActiveRow),old_$nkol) {}
            }
            if { $VPTOV_DATA($VPTOV(ActiveRow),old_$nkol) != $VPTOV_DATA($VPTOV(ActiveRow),$nkol) } {
                if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),kol) ] { 
                    set VPTOV_DATA($VPTOV(ActiveRow),kol) {}
                }
                if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),operrcod) ] { 
                    set VPTOV_DATA($VPTOV(ActiveRow),operrcod) 0 
                }
                if ![ info exists VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod) ] { 
                    set VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod) 0 
                }
                if { $VPTOV_DATA($VPTOV(ActiveRow),operrcod) > 0 || \
                    $VPTOV_DATA($VPTOV(ActiveRow),vpoperpcod) > 0 } {
                    if { [whattovarkol $VP(tip) $VPTOV_DATA($VPTOV(ActiveRow),operrcod)] < \
                         [expr $VPTOV_DATA($VPTOV(ActiveRow),$nkol) - $VPTOV_DATA($VPTOV(ActiveRow),old_$nkol)] } {
                        errormsg nosocks " !!!       ."
                        set VPTOV_DATA($VPTOV(ActiveRow),$nkol) $VPTOV_DATA($VPTOV(ActiveRow),old_$nkol)
                    }
                } else {
                    if { $VPTOV_DATA($VPTOV(ActiveRow),kol) < $VPTOV_DATA($VPTOV(ActiveRow),$nkol) } {
                        errormsg nosocks " !!!       ."
                        set VPTOV_DATA($VPTOV(ActiveRow),$nkol) $VPTOV_DATA($VPTOV(ActiveRow),kol)
                    }
                }
            }
        }
    }
    
    set VPTOV(ActiveRowCol) $rowcol 
    scan $VPTOV(ActiveRowCol) "%\[^,]%*c%s" VPTOV(ActiveRow) VPTOV(ActiveCol)
    
    # before tovarnam
    if { $VPTOV(ActiveCol) == 0 } {
        if [info exists VPTOV_DATA($VPTOV(ActiveRow),0)] {
            set VPTOV_DATA($VPTOV(ActiveRow),old_0) $VPTOV_DATA($VPTOV(ActiveRow),0)
        }
    }
    vptov:summa
    if { $VPTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $VPTOV(ActiveRow)
    }
}

proc vptov {} {
    global VS VPTOV VPTOV_DATA VPTOV VP
    
    set VPTOV(rows) 8
    set w $VP(inwin).vp.tov
    set VPTOV(width) 6
    set VPTOV(cols) 6
    
    if { $VP(tip) == "f" } {
        set VPTOV(width) 4
        set VPTOV(cols) 4
    }
    
    frame $w.itogo
    frame $w.itogo.1
    frame $w.itogo.2
    frame $w.curfldval
    entry $w.curfldval.e -width 50 -textvar VPTOV_DATA(active) -fg red -bg #fffff0
    label $w.tut -bg gray70 -wraplength 1 -font $VS(fontn) -width 2 -height 5 -text "" -relief sunken -bd 1
    pack $w.tut -side left -fill y
    pack $w.curfldval -anchor nw
    pack $w.curfldval.e -side left
    pack $w.itogo -side bottom -fill x
    pack $w.itogo.1 -side top -fill x
    pack $w.itogo.2 -side bottom -fill x
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width $VPTOV(width) -height 8 -cols $VPTOV(cols) \
        -rows $VPTOV(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable VPTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { vptov:browsecommand %S } \
        -wrap on
        
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -bg grey85
    $w.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tbl
    if { $VP(tip) == "f" } {
        $w.tbl tag col AnchorCenter 2 
        $w.tbl tag col AnchorE 1 3
        $w.tbl tag col Disabled  2 3
        $w.tbl tag row AnchorCenter -1
        $w.tbl width 0 49 1 9 2 10 3 10
    } else {
        $w.tbl tag col AnchorCenter 4 
        $w.tbl tag col AnchorE 2 4 5
        $w.tbl tag col Disabled 1 3 4 5
        $w.tbl tag row AnchorCenter -1
        $w.tbl width 0 29 1 20 2 9 3 10 4 10 5 10
        
    }
    
    label $w.itogo.1.l1 -text "                                            :"
    label $w.itogo.1.skol -textvar VPTOV(skol) -bd 1 -relief sunken -anchor e -width 8 -bg gray40 -fg cyan
    label $w.itogo.1.l2 -text "          "
    label $w.itogo.1.scena1 -textvar VPTOV(scena1) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    if { $VP(tip) != "f" } {
        label $w.itogo.1.l3 -text ""
        label $w.itogo.1.scena2 -textvar VPTOV(scena2) -bd 1 -relief sunken -anchor e -width 9 -bg gray40 -fg cyan
    }
    foreach i { 1.l1 1.skol 1.l2 1.scena1 } {
        pack $w.itogo.$i -side left
    }
    if { $VP(tip) != "f" } {
        foreach i { 1.l3 1.scena2 } {
            pack $w.itogo.$i -side left
        }
    }
    
    pack $w.tbl -side left
    pack $w.sby -side right -fill y
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    if { $VP(cod) != 0 } { focus $w.tbl }
}

