proc zaimlist { tip } {
    global VS ZAIMLIST ZAIMLISTTOV ZAIMLISTTOV_DATA

    catch [unset ZAIMLISTTOV_DATA]
    set ZAIMLIST(tip) $tip
    zaimlisttov:clear
    set ZAIMLIST(find) ""
    set w .zaimlist
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +10+55
    wm geometry $w =0x0
    switch $tip {
        "z" { wm title $w "    " }
        "g" { wm title $w "  " }
    }
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    menu $w1.1.sort -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<F5>" -command "zaimlist:find"
    $w1.1 add command -label "" -command "zaimlist:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "2, 3, 10" -command zaimlist:read
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "3, 10" -command zaimlist:read
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "4, 10" -command zaimlist:read
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "9, 10, 3" -command zaimlist:read
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "10, 3" -command zaimlist:read
        $w1.1.sort add radio -label "  " -variable ZAIMLIST(sortstr) -value "11, 10, 3" -command zaimlist:read
        $w1.1.sort add radio -label "   " -variable ZAIMLIST(sortstr) -value "12, 10, 3" -command zaimlist:read
        $w1.1.sort add separator
        $w1.1.sort add radio -label " " -variable ZAIMLIST(sortdesc) -value " " -command zaimlist:read
        $w1.1.sort add radio -label " " -variable ZAIMLIST(sortdesc) -value "desc" -command zaimlist:read
        $w1.1.sort add separator
        $w1.1.sort add command -label "" 
    $w1.1 add command -accelerator "<Enter>" -label "" -command zaimlist:document
    $w1.1 add separator
    $w1.1 add command  -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach { i j } { find  print  sort  schet  exit  } {
        if { $i == "print" } { findbox zaimlist 60 }
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} { button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy $w" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        .zaimlist.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w <Key-Escape> { .zaimlist.buttons.exit invoke }
    bind $w <Key-F5>     { zaimlist:find }
    bind $w <Key-Return> { .zaimlist.butimg.schet invoke }
    zaimlisthead    
    wm geometry $w [centerwindow $w]
    zaimlist:read
}

proc zaimlist:entry:createvar {} {
    global ZAIMLIST
    
    foreach i { tovarnam sernum kol klientnam numdoc datzaima } {
        if ![info exists ZAIMLIST(entry,$i)] {
            set ZAIMLIST(entry,$i) ""
        }
    }
}

proc zaimlist:entry:clearvar {} {
    global ZAIMLIST
    
    foreach i { tovarnam sernum kol klientnam numdoc datzaima } {
        set ZAIMLIST(entry,$i) ""
    }
}

proc zaimlist:entry {} {
    global VS ZAIMLIST
    
    set w .zaimlist.entry
    set ZAIMLIST(entrystatus) ""
    zaimlist:entry:createvar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +105+79
    wm geometry $w =0x0
    frame $w.msg
    wm title $w ""
    label $w.msg.l -font $VS(fontn) -text "  "
    label $w.msg.logo -image logo_find -bg cyan -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    
    foreach { i } { tovar sernum kol klient num dat } {
        frame $w.inf.$i
        pack $w.inf.$i -anchor w -padx 3 -pady 2
        if { $i == "klient" } {
            frame $w.inf.sep$i -bd 1 -height 2 -relief sunken
            pack $w.inf.sep$i -fill x
        }
    }
    foreach { i j } { tovar    "   " \
                      sernum   "        " \
                      kol      "           " \
                      klient   "               " \
                      num      "       " \
                      dat      "        " \
                  } {
        label $w.inf.$i.l -text $j
        pack $w.inf.$i.l -side left
    }
    foreach { i j k } {num      numdoc      20 \
                       dat      datzaima    20 \
                       klient   klientnam   50 \
                       tovar    tovarnam    50 \
                       sernum   sernum      20 \
                       kol      kol         15 \
                       } {
        entry $w.inf.$i.e -textvariable ZAIMLIST(entry,$j) -width $k
    }
    button $w.inf.klient.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { zaimlist:heklient r .zaimlist.entry }
    button $w.inf.tovar.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { zaimlist:hetovar r .zaimlist.entry }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set ZAIMLIST(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "zaimlist:entry:clearvar"
    button $w.buttons.exit -text "" -command "set ZAIMLIST(entrystatus) 0; destroy $w"
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
  
    foreach i { num.e dat.e \
                klient.e klient.b \
                tovar.e tovar.b kol.e \
                sernum.e
              } {
        pack $w.inf.$i -side left
    }
    focus $w.inf.tovar.e
    bind $w <Key-Escape>     { .zaimlist.entry.buttons.exit invoke }
    bind $w <Control-Return> { .zaimlist.entry.buttons.ok invoke }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}

proc zaimlist:document {} {
    global ZAIMLIST ZAIMLISTTOV ZAIMLISTTOV_DATA NAKLPLIST

    set w .zaimlist.tov.tbl
    scan [$w index active] "%\[^,]" row
    if [info exists ZAIMLISTTOV_DATA($row,0)] {
        switch -exact $ZAIMLISTTOV_DATA($row,0) {
            P   {
                set NAKLPLIST(pr) p
                naklp 1 m $ZAIMLISTTOV_DATA($row,cod) .zaimlist
            }
            R   {
                set NAKLPLIST(pr) r
                naklp 1 m $ZAIMLISTTOV_DATA($row,cod) .zaimlist
            }
        }
    }
}
