proc zaimopl:summa {} {
    global ZAIMOPL ZAIMOPL_DATA ZAIMOPL_ITOGO NAKLPTOV ZAIMTOV_ITOGO
    
    set w $ZAIMOPL(inwin)
    set i 0
    set ZAIMOPL_ITOGO(-2,1) 0
    set ZAIMOPL_ITOGO(-2,2) 0
    while { [info exists ZAIMOPL_DATA($i,0)] } {
        if [info exists ZAIMOPL_DATA($i,1)] {
            set ZAIMOPL_ITOGO(-2,1) [expr $ZAIMOPL_ITOGO(-2,1) + $ZAIMOPL_DATA($i,1)]
        }
        if [info exists ZAIMOPL_DATA($i,2)] {
            set ZAIMOPL_ITOGO(-2,2) [expr $ZAIMOPL_ITOGO(-2,2) + $ZAIMOPL_DATA($i,2)]
        }
        incr i
    }
    set ZAIMOPL_ITOGO(-1,1) [expr $NAKLPTOV(scena1) - $ZAIMOPL_ITOGO(-2,1) - $ZAIMTOV_ITOGO(-1,6)]
    set ZAIMOPL_ITOGO(-1,2) [expr $NAKLPTOV(scena2) - $ZAIMOPL_ITOGO(-2,2) - $ZAIMTOV_ITOGO(-1,7)]
    if { $ZAIMOPL_ITOGO(-1,1) == 0 } { $w.itogo tag cell ItogoRavno -1,1 }
    if { $ZAIMOPL_ITOGO(-1,1) > 0 }  { $w.itogo tag cell ItogoBolshe -1,1 }
    if { $ZAIMOPL_ITOGO(-1,1) < 0 }  { $w.itogo tag cell ItogoMenshe -1,1 }
    if { $ZAIMOPL_ITOGO(-1,2) == 0 } { $w.itogo tag cell ItogoRavno -1,2 }
    if { $ZAIMOPL_ITOGO(-1,2) > 0 }  { $w.itogo tag cell ItogoBolshe -1,2 }
    if { $ZAIMOPL_ITOGO(-1,2) < 0 }  { $w.itogo tag cell ItogoMenshe -1,2 }
}

proc zaimopl { win doccod } {
    global VS ZAIMOPL ZAIMOPL_DATA NAKLP ZAIMOPL_ITOGO STT
    
    set w $win.zaim.opl
    if { $NAKLP(operaciacod) == $STT(zaimtocod) }    { set ZAIMOPL(tip) "to" }
    if { $NAKLP(operaciacod) == $STT(zaimfromcod) }  { set ZAIMOPL(tip) "from" }
    if { $NAKLP(operaciacod) == $STT(gklp1cod) }     { set ZAIMOPL(tip) "gklp" }
    if { $NAKLP(operaciacod) == $STT(gklp2cod) }     { set ZAIMOPL(tip) "gklp" }
    if { $NAKLP(operaciacod) == $STT(gklr1cod) }     { set ZAIMOPL(tip) "gklr" }
    if { $NAKLP(operaciacod) == $STT(gklr2cod) }     { set ZAIMOPL(tip) "gklr" }
    if { $NAKLP(operaciacod) == $STT(gpsr1cod) }     { set ZAIMOPL(tip) "gpsr" }
    if { $NAKLP(operaciacod) == $STT(gpsr2cod) }     { set ZAIMOPL(tip) "gpsr" }
    if { $NAKLP(operaciacod) == $STT(gpsp1cod) }     { set ZAIMOPL(tip) "gpsp" }
    if { $NAKLP(operaciacod) == $STT(gpsp2cod) }     { set ZAIMOPL(tip) "gpsp" }
    set ZAIMOPL(inwin) $w
    set ZAIMOPL(doccod) $doccod
    set ZAIMOPL(rows) 6
    frame $w -bd 1 -relief raised
    pack $w -side right -padx 1 -pady 1
    entry $w.curfldval -bd 1 -width 20 -textvar ZAIMOPL_DATA(active) -fg red \
        -bg #fffff0 -takefocus 0
    switch -- $ZAIMOPL(tip) {
        "to"      { set ltxt "-" }
        "from"    { set ltxt "-" }
        "gklp"    { set ltxt "-" }
        "gklr"    { set ltxt "-" }
        "gpsr"    { set ltxt "-" }
        "gpsp"    { set ltxt "-" }
    }
    label $w.tut -bg gray70 -wraplength 1 -font $VS(fontn) -width 1 -height 5 -text $ltxt -relief sunken -bd 1
    pack $w.tut -side left -fill y
    pack $w.curfldval -anchor nw
    scrollbar $w.sby -takefocus 0 -command " $w.tbl yview "
    table $w.tbl -width 3 -height 6 -cols 3 -rows $ZAIMOPL(rows) \
        -yscrollcommand " $w.sby set " \
        -cursor arrow \
        -variable ZAIMOPL_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { zaimopl:browsecommand %S } \
        -wrap on
        
    tktableinittag $w.tbl
    $w.tbl tag col AnchorE 1 2
    $w.tbl tag row AnchorCenter -1
    $w.tbl width 0 9 1 11 2 11
    
    table $w.itogo -width 3 -height 2 -cols 3 -rows 2 \
        -variable ZAIMOPL_ITOGO \
        -cursor arrow \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -takefocus 0 \
        -state disabled \
        -wrap on \
        -bd 0
    tktableinittag $w.itogo
    $w.itogo width 0 9 1 11 2 11
    $w.itogo tag cell ItogoActive -1,1 -1,2 -2,1 -2,2
    $w.itogo tag cell ItogoPassive -1,0 -2,0
    $w.itogo tag col AnchorE 0 1 2
    
    pack $w.sby -side right -fill y
    pack $w.tbl
    pack $w.itogo
    
    set ZAIMOPL_ITOGO(-2,0) ":"
    set ZAIMOPL_ITOGO(-1,0) ":"
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.itogo <FocusIn>    { focus $ZAIMOPL(inwin).tbl }
    bind $w.tbl <KeyPress-F2> {
        if { $ZAIMOPL(ActiveRow) >= 0 && $ZAIMOPL(ActiveCol) == 0 } {
            set ZAIMOPL_DATA($ZAIMOPL(ActiveRow),0) "$VS(day)$VS(month)$VS(year)"
        }
    }
}

proc zaimopl:browsecommand { rowcol } {
    global ZAIMOPL ZAIMOPL_DATA
    
    set w $ZAIMOPL(inwin)
    if { [info exists ZAIMOPL(ActiveRow)] && \
         $ZAIMOPL(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $ZAIMOPL(ActiveRow)
    }
    set ZAIMOPL(ActiveRowCol) $rowcol 
    scan $ZAIMOPL(ActiveRowCol) "%\[^,]%*c%s" ZAIMOPL(ActiveRow) ZAIMOPL(ActiveCol)
    zaimopl:summa
    if { $ZAIMOPL(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $ZAIMOPL(ActiveRow)
    }
}

