proc zaimtov:varold { i } {
    global ZAIMTOV_DATA

    set ZAIMTOV_DATA($i,old_tovarcod) $ZAIMTOV_DATA($i,tovarcod)
    set ZAIMTOV_DATA($i,old_0)        $ZAIMTOV_DATA($i,0)
    set ZAIMTOV_DATA($i,old_1)        $ZAIMTOV_DATA($i,1)
    set ZAIMTOV_DATA($i,old_2)        $ZAIMTOV_DATA($i,2)
    set ZAIMTOV_DATA($i,old_3)        $ZAIMTOV_DATA($i,3)
    set ZAIMTOV_DATA($i,old_4)        $ZAIMTOV_DATA($i,4)
    set ZAIMTOV_DATA($i,old_5)        $ZAIMTOV_DATA($i,5)
    set ZAIMTOV_DATA($i,old_6)        $ZAIMTOV_DATA($i,6)
    set ZAIMTOV_DATA($i,old_7)        $ZAIMTOV_DATA($i,7)
}

proc zaimtov:clear {} {
    global VS ZAIMTOV_DATA
    
    catch [unset ZAIMTOV_DATA]
    set ZAIMTOV_DATA(-1,0) "N"
    set ZAIMTOV_DATA(-1,1) ""
    set ZAIMTOV_DATA(-1,2) " "
    set ZAIMTOV_DATA(-1,3) ".N"
    set ZAIMTOV_DATA(-1,4) "."
    set ZAIMTOV_DATA(-1,5) ".."
    set ZAIMTOV_DATA(-1,6) ""
    set ZAIMTOV_DATA(-1,7) ""
}

proc zaimtov:read {} {
    global VS ZAIMTOV_DATA ZAIMTOV NAKLP
    
    zaimtov:clear
    set w $ZAIMTOV(inwin).tbl
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "zaimtov_sel $ZAIMTOV(tip) $ZAIMTOV(doccod)"
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach { j } { naklcod matopercod tovarcod 0 1 2 3 4 5 6 } {
                set ZAIMTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                ZAIMTOV_DATA($i,naklcod)  ZAIMTOV_DATA($i,matopercod) \
                ZAIMTOV_DATA($i,tovarcod) ZAIMTOV_DATA($i,0) \
                ZAIMTOV_DATA($i,1)        ZAIMTOV_DATA($i,2) \
                ZAIMTOV_DATA($i,3)        ZAIMTOV_DATA($i,4) \
                ZAIMTOV_DATA($i,5)        ZAIMTOV_DATA($i,6) \
                ZAIMTOV_DATA($i,7)
            
            set ZAIMTOV_DATA($i,2) [clipped   $ZAIMTOV_DATA($i,2)]
            set ZAIMTOV_DATA($i,3) [clipped   $ZAIMTOV_DATA($i,3)]
            catch [set ZAIMTOV_DATA($i,4) [format "%7.2f" $ZAIMTOV_DATA($i,4)]]
            catch [set ZAIMTOV_DATA($i,6) [format "%9.2f" $ZAIMTOV_DATA($i,6)]]
            catch [set ZAIMTOV_DATA($i,7) [format "%9.2f" $ZAIMTOV_DATA($i,7)]]
            zaimtov:varold $i
        }
        if [info exists ZAIMTOV(ActiveRow)] { 
            if { $i < $ZAIMTOV(ActiveRow) && $i >= 0 } { set ZAIMTOV(ActiveRow) $i }
            $w see $ZAIMTOV(ActiveRow),0
            $w activate $ZAIMTOV(ActiveRow),$ZAIMTOV(ActiveCol)
        }
        
        set ZAIMTOV(rows) [expr $i + 2]
        if { $ZAIMTOV(rows) < 6 } { set ZAIMTOV(rows) 6 }
        $w configure -rows $ZAIMTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    zaimtov:summa
    waiting "" ""
}

proc zaimtov:delete {} {
    global VS ZAIMTOV ZAIMTOV_DATA NAKLP
    
    set w $ZAIMTOV(inwin).tbl
    if [info exists ZAIMTOV(ActiveRow)] {
        if [info exists ZAIMTOV_DATA($ZAIMTOV(ActiveRow),matopercod)] {
            set ZAIMTOV_DATA(active) ""
            $w tag row UnSelectRow $ZAIMTOV(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $ZAIMTOV(ActiveRow)
                waiting "  ..." red
                puts $socks "zaimtov_del $ZAIMTOV(tip) \
                                         $ZAIMTOV_DATA($ZAIMTOV(ActiveRow),naklcod) \
                                         $ZAIMTOV_DATA($ZAIMTOV(ActiveRow),matopercod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $ZAIMTOV(ActiveRow)
                waiting "" ""
                zaimtov:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc zaimtov:insert { row } {
    global VS ZAIMTOV_DATA ZAIMTOV NAKLP STT
    
    set w $ZAIMTOV(inwin).tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        if { $NAKLP(operaciacod) == $STT(zaimtocod) }    { set opc $STT(pzaimtocod) }
        if { $NAKLP(operaciacod) == $STT(pzaimtocod) }   { set opc $STT(zaimtocod) }
        if { $NAKLP(operaciacod) == $STT(zaimfromcod) }  { set opc $STT(pzaimfromcod) }
        if { $NAKLP(operaciacod) == $STT(pzaimfromcod) } { set opc $STT(zaimfromcod) }
        if { $NAKLP(operaciacod) == $STT(gklp1cod) }     { set opc $STT(gklr1cod) }
        if { $NAKLP(operaciacod) == $STT(gklp2cod) }     { set opc $STT(gklr2cod) }
        if { $NAKLP(operaciacod) == $STT(gklr1cod) }     { set opc $STT(gklp1cod) }
        if { $NAKLP(operaciacod) == $STT(gklr2cod) }     { set opc $STT(gklp2cod) }
        if { $NAKLP(operaciacod) == $STT(gpsr1cod) }     { set opc $STT(gpsp1cod) }
        if { $NAKLP(operaciacod) == $STT(gpsr2cod) }     { set opc $STT(gpsp2cod) }
        if { $NAKLP(operaciacod) == $STT(gpsp1cod) }     { set opc $STT(gpsr1cod) }
        if { $NAKLP(operaciacod) == $STT(gpsp2cod) }     { set opc $STT(gpsr2cod) }
        if ![info exists ZAIMTOV_DATA($row,operpcod)]    { set ZAIMTOV_DATA($row,operpcod) 0 }
        if ![info exists ZAIMTOV_DATA($row,3)]           { set ZAIMTOV_DATA($row,3) {} }
        puts $socks "zaimtov_ins $ZAIMTOV(tip) \
                                 $ZAIMTOV(doccod) \
                                 [clipped \"$ZAIMTOV_DATA($row,1)\"] \
                                 $NAKLP(skladcod) \
                                 $opc \
                                 $NAKLP(klientcod) \
                                 $ZAIMTOV_DATA($row,tovarcod) \
                                 $ZAIMTOV_DATA($row,operpcod) \
                                 [clipped \"$ZAIMTOV_DATA($row,3)\"] \
                                 [clipped \"$ZAIMTOV_DATA($row,4)\"] \
                                 [clipped \"$ZAIMTOV_DATA($row,6)\"] \
                                 [clipped \"$ZAIMTOV_DATA($row,7)\"] "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                ZAIMTOV_DATA($row,naklcod) \
                ZAIMTOV_DATA($row,matopercod) \
                ZAIMTOV_DATA($row,0)
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set ZAIMTOV_DATA($row,old_tovarcod) $ZAIMTOV_DATA($row,tovarcod)
        set ZAIMTOV_DATA($row,2)            [clipped $ZAIMTOV_DATA($row,2)]
        set ZAIMTOV_DATA($row,3)            [clipped $ZAIMTOV_DATA($row,3)]
        set ZAIMTOV_DATA($row,old_1)        $ZAIMTOV_DATA($row,1)
        set ZAIMTOV_DATA($row,old_3)        $ZAIMTOV_DATA($row,3)
        set ZAIMTOV_DATA($row,old_4)        $ZAIMTOV_DATA($row,4)
        set ZAIMTOV_DATA($row,old_6)        $ZAIMTOV_DATA($row,6)
        set ZAIMTOV_DATA($row,old_7)        $ZAIMTOV_DATA($row,7)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc zaimtov:update { row } {
    global VS ZAIMTOV_DATA ZAIMTOV
    
    set w $ZAIMTOV(inwin).tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        if ![info exists ZAIMTOV_DATA($row,6)] { set ZAIMTOV_DATA($row,6) 0.00 }
        if ![info exists ZAIMTOV_DATA($row,7)] { set ZAIMTOV_DATA($row,7) 0.00 }
        if ![info exists ZAIMTOV_DATA($row,1)] { set ZAIMTOV_DATA($row,1) {} }
        if ![info exists ZAIMTOV_DATA($row,3)] { set ZAIMTOV_DATA($row,3) {} }
        puts $socks "zaimtov_upd $ZAIMTOV(tip) \
                                 $ZAIMTOV_DATA($row,naklcod) \
                                 $ZAIMTOV_DATA($row,matopercod) \
                                 $ZAIMTOV_DATA($row,tovarcod) \
                                 \"$ZAIMTOV_DATA($row,1)\" \
                                 \"$ZAIMTOV_DATA($row,3)\" \
                                 \"$ZAIMTOV_DATA($row,4)\" \
                                 \"$ZAIMTOV_DATA($row,6)\" \
                                 \"$ZAIMTOV_DATA($row,7)\""
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            zaimtov:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc zaimtov:hetovarnamto { tip win } {
    global VS ZAIMTOV_DATA HE ZAIMTOV
    
    set w $ZAIMTOV(inwin).curfldval
    set HE(tit) "                                 ..               "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 6 75 tovar "$ZAIMTOV_DATA($ZAIMTOV(ActiveRow),2)" $tip $win
    scan $HE(cod) "%\[^\003]%*c%s" \
        ZAIMTOV_DATA($ZAIMTOV(ActiveRow),tovarcod) \
        ZAIMTOV_DATA($ZAIMTOV(ActiveRow),eicod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
        ZAIMTOV_DATA($ZAIMTOV(ActiveRow),2) \
        ZAIMTOV_DATA($ZAIMTOV(ActiveRow),5) \
        ZAIMTOV_DATA($ZAIMTOV(ActiveRow),6) \
        fuf
    set ZAIMTOV_DATA($ZAIMTOV(ActiveRow),2) [clipped $ZAIMTOV_DATA($ZAIMTOV(ActiveRow),2)]
}

proc zaimtov:hetovarnamfrom { tip win } {
    global VS ZAIMTOV_DATA HE ZAIMTOV
    
    set sep \003
    set c2 $ZAIMTOV(ActiveRow)
    set HE(tit) "                                    .              . ..                                            .     "
    set skladdat $ZAIMTOV_DATA($c2,1)
    set w $ZAIMTOV(inwin).curfldval
    he [expr [winfo rootx $w] - 25] [expr [winfo rooty $w] + [winfo height $w] - 25] 8 93 tovarostatokskl "m$sep$skladdat$sep$ZAIMTOV_DATA($c2,2)" $tip $win
    scan $HE(cod) "%\[^\003]%*c%\[^\003]%*c%s" \
        ZAIMTOV_DATA($c2,operpcod) \
        ZAIMTOV_DATA($c2,tovarcod) \
        ZAIMTOV_DATA($c2,eicod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\t]" \
        datpokupki \
        ZAIMTOV_DATA($c2,2) \
        ZAIMTOV_DATA($c2,3) \
        ZAIMTOV_DATA($c2,4) \
        ZAIMTOV_DATA($c2,5) \
        ZAIMTOV_DATA($c2,6) \
        ZAIMTOV_DATA($c2,7) \
        isnds \
        skladnam
            
    catch [set ZAIMTOV_DATA($c2,2) [clipped $ZAIMTOV_DATA($c2,2)]]
    catch [set ZAIMTOV_DATA($c2,3) [clipped $ZAIMTOV_DATA($c2,3)]]
    catch [set ZAIMTOV_DATA($c2,5) [clipped $ZAIMTOV_DATA($c2,5)]]
}

proc zaimtov:hetovarnamgklp { tip win } {
    zaimtov:hetovarnamfrom $tip $win
}

proc zaimtov:hetovarnamgpsr { tip win } {
    zaimtov:hetovarnamto $tip $win
}
