globals "globals.4gl"

function issostav(tovarcod)
define
    str     	char(128),
    tovarcod    integer,
    cnt         smallint

    whenever error call err
    
    initialize cnt to null
    let str = "execute procedure issostav(?)"
    prepare p_issostav from str
    declare cur_issostav cursor for p_issostav
    let transaction = 1
    begin work
    open cur_issostav using tovarcod
        fetch cur_issostav into cnt
        display cnt
    close cur_issostav
    commit work
end function

function issofnrnnakl(sofnrcod)
define
    str     	char(128),
    sofnrcod    integer,
    nnaklcod    integer
    
    initialize nnaklcod to null
    let str = "execute procedure issofnrnnakl(?)"
    prepare p_issofnrnnakl from str
    declare cur_issofnrnnakl cursor for p_issofnrnnakl
    let transaction = 1
    begin work
    open cur_issofnrnnakl using sofnrcod
        fetch cur_issofnrnnakl into nnaklcod
        if nnaklcod is null then let nnaklcod = 0 end if
        display nnaklcod
    close cur_issofnrnnakl
    commit work
end function
