globals "globals.4gl"

globals
    define field1str, field2str, tbl1str, tbl2str  char(50)
end globals


main
define namprg   char(20),
       a        smallint,
       maxcod   integer

    whenever error call err

    set lock mode to wait
    
    let formfeed=ascii 12
	let field1str = "sum(kol * cena)"
	let sanserif=ascii 27,ascii 73,ascii 50
	let underlineon=ascii 27,ascii 45,ascii 1
    let tbl1str = "finoperp"	
    let underlineoff=ascii 27,ascii 45,ascii 48
    let field2str = "sum(kol * cenad)"
    let elite=ascii 27,ascii 58
    let tbl2str = "matoperp"
	
	let italic=ascii 28,ascii 52
	let vidon=ascii 27,ascii 69	
	let vidoff=ascii 27,ascii 70
	let downindex=ascii 27,ascii 83,ascii 1 
	let topindex=ascii 27,ascii 83,ascii 48
	let indexoff=ascii 27,ascii 84
	let passon=ascii 27,ascii 15
	let passoff=ascii 18
	let twicewidthon=ascii 27,ascii 87, ascii 49
	let twicewidthoff=ascii 27,ascii 87, ascii 48
	let betweenstr6=ascii 27, ascii 50
	let betweenstr8=ascii 27, ascii 48
	let betweenstr10=ascii 27, ascii 49
    
    let namprg = arg_val(0)
    
    call runprg(namprg)
end main

function runprg(namprg)
define  namprg  char(20),
    i   integer,
    dec1, dec2   decimal(20,2),
    str     char(256)
    
    case namprg
        when "he" 
            call he(arg_val(1), arg_val(2))
        when "operacia_del"
            call operacia_del(arg_val(1))
        when "operacia_sel"
            call operacia_sel(arg_val(1), arg_val(2), arg_val(3))
        when "operacia_ins"
            call operacia_ins(arg_val(1), arg_val(2))
        when "operacia_upd"
            call operacia_upd(arg_val(1), arg_val(2))
        when "operacia_rep"
            call operacia_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "lgota_del"
            call lgota_del(arg_val(1))
        when "lgota_sel"
            call lgota_sel(arg_val(1), arg_val(2))
        when "lgota_ins"
            call lgota_ins(arg_val(1), arg_val(2))
        when "lgota_upd"
            call lgota_upd(arg_val(1), arg_val(2), arg_val(3))
        when "lgota_rep"
            call lgota_rep(arg_val(1), arg_val(2), arg_val(3))
        when "ei_del"
            call ei_del(arg_val(1))
        when "ei_sel"
            call ei_sel(arg_val(1), arg_val(2))
        when "ei_ins"
            call ei_ins(arg_val(1))
        when "ei_upd"
            call ei_upd(arg_val(1), arg_val(2))
        when "ei_rep"
            call ei_rep(arg_val(1), arg_val(2), arg_val(3))
        when "gorod_he"
            call gorod_he(arg_val(1))
        when "gorod_del"
            call gorod_del(arg_val(1))
        when "gorod_sel"
            call gorod_sel(arg_val(1), arg_val(2))
        when "gorod_ins"
            call gorod_ins(arg_val(1), arg_val(2))
        when "gorod_upd"
            call gorod_upd(arg_val(1), arg_val(2), arg_val(3))
        when "gorod_rep"
            call gorod_rep(arg_val(1), arg_val(2), arg_val(3))
        when "tovargroup_del"
            call tovargroup_del(arg_val(1))
        when "tovargroup_sel"
            call tovargroup_sel(arg_val(1), arg_val(2))
        when "tovargroup_ins"
            call tovargroup_ins(arg_val(1))
        when "tovargroup_upd"
            call tovargroup_upd(arg_val(1), arg_val(2))
        when "tovargroup_rep"
            call tovargroup_rep(arg_val(1), arg_val(2), arg_val(3))
        when "tovartip_del"
            call tovartip_del(arg_val(1))
        when "tovartip_sel"
            call tovartip_sel(arg_val(1), arg_val(2), arg_val(3))
        when "tovartip_ins"
            call tovartip_ins(arg_val(1), arg_val(2))
        when "tovartip_upd"
            call tovartip_upd(arg_val(1), arg_val(2))
        when "tovartip_rep"
            call tovartip_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "tovar_del"
            call tovar_del(arg_val(1))
        when "tovar_sel"
            call tovar_sel(arg_val(1), arg_val(2), arg_val(3))
        when "tovar_ins"
            call tovar_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11))
        when "tovar_upd"
            call tovar_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10))
        when "tovar_rep"
            call tovar_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "sot_del"
            call sot_del(arg_val(1))
        when "sotone_sel"
            call sotone_sel(arg_val(1))
        when "sotmany_sel"
            call sotmany_sel(arg_val(1), arg_val(2))
        when "sot_ins"
            call sot_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12))
        when "sot_upd"
            call sot_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12), arg_val(13))
        when "sot_rep"
            call sot_rep(arg_val(1), arg_val(2), arg_val(3))
        when "postpol_globper"
            call postpol_globper(arg_val(1), arg_val(2))
        when "tovar_globper"
            call tovar_globper(arg_val(1), arg_val(2))
        when "tovarmany_sel"
            call tovarmany_sel(arg_val(1), arg_val(2))
        when "postpol_del"
            call postpol_del(arg_val(1))
        when "postpolone_sel"
            call postpolone_sel(arg_val(1))
        when "postpolmany_sel"
            call postpolmany_sel(arg_val(1), arg_val(2))
        when "postpol_ins"
            call postpol_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12), arg_val(13), arg_val(14), arg_val(15), arg_val(16), arg_val(17), arg_val(18), arg_val(19), arg_val(20), arg_val(21), arg_val(22), arg_val(23), arg_val(24), arg_val(25), arg_val(26), arg_val(27), arg_val(28), arg_val(29), arg_val(30), arg_val(31), arg_val(32), arg_val(33), arg_val(34), arg_val(35), arg_val(36), arg_val(37), arg_val(38), arg_val(39), arg_val(40), arg_val(41), arg_val(42), arg_val(43), arg_val(44))
        when "postpol_upd"
            call postpol_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12), arg_val(13), arg_val(14), arg_val(15), arg_val(16), arg_val(17), arg_val(18), arg_val(19), arg_val(20), arg_val(21), arg_val(22), arg_val(23), arg_val(24), arg_val(25), arg_val(26), arg_val(27), arg_val(28), arg_val(29), arg_val(30), arg_val(31), arg_val(32), arg_val(33), arg_val(34), arg_val(35), arg_val(36), arg_val(37), arg_val(38), arg_val(39), arg_val(40), arg_val(41), arg_val(42), arg_val(43), arg_val(44), arg_val(45))
        when "postpol_rep"
            call postpol_rep(arg_val(1), arg_val(2), arg_val(3))
        when "sklad_del"
            call sklad_del(arg_val(1))
        when "sklad_sel"
            call sklad_sel(arg_val(1), arg_val(2))
        when "sklad_selmo"
            call sklad_selmo(arg_val(1), arg_val(2), arg_val(3))
        when "sklad_ins"
            call sklad_ins(arg_val(1), arg_val(2))
        when "sklad_upd"
            call sklad_upd(arg_val(1), arg_val(2))
        when "sklad_repmo"
            call sklad_repmo(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        
        when "myorg_ins"
            call myorg_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12), arg_val(13), arg_val(14), arg_val(15), arg_val(16), arg_val(17), arg_val(18), arg_val(19), arg_val(20))
        when "myorg_sel"
            call myorg_sel()
        
        when "sostav_del"
            call sostav_del(arg_val(1))
        when "sostav_sel"
            call sostav_sel(arg_val(1), arg_val(2), arg_val(3))
        when "sostavm_sel"
            call sostavm_sel(arg_val(1), arg_val(2))
        when "sostav_ins"
            call sostav_ins(arg_val(1), arg_val(2))
        when "sostav_upd"
            call sostav_upd(arg_val(1), arg_val(2))
        when "sostav_rep"
            call sostav_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        
        when "stt_ins"
            call stt_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12), arg_val(13), arg_val(14), arg_val(15), arg_val(16))
        when "stt_sel"
            call stt_sel()
        
        when "schet_ins"
            call schet_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7))
        when "schetone_sel"
            call schetone_sel(arg_val(1))
        when "schet_upd"
            call schet_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9))
        when "schet_del"
            call schet_del(arg_val(1))
        when "schet_rep"
            call schet_rep(arg_val(1), arg_val(2), arg_val(3))
        when "schetkwit_rep"
            call schetkwit_rep(arg_val(1), arg_val(2))
        when "schetobjava_rep"
            call schetobjava_rep(arg_val(1), arg_val(2), arg_val(3))
        when "schetnnakl_sel"
            call schetnnakl_sel(arg_val(1))
        when "schetnnakl_rep"
            call schetnnakl_rep(arg_val(1), arg_val(2))
        
        when "finnaklr_del"
            call finnaklr_del(arg_val(1))
        when "finnaklrone_sel"
            call finnaklrone_sel(arg_val(1))
        when "finnaklr_ins"
            call finnaklr_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6))
        when "finnaklr_upd"
            call finnaklr_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7))
        when "finnaklr_rep"
            call finnaklr_rep(arg_val(1), arg_val(2), arg_val(3))
        when "issofnrnnakl"
            call issofnrnnakl(arg_val(1))
        
        when "schettov_ins"
            call schettov_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "schettov_sel"
            call schettov_sel(arg_val(1), arg_val(2))
        when "schettov_del"
            call schettov_del(arg_val(1))
        when "schettov_upd"
            call schettov_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "schettov_rep"
            call schettov_rep(arg_val(1), arg_val(2), arg_val(3))
        
        when "schetopl_ins"
            call schetopl_ins(arg_val(1), arg_val(2), arg_val(3))
        when "schetopl_sel"
            call schetopl_sel(arg_val(1))
        when "schetopl_del"
            call schetopl_del(arg_val(1))
        when "schetopl_summa"
            call schetopl_summa(arg_val(1))
        when "schetopl_upd"
            call schetopl_upd(arg_val(1), arg_val(2), arg_val(3))
        when "schetopl_rep"
            call schetopl_rep(arg_val(1), arg_val(2))

        when "schettovt_ins"
            call schettovt_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "schettovt_sel"
            call schettovt_sel(arg_val(1), arg_val(2))
        when "schettovt2_sel"
            call schettovt2_sel(arg_val(1), arg_val(2), arg_val(3))
        when "schettovt_del"
            call schettovt_del(arg_val(1))
        when "schettovt_upd"
            call schettovt_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "schettovt1_rep"
            call schettovt1_rep(arg_val(1), arg_val(2), arg_val(3))
        when "schettovt2_rep"
            call schettovt2_rep(arg_val(1), arg_val(2), arg_val(3))
        when "issostav"
            call issostav(arg_val(1))
        
        when "nnakl_del"
            call nnakl_del(arg_val(1))
        when "nnakl_sel"
            call nnakl_sel(arg_val(1))
        when "nnakl_upd"
            call nnakl_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6))
        when "nnakl_rep"
            call nnakl_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "nnaklgenerate"
            call nnaklgenerate(arg_val(1), arg_val(2), arg_val(3))
        
        when "nnakltov_sel"
            call nnakltov_sel(arg_val(1), arg_val(2), arg_val(3))
        when "nnakltov_upd"
            call nnakltov_upd(arg_val(1), arg_val(2))
        when "nnakltov_ins"
            call nnakltov_ins(arg_val(1), arg_val(2), arg_val(3))
        when "nnakltov_del"
            call nnakltov_del(arg_val(1))
            
        when "naklplist_sel"
            call naklplist_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "naklplist_rep"
            call naklplist_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "naklp_del"
            call naklp_del(arg_val(1), arg_val(2))
        when "naklpone_sel"
            call naklpone_sel(arg_val(1), arg_val(2))
        when "naklp_ins"
            call naklp_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11))
        when "naklp_upd"
            call naklp_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11))
        when "naklphead_rep"
            call naklphead_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
            
        when "snnno_sel"
            call snnno_sel(arg_val(1), arg_val(2), arg_val(3))
        when "snnnoone_sel"
            call snnnoone_sel(arg_val(1))
        when "snnno_rep"
            call snnno_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
            
        when "noo_sel"
            call noo_sel(arg_val(1), arg_val(2), arg_val(3))
        when "nooone_sel"
            call nooone_sel(arg_val(1))
        when "noo_rep"
            call noo_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))

        when "nds_ins"
            call nds_ins(arg_val(1), arg_val(2))
        when "nds_sel"
            call nds_sel()
        when "nds_del"
            call nds_del(arg_val(1))
        when "nds_upd"
            call nds_upd(arg_val(1), arg_val(2), arg_val(3))
        
        when "naklptov_sel"
            call naklptov_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "naklptov_ins"
            call naklptov_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10))
        when "naklptov_upd"
            call naklptov_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9))
        when "naklptov_del"
            call naklptov_del(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        
        when "vplist_sel"
            call vplist_sel(arg_val(1), arg_val(2), arg_val(3))
        when "vplist_rep"
            call vplist_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "vp_ins"
            call vp_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "vp_del"
            call vp_del(arg_val(1))
        when "vp_upd"
            call vp_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6))
        when "vpone_sel"
            call vpone_sel(arg_val(1))
        when "vptov_ins"
            call vptov_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6))
        when "vptov_sel"
            call vptov_sel(arg_val(1), arg_val(2), arg_val(3))
        when "vptov_del"
            call vptov_del(arg_val(1), arg_val(2), arg_val(3))
        when "vptov_upd"
            call vptov_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "vphead_rep"
            call vphead_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "sernum_sel"
            call sernum_sel(arg_val(1), arg_val(2), arg_val(3))
        when "sernum_rep"
            call sernum_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "sernumtov_upd"
            call sernumtov_upd(arg_val(1), arg_val(2), arg_val(3))
        when "sernumtov_del"
            call sernumtov_del(arg_val(1))
        when "whattovarkol"
            call whattovarkol(arg_val(1), arg_val(2))
        when "spisaniehead_sel"
            call spisaniehead_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "spisanietov_ins"
            call spisanietov_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10))
        when "spisanietov_sel"
            call spisanietov_sel(arg_val(1))
        when "spisanietov_upd"
            call spisanietov_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6))
        when "spisanietov_del"
            call spisanietov_del(arg_val(1), arg_val(2))
        when "reztov_sel"
            call reztov_sel(arg_val(1))
        when "otgtov_sel"
            call otgtov_sel(arg_val(1))
        when "nnakllist_sel"
            call nnakllist_sel(arg_val(1), arg_val(2))
        when "nnakllist_rep"
            call nnakllist_rep(arg_val(1), arg_val(2), arg_val(3))
        when "tovcardhead_sel"
            call tovcardhead_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "tovcardtov_sel"
            call tovcardtov_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8))
        when "tovcardtov_rep"
            call tovcardtov_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9))
        when "oplnototg_sel"
            call oplnototg_sel(arg_val(1), arg_val(2), arg_val(3))
        when "oplnototg_rep"
            call oplnototg_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "otgnotopl_sel"
            call otgnotopl_sel(arg_val(1), arg_val(2), arg_val(3))
        when "otgnotopl_rep"
            call otgnotopl_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "jurnal_sel"
            call jurnal_sel(arg_val(1), arg_val(2), arg_val(3))
        when "jurnal_rep"
            call jurnal_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "prodaga_sel"
            call prodaga_sel(arg_val(1), arg_val(2), arg_val(3))
        when "prodaga_rep"
            call prodaga_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "klientbalans"
            call klientbalans(arg_val(1))
        when "skladosttov_sel"
            call skladosttov_sel(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7))
        when "skladosttov_rep1"
            call skladosttov_rep1(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8))
        when "skladosttov_rep2"
            call skladosttov_rep2(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8))
        when "whomathtov_sel"
            call whomathtov_sel(arg_val(1))
        
        when "docopl_ins"
            call docopl_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "docopl_sel"
            call docopl_sel(arg_val(1), arg_val(2))
        when "docopl_del"
            call docopl_del(arg_val(1), arg_val(2))
        when "docopl_upd"
            call docopl_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "docopl_rep"
            call docopl_rep(arg_val(1), arg_val(2), arg_val(3))
            
        when "tovinrez_sel"
            call tovinrez_sel(arg_val(1), arg_val(2))
        when "tovinrez_rep"
            call tovinrez_rep(arg_val(1), arg_val(2), arg_val(3))
            
        when "garanttalon_rep"
            call garanttalon_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "controlu"
            call controlu(arg_val(1), arg_val(2))

        when "prodagamat_sel"
            call prodagamat_sel(arg_val(1), arg_val(2), arg_val(3))
        
        when "prikid_sel"
            call prikid_sel(arg_val(1), arg_val(2))

        when "valuta_del"
            call valuta_del(arg_val(1))
        when "valuta_sel"
            call valuta_sel(arg_val(1), arg_val(2))
        when "valuta_ins"
            call valuta_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "valuta_upd"
            call valuta_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4),  arg_val(5))
        when "valuta_rep"
            call valuta_rep(arg_val(1), arg_val(2), arg_val(3))

        when "tovdolg_sel"
            call tovdolg_sel(arg_val(1), arg_val(2))
        when "tovdolg_rep"
            call tovdolg_rep(arg_val(1), arg_val(2), arg_val(3))
            
        when "whorezdoc_sel"
            call whorezdoc_sel(arg_val(1), arg_val(2))
        
        when "prodmattov_sel"
            call prodmattov_sel(arg_val(1), arg_val(2))
        
        when "tovarwww_sel"
            call tovarwww_sel(arg_val(1))
        when "tovarwww_ins"
            call tovarwww_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        
        when "zaimtov_ins"
            call zaimtov_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9), arg_val(10), arg_val(11), arg_val(12))
        when "zaimtov_sel"
            call zaimtov_sel(arg_val(1), arg_val(2))
        when "zaimtov_del"
            call zaimtov_del(arg_val(1), arg_val(2), arg_val(3))
        when "zaimtov_upd"
            call zaimtov_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5), arg_val(6), arg_val(7), arg_val(8), arg_val(9))
        when "zaimopl_sel"
            call zaimopl_sel(arg_val(1), arg_val(2))
        when "zaimopl_del"
            call zaimopl_del(arg_val(1), arg_val(2))
        when "zaimopl_ins"
            call zaimopl_ins(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "zaimopl_upd"
            call zaimopl_upd(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        when "zaimlist_sel"
            call zaimlist_sel(arg_val(1), arg_val(2), arg_val(3))
        when "zaimlist_rep"
            call zaimlist_rep(arg_val(1), arg_val(2), arg_val(3), arg_val(4))
        when "pricepost_sel"
            call pricepost_sel()
        when "pricepost_write"
            call pricepost_write(arg_val(1), arg_val(2))
        when "pricetov_sel"
            call pricetov_sel()
        when "pricetov_write"
            call pricetov_write(arg_val(1), arg_val(2), arg_val(3), arg_val(4), arg_val(5))
        otherwise display "not program"
    end case
end function

function err()
define	se1, se2	char(80),
    sep     char(7)

    initialize se1, se2 to null
    let se2 = err_get(status)
    let sep = ascii 1, ascii 2, ascii 3, ascii 4, ascii 5, ascii 6, ascii 7
    
    case status
        when -692 let se1 = "  "
        when -530 let se1 = "   "
    end case
    
    display sep, "\n-1\n", " :", status using "------", " \t",
                            se1 clipped, " \t", 
                            se2 clipped
    
    if transaction = 1 then
        rollback work
    end if
    exit program -1
end function

#         
function funpdv(dat, s)
define	s, swpdv, pdv   decimal(20,10),
        pnds            like nds.stavka,
        dat             date,
        ipdv            integer,
        dec             decimal(10,10)
	
	let pnds = procnds(dat)
    let	pdv = s * pnds / (100 + pnds)
    
    #  4    5      1
    let ipdv = pdv
    let dec = pdv - ipdv
    let ipdv = dec * 100
    let dec = dec - ipdv / 100
    if dec >= 0.0005 and dec < 0.0006
    then
        let pdv = pdv + 0.0001
    end if
    
    let swpdv = s - pdv
    return swpdv, pdv
end function

function whatsot()	#  login  
	select fio into userfio from _sot where login = user
end function

function myorg()
    select * into p_myorg.* from myorg
end function

function procnds(datt)
define  pnds    like nds.stavka,
    datt        date

    select a.stavka into pnds 
        from nds a
        where a.dat = (select max(x.dat) from nds x where x.dat <= datt)
    return pnds
end function

function stt()
    select * into p_stt.* from stt
end function

function toupper(ch)
define  ch  char(1)
    case ch
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        when "" let ch = ""
        otherwise let ch = "?"
    end case
    return ch
end function
