globals "globals.4gl"

function prikid_sel(tip, cod)
define  
    str         char(1024),
    tip         char(1),
    cod         integer,
    p record
        kol         like naklrtov.kol,
        cenamin     like matoperp.cena,
        cenadmin    like matoperp.cenad,
        cenamax     like matoperp.cena,
        cenadmax    like matoperp.cenad
    end record,
    p1 record
        tovarnam    like tovar.nam,
        cenamin     decimal(9,2),
        cenadmin    decimal(9,2),
        cenamax     decimal(9,2),
        cenadmax    decimal(9,2)
    end record,
    p2 record
        tovarnam    like tovar.nam,
        summa       like matoperp.cena,
        summad      like matoperp.cenad,
        dat_pokupki date
    end record,
    icenamin, icenadmin, icenamax, icenadmax   decimal(9,2)

    whenever error call err
    
    begin work
    call stt()

    if tip = "n" then
        let str = "select b.nam, a.kol * min(c.cena), a.kol * min(c.cenad), a.kol * max(c.cena), a.kol * max(c.cenad)  ",
                     "from naklrtov a, tovar b, _tovarostatokmat c ",
                     "where a.naklr_cod = ", cod, " and ",
                           "a.tovar_cod = b.cod and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol"
    end if
    if tip = "s" then
        let str = "select b.nam, a.kol * min(c.cena), a.kol * min(c.cenad), a.kol * max(c.cena), a.kol * max(c.cenad)  ",
                     "from schfnrtov a, tovar b, _tovarostatokmat c ",
                     "where a.schetfnr_cod = ", cod, " and ",
                           "a.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                           "a.tovar_cod = b.cod and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol ",
                   "union ",
                   "select b.nam, a.kol * min(c.cena), a.kol * min(c.cenad), a.kol * max(c.cena), a.kol * max(c.cenad)  ",
                     "from schfnrtovt a, tovar b, _tovarostatokmat c ",
                     "where a.schetfnr_cod = ", cod, " and ",
                           "a.tovar_cod = b.cod and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol"
    end if
    prepare p_sel1 from str
    
    initialize p1 to null
    declare cur_sel1 cursor for p_sel1
    foreach cur_sel1 into p1.*
        display "yes", "\t",
                p1.tovarnam, "\t",
                p1.cenamin, "\t",
                p1.cenadmin, "\t",
                p1.cenamax, "\t",
                p1.cenadmax
    end foreach
    
    if tip = "n" then
        let str = "select b.nam, a.kol * max(c.cena), a.kol * max(c.cenad), max(dat_pokupki) ",
                     "from naklrtov a, tovar b, matoperp c ",
                     "where a.naklr_cod = ", cod, " and ",
                           "a.tovar_cod = b.cod and ",
                           "b.cod not in (select x0.tovar_cod from _tovarostatokmat x0 where x0.tovar_cod = b.cod) and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol"
    end if
    if tip = "s" then
        let str = "select b.nam, a.kol * max(c.cena), a.kol * max(c.cenad), max(dat_pokupki)  ",
                     "from schfnrtov a, tovar b, matoperp c ",
                     "where a.schetfnr_cod = ", cod, " and ",
                           "a.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                           "b.cod not in (select x0.tovar_cod from _tovarostatokmat x0 where x0.tovar_cod = b.cod) and ",
                           "a.tovar_cod = b.cod and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol ",
                   "union ",
                   "select b.nam, a.kol * max(c.cena), a.kol * max(c.cenad), max(dat_pokupki)  ",
                     "from schfnrtovt a, tovar b, matoperp c ",
                     "where a.schetfnr_cod = ", cod, " and ",
                           "b.cod not in (select x0.tovar_cod from _tovarostatokmat x0 where x0.tovar_cod = b.cod) and ",
                           "a.tovar_cod = b.cod and ",
                           "c.naklp_cod is not null and ",
                           "a.tovar_cod = c.tovar_cod ",
                     "group by b.nam, a.kol"
    end if
    
    prepare p_sel2 from str
    
    initialize p2 to null
    declare cur_sel2 cursor for p_sel2
    foreach cur_sel2 into p2.*
        display "not", "\t",
                p2.tovarnam, "\t",
                p2.summa, "\t",
                p2.summad, "\t",
                p2.dat_pokupki using "dd.mm.yyyy"
    end foreach
    commit work
end function
