globals "globals.4gl"

function skladosttov_sel(tip, sernum, prih, cena, dat, find_str, sort_str)
define  
    tip, sernum, prih, cena char(1),
    find_str    char(256),
    sort_str    char(64),
    dat         date,
    codes_fld, sernum_fld2, prih_fld1, cena_fld1   char(256),
    p   record
        naklpcod    integer,
        tovarcod    integer,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        datp        date,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad,
        skladnam    like sklad.nam,
        kolrez      like matoperp.kol,
        skladcod    integer,
        prim1       like naklp.prim1
    end record,
    str     char(4096),
    kolost          decimal(7,2),
    kolrash         decimal(7,2)

    whenever error call err

    initialize p, kolost to null
    # mattov with prim ################################################################
    if tip = 'p' then
        if sernum = 'a' then
            let sernum_fld2 = "a.sernum,"
        else
            let sernum_fld2 = "nullchar(),"
        end if
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        if cena = 'a' then
            let cena_fld1 = "a.cena, a.cenad,"
        else
            let cena_fld1 = "nulldecimal(), nulldecimal(),"
        end if
        if sernum = 'a' and prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), a.tovar_cod,"
        end if
        let str = "select unique ", codes_fld clipped,
                         "b.nam, ", sernum_fld2 clipped,
                         "sum(a.kol - kolmattovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "d.nam, ",
                         "sum(kolmattovrforpdasr(a.cod)), d.cod, e.prim1 ",
                    "from matoperp a, tovar b, ei c, sklad d, outer vp e ",
                    "where a.tovar_cod = b.cod and ",
                          "a.doc_cod = e.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "(a.kol - kolmattovrforpdas(a.cod,'", dat, "') != 0 or kolmattovrforpdasr(a.cod) != 0) and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 12, 13 ", 
                    "order by ", sort_str clipped
    end if
    
    # mattov ################################################################
    if tip = 'm' then
        if sernum = 'a' then
            let sernum_fld2 = "a.sernum,"
        else
            let sernum_fld2 = "nullchar(),"
        end if
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        if cena = 'a' then
            let cena_fld1 = "a.cena, a.cenad,"
        else
            let cena_fld1 = "nulldecimal(), nulldecimal(),"
        end if
        if sernum = 'a' and prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), a.tovar_cod,"
        end if
        let str = "select unique ", codes_fld clipped,
                         "b.nam, ", sernum_fld2 clipped,
                         "sum(a.kol - kolmattovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "d.nam, ",
                         "sum(kolmattovrforpdasr(a.cod)), d.cod, nullchar() ",
                    "from matoperp a, tovar b, ei c, sklad d ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "(a.kol - kolmattovrforpdas(a.cod,'", dat, "') != 0 or kolmattovrforpdasr(a.cod) != 0) and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 12 ", 
                    "order by ", sort_str clipped
    end if
    
    # fintov ################################################################
    if tip = 'f' then
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        
        if cena = 'a' then
            let cena_fld1 = "a.cena,"
        else
            let cena_fld1 = "nulldecimal(),"
        end if
        
        if prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        
        let str = "select unique ", codes_fld clipped,
                         "b.nam, nullchar(), ",
                         "sum(a.kol - kolfintovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "nulldecimal(), d.nam, ",
                         "nulldecimal(), d.cod, nullchar() ",
                    "from finoperp a, tovar b, ei c, sklad d ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "a.kol - kolfintovrforpdas(a.cod,'", dat, "') != 0 and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12 ", 
                    "order by ", sort_str clipped
    end if
    
    prepare p_seltov from str
    
    declare cur_seltov cursor for p_seltov
    let transaction = 1    
    begin work
    foreach cur_seltov into p.*
        display p.skladcod, "\t",
                p.naklpcod, "\t", 
                p.tovarcod, "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.kol using "-----.--", "\t",
                p.einam, "\t",
                p.datp using "ddmmyy", "\t",
                p.cena using "#######.##", "\t",
                p.cenad using "#######.##", "\t",
                p.skladnam, "\t",
                p.kolrez using "-----.--", "\t",
                p.prim1
    end foreach
    commit work
end function

function skladosttov_rep1(tip, sernum, prih, cena, dat, find_str, sort_str, pipe_str)
define  
    tip, sernum, prih, cena char(1),
    find_str    char(256),
    sort_str    char(64),
    pipe_str    char(256),
    dat         date,
    codes_fld, sernum_fld2, prih_fld1, cena_fld1   char(256),
    p   record
        naklpcod    integer,
        tovarcod    integer,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        datp        date,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad,
        skladnam    like sklad.nam,
        kolrez      like matoperp.kol,
        prim1     like naklp.prim1
    end record,
    str     char(4096),
    kolost          decimal(7,2),
    kolrash         decimal(7,2)
    
    initialize p, kolost to null
    let reppipe = pipe_str
    # mattov with prim1 ################################################################
    if tip = 'p' then
        if sernum = 'a' then
            let sernum_fld2 = "a.sernum,"
        else
            let sernum_fld2 = "nullchar(),"
        end if
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        if cena = 'a' then
            let cena_fld1 = "a.cena, a.cenad,"
        else
            let cena_fld1 = "nulldecimal(), nulldecimal(),"
        end if
        if sernum = 'a' and prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        let str = "select unique ", codes_fld clipped,
                         "b.nam, ", sernum_fld2 clipped,
                         "sum(a.kol - kolmattovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "d.nam, ",
                         "sum(kolmattovrforpdasr(a.cod)), e.prim1 ",
                    "from matoperp a, tovar b, ei c, sklad d, outer vp e ",
                    "where a.tovar_cod = b.cod and ",
                          "a.doc_cod = e.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "(a.kol - kolmattovrforpdas(a.cod,'", dat, "') != 0 or kolmattovrforpdasr(a.cod) != 0) and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 12 ", 
                    "order by ", sort_str clipped
    end if
    
    # mattov ################################################################
    if tip = 'm' then
        if sernum = 'a' then
            let sernum_fld2 = "a.sernum,"
        else
            let sernum_fld2 = "nullchar(),"
        end if
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        if cena = 'a' then
            let cena_fld1 = "a.cena, a.cenad,"
        else
            let cena_fld1 = "nulldecimal(), nulldecimal(),"
        end if
        if sernum = 'a' and prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        let str = "select unique ", codes_fld clipped,
                         "b.nam, ", sernum_fld2 clipped,
                         "sum(a.kol - kolmattovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "d.nam, ",
                         "sum(kolmattovrforpdasr(a.cod)), nullchar() ",
                    "from matoperp a, tovar b, ei c, sklad d ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "(a.kol - kolmattovrforpdas(a.cod,'", dat, "') != 0 or kolmattovrforpdasr(a.cod) != 0) and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10 ", 
                    "order by ", sort_str clipped
    end if
    
    # fintov ################################################################
    if tip = 'f' then
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        
        if cena = 'a' then
            let cena_fld1 = "a.cena,"
        else
            let cena_fld1 = "nulldecimal(),"
        end if
        
        if prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        
        let str = "select unique ", codes_fld clipped,
                         "b.nam, nullchar(), ",
                         "sum(a.kol - kolfintovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "nulldecimal(), d.nam, nulldecimal(), nullchar() ",
                    "from finoperp a, tovar b, ei c, sklad d ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "a.kol - kolfintovrforpdas(a.cod,'", dat, "') != 0 and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 11 ", 
                    "order by ", sort_str clipped
    end if
    
    prepare p_rep1tov from str
    
    declare cur_rep1tov cursor for p_rep1tov
    let transaction = 1    
    begin work
    start report r1_skladost
        foreach cur_rep1tov into p.*
            output to report r1_skladost(dat, p.skladnam, p.tovarnam, p.sernum, p.kol,
                                         p.einam, p.datp, p.cena, p.cenad, p.kolrez, p.prim1)
        end foreach
    finish report r1_skladost
    commit work
end function

report r1_skladost(ostdat, skladnam, tovarnam, sernum, kol, einam, datp, cenasklad, cenaskladd, kolrez, prim1)
define	
    skladnam    like sklad.nam,
    tovarnam    like tovar.nam,
    einam       like ei.nam,
    sernum      like matoperp.sernum,
    kol, kolrez         like matoperp.kol,
    ostdat, datp        date,
    cenasklad, cenaskladd   like matoperp.cena,
    prim1       like naklp.prim1

output
    report to pipe reppipe
#    report to printer
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"     ",vidoff,twicewidthoff,"  ",vidon,ostdat using "dd/mm/yyyy",vidoff,"."
      skip 1 line
      print passon,"================================================================================================================================="
      print "                           |        SN       | -  | i- |.|  |  i  |  i  |  i" 
      print "                                             |                 |    | i |. ||  i  |  i  |    "
      print "=================================================================================================================================="
    before group of skladnam
        print "-= ", skladnam clipped," =-"
    on every row
      print tovarnam[1,45], " ", sernum[1,17], kolrez using " ####.##", kol using " ####.## ", einam[1,5], datp using " ddmmyy", cenasklad using " #######.##", cenaskladd using " #######.## ", prim1[1,15] clipped
    after group of tovarnam
      if group count(*) > 1 then
        print "                                                              : ", group sum(kol) using " ######.## ", einam
      end if
    on last row
      print "==================================================================================================================================",passoff
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

function skladosttov_rep2(tip, sernum, prih, cena, dat, find_str, sort_str, pipe_str)
define  
    tip, sernum, prih, cena char(1),
    find_str    char(256),
    sort_str    char(64),
    pipe_str    char(256),
    dat         date,
    codes_fld, sernum_fld2, prih_fld1, cena_fld1   char(256),
    p   record
        naklpcod    integer,
        tovarcod    integer,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        datp        date,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad,
        skladnam    like sklad.nam,
        tovargroupnam  like tovargroup.nam,
        tovartipnam like tovartip.nam,
        kolrez      like matoperp.kol
    end record,
    str     char(4096),
    kolost          decimal(7,2),
    kolrash         decimal(7,2)
    
    initialize p, kolost to null
    let reppipe = pipe_str
    
    # mattov ################################################################
    if tip = 'm' then
        if sernum = 'a' then
            let sernum_fld2 = "a.sernum,"
        else
            let sernum_fld2 = "nullchar(),"
        end if
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        if cena = 'a' then
            let cena_fld1 = "a.cena, a.cenad,"
        else
            let cena_fld1 = "nulldecimal(), nulldecimal(),"
        end if
        if sernum = 'a' and prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        let str = "select unique ", codes_fld clipped,
                         "b.nam, ", sernum_fld2 clipped,
                         "sum(a.kol - kolmattovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "d.nam, e.nam, f.nam, ",
                         "sum(kolmattovrforpdasr(a.cod)) ",
                    "from matoperp a, tovar b, ei c, sklad d, tovargroup e, tovartip f ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "b.tovargroup_cod = e.cod and ",
                          "b.tovartip_cod = f.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "(a.kol - kolmattovrforpdas(a.cod,'", dat, "') != 0 or kolmattovrforpdasr(a.cod) != 0) and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12 ", 
                    "order by 10, 11, 12, ", sort_str clipped
    end if
    
    # fintov ################################################################
    if tip = 'f' then
        if prih = 'a' then
            let prih_fld1 = "a.dat_pokupki,"
        else
            let prih_fld1 = "date(null),"
        end if
        
        if cena = 'a' then
            let cena_fld1 = "a.cena,"
        else
            let cena_fld1 = "nulldecimal(),"
        end if
        
        if prih = 'a' and cena = 'a' then
            let codes_fld = "a.naklp_cod, a.tovar_cod,"
        else
            let codes_fld = "nullint(), nullint(),"
        end if
        
        let str = "select unique ", codes_fld clipped,
                         "b.nam, nullchar(), ",
                         "sum(a.kol - kolfintovrforpdas(a.cod,'", dat, "')), ",
                         "c.nam, ", prih_fld1 clipped,
                         cena_fld1 clipped,
                         "nulldecimal(), d.nam, e.nam, f.nam ",
                    "from finoperp a, tovar b, ei c, sklad d, tovargroup e, tovartip f ",
                    "where a.tovar_cod = b.cod and ",
                          "b.ei_cod = c.cod and ",
                          "b.tovargroup_cod = e.cod and ",
                          "b.tovartip_cod = f.cod and ",
                          "a.dat_pokupki < '", dat, "' and ",
                          "a.sklad_cod = d.cod and ",
                          "a.kol - kolfintovrforpdas(a.cod,'", dat, "') != 0 and ",
                          find_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12 ", 
                    "order by 10, 11, 12, ", sort_str clipped
    end if

    prepare p_rep2tov from str
    
    declare cur_rep2tov cursor for p_rep2tov
    let transaction = 1    
    begin work
    start report r2_skladost
        foreach cur_rep2tov into p.*
            output to report r2_skladost(dat, p.skladnam, p.tovargroupnam, p.tovartipnam, p.tovarnam, p.kol, p.kolrez)
        end foreach
    finish report r2_skladost
    commit work
end function

report r2_skladost(ostdat, skladnam, tovargroupnam, tovartipnam, tovarnam, kol, kolrez)
define	
    skladnam        like sklad.nam,
    tovargroupnam   like tovargroup.nam,
    tovartipnam     like tovartip.nam,
    tovarnam        like tovar.nam,
    kol, kolrez     like matoperp.kol,
    ostdat          date

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"     ",vidoff,twicewidthoff,"  ",vidon,ostdat using "dd/mm/yyyy",vidoff,"."
      skip 1 line
      print "=================================================================================="
      print "                                                |           |           |"
      print "                                              |     | ii |"
      print "                                       |           |           |"
      print "=================================================================================="
    before group of skladnam
        print "-= ", skladnam clipped," =-"
    before group of tovargroupnam
      print tovargroupnam
    before group of tovartipnam
      print "    ",tovartipnam
    after group of tovarnam
      print "        ", tovarnam, group sum(kolrez) using " ######.## ", group sum(kol) using " ######.## "
    #on every row
    #  print "        ", tovarnam, kol using " ######.## "
    on last row
      print "======================================================================"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
