globals "globals.4gl"

# tip d -  
# tip s -   
# tip i -   
# tip f -  

# ros r - 
# ros o - 
# ros s - 

function spisaniehead_sel(ros, tip, where_str, sort_str)
define  
    ros, tip         char(1),
    where_str   char(512),
    sort_str    char(64),
    p   record
        schetcod        integer,
        naklrcod        integer,
        schfnrtovcod    integer,
        skladcod        integer,
        tovarnam        like tovar.nam,
        printnam        like schfnrtov.printnam,
        schetnum        like schetfnr.schet_num,
        schetdat        like schetfnr.schet_dat,
        naklnum         like schetfnr.finnaklr_num,
        nakldat         like schetfnr.finnaklr_dat,
        kol             like schfnrtov.kol,
        einam           like ei.nam,
        cena            like schfnrtov.cena,
        cenawpdv        like schfnrtov.cena,
        cenad           like matoperr.cenad,
        kolotg          like matoperr.kol,
        skladnam        like sklad.nam,
        klientnam       like klient.nam,
        issernum        like tovar.issernum
    end record,
    str     char(3096),
    sgpnam  like sklad.nam

    whenever error call err
    
    call stt()
    select nam into sgpnam 
        from sklad 
        where cod = p_stt.sgp
    
    if tip = 'd' then
        if ros = 's' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, ",
                             "cenawithoutpdv(c.cod, b.cena, a.finnaklr_dat), ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'r' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "union ",
                        "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from schetfnr a, _schfnrtovt b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "union ",
                        "select nullint(), a.cod, b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "b.cenad, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from _naklr a, _naklrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.naklr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'o' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                               where_str clipped," ",
                        "union ",
                        "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, _schfnrtovt b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "union ",
                        "select nullint(), a.cod, b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "b.cenad, 0, e.nam, f.nam, c.issernum ",
                        "from _naklr a, _naklrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.naklr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
    end if
    if tip = 's' then
        if ros = 's' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, ",
                             "cenawithoutpdv(c.cod, b.cena, a.finnaklr_dat), ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'r' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "union ",
                        "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from schetfnr a, _schfnrtovt b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'o' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                               where_str clipped," ",
                        "union ",
                        "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, _schfnrtovt b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
    end if
    if tip = 'f' then
        if ros = 's' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, ",
                             "cenawithoutpdv(c.cod, b.cena, a.finnaklr_dat), ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol - spisanoschtovkol(b.cod) != 0 and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'o' then
            let str = "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, schfnrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                              "b.kol != otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "union ",
                        "select a.cod, nullint(), b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "0, 0, e.nam, f.nam, c.issernum ",
                        "from schetfnr a, _schfnrtovt b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.schetfnr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol != otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "union ",
                        "select nullint(), a.cod, b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "b.cenad, 0, e.nam, f.nam, c.issernum ",
                        "from _naklr a, _naklrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.naklr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol != otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
    end if
    
    if tip = 'i' then
        if ros = 'r' then
            let str = "select nullint(), a.cod, b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "b.cenad, otgtovkol(b.cod), e.nam, f.nam, c.issernum ",
                        "from _naklr a, _naklrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.naklr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                              "b.kol > otgtovkol(b.cod) and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
        if ros = 'o' then
            let str = "select nullint(), a.cod, b.cod, a.sklad_cod, c.nam, b.printnam, ",
                             "a.schet_num, a.schet_dat, a.finnaklr_num, ",
                             "a.finnaklr_dat, b.kol, d.nam, b.cena, 0, ",
                             "b.cenad, 0, e.nam, f.nam, c.issernum ",
                        "from _naklr a, _naklrtov b, tovar c, ei d, outer sklad e, klient f ",
                        "where a.cod = b.naklr_cod and ",
                              "b.tovar_cod = c.cod and ",
                              "c.ei_cod = d.cod and ",
                              "a.sklad_cod = e.cod and ",
                              "a.klient_cod = f.cod and ",
                               where_str clipped," ",
                        "order by ", sort_str clipped
        end if
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.schetdat is null then
            initialize p.schetnum to null
        end if
        if p.skladcod is null then 
            let p.skladcod = p_stt.sgp 
            let p.skladnam = sgpnam
        end if
        display p.schetcod, "\t",
                p.naklrcod, "\t",
                p.schfnrtovcod, "\t",
                p.skladcod, "\t",
                p.tovarnam, "\t",
                p.printnam, "\t",
                p.schetnum, "\t",
                p.schetdat using "dd.mm.yyyy", "\t", 
                p.naklnum, "\t", 
                p.nakldat using "dd.mm.yyyy", "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.cena using "#######.##", "\t",
                p.cenawpdv using "#######.##", "\t",
                p.cenad using "#######.##", "\t",
                p.kolotg using "#####.##", "\t",
                p.skladnam, "\t",
                p.klientnam, "\t",
                p.issernum
    end foreach
    commit work
end function

function spisanietov_ins(ros, schetcod, schfnrtovcod, operpcod, 
                         koll, cenaa, cenadd, datotg, primreznam, datgar)
define
    ros             char(1),
    str     	    char(128),
    operrcod        integer,
    schetcod, schfnrtovcod, operpcod    integer,
    koll            like finoperr.kol,
    cenaa           like finoperr.cena,
    cenadd          like matoperr.cena,
    datotg          like matoperr.datotg,
    datgar          date,
    primreznam      like primrez.nam
    
    initialize operrcod to null
    let str = "execute procedure spisanietov_ins(?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using ros, schetcod, schfnrtovcod, operpcod, 
                       koll, cenaa, cenadd, datotg, primreznam, datgar
        fetch cur_ins into operrcod
        display operrcod
    close cur_ins
    commit work
end function

function spisanietov_sel(schfnrtovcod)
define  
    schfnrtovcod        integer,
    p   record
        operrcod        integer,
        tovarcod        integer,
        tovarnam        like tovar.nam,
        kol             like schfnrtov.kol,
        einam           like ei.nam,
        cenaprihoda     like schfnrtov.cena,
        skladnam        like sklad.nam
    end record,
    str     char(512)
    
    let str = "select a.cod, c.cod, c.nam, a.kol, d.nam, b.cena, f.nam ",
                  "from finoperr a, finoperp b, tovar c, ei d, sklad f ",
                  "where a.finoperp_cod = b.cod and ",
                        "b.tovar_cod = c.cod and ",
                        "c.ei_cod = d.cod and ",
                        "b.sklad_cod = f.cod and ",
                        "a.doc_cod = ",schfnrtovcod, " ",
                  "order by 2, 3, 5"
    prepare p_seltov from str
    
    initialize p to null
    declare cur_seltov cursor for p_seltov
    let transaction = 1    
    begin work
    foreach cur_seltov into p.*
        display p.operrcod, "\t",
                p.tovarcod, "\t",
                p.tovarnam, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.cenaprihoda using "#######.##", "\t",
                " ", "\t",
                " ", "\t",
                p.skladnam, "\t",
                " ", "\t",
                " ", "\t",
                " ", "\t",
                " ", "\t",
                " "
    end foreach
    commit work
end function

function reztov_sel(codesdoccod)
define  
    codesdoccod         integer,
    p   record
        operrcod        integer,
        tovarcod        integer,
        tovarnam        like tovar.nam,
        sernum          like matoperp.sernum,
        kol             like schfnrtov.kol,
        einam           like ei.nam,
        primreznam      like primrez.nam,
        skladnam        like sklad.nam
    end record,
    str     char(512)
    
    let str = "select a.cod, c.cod, c.nam, b.sernum, a.kol, d.nam, e.nam, f.nam ",
                  "from matoperr a, matoperp b, tovar c, ei d, outer primrez e, sklad f ",
                  "where a.matoperp_cod = b.cod and ",
                        "b.tovar_cod = c.cod and ",
                        "c.ei_cod = d.cod and ",
                        "a.doc_cod = ", codesdoccod, " and ",
                        "a.cod = e.matoperr_cod and ",
                        "b.sklad_cod = f.cod and ",
                        "a.datotg is null ",
                        #a.kol > otgtovforoperr(a.cod) ",
                  "order by 2, 3"
    prepare p_seltov2 from str
    
    initialize p to null
    declare cur_seltov2 cursor for p_seltov2
    let transaction = 1    
    begin work
    foreach cur_seltov2 into p.*
        display p.operrcod, "\t",
                p.tovarcod, "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                " ", "\t",
                p.primreznam, "\t",
                p.skladnam, "\t",
                " ", "\t",
                " ", "\t",
                " ", "\t",
                " ", "\t",
                " "
    end foreach
    commit work
end function

function otgtov_sel(codesdoccod)
define  
    codesdoccod         integer,
    p   record
        operrcod        integer,
        tovarcod        integer,
        tovarnam        like tovar.nam,
        sernum          like matoperp.sernum,
        kol             like schfnrtov.kol,
        einam           like ei.nam,
        datotg          like matoperr.datotg,
        primreznam      like primrez.nam,
        skladnam        like sklad.nam,
        datgar          date,
        cenaprih        like matoperp.cena,
        cenadprih       like matoperp.cenad,
        datgarleft      date,
        gsleft          char(2),
        datpokupkileft  date
    end record,
    str     char(512)
    
    let str = "select a.cod, c.cod, c.nam, b.sernum, a.kol, d.nam, a.datotg, ",
                     "e.nam, f.nam, a.dat_gar, b.cena, b.cenad, ",
                     "b.dat_gar, c.gs, b.dat_pokupki ",
                  "from matoperr a, matoperp b, tovar c, ei d, outer primrez e, sklad f ",
                  "where a.matoperp_cod = b.cod and ",
                        "b.tovar_cod = c.cod and ",
                        "c.ei_cod = d.cod and ",
                        "a.cod = e.matoperr_cod and ",
                        "b.sklad_cod = f.cod and ",
                        "a.doc_cod = ", codesdoccod, " ",
                  "order by 2, 3"
    prepare p_seltov3 from str
    
    initialize p to null
    declare cur_seltov3 cursor for p_seltov3
    let transaction = 1    
    begin work
    foreach cur_seltov3 into p.*
        display p.operrcod, "\t",
                p.tovarcod, "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.datotg using "dd.mm.yyyy", "\t",
                p.primreznam, "\t",
                p.skladnam, "\t",
                p.datgar using "dd.mm.yyyy", "\t",
                p.cenaprih using "#######.##", "\t",
                p.cenadprih using "#######.##", "\t",
                p.datgarleft using "dd.mm.yyyy", "\t",
                p.gsleft, "\t",
                p.datpokupkileft using "dd.mm.yyyy"
    end foreach
    commit work
end function

function spisanietov_upd(ros, operrcod, datotg, koll, primreznam, datgar)
define
    ros         char(1),
    str     	char(128),
    operrcod    integer,
    datotg      like matoperr.datotg,
    koll        like finoperr.kol,
    primreznam  like primrez.nam,
    datgar      date
    
    let str = "execute procedure spisanietov_upd(?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using ros, operrcod, datotg, koll, primreznam, datgar
    commit work
end function

function spisanietov_del(ros, operrcod)
define
    ros         char(1),
    str     	char(128),
    operrcod    integer
    
    let str = "execute procedure spisanietov_del(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using ros, operrcod
    commit work
end function
