globals "globals.4gl"

function tovarwww_sel(tovarcod)
define  
    tovarcod   integer,
    p   record
        smallimage      like tovarwww.smallimage,
        bigimage        like tovarwww.bigimage,
        opisanieshort   like tovarwww.opisanieshort,
        opisanielong    like tovarwww.opisanielong
    end record,
    str         char(768)

#    whenever error call err
    
    let str = "select smallimage, bigimage, opisanieshort, opisanielong ",
                 "from tovarwww ",
                 "where tovar_cod = ", tovarcod
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.smallimage clipped, "\t", 
                p.bigimage clipped, "\t", 
                p.opisanieshort clipped, "\t", 
                p.opisanielong clipped
    end foreach
    commit work
end function

function tovarwww_ins(tovarcod, smallimage, bigimage, opisanieshort,
                   opisanielong)

define
    str     	    char(128),
    tovarcod        integer,
    smallimage      like tovarwww.smallimage,
    bigimage        like tovarwww.bigimage,
    opisanieshort   like tovarwww.opisanieshort,
    opisanielong    like tovarwww.opisanielong
    
    let str = "execute procedure tovarwww_ins(?,?,?,?,?)"
    prepare p_ins from str
    let transaction = 1
    begin work
    execute p_ins using tovarcod, smallimage, bigimage, opisanieshort, opisanielong
    commit work
end function
