globals "globals.4gl"

function whomathtov_sel(tovarcod)
define  
    tovarcod        integer,
    p   record
        tovarcod    integer,
        skladnam    like sklad.nam,
        kolrez      like matoperp.kol,
        kol         like matoperp.kol,
        einam       like ei.nam,
        cena        like matoperp.cena,
        cenad       like matoperp.cenad
    end record,
    str         char(1024)
    
    whenever error call err

    let str = "select a.tovar_cod, b.nam, sum(a.kolrez), sum(a.kol), d.nam, ",
                     "a.cenawithpdv, a.cenad ",
                 "from _whomathtov a, sklad b, tovar c, ei d ",
                 "where a.tovar_cod = ", tovarcod, " and ",
                       "a.sklad_cod = b.cod and ",
                       "a.tovar_cod = c.cod and ",
                       "c.ei_cod = d.cod ",
                 "group by 1, 2, 5, 6, 7 ",
                 "having sum(a.kolrez) > 0 or sum(a.kol) > 0 ",
                 "order by 2, 5, 6, 4"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.skladnam, "\t", 
                p.kolrez using "#####.##", "\t", 
                p.kol using "#####.##", "\t", 
                p.einam, "\t", 
                p.cena using "#######.##", "\t",
                p.cenad using "#######.##"
    end foreach
    commit work
end function

