globals "globals.4gl"

function zaimopl_sel(tip, cod)
define  
    tip     char(4),
    cod     integer
    
    whenever error call err
    
    case tip
        when 'to'   call naklropl_sel(cod)
        when 'from' call naklpopl_sel(cod)
        when 'gklp' call naklpopl_sel(cod)
        when 'gpsr' call naklropl_sel(cod)
    end case
end function

function zaimopl_del(tip, cod)
define  
    tip     char(4),
    cod     integer
    
    case tip
        when 'to'   call naklropl_del(cod)
        when 'from' call naklpopl_del(cod)
        when 'gklp' call naklpopl_del(cod)
        when 'gpsr' call naklropl_del(cod)
    end case
end function

function zaimopl_ins(tip, cod, f0, f1, f2)
define
    tip     char(4),
    cod     integer,
    f0, f1, f2  char(12)
    
    case tip
        when 'to'   call naklropl_ins(cod, f0, f1, f2)
        when 'from' call naklpopl_ins(cod, f0, f1, f2)
        when 'gklp' call naklpopl_ins(cod, f0, f1, f2)
        when 'gpsr' call naklropl_ins(cod, f0, f1, f2)
    end case
end function

function zaimopl_upd(tip, cod, f0, f1, f2)
define
    tip     char(4),
    cod     integer,
    f0, f1, f2  char(12)
    
    case tip
        when 'to'   call naklropl_upd(cod, f0, f1, f2)
        when 'from' call naklpopl_upd(cod, f0, f1, f2)
        when 'gklp' call naklpopl_upd(cod, f0, f1, f2)
        when 'gpsr' call naklropl_upd(cod, f0, f1, f2)
    end case
end function
